#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <syslog.h>
#include <unistd.h>
#include <math.h>
#include <time.h>

#include "read_config.h"
#include "read_iplist.h"
#include "firewall.h"
#include "shaperd_old.h"


int				load_balancing = 0;
int				pos_diff = 0;

extern char			ipchains_path[];
extern char			iptables_path[];
extern char			tc_path[];

extern int			**local_int_tab2;
extern int			local_int_pos;
extern int			upload_control;
extern int			start_speed;
extern int			even_division;
extern int			alt_natstat;
extern int			continuous_control;
extern int			squid;
extern int			squid_ingress;
extern int			squid_port;
extern float			squid_factor;
extern int			timeout_ipchains_22;
extern int			timeout_ipchains_24;
extern int			timeout_iptables_24;
extern int			timeout_global;
extern int			nomasq;
extern int			nomasq_cycles;
extern int			jump_type;
extern int			nop_factor;
extern int			add_factor;
extern int			htb_r2q;
extern int			divide_upload;
extern int			quick_start;
extern int			delta_factor;
extern short			output_type;
extern unsigned long int	speed_out;
extern unsigned int		natstat_sensivity;
extern unsigned int		natstat_upload_sensivity;
extern char			speed_ext[];
extern int			delay;
extern int			olddelay;
extern int			debug;
extern int			notc;
extern int			class_type;
extern int			extended_queue;
extern int			upload_class_type;
extern int			check_always;
extern int			check_sum_of_bandwidth;
extern int			shaperd_counter;
extern int			always_max;
extern char			output[];
extern char			configfile[];
extern char			pidfile[];
extern char			ignorefile[];
extern char			iplistfile[];
extern char			oldfile[];
extern char			oldfile_upload[];
extern unsigned int		cnt[10][256];
extern int			mult;
extern short			htb_quantum;
extern short			burst_type;
extern short			cburst_type;
extern short			htb_burst;
extern short			htb_cburst;
extern short			min_factor;
extern short			check_download_factor;
extern short			check_upload_factor;
extern short			check_factor_cnt;
extern short			check_upload_factor_cnt;
extern short			remove_dead_class;
extern short			refresh_dead_fwrule;
extern short			static_dnload_class;
extern short			static_upload_class;
/**ZQ**/
extern short			extended_download_limits;
extern short			common_limit;
extern short			total_limit;
extern short			delay_mesg;
extern short			mask_mesg;
extern short			control_mesg;
extern unsigned long int	ceil_download;
extern unsigned long int	ceil_upload;
/*
extern unsigned long int	default_download_limit;
extern unsigned long int	default_upload_limit;
*/
extern double			default_download_limit;
extern double			default_upload_limit;
extern unsigned long int	default_download_limit_hispeed;
extern unsigned long int	default_upload_limit_hispeed;
extern short			interactive;
extern int			firewall_type;
extern int			lastrate_numcycles;
extern short			alt_thandle;
extern char			***config;
extern int			last_state_perm;
extern int			check_firewall_numcycles;
extern short			enable_eir_factor;
extern short			ban_user;
extern unsigned short		default_ban_download_cnt; // na ile cykli ma byc robiony ban na firewallu w przypadku przelamania klasy
extern unsigned short		default_ban_upload_cnt; // na ile cykli ma byc robiony ban na firewallu w przypadku przelamania klasy
extern unsigned short		max_ban_download;
extern unsigned short		max_ban_upload;

char ***read_config(char *fname)
{
    int		nr_linii = 0;
    FILE	*fp;
    char	buf[1000];
    char	buf_copy[1000];
    char	*res;
    char	***local_int_tab = NULL;

    if (!(fp = fopen(fname,"r")))
    {
	syslog(LOG_ERR,"Can't read configuration file %s",fname);
	error("Can't read configuration file %s\nExiting\n",fname);
    }
    local_int_tab = (char ***) calloc(6,sizeof(char **));
    local_int_tab2 = (int **) calloc(6,sizeof(int *));
    local_int_tab[1] = (char **) NULL;
    local_int_tab2[1] = (int *) NULL;

    while ((fgets(buf,1000,fp))!=NULL)
    {
	nr_linii++;
	strcpy(buf_copy,buf);
	if (buf[0]!='#' && strlen(buf))
	{
	    res=strtok(buf,"=");
/*
	    if ((! strcmp("high_start_speed",res)) && (! strcmp(res,"high_start_speed")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) high_start_speed = 1;
		else
		if (!strcmp(res,"no")) high_start_speed = 0;
		else
	    	    high_start_speed = atoi(res);
	    }
	    else
*/
	    if ((! strcmp("start_speed",res)) && (! strcmp(res,"start_speed")))
	    {
		res = lower(strtok(NULL,"\n"));
	    	start_speed = atoi(res);
		if (start_speed < 0) start_speed = 0;
		if (start_speed > 255) start_speed = 255;
		syslog(LOG_INFO,"start_speed: %d",start_speed);
	    }
	    else
	    if ((! strcmp("ipchains_path",res)) && (! strcmp(res,"ipchains_path")))
	    {
		res = strtok(NULL,"\n");
		strncpy(ipchains_path,res,100);
		syslog(LOG_INFO,"ipchains_path: %s",ipchains_path);
	    }
	    else
	    if ((! strcmp("iptables_path",res)) && (! strcmp(res,"iptables_path")))
	    {
		res = strtok(NULL,"\n");
		strncpy(iptables_path,res,100);
		syslog(LOG_INFO,"iptables_path: %s\n",iptables_path);
	    }
	    else
	    if ((! strcmp("tc_path",res)) && (! strcmp(res,"tc_path")))
	    {
		res = strtok(NULL,"\n");
		strncpy(tc_path,res,100);
		syslog(LOG_INFO,"tc_path: %s",tc_path);
	    }
	    else
	    if ((! strcmp("even_division",res)) && (! strcmp(res,"even_division")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) even_division = 1;
		else
		if (!strcmp(res,"no")) even_division = 0;
		else
	    	    even_division = atoi(res);
	    }
	    else
	    if ((! strcmp("static_dnload",res)) && (! strcmp(res,"static_dnload")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) static_dnload_class = 1;
		else
		if (!strcmp(res,"no")) static_dnload_class = 0;
		else
	    	    static_dnload_class = atoi(res);
	    }
	    else
	    if ((! strcmp("static_upload",res)) && (! strcmp(res,"static_upload")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) static_upload_class = 1;
		else
		if (!strcmp(res,"no")) static_upload_class = 0;
		else
	    	    static_upload_class = atoi(res);
	    }
	    else
	    if ((! strcmp("always_max",res)) && (! strcmp(res,"always_max")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) always_max = 1;
		else
		if (!strcmp(res,"no")) always_max = 0;
		else
	    	    always_max = atoi(res);
	    }
	    else
	    if ((! strcmp("alt_natstat",res)) && (! strcmp(res,"alt_natstat")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) alt_natstat = 1;
		else
		if (!strcmp(res,"no")) alt_natstat = 0;
		else alt_natstat = atoi(res);
	    }
	    else
	    if ((! strcmp("continuous_control",res)) && (! strcmp(res,"continuous_control")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) continuous_control = 1;
		else
		if (!strcmp(res,"no")) continuous_control = 0;
		else
	    	    continuous_control = atoi(res);
	    }
	    else
	    if ((! strcmp("load_balancing",res)) && (! strcmp(res,"load_balancing")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) load_balancing = 1;
		else
		if (!strcmp(res,"no")) load_balancing = 0;
		else
	    	    load_balancing = atoi(res);
		if (! interactive && load_balancing) syslog(LOG_INFO,"Load Balancing enabled.");
	    }
	    else
	    if ((! strcmp("common_limit",res)) && (! strcmp(res,"common_limit")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) common_limit = 1;
		else
		if (!strcmp(res,"no")) common_limit = 0;
		else
	    	    common_limit = atoi(res);
		if (! interactive && common_limit) syslog(LOG_INFO,"common_limit enabled.");
	    }
	    else
	    if ((! strcmp("total_limit",res)) && (! strcmp(res,"total_limit")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) total_limit = 1;
		else
		if (!strcmp(res,"no")) total_limit = 0;
		else
	    	    total_limit = atoi(res);
		if (! interactive && total_limit) syslog(LOG_INFO,"total_limit enabled.");
	    }
	    else
	    if ((! strcmp("ban_user",res)) && (! strcmp(res,"ban_user")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) ban_user = 1;
		else
		if (!strcmp(res,"no")) ban_user = 0;
		else
	    	    ban_user = atoi(res);
		if (! interactive && ban_user) syslog(LOG_INFO,"ban_user enabled.");
	    }
	    else
	    if ((! strcmp("max_ban_download",res)) && (! strcmp(res,"max_ban_download")))
	    {
		res = strtok(NULL,"\n");
	        max_ban_download = atoi(res);
	    }
	    else
	    if ((! strcmp("max_ban_upload",res)) && (! strcmp(res,"max_ban_upload")))
	    {
		res = strtok(NULL,"\n");
	        max_ban_upload = atoi(res);
	    }
	    else
	    if ((! strcmp("jump_type",res)) && (! strcmp(res,"jump_type")))
	    {
		res = strtok(NULL,"\n");
	        jump_type = atoi(res);
	    }
	    else
	    if ((! strcmp("write_type",res)) && (! strcmp(res,"write_type")))
	    {
		res = strtok(NULL,"\n");
	        output_type = atoi(res);
	    }
	    else
	    if ((! strcmp("timeout_ipchains_22",res)) && (! strcmp(res,"timeout_ipchains_22")))
	    {
		res = strtok(NULL,"\n");
	        timeout_ipchains_22 = atoi(res);
	    }
	    else
	    if ((! strcmp("timeout_ipchains_24",res)) && (! strcmp(res,"timeout_ipchains_24")))
	    {
		res = strtok(NULL,"\n");
	        timeout_ipchains_24 = atoi(res);
	    }
	    else
	    if ((! strcmp("timeout_iptables_24",res)) && (! strcmp(res,"timeout_iptables_24")))
	    {
		res = strtok(NULL,"\n");
	        timeout_iptables_24 = atoi(res);
	    }
	    else
	    if ((! strcmp("timeout_global",res)) && (! strcmp(res,"timeout_global")))
	    {
		res = strtok(NULL,"\n");
	        timeout_global = atoi(res);
	    }
	    else
	    if ((! strcmp("delta_factor",res)) && (! strcmp(res,"delta_factor")))
	    {
		res = strtok(NULL,"\n");
	        delta_factor = atoi(res);
	    }
	    else
	    if ((! strcmp("check_download_factor_cnt",res)) && (! strcmp(res,"check_download_factor_cnt")))
	    {
		res = strtok(NULL,"\n");
	        check_factor_cnt = atoi(res);
	    }
	    else
	    if ((! strcmp("check_download_factor",res)) && (! strcmp(res,"check_download_factor")))
	    {
		res = strtok(NULL,"\n");
	        check_download_factor = atoi(res);
	    }
	    else
	    if ((! strcmp("check_upload_factor_cnt",res)) && (! strcmp(res,"check_upload_factor_cnt")))
	    {
		res = strtok(NULL,"\n");
	        check_upload_factor_cnt = atoi(res);
	    }
	    else
	    if ((! strcmp("check_upload_factor",res)) && (! strcmp(res,"check_upload_factor")))
	    {
		res = strtok(NULL,"\n");
	        check_upload_factor = atoi(res);
	    }
	    else
	    if ((! strcmp("burst_type",res)) && (! strcmp(res,"burst_type")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"current")) burst_type = 1;
		else
		if (!strcmp(res,"maximum")) burst_type = 0;
		else
	    	    burst_type = atoi(res);
	    }
	    else
	    if ((! strcmp("cburst_type",res)) && (! strcmp(res,"cburst_type")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"current")) cburst_type = 1;
		else
		if (!strcmp(res,"maximum")) cburst_type = 0;
		else
	    	    cburst_type = atoi(res);
	    }
	    else
	    if ((! strcmp("htb_burst",res)) && (! strcmp(res,"htb_burst")))
	    {
		res = strtok(NULL,"\n");
	        htb_burst = atoi(res);
		if (htb_burst < 0) htb_burst = 0;
		else
		if (htb_burst > 32) htb_burst = 32;
	    }
	    else
	    if ((! strcmp("htb_cburst",res)) && (! strcmp(res,"htb_cburst")))
	    {
		res = strtok(NULL,"\n");
	        htb_cburst = atoi(res);
		if (htb_cburst < 0) htb_cburst = 0;
		else
		if (htb_cburst > 32) htb_cburst = 32;
	    }
	    else
	    if ((! strcmp("ceil_download",res)) && (! strcmp(res,"ceil_download")))
	    {
		res = strtok(NULL,"\n");
	        ceil_download = atoi(res);
		if (ceil_download < 0) ceil_download = 0;
	    }
	    else
	    if ((! strcmp("ceil_upload",res)) && (! strcmp(res,"ceil_upload")))
	    {
		res = strtok(NULL,"\n");
	        ceil_upload = atoi(res);
		if (ceil_upload < 0) ceil_upload = 0;
	    }
	    else
	    if ((! strcmp("natstat_download_sensivity",res)) && (! strcmp(res,"natstat_download_sensivity")))
	    {
		res = strtok(NULL,"\n");
	        natstat_sensivity = atoi(res);
		if (natstat_sensivity < 1) natstat_sensivity = 1;
	    }
	    else
	    if ((! strcmp("natstat_upload_sensivity",res)) && (! strcmp(res,"natstat_upload_sensivity")))
	    {
		res = strtok(NULL,"\n");
	        natstat_upload_sensivity = atoi(res);
		if (natstat_upload_sensivity < 1) natstat_upload_sensivity = 1;
	    }
	    else
        /** ZQ**/
		if ((! strcmp("extended_download_limits",res)) && (! strcmp(res,"extended_download_limits")))
		{
			res = lower(strtok(NULL,"\n"));
			if (!strcmp(res,"yes")) extended_download_limits = 1;
		    else
				if (!strcmp(res,"no")) extended_download_limits = 0;
				else
					extended_download_limits= atoi(res);
		}
		else
		if ((! strcmp("default_download_limit",res)) && (! strcmp(res,"default_download_limit")))
	    {
		res = strtok(NULL,"\n");
//	        default_download_limit = strtoul(res,NULL,10);
	        default_download_limit = atof(res);
		if (default_download_limit < 0) default_download_limit = 0;
//		if (! interactive && default_download_limit) syslog(LOG_INFO,"Default download limit is %lu.",default_download_limit);
		if (! interactive && default_download_limit) syslog(LOG_INFO,"Default download limit is %.0f.",default_download_limit);
	    }
	    else
	    if ((! strcmp("default_upload_limit",res)) && (! strcmp(res,"default_upload_limit")))
	    {
		res = strtok(NULL,"\n");
//	        default_upload_limit = strtoul(res,NULL,10);
	        default_upload_limit = atof(res);
		if (default_upload_limit < 0) default_upload_limit = 0;
//		if (! interactive && default_upload_limit) syslog(LOG_INFO,"Default upload limit is %lu.",default_upload_limit);
		if (! interactive && default_upload_limit) syslog(LOG_INFO,"Default upload limit is %.0f.",default_upload_limit);
	    }
	    else
	    if ((! strcmp("default_download_hispeed",res)) && (! strcmp(res,"default_download_hispeed")))
	    {
		res = strtok(NULL,"\n");
	        default_download_limit_hispeed = strtoul(res,NULL,10);
		if (default_download_limit_hispeed < 0) default_download_limit_hispeed = 0;
		if (! interactive && default_download_limit_hispeed) syslog(LOG_INFO,"Default download hispeed is %lu%s.",default_download_limit_hispeed,speed_ext);
	    }
	    else
	    if ((! strcmp("default_upload_hispeed",res)) && (! strcmp(res,"default_upload_hispeed")))
	    {
		res = strtok(NULL,"\n");
	        default_upload_limit_hispeed = strtoul(res,NULL,10);
		if (default_upload_limit_hispeed < 0) default_upload_limit_hispeed = 0;
		if (! interactive && default_upload_limit_hispeed) syslog(LOG_INFO,"Default upload hispeed is %lu%s.",default_upload_limit_hispeed,speed_ext);
	    }
	    else
	    if ((! strcmp("remove_dead_class",res)) && (! strcmp(res,"remove_dead_class")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) remove_dead_class = 1;
		else
		if (!strcmp(res,"no")) remove_dead_class = 0;
		else
	    	    remove_dead_class = atoi(res);
	    }
	    else
	    if ((! strcmp("refresh_dead_fwrule",res)) && (! strcmp(res,"refresh_dead_fwrule")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) refresh_dead_fwrule = 1;
		else
		if (!strcmp(res,"no")) refresh_dead_fwrule = 0;
		else
	    	    refresh_dead_fwrule = atoi(res);
	    }
	    else
	    if ((! strcmp("pos_diff",res)) && (! strcmp(res,"pos_diff")))
	    {
		int	f;
	    
		res = strtok(NULL,"\n");
	        f = atoi(res);
		if (f > 0)
		{
		    pos_diff = f;
		}
	    }
	    else
	    if ((! strcmp("nop_factor",res)) && (! strcmp(res,"nop_factor")))
	    {
		int	f;
	    
		res = strtok(NULL,"\n");
	        f = atoi(res);
		if (f > 0 && f < 99)
		{
		    nop_factor = f;
		    if (! interactive) syslog(LOG_INFO,"setting nop_factor to %d",nop_factor);
		}
		else syslog(LOG_ERR,"nop_factor must be 1-98");
	    }
	    else
	    if ((! strcmp("add_factor",res)) && (! strcmp(res,"add_factor")))
	    {
		int	f;
	    
		res = strtok(NULL,"\n");
	        f = atoi(res);
		if (f > 0 && f < 100)
		{
		    add_factor = f;
		    if (! interactive) syslog(LOG_INFO,"setting add_factor to %d",add_factor);
		}
		else syslog(LOG_ERR,"add_factor must be 1-99");
	    }
	    else
	    if ((! strcmp("check_sum_of_bandwidth",res)) && (! strcmp(res,"check_sum_of_bandwidth")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) check_sum_of_bandwidth = 1;
		else
		if (!strcmp(res,"no")) check_sum_of_bandwidth = 0;
		else
		    check_sum_of_bandwidth = atoi(res);
		if (! interactive && check_sum_of_bandwidth) syslog(LOG_INFO,"Check sum of bandwidth enabled");
	    }
	    else
	    if ((! strcmp("squid_support",res)) && (! strcmp(res,"squid_support")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"rules_only")) squid = 2;
		else
		if (!strcmp(res,"yes")) squid = 1;
		else
		if (!strcmp(res,"no")) squid = 0;
		else
	    	    squid = atoi(res);
	        if (squid==1 && !interactive) syslog(LOG_INFO,"squid_support active");
		else
		if (squid==2 && !interactive) syslog(LOG_INFO,"squid_support rules_only");
	    }
	    else
	    if ((! strcmp("squid_ingress_support",res)) && (! strcmp(res,"squid_ingress_support")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) squid_ingress = 1;
		else
		if (!strcmp(res,"no")) squid_ingress = 0;
		else
	    	    squid_ingress = atoi(res);
	        if (squid_ingress==1 && !interactive) syslog(LOG_INFO,"squid_ingress_support active");
	    }
	    else
	    if ((! strcmp("squid_port",res)) && (! strcmp(res,"squid_port")))
	    {
		res = strtok(NULL,"\n");
		if (atoi(res) > 0 && atoi(res) < 65536) squid_port = atoi(res);
		else syslog(LOG_ERR,"Invalid value of squid_port. Setting %d value.",squid_port);
	    }
	    else
	    if ((! strcmp("squid_factor",res)) && (! strcmp(res,"squid_factor")))
	    {
		res = strtok(NULL,"\n");
		if (atof(res) > 0 && atof(res) < 100) squid_factor = atof(res);
		else syslog(LOG_ERR,"Invalid value of squid_factor. Setting %f value.",squid_factor);
	    }
	    else
	    if ((! strcmp("divide_upload",res)) && (! strcmp(res,"divide_upload")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) divide_upload = 1;
		else
		if (!strcmp(res,"no")) divide_upload = 0;
		else
	    	    divide_upload = atoi(res);
	        if (divide_upload && !interactive) syslog(LOG_INFO,"divide_upload active");
	    }
	    else
	    if ((! strcmp("nomasq",res)) && (! strcmp(res,"nomasq")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) nomasq = 1;
		else
		if (!strcmp(res,"no")) nomasq = 0;
		else
	    	    nomasq = atoi(res);
	        if (nomasq && !interactive) syslog(LOG_INFO,"masquerade control deactivated");
	    }
	    else
	    if ((! strcmp("class_type",res)) && (! strcmp(res,"class_type")))
	    {
	        res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"cbq")) class_type = 0;
		else
		if (!strcmp(res,"htb")) class_type = 1;
		else
		if (!strcmp(res,"ehtb")) class_type = 2;
		else
		if (!strcmp(res,"shtb")) class_type = 3;

		if (class_type == 1 && !interactive) syslog(LOG_INFO,"HTB Download Class type activated");
		else
		if (class_type == 2 && !interactive) syslog(LOG_INFO,"EHTB Download Class type activated");
		else
		if (class_type == 3 && !interactive) syslog(LOG_INFO,"SHTB Download Class type activated");
		free(res);
	    }
	    else
	    if ((! strcmp("extended_queue",res)) && (! strcmp(res,"extended_queue")))
	    {
	        res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) extended_queue = 1;
		else
		if (!strcmp(res,"no")) extended_queue = 0;
		if (extended_queue && !interactive) syslog(LOG_INFO,"Extended queue activated");
		free(res);
	    }
	    else
	    if ((! strcmp("debug_output",res)) && (! strcmp(res,"debug_output")))
	    {
	        strcpy(output,strtok(NULL,"\n"));
	    }
	    else
	    if ((! strcmp("upload_class_type",res)) && (! strcmp(res,"upload_class_type")))
	    {
	        res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"cbq")) upload_class_type = 0;
		else
		if (!strcmp(res,"htb")) upload_class_type = 1;
		else
		if (!strcmp(res,"ehtb")) upload_class_type = 2;
		else
		if (!strcmp(res,"shtb")) upload_class_type = 3;

		if (upload_class_type == 1 && !interactive) syslog(LOG_INFO,"HTB Upload Class type activated");
		else
		if (upload_class_type == 2 && !interactive) syslog(LOG_INFO,"EHTB Upload Class type activated");
		else
		if (upload_class_type == 3 && !interactive) syslog(LOG_INFO,"SHTB Upload Class type activated");
		free(res);
	    }
	    else
	    if ((! strcmp("speed_ext",res)) && (! strcmp(res,"speed_ext")))
	    {
	        res = lower(strtok(NULL,"\n"));
	        if (! strcmp(res,"kbit") || ! strcmp(res,"mbit")) strncpy(speed_ext,res,10);
	        else strncpy(speed_ext,"\0",10);
		free(res);
	    }
	    else
	    if ((! strcmp("debug",res)) && (! strcmp(res,"debug")))
	    {
	        res = strtok(NULL,"\n");
	        debug = atoi(res);
	    }
	    else
	    if ((! strcmp("notc",res)) && (! strcmp(res,"notc")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) notc = 1;
		else
		if (!strcmp(res,"no")) notc = 0;
		else
	    	    notc = atoi(res);
	    }
	    else
	    if ((! strcmp("delay_mesg",res)) && (! strcmp(res,"delay_mesg")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) delay_mesg = 1;
		else
		if (!strcmp(res,"no")) delay_mesg = 0;
		else
	    	    delay_mesg = (short) atoi(res);
	    }
	    else
	    if ((! strcmp("mask_mesg",res)) && (! strcmp(res,"mask_mesg")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) mask_mesg = 1;
		else
		if (!strcmp(res,"no")) mask_mesg = 0;
		else
	    	    mask_mesg = (short) atoi(res);
	    }
	    else
	    if ((! strcmp("control_mesg",res)) && (! strcmp(res,"control_mesg")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) control_mesg = 1;
		else
		if (!strcmp(res,"no")) control_mesg = 0;
		else
	    	    control_mesg = (short) atoi(res);
	    }
	    else
	    if ((! strcmp("enable_eir_factor",res)) && (! strcmp(res,"enable_eir_factor")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) enable_eir_factor = 1;
		else
		if (!strcmp(res,"no")) enable_eir_factor = 0;
		else
	    	    enable_eir_factor = (short) atoi(res);
	    }
	    else
	    if ((! strcmp("delay",res)) && (! strcmp(res,"delay")))
	    {
	        res = strtok(NULL,"\n");
	        delay = atoi(res);
	        if (delay < 10) delay = 10;
	    }
	    else
	    if ((! strcmp("alt_delay_handle",res)) && (! strcmp(res,"alt_delay_handle")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) alt_thandle = 1;
		else
		if (!strcmp(res,"no")) alt_thandle = 0;
		else
	    	    alt_thandle = atoi(res);
	    }
	    else
	    if ((! strcmp("write_delay",res)) && (! strcmp(res,"write_delay")))
	    {
	        res = strtok(NULL,"\n");
	        olddelay = atoi(res);
	        if (olddelay < 0) olddelay = 0;
	    }
	    else
	    if ((! strcmp("write_last_rate",res)) && (! strcmp(res,"write_last_rate")))
	    {
	        res = strtok(NULL,"\n");
	        lastrate_numcycles = atoi(res);
	        if (lastrate_numcycles < 0) lastrate_numcycles = 0;
		if (! interactive && lastrate_numcycles) syslog(LOG_INFO,"Write LastRate every %d cycle(s).",lastrate_numcycles);
	    }
	    else
	    if ((! strcmp("last_rate_perm",res)) && (! strcmp(res,"last_rate_perm")))
	    {
	        res = strtok(NULL,"\n");
		sscanf(res,"%3o",&last_state_perm);
	    }
	    else
	    if ((! strcmp("check_firewall_counters",res)) && (! strcmp(res,"check_firewall_counters")))
	    {
	        res = strtok(NULL,"\n");
	        check_firewall_numcycles = atoi(res);
	        if (check_firewall_numcycles < 0) check_firewall_numcycles = 0;
		if (! interactive && check_firewall_numcycles) syslog(LOG_INFO,"Check firewall counters every %d cycle(s).",check_firewall_numcycles);
	    }
	    else
	    if ((! strcmp("inter_int",res)) && (! strcmp(res,"inter_int")))
	    {
		if (local_int_pos < 11)
		{
		    if (count_char_in_string(buf_copy,';') == 6)
		    {
	    		local_int_tab[1] = (char **) realloc((char **) local_int_tab[1],sizeof(char *)*6*(local_int_pos+1));
			local_int_tab2[1] = (int *) realloc((int *) local_int_tab2[1],sizeof(int)*6*(local_int_pos+1));
    
			// ustawiamy 1 dla internetowych interfejsow
	    		local_int_tab2[1][(local_int_pos*6)+5] = 1;
    
			// pobieramy nazwe interfejsu internetowego
	    		res=strtok(NULL,";");
			if (is_device(res))
			{
	    		    local_int_tab[1][(local_int_pos*6)+1]= (char *) calloc(strlen(res)+2,sizeof(char));
	    		    strcpy(local_int_tab[1][(local_int_pos*6)+1],res);

	    		    // pobieramy lospeed
	    		    res=strtok(NULL,";");
	    		    if (strtoul(res,NULL,10) > 0) local_int_tab2[1][(local_int_pos*6)+1]= strtoul(res,NULL,10);
			    else
			    {
    				syslog(LOG_ERR,"Wrong download lospeed value in inter_int for %s interface.",local_int_tab[1][(local_int_pos*6)+1]);
				error("Wrong download lospeed value in inter_int for %s interface.",local_int_tab[1][(local_int_pos*6)+1]);
			    }

    	    		    // pobieramy hispeed
	    		    res=strtok(NULL,";");
	    		    if (strtoul(res,NULL,10) > 0) local_int_tab2[1][(local_int_pos*6)+2]= strtoul(res,NULL,10);
			    else
			    {
    				syslog(LOG_ERR,"Wrong download hispeed value in inter_int for %s interface.",local_int_tab[1][(local_int_pos*6)+1]);
				error("Wrong download hispeed value in inter_int for %s interface.",local_int_tab[1][(local_int_pos*6)+1]);
			    }

	    		    // pobieramy upload_lospeed
	    		    res=strtok(NULL,";");
	    		    if (strtoul(res,NULL,10) > 0) local_int_tab2[1][(local_int_pos*6)+3]= strtoul(res,NULL,10);
			    else
			    {
    				syslog(LOG_ERR,"Wrong upload lospeed value in inter_int for %s interface.",local_int_tab[1][(local_int_pos*6)+1]);
				error("Wrong upload lospeed value in inter_int for %s interface.",local_int_tab[1][(local_int_pos*6)+1]);
			    }

	    		    // pobieramy upload_hispeed
	    		    res=strtok(NULL,";");
	    		    if (strtoul(res,NULL,10) > 0) local_int_tab2[1][(local_int_pos*6)+4]= strtoul(res,NULL,10);
			    else
			    {
    				syslog(LOG_ERR,"Wrong upload hispeed value in inter_int for %s interface.",local_int_tab[1][(local_int_pos*6)+1]);
				error("Wrong upload hispeed value in inter_int for %s interface.",local_int_tab[1][(local_int_pos*6)+1]);
			    }

	        	    // pobieramy numer IP
	    		    res=strtok(NULL,";");
	    		    if (!strcmp(res,"auto"))
	    		    {
				char	*ip;

    				if ((ip = get_mainip(local_int_tab[1][(local_int_pos*6)+1])))
				{
		    		    local_int_tab[1][(local_int_pos*6)+2]= (char *) calloc(strlen(ip)+2,sizeof(char));
	    	    		    strcpy(local_int_tab[1][(local_int_pos*6)+2],ip);
				}
				else
	    			{
	    	    		    syslog(LOG_ERR,"Can't read IP from %s interface.",local_int_tab[1][(local_int_pos*6)+1]);
	    	    	    	    error("Can't read IP from %s interface.\n",local_int_tab[1][(local_int_pos*6)+1]);
				}
			    }
	    		    else
	    		    {
	    			local_int_tab[1][(local_int_pos*6)+2]= (char *) calloc(strlen(res)+2,sizeof(char));
				strcpy(local_int_tab[1][(local_int_pos*6)+2],res);
			    }

	    		    // pobieramy numer klasy
	    		    res=strtok(NULL,"\n");
			    if (atoi(res)<1 || atoi(res)>255)
			    {
    				syslog(LOG_ERR,"wrong CBQ class identifier in inter_int for %s interface. Should be 1-255",local_int_tab[1][(local_int_pos*6)+1]);
				error("wrong CBQ class identifier in inter_int for %s interface. Should be 1-255",local_int_tab[1][(local_int_pos*6)+1]);
			    }
	    		    local_int_tab[1][(local_int_pos*6)+3]= (char *) calloc(strlen(res)+2,sizeof(char *));
	    		    strcpy(local_int_tab[1][(local_int_pos*6)+3],res);

        		    if (! interactive) syslog(LOG_INFO, "using IP %s for %s internet interface",local_int_tab[1][(local_int_pos*6)+2],local_int_tab[1][(local_int_pos*6)+1]);
	    		    local_int_pos++;
			}
			else
			{
			    error("device %s not exists - in line %d of %s file",res,nr_linii,fname);
			}
		    }
		    else
		    {
			error("syntax error in line %d of %s file",nr_linii,fname);
		    }
		}
		else
		{
	    	    syslog(LOG_ERR,"Too much interfaces.");
	    	    error("Too much interfaces.\n");
		}
	    }
	    else
	    if ((! strcmp("local_int",res)) && (! strcmp(res,"local_int")))
	    {
		if (local_int_pos < 11)
		{
		    if (count_char_in_string(buf_copy,';') == 4)
		    {
	    		local_int_tab[1] = (char **) realloc((char **) local_int_tab[1],sizeof(char *)*6*(local_int_pos+1));
	    	        local_int_tab2[1] = (int *) realloc((int *) local_int_tab2[1],sizeof(int)*6*(local_int_pos+1));
    
			// ustawiamy 0 dla lokalnych interfejsow
	    		local_int_tab2[1][(local_int_pos*6)+5] = 0;
    
    	    		// pobieramy nazwe interfejsu sieciowego
	    		res=strtok(NULL,";");
			if (is_device(res))
			{
			    local_int_tab[1][(local_int_pos*6)+1]= (char *) calloc(strlen(res)+2,sizeof(char));
	    		    strcpy(local_int_tab[1][(local_int_pos*6)+1],res);
    
	    		    // pobieramy przepustowosc interfejsu
			    res=strtok(NULL,";");
	    		    local_int_tab[1][(local_int_pos*6)+2]= (char *) calloc(strlen(res)+2,sizeof(char));
	    		    strcpy(local_int_tab[1][(local_int_pos*6)+2],res);

			    // pobieramy numer IP zrodlowy
	    	    	    res=strtok(NULL,";");
	    		    if (check_mask(res))
			    {
		    		local_int_tab[1][(local_int_pos*6)+3]= (char *) calloc(strlen(res)+2,sizeof(char));
				strcpy(local_int_tab[1][(local_int_pos*6)+3],res);
		    	        local_int_tab2[1][(local_int_pos*6)+1] = mask2hex(res);
			    }
	    		    else
	    		    {
		    		syslog(LOG_ERR,"Can't find mask for IP %s in local_int section - file %s/shaper.%d.cfg",res,CONFIG_DIR,shaperd_counter);
		    		error("Can't find mask for IP %s in local_int section - file %s/shaper.%d.cfg\nExiting\n",res,CONFIG_DIR,shaperd_counter);
			    }

			    // pobieramy numer IP interfejsu
	    		    res=strtok(NULL,";");
	    		    if (check_mask(res))
	    		    {
		    		local_int_tab[1][(local_int_pos*6)+4]= (char *) calloc(strlen(res)+2,sizeof(char));
		    		strcpy(local_int_tab[1][(local_int_pos*6)+4],res);
		    		local_int_tab2[1][(local_int_pos*6)+2] = mask2hex(res);
			    }
			    else
	    		    {
	    			syslog(LOG_ERR,"Can't find mask for IP %s in local_int section - file %s/shaper.%d.cfg",res,CONFIG_DIR,shaperd_counter);
			        error("Can't find mask for IP %s in local_int section - file %s/shaper.%d.cfg\nExiting\n",res,CONFIG_DIR,shaperd_counter);
			    }

			    // numer klasy
	    		    res=strtok(NULL,"\n");
			    if (atoi(res)<1 || atoi(res)>255)
			    {
    				syslog(LOG_ERR,"wrong CBQ class identifier in local_int for %s interface. Should be 1-255",local_int_tab[1][(local_int_pos*6)+1]);
				error("wrong CBQ class identifier in inter_int for %s interface. Should be 1-255",local_int_tab[1][(local_int_pos*6)+1]);
			    }
			    local_int_tab[1][(local_int_pos*6)+5]= (char *) calloc(strlen(res)+2,sizeof(char *));
			    strcpy(local_int_tab[1][(local_int_pos*6)+5],res);
    
    			    if (! interactive) syslog(LOG_INFO, "using IP %s for %s local interface",local_int_tab[1][(local_int_pos*6)+4],local_int_tab[1][(local_int_pos*6)+1]);
	    		    local_int_pos++;
			}
			else
			{
			    error("device %s not exists - in line %d of %s file",res,nr_linii,fname);
			}
		    }
		    else
		    {
			error("syntax error in line %d of %s file",nr_linii,fname);
		    }
		}
		else
		{
	    	    syslog(LOG_ERR,"Too much interfaces.");
	    	    error("Too much interfaces.\n");
		}
	    }
	}
    }
    fclose(fp);
    return(local_int_tab);
}

void reload_config(char *fname)
{
    int		nr_linii2 = 0;
    int		n;
    FILE	*fp;
    char	buf[1000];
    char	buf_copy[1000];
    char	*res;
    
    if (!(fp = fopen(fname,"r")))
    {
	syslog(LOG_ERR,"Can't reload configuration file %s",fname);
	return;
    }
    while ((fgets(buf,990,fp)) != NULL)
    {
	nr_linii2++;
	strcpy(buf_copy,buf);
	if (buf[0]!='#' && strlen(buf))
	{
	    res=strtok(buf,"=");
/*
	    if ((! strcmp("high_start_speed",res)) && (! strcmp(res,"high_start_speed")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) high_start_speed = 1;
		else
		if (!strcmp(res,"no")) high_start_speed = 0;
		else
	    	    high_start_speed = atoi(res);
	    }
	    else
*/
	    if ((! strcmp("start_speed",res)) && (! strcmp(res,"start_speed")))
	    {
		res = lower(strtok(NULL,"\n"));
	    	start_speed = atoi(res);
		if (start_speed < 0) start_speed = 0;
		if (start_speed > 255) start_speed = 255;
		syslog(LOG_INFO,"start_speed: %d",start_speed);
	    }
	    else
	    if ((! strcmp("ipchains_path",res)) && (! strcmp(res,"ipchains_path")))
	    {
		res = strtok(NULL,"\n");
		strncpy(ipchains_path,res,100);
		syslog(LOG_INFO,"ipchains_path: %s",ipchains_path);
	    }
	    else
	    if ((! strcmp("iptables_path",res)) && (! strcmp(res,"iptables_path")))
	    {
		res = strtok(NULL,"\n");
		strncpy(iptables_path,res,100);
		syslog(LOG_INFO,"iptables_path: %s",iptables_path);
	    }
	    else
	    if ((! strcmp("tc_path",res)) && (! strcmp(res,"tc_path")))
	    {
		res = strtok(NULL,"\n");
		strncpy(tc_path,res,100);
		syslog(LOG_INFO,"tc_path: %s",tc_path);
	    }
	    else
	    if ((! strcmp("even_division",res)) && (! strcmp(res,"even_division")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) even_division = 1;
		else
		if (!strcmp(res,"no")) even_division = 0;
		else
	    	    even_division = atoi(res);
	    }
	    else
	    if ((! strcmp("static_dnload",res)) && (! strcmp(res,"static_dnload")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) static_dnload_class = 1;
		else
		if (!strcmp(res,"no")) static_dnload_class = 0;
		else
	    	    static_dnload_class = atoi(res);
	    }
	    else
	    if ((! strcmp("static_upload",res)) && (! strcmp(res,"static_upload")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) static_upload_class = 1;
		else
		if (!strcmp(res,"no")) static_upload_class = 0;
		else
	    	    static_upload_class = atoi(res);
	    }
	    else
	    if ((! strcmp("always_max",res)) && (! strcmp(res,"always_max")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) always_max = 1;
		else
		if (!strcmp(res,"no")) always_max = 0;
		else
	    	    always_max = atoi(res);
	    }
	    else
	    if ((! strcmp("alt_natstat",res)) && (! strcmp(res,"alt_natstat")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) alt_natstat = 1;
		else
		if (!strcmp(res,"no")) alt_natstat = 0;
		else alt_natstat = atoi(res);
	    }
	    else
	    if ((! strcmp("continuous_control",res)) && (! strcmp(res,"continuous_control")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) continuous_control = 1;
		else
		if (!strcmp(res,"no")) continuous_control = 0;
		else
	    	    continuous_control = atoi(res);
	    }
	    else
	    if ((! strcmp("load_balancing",res)) && (! strcmp(res,"load_balancing")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) load_balancing = 1;
		else
		if (!strcmp(res,"no")) load_balancing = 0;
		else
	    	    load_balancing = atoi(res);
		if (load_balancing) syslog(LOG_INFO,"Load Balancing enabled.");
	    }
	    else
	    if ((! strcmp("common_limit",res)) && (! strcmp(res,"common_limit")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) common_limit = 1;
		else
		if (!strcmp(res,"no")) common_limit = 0;
		else
	    	    common_limit = atoi(res);
		if (! interactive && common_limit) syslog(LOG_INFO,"common_limit enabled.");
	    }
	    else
	    if ((! strcmp("total_limit",res)) && (! strcmp(res,"total_limit")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) total_limit = 1;
		else
		if (!strcmp(res,"no")) total_limit = 0;
		else
	    	    total_limit = atoi(res);
		if (! interactive && total_limit) syslog(LOG_INFO,"total_limit enabled.");
	    }
	    else
	    if ((! strcmp("ban_user",res)) && (! strcmp(res,"ban_user")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) ban_user = 1;
		else
		if (!strcmp(res,"no")) ban_user = 0;
		else
	    	    ban_user = atoi(res);
		if (! interactive && ban_user) syslog(LOG_INFO,"ban_user enabled.");
    	    }
	    else
	    if ((! strcmp("max_ban_download",res)) && (! strcmp(res,"max_ban_download")))
	    {
		res = strtok(NULL,"\n");
	        max_ban_download = atoi(res);
	    }
	    else
	    if ((! strcmp("max_ban_upload",res)) && (! strcmp(res,"max_ban_upload")))
	    {
		res = strtok(NULL,"\n");
	        max_ban_upload = atoi(res);
	    }
	    else
	    if ((! strcmp("jump_type",res)) && (! strcmp(res,"jump_type")))
	    {
		res = strtok(NULL,"\n");
	        jump_type = atoi(res);
	    }
	    else
	    if ((! strcmp("write_type",res)) && (! strcmp(res,"write_type")))
	    {
		res = strtok(NULL,"\n");
	        output_type = atoi(res);
	    }
	    else
	    if ((! strcmp("timeout_ipchains_22",res)) && (! strcmp(res,"timeout_ipchains_22")))
	    {
		res = strtok(NULL,"\n");
	        timeout_ipchains_22 = atoi(res);
	    }
	    else
	    if ((! strcmp("timeout_ipchains_24",res)) && (! strcmp(res,"timeout_ipchains_24")))
	    {
		res = strtok(NULL,"\n");
	        timeout_ipchains_24 = atoi(res);
	    }
	    else
	    if ((! strcmp("timeout_iptables_24",res)) && (! strcmp(res,"timeout_iptables_24")))
	    {
		res = strtok(NULL,"\n");
	        timeout_iptables_24 = atoi(res);
	    }
	    else
	    if ((! strcmp("timeout_global",res)) && (! strcmp(res,"timeout_global")))
	    {
		res = strtok(NULL,"\n");
	        timeout_global = atoi(res);
	    }
	    else
	    if ((! strcmp("delta_factor",res)) && (! strcmp(res,"delta_factor")))
	    {
		res = strtok(NULL,"\n");
	        delta_factor = atoi(res);
	    }
	    else
	    if ((! strcmp("check_download_factor_cnt",res)) && (! strcmp(res,"check_download_factor_cnt")))
	    {
		res = strtok(NULL,"\n");
	        check_factor_cnt = atoi(res);
	    }
	    else
	    if ((! strcmp("check_download_factor",res)) && (! strcmp(res,"check_download_factor")))
	    {
		res = strtok(NULL,"\n");
	        check_download_factor = atoi(res);
	    }
	    else
	    if ((! strcmp("check_upload_factor_cnt",res)) && (! strcmp(res,"check_upload_factor_cnt")))
	    {
		res = strtok(NULL,"\n");
	        check_upload_factor_cnt = atoi(res);
	    }
	    else
	    if ((! strcmp("check_upload_factor",res)) && (! strcmp(res,"check_upload_factor")))
	    {
		res = strtok(NULL,"\n");
	        check_upload_factor = atoi(res);
	    }
	    else
	    if ((! strcmp("burst_type",res)) && (! strcmp(res,"burst_type")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"current")) burst_type = 1;
		else
		if (!strcmp(res,"maximum")) burst_type = 0;
		else
	    	    burst_type = atoi(res);
	    }
	    else
	    if ((! strcmp("cburst_type",res)) && (! strcmp(res,"cburst_type")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"current")) cburst_type = 1;
		else
		if (!strcmp(res,"maximum")) cburst_type = 0;
		else
	    	    cburst_type = atoi(res);
	    }
	    else
	    if ((! strcmp("htb_burst",res)) && (! strcmp(res,"htb_burst")))
	    {
		res = strtok(NULL,"\n");
	        htb_burst = atoi(res);
		if (htb_burst < 0) htb_burst = 0;
		else
		if (htb_burst > 32) htb_burst = 32;
	    }
	    else
	    if ((! strcmp("htb_cburst",res)) && (! strcmp(res,"htb_cburst")))
	    {
		res = strtok(NULL,"\n");
	        htb_cburst = atoi(res);
		if (htb_cburst < 0) htb_cburst = 0;
		else
		if (htb_cburst > 32) htb_cburst = 32;
	    }
	    else
	    if ((! strcmp("ceil_download",res)) && (! strcmp(res,"ceil_download")))
	    {
		res = strtok(NULL,"\n");
	        ceil_download = atoi(res);
		if (ceil_download < 0) ceil_download = 0;
	    }
	    else
	    if ((! strcmp("ceil_upload",res)) && (! strcmp(res,"ceil_upload")))
	    {
		res = strtok(NULL,"\n");
	        ceil_upload = atoi(res);
		if (ceil_upload < 0) ceil_upload = 0;
	    }
	    else
	    if ((! strcmp("natstat_download_sensivity",res)) && (! strcmp(res,"natstat_download_sensivity")))
	    {
		res = strtok(NULL,"\n");
	        natstat_sensivity = atoi(res);
		if (natstat_sensivity < 1) natstat_sensivity = 1;
	    }
	    else
	    if ((! strcmp("natstat_upload_sensivity",res)) && (! strcmp(res,"natstat_upload_sensivity")))
	    {
		res = strtok(NULL,"\n");
	        natstat_upload_sensivity = atoi(res);
		if (natstat_upload_sensivity < 1) natstat_upload_sensivity = 1;
	    }
	    else
	    if ((! strcmp("default_download_limit",res)) && (! strcmp(res,"default_download_limit")))
	    {
		res = strtok(NULL,"\n");
//	        default_download_limit = strtoul(res,NULL,10);
	        default_download_limit = atof(res);
		if (default_download_limit < 0) default_download_limit = 0;
//		if (default_download_limit) syslog(LOG_INFO,"Default download limit is %lu.",default_download_limit);
		if (default_download_limit) syslog(LOG_INFO,"Default download limit is %.0f.",default_download_limit);
	    }
	    else
	    if ((! strcmp("default_upload_limit",res)) && (! strcmp(res,"default_upload_limit")))
	    {
		res = strtok(NULL,"\n");
//	        default_upload_limit = strtoul(res,NULL,10);
	        default_upload_limit = atof(res);
		if (default_upload_limit < 0) default_upload_limit = 0;
//		if (default_upload_limit) syslog(LOG_INFO,"Default upload limit is %lu.",default_upload_limit);
		if (default_upload_limit) syslog(LOG_INFO,"Default upload limit is %.0f.",default_upload_limit);
	    }
	    else
	    if ((! strcmp("default_download_hispeed",res)) && (! strcmp(res,"default_download_hispeed")))
	    {
		res = strtok(NULL,"\n");
	        default_download_limit_hispeed = strtoul(res,NULL,10);
		if (default_download_limit_hispeed < 0) default_download_limit_hispeed = 0;
		if (default_download_limit_hispeed) syslog(LOG_INFO,"Default download hispeed is %lu%s.",default_download_limit_hispeed,speed_ext);
	    }
	    else
	    if ((! strcmp("default_upload_hispeed",res)) && (! strcmp(res,"default_upload_hispeed")))
	    {
		res = strtok(NULL,"\n");
	        default_upload_limit_hispeed = strtoul(res,NULL,10);
		if (default_upload_limit_hispeed < 0) default_upload_limit_hispeed = 0;
		if (default_upload_limit_hispeed) syslog(LOG_INFO,"Default upload hispeed is %lu%s.",default_upload_limit_hispeed,speed_ext);
	    }
	    else
	    if ((! strcmp("remove_dead_class",res)) && (! strcmp(res,"remove_dead_class")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) remove_dead_class = 1;
		else
		if (!strcmp(res,"no")) remove_dead_class = 0;
		else
	    	    remove_dead_class = atoi(res);
	    }
	    else
	    if ((! strcmp("refresh_dead_fwrule",res)) && (! strcmp(res,"refresh_dead_fwrule")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) refresh_dead_fwrule = 1;
		else
		if (!strcmp(res,"no")) refresh_dead_fwrule = 0;
		else
	    	    refresh_dead_fwrule = atoi(res);
	    }
	    else
	    if ((! strcmp("pos_diff",res)) && (! strcmp(res,"pos_diff")))
	    {
		int	f;
	    
		res = strtok(NULL,"\n");
	        f = atoi(res);
		if (f > 0)
		{
		    pos_diff = f;
		}
	    }
	    else
	    if ((! strcmp("nop_factor",res)) && (! strcmp(res,"nop_factor")))
	    {
		int	f;
	    
		res = strtok(NULL,"\n");
	        f = atoi(res);
		if (f > 0 && f < 99)
		{
		    nop_factor = f;
		    if (! interactive) syslog(LOG_INFO,"setting nop_factor to %d",nop_factor);
		}
		else syslog(LOG_ERR,"nop_factor must be 1-98");
	    }
	    else
	    if ((! strcmp("add_factor",res)) && (! strcmp(res,"add_factor")))
	    {
		int	f;
	    
		res = strtok(NULL,"\n");
	        f = atoi(res);
		if (f > 0 && f < 100)
		{
		    add_factor = f;
		    if (! interactive) syslog(LOG_INFO,"setting add_factor to %d",add_factor);
		}
		else syslog(LOG_ERR,"add_factor must be 1-99");
	    }
	    else
	    if ((! strcmp("check_sum_of_bandwidth",res)) && (! strcmp(res,"check_sum_of_bandwidth")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) check_sum_of_bandwidth = 1;
		else
		if (!strcmp(res,"no")) check_sum_of_bandwidth = 0;
		else
		    check_sum_of_bandwidth = atoi(res);
		if (check_sum_of_bandwidth) syslog(LOG_INFO,"Check sum of bandwidth enabled");

	    }
	    else
	    if ((! strcmp("squid_support",res)) && (! strcmp(res,"squid_support")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"rules_only")) squid = 2;
		else
		if (!strcmp(res,"yes")) squid = 1;
		else
		if (!strcmp(res,"no")) squid = 0;
		else
	    	    squid = atoi(res);
	        if (squid==1 && !interactive) syslog(LOG_INFO,"squid_support active");
		else
		if (squid==2 && !interactive) syslog(LOG_INFO,"squid_support rules_only");

	    }
	    else
	    if ((! strcmp("squid_port",res)) && (! strcmp(res,"squid_port")))
	    {
		res = strtok(NULL,"\n");
		if (atoi(res) > 0 && atoi(res) < 65536) squid_port = atoi(res);
		else syslog(LOG_ERR,"Invalid value of squid_port. Setting %d value.",squid_port);
	    }
	    else
	    if ((! strcmp("squid_factor",res)) && (! strcmp(res,"squid_factor")))
	    {
		res = strtok(NULL,"\n");
		if (atof(res) > 0 && atof(res) < 100) squid_factor = atof(res);
		else syslog(LOG_ERR,"Invalid value of squid_factor. Setting %f value.",squid_factor);
	    }
	    else
	    if ((! strcmp("divide_upload",res)) && (! strcmp(res,"divide_upload")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) divide_upload = 1;
		else
		if (!strcmp(res,"no")) divide_upload = 0;
		else
	    	    divide_upload = atoi(res);
	        if (divide_upload && !interactive) syslog(LOG_INFO,"divide_upload active");
	    }
	    else
	    if ((! strcmp("nomasq",res)) && (! strcmp(res,"nomasq")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) nomasq = 1;
		else
		if (!strcmp(res,"no")) nomasq = 0;
		else
	    	    nomasq = atoi(res);
	        if (nomasq && !interactive) syslog(LOG_INFO,"masquerade control deactivated");
	    }
	    else
	    if ((! strcmp("class_type",res)) && (! strcmp(res,"class_type")))
	    {
	        res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"cbq")) class_type = 0;
		else
		if (!strcmp(res,"htb")) class_type = 1;
		else
		if (!strcmp(res,"ehtb")) class_type = 2;
		else
		if (!strcmp(res,"shtb")) class_type = 3;
		
		if (class_type == 1 && !interactive) syslog(LOG_INFO,"HTB Download Class type activated");
		else
		if (class_type == 2 && !interactive) syslog(LOG_INFO,"EHTB Download Class type activated");
		else
		if (class_type == 3 && !interactive) syslog(LOG_INFO,"SHTB Download Class type activated");

		free(res);
	    }
	    else
	    if ((! strcmp("extended_queue",res)) && (! strcmp(res,"extended_queue")))
	    {
	        res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) extended_queue = 1;
		else
		if (!strcmp(res,"no")) extended_queue = 0;
		if (extended_queue && !interactive) syslog(LOG_INFO,"Extended queue activated");
		free(res);
	    }
	    else
	    if ((! strcmp("debug_output",res)) && (! strcmp(res,"debug_output")))
	    {
	        strcpy(output,strtok(NULL,"\n"));
	    }
	    else
	    if ((! strcmp("upload_class_type",res)) && (! strcmp(res,"upload_class_type")))
	    {
	        res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"cbq")) upload_class_type = 0;
		else
		if (!strcmp(res,"htb")) upload_class_type = 1;
		else
		if (!strcmp(res,"ehtb")) upload_class_type = 2;
		else
		if (!strcmp(res,"shtb")) upload_class_type = 3;

		if (upload_class_type == 1 && !interactive) syslog(LOG_INFO,"HTB Upload Class type activated");
		else
		if (upload_class_type == 2 && !interactive) syslog(LOG_INFO,"EHTB Upload Class type activated");
		else
		if (upload_class_type == 3 && !interactive) syslog(LOG_INFO,"SHTB Upload Class type activated");
		free(res);
	    }
	    else
	    if ((! strcmp("speed_ext",res)) && (! strcmp(res,"speed_ext")))
	    {
	        res = lower(strtok(NULL,"\n"));
	        if (! strcmp(res,"kbit") || ! strcmp(res,"mbit")) strncpy(speed_ext,res,10);
	        else strncpy(speed_ext,"\0",10);
		free(res);
	    }
	    else
	    if ((! strcmp("debug",res)) && (! strcmp(res,"debug")))
	    {
	        res = strtok(NULL,"\n");
	        debug = atoi(res);
	    }
	    else
	    if ((! strcmp("notc",res)) && (! strcmp(res,"notc")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) notc = 1;
		else
		if (!strcmp(res,"no")) notc = 0;
		else
	    	    notc = atoi(res);
	    }
	    else
	    if ((! strcmp("delay_mesg",res)) && (! strcmp(res,"delay_mesg")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) delay_mesg = 1;
		else
		if (!strcmp(res,"no")) delay_mesg = 0;
		else
	    	    delay_mesg = (short) atoi(res);
	    }
	    else
	    if ((! strcmp("mask_mesg",res)) && (! strcmp(res,"mask_mesg")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) mask_mesg = 1;
		else
		if (!strcmp(res,"no")) mask_mesg = 0;
		else
	    	    mask_mesg = (short) atoi(res);
	    }
	    else
	    if ((! strcmp("control_mesg",res)) && (! strcmp(res,"control_mesg")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) control_mesg = 1;
		else
		if (!strcmp(res,"no")) control_mesg = 0;
		else
	    	    control_mesg = (short) atoi(res);
	    }
	    else
	    if ((! strcmp("enable_eir_factor",res)) && (! strcmp(res,"enable_eir_factor")))
	    {
		res = lower(strtok(NULL,"\n"));
		if (!strcmp(res,"yes")) enable_eir_factor = 1;
		else
		if (!strcmp(res,"no")) enable_eir_factor = 0;
		else
	    	    enable_eir_factor = (short) atoi(res);
	    }
	    else
	    if ((! strcmp("delay",res)) && (! strcmp(res,"delay")))
	    {
	        res = strtok(NULL,"\n");
	        delay = atoi(res);
	        if (delay < 10) delay = 10;
	    }
	    else
	    if ((! strcmp("write_delay",res)) && (! strcmp(res,"write_delay")))
	    {
	        res = strtok(NULL,"\n");
	        olddelay = atoi(res);
	        if (olddelay < 0) olddelay = 0;
	    }
	    else
	    if ((! strcmp("write_last_rate",res)) && (! strcmp(res,"write_last_rate")))
	    {
	        res = strtok(NULL,"\n");
	        lastrate_numcycles = atoi(res);
	        if (lastrate_numcycles < 0) lastrate_numcycles = 0;
		if (! interactive && lastrate_numcycles) syslog(LOG_INFO,"Write LastRate every %d cycle(s).",lastrate_numcycles);
	    }
	    else
	    if ((! strcmp("last_rate_perm",res)) && (! strcmp(res,"last_rate_perm")))
	    {
	        res = strtok(NULL,"\n");
		sscanf(res,"%3o",&last_state_perm);
	    }
	    else
	    if ((! strcmp("check_firewall_counters",res)) && (! strcmp(res,"check_firewall_counters")))
	    {
	        res = strtok(NULL,"\n");
	        check_firewall_numcycles = atoi(res);
	        if (check_firewall_numcycles < 0) check_firewall_numcycles = 0;
		if (! interactive && check_firewall_numcycles) syslog(LOG_INFO,"Check firewall counters every %d cycle(s).",check_firewall_numcycles);
	    }
	    else
	    if ((! strcmp("inter_int",res)) && (! strcmp(res,"inter_int")))
	    {
		int	fin = 0;

	        // pobieramy nazwe interfejsu internetowego
		res=strtok(NULL,";");

		for(n=1;n<local_int_pos;n++)
		{
		    if (!strcmp(config[1][(n*6)+1],res) && !strcmp(res,config[1][(n*6)+1]))
		    {
			fin = 1;
			break;
		    }
		}
		
		if (fin && is_device(res))
		{
    		    // pobieramy lospeed
	    	    res=strtok(NULL,";");
	    	    local_int_tab2[1][(n*6)+1]= strtoul(res,NULL,10);

    		    // pobieramy hispeed
	    	    res=strtok(NULL,";");
	    	    local_int_tab2[1][(n*6)+2]= strtoul(res,NULL,10);

        	    // pobieramy upload_lospeed
	    	    res=strtok(NULL,";");
	    	    local_int_tab2[1][(n*6)+3]= strtoul(res,NULL,10);

    		    // pobieramy upload_hispeed
	    	    res=strtok(NULL,";");
	    	    local_int_tab2[1][(n*6)+4]= strtoul(res,NULL,10);

	    	    // pobieramy numer IP
	    	    res=strtok(NULL,";");
	    	    if (!strcmp(res,"auto"))
	    	    {
		        char	*ip;

    			if ((ip = get_mainip(config[1][(n*6)+1])))
			{
		    	    config[1][(n*6)+2]= (char *) realloc((char *) config[1][(n*6)+2],sizeof(char)*strlen(ip)+2);
	    	    	    strcpy(config[1][(n*6)+2],ip);
			}
			else
	    		{
	    	    	    syslog(LOG_ERR,"Can't read IP from %s interface.",config[1][(n*6)+1]);
			}
		    }
	    	    else
	    	    {
		        config[1][(n*6)+2]= (char *) realloc((char *) config[1][(n*6)+2],sizeof(char)*strlen(res)+2);
		        strcpy(config[1][(n*6)+2],res);
		    }

	    	    // pobieramy numer klasy
	    	    res=strtok(NULL,"\n");
		    if (atoi(res)<1 || atoi(res)>255)
		    {
    		        syslog(LOG_ERR,"wrong CBQ class identifier in inter_int for %s interface. Should be 1-255",config[1][(n*6)+1]);
		    }
		    else
		    {
			config[1][(n*6)+3]= (char *) realloc((char *) config[1][(n*6)+3],sizeof(char)*strlen(res)+2);
	    	        strcpy(config[1][(n*6)+3],res);
		    }

        	    if (! interactive) syslog(LOG_INFO, "using IP %s for %s internet interface",config[1][(n*6)+2],config[1][(n*6)+1]);
		}
		else
		{
		    syslog(LOG_ERR,"device %s not exists - in line %d of %s file",res,nr_linii2,fname);
		}
	    }
	    else
	    if ((! strcmp("local_int",res)) && (! strcmp(res,"local_int")))
	    {
		int	fin = 0;
	    
    		// pobieramy nazwe interfejsu sieciowego
	    	res=strtok(NULL,";");
		for(n=1;n<local_int_pos;n++)
		{
		    if (!strcmp(config[1][(n*6)+1],res) && !strcmp(res,config[1][(n*6)+1]))
		    {
			fin = 1;
			break;
		    }
		}

	    	// ustawiamy 0 dla lokalnych interfejsow
	    	local_int_tab2[1][(n*6)+5] = 0;
    
		if (fin && is_device(res))
//		   if (is_device(res))
		{
	    	    // pobieramy przepustowosc interfejsu
		    res=strtok(NULL,";");
    		    config[1][(n*6)+2]= (char *) realloc((char *) config[1][(n*6)+2],sizeof(char)*strlen(res)+2);
	    	    strcpy(config[1][(n*6)+2],res);

		    // pobieramy numer IP zrodlowy
	    	    res=strtok(NULL,";");
	    	    if (check_mask(res))
		    {
    		        config[1][(n*6)+3]= (char *) realloc((char *) config[1][(n*6)+3],sizeof(char)*strlen(res)+2);
		        strcpy(config[1][(n*6)+3],res);
		        local_int_tab2[1][(n*6)+1] = mask2hex(res);
		    }
	    	    else
	    	    {
		        syslog(LOG_ERR,"Can't find mask for IP %s in local_int section - file %s/shaper.%d.cfg",res,CONFIG_DIR,shaperd_counter);
		    }

		    // pobieramy numer IP interfejsu
	    	    res=strtok(NULL,";");
	    	    if (check_mask(res))
	    	    {
    			config[1][(n*6)+4]= (char *) realloc((char *) config[1][(n*6)+4],sizeof(char)*strlen(res)+2);
			strcpy(config[1][(n*6)+4],res);
		    	local_int_tab2[1][(n*6)+2] = mask2hex(res);
		    }
		    else
	    	    {
	    	        syslog(LOG_ERR,"Can't find mask for IP %s in local_int section - file %s/shaper.%d.cfg",res,CONFIG_DIR,shaperd_counter);
		    }

		    // numer klasy
	    	    res=strtok(NULL,"\n");
		    if (atoi(res)<1 || atoi(res)>255)
		    {
    		        syslog(LOG_ERR,"wrong CBQ class identifier in local_int for %s interface. Should be 1-255",config[1][(n*6)+1]);
		    }
		    else
		    {
    		        config[1][(n*6)+5]= (char *) realloc((char *) config[1][(n*6)+5],sizeof(char)*strlen(res)+2);
		        strcpy(config[1][(n*6)+5],res);
		    }
    
    		    if (! interactive) syslog(LOG_INFO, "using IP %s for %s local interface",config[1][(n*6)+4],config[1][(n*6)+1]);
		}
		else
		{
		    syslog(LOG_ERR,"device %s not exists - in line %d of %s file",res,nr_linii2,fname);
		}
	    }
	}
    }
    fclose(fp);
}

void free_config(char ***local_int_tab)
{
    int	m,n;

    if (local_int_pos > 1)
    {
	for(m=1;m<local_int_pos;m++)
	{
	    for(n=1;n<6;n++)
		free(local_int_tab[1][(m*6)+n]);
	}
	free(local_int_tab[1]);
	free(local_int_tab2[1]);
	free(local_int_tab);
	free(local_int_tab2);
	local_int_pos = 1;
    }
}

void free_config_new(char ***local_int_tab_,int **local_int_tab2_,int pos)
{
    int	m,n;

    if (local_int_tab_)
    {
	for(m=1;m<pos;m++)
	{
	    for(n=1;n<6;n++)
		free(local_int_tab_[1][(m*6)+n]);
	}
	free(local_int_tab_[1]);
	free(local_int_tab2_[1]);
	free(local_int_tab_);
	free(local_int_tab2_);
    }
}

unsigned int get_local_int_numbers(char ***config)
{
    int			n;
    unsigned int	m=0;

    for(n=1;n<local_int_pos;n++)
    {
	if (!(local_int_tab2[1][(n*6)+5])) m++;
    }
    return(m);
}
