/*
**
** (C) 2004 Grzegorz Fitrzyk SP9WUN
**   email: sp9wun@poczta.onet.pl
**    http://sp9wun.republika.pl/
**
*/

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <math.h>
#include <syslog.h>
#include <signal.h>
#include <setjmp.h>
#include <time.h>

#include "shaperd_config.h"
#include "shaperd_old.h"
#include "read_config.h"
#include "read_iplist.h"
#include "firewall.h"

#define IP_CONNTRACK 	"/proc/net/ip_conntrack"
#define DEVFILE		"/proc/net/dev"

#define MAX_FIREWALL_VALUE	2147483647

extern struct IPLISTA *iplista_str;

jmp_buf   		env_buf;

int			exit_signal = 0;
int			reload_signal = 0;
int			clear_signal = 0;
int			diff_signal = 0;

static struct		FLAGI	flagi;

int			natstat_tab_pos = 0;
int			natstat_tab_pos_upload = 0;

int			iplista_pos = 0;

int			**local_int_tab2 = NULL;
int			local_int_pos = 1;
int			**local_int_tab2_new = NULL;
int			local_int_pos_new = 1;

int			bitrate_user_last_pos[10];
int			bitrate_user_last_pos_upload[10];
int			ignore_pos = 1;
char			**devlist;
int			devlist_pos = 1;
int			masqip_pos[11];
int			masqip_pos_upload[11];
int			kernel_type = 0;
long unsigned int	total_dnload_cir = 0;
long unsigned int	total_upload_cir = 0;

// Config
char		ipchains_path[100];
char		iptables_path[100];
char		tc_path[100];

int			upload_control = 0;
int			start_speed = 0;
int			even_division = 0;
int			alt_natstat = 1;
int			continuous_control = 1;
int			squid = 0;
int			squid_ingress = 0;
int			squid_port = 8192;
float			squid_factor = 1.0;
int			timeout_ipchains_22 = 300;
int			timeout_ipchains_24 = 7200;
int			timeout_iptables_24 = 432000;
int			timeout_global = 300;
int			nomasq = 1;
int			nomasq_cycles = 3;
int			jump_type = 0;
int			nop_factor = 50;
int			add_factor = 75;
int			htb_r2q = 40;
int			divide_upload = 0;
int			quick_start = 0;
int			delta_factor = 5;
short			output_type = 0; // wyglad wyswietlanych przydzialow
unsigned long int	speed_out = 70000;
unsigned int		natstat_sensivity = 5000;		// min. szybkosc wyslanych danych do przydzialu widelek
unsigned int		natstat_upload_sensivity = 5000;	// min. szybkosc wyslanych danych do przydzialu widelek
char			speed_ext[10] = "\0";
int			delay	= 10;
int			olddelay = 1;
int			debug = 0;
int			notc = 0;
int			class_type = 0; // 0-CBQ 1-HTB 2-EHTB 3-SHTB
int			extended_queue = 0;
int			upload_class_type = 0; // 0-CBQ 1-HTB 2-EHTB 3-SHTB
int			check_always = 1;
int			check_sum_of_bandwidth = 1;
int			shaperd_counter = 0;
int			always_max = 0;
char			output[100] = "/dev/null";
char			configfile[100];
char			pidfile[100];
char			ignorefile[100];
char			iplistfile[100];
char			oldfile[100];
char			oldfile_upload[100];
char			lastrate[100];
char			difffile[100];
unsigned int		cnt[10][256];	// tablica licznikow klas
int			mult = 1;
short			htb_quantum = 0; // 1 - jesli tc ma opcje quantum dla htb
short			burst_type = 1; // 1 - t_speed, 0 - max_speed
short			cburst_type = 1; // 1 - t_speed, 0 - max_speed
short			htb_burst = 0;
short			htb_cburst = 0;
short			min_factor = 10;
short			check_download_factor = 50;
short			check_upload_factor = 50;
short			check_factor_cnt = 5;
short			check_upload_factor_cnt = 5;
short			remove_dead_class = 0; // 1 - jesli jakas klasa nie bedzie kontrolowac transferu to ja usun
short			refresh_dead_fwrule = 0; // 1 - jesli jakas klasa nie bedzie kontrolowac transferu to odswierz regulki
short			delay_mesg = 1; // 0 - wylacza komunikaty delay
short			mask_mesg = 1; // 0 - wylacza komunikaty "Can't find mask for ..."
short			control_mesg = 1; // 0 - wylacza komunikaty "Can't control bandwidth of ... IP"
short			static_dnload_class = 0; // 1 - wlacza statyczny podzial
short			static_upload_class = 0; // 1 - wlacza statyczny podzial
// ZQ *//
short			extended_download_limits = 0; //rozszerzona obsluga limitow
short			common_limit = 0; // 1 - przekroczenie jednego z limitow powoduje zalaczenie ograniczen w obu kierunkach
short			total_limit = 0; // 1 - przekroczenie sumy wszystkich limitow przez sume wszystkich licznikow powoduje zalaczenie ograniczen w obu kierunkach
unsigned long int	ceil_download = 10;
unsigned long int       ceil_upload = 10;
/*
unsigned long int	default_download_limit = 0; // globalny limit ilosci pobranych danych
unsigned long int	default_upload_limit = 0; // globalny limit ilosci wyslanych danych
*/
double			default_download_limit = 0; // globalny limit ilosci pobranych danych
double			default_upload_limit = 0; // globalny limit ilosci wyslanych danych
unsigned long int	default_download_limit_hispeed = 0; // globalna wartosc EIR po przekroczeniu limitu download
unsigned long int	default_upload_limit_hispeed = 0; // globalna wartosc EIR po przekroczeniu limitu upload
short			interactive = 0;
int			firewall_type = 0;
int			lastrate_numcycles = 0; // co ile cykli ma byc zapisywany stan licznikow. 1 - co kazdy, 0 - wyl.
int			last_state_perm = 0600; // prawa dostpu do pliku last.X
int			check_firewall_numcycles = 12; // co ile cykli ma byc sprawdzany stan licznikow firewalla i w razie ich przepelnienia zerowany
short			enable_eir_factor = 0; // 1 - przydzialy proporcjonalne do EIR 
short			alt_thandle = 0; //alternatywny sposob zmieniania opoznienia (+1s)
short			ban_user = 0; // 1 - wlaczamy banowanie na firewallu userow przekraczajacych widelki
unsigned short		default_ban_download_cnt = 1; // na ile cykli ma byc robiony ban na firewallu w przypadku przelamania klasy
unsigned short		default_ban_upload_cnt = 1; // na ile cykli ma byc robiony ban na firewallu w przypadku przelamania klasy
unsigned short		default_ban_download_cnt2 = 360; // co ile cykli moze shaper usuwac klase w przypadku przelamania klasy (dla ban_user)
unsigned short		default_ban_upload_cnt2 = 360; // co ile cykli moze shaper usuwac klase w przypadku przelamania klasy (dla ban_user)
unsigned short		max_ban_download = 5; // na max ile cykli moze byc nalozony ban (dla ban_user)
unsigned short		max_ban_upload = 5; // na max ile cykli moze byc nalozony ban (dla ban_user)
char			***config;

char			***bitrate_user_last[10];
char			***bitrate_user_last_upload[10];

extern int      	load_balancing;

static int daemonize(void);


int old_main(int argc, char *argv[])
{
    int			n;
    int			nr[10];
    int			nr_upload[10];
    char		***nattab;
    char		***nattab_upload;
    char		***speed_tab[10];
    char		***del_tab[10];
    char		***speed_tab_upload[10];
    char		***del_tab_upload[10];
    char		**lista;
    char		**ignore;
    char		**masq[10];
    char		**masq_upload[10];
    int			*masq_factor[10];
    int			*masq_upload_factor[10];
    char		*str;
    unsigned long int	speed[10];
    unsigned long int	speed_upload[10];
    unsigned long int	tspeed;
    unsigned long int	even_speed;
    long int		reszta[10];
    long int		reszta_upload[10];
/** ZQ **/
    unsigned long int   *currbitrate_tab;
	long int   *lastbitrate_tab;
    unsigned long int   currbitrate;
    unsigned long int   currbitrate_total;
    long int		lastbitrate;
    int			ilip[10];
    int			ilip_upload[10];
    int			log;
    int			old = olddelay;
    int			ipcol = 0;
    int			start_time;
    int			start_loop;
    int			delta_time;
    int			loop_time;
    int			check_time;
    int			delay_org;
    int			int_cnt;
    int			lastrate_cnt;
    int			check_firewall_cnt;
    char		***config_new;
    unsigned int	reload_signal2 = 0;
    int			*iplista_work[11]; // lista wszystkich pracujacych numerow ip na wszystkich interfejsach
    
    log = 1;

    for(n=0;n<10;n++)
    {
	bitrate_user_last[n] = NULL;
	bitrate_user_last_upload[n] = NULL;
	bitrate_user_last_pos[n] = 0;
	bitrate_user_last_pos_upload[n] = 0;
	iplista_work[n] = NULL;
    }

    strcpy(ipchains_path,"/sbin/ipchains");
    strcpy(iptables_path,"/sbin/iptables");
    strcpy(tc_path,"/sbin/tc");
    
    // Start syslog
    if (log)
    {
	char	buf[20];
	
	sprintf(buf,"shaperd%d",shaperd_counter);
        openlog(buf, LOG_CONS|LOG_PERROR, LOG_DAEMON);
	openlog(buf, LOG_CONS, LOG_DAEMON);
    }

    if ((int) signal(SIGTERM, exit_handler) == -1)
    {
	syslog(LOG_ERR,"Cannot setup SIGTERM handler.");
	syslog(LOG_ERR,"Exit.");
	error("Cannot setup SIGTERM handler.\nExiting\n");
    }

    if ((int) signal(SIGHUP, reload_handler) == -1)
    {
	syslog(LOG_ERR,"Cannot setup SIGHUP handler.");
	syslog(LOG_ERR,"Exit.");
	error("Cannot setup SIGHUP handler.\nExiting\n");
    }

    if ((int) signal(SIGUSR1, clear_handler) == -1)
    {
	syslog(LOG_ERR,"Cannot setup SIGUSR1 handler.");
	syslog(LOG_ERR,"Exit.");
	error("Cannot setup SIGUSR1 handler.\nExiting\n");
    }

    if ((int) signal(SIGUSR2, diff_handler) == -1)
    {
	syslog(LOG_ERR,"Cannot setup SIGUSR2 handler.");
	syslog(LOG_ERR,"Exit.");
	error("Cannot setup SIGUSR2 handler.\nExiting\n");
    }

    // Sprawdzamy czy pakiet iproute2 jest zainstalowany
    if (!is_iproute2())
    {
	syslog(LOG_ERR,"Package iproute2 not found.");
	syslog(LOG_ERR,"Exit.");
	error("Package iproute2 not found.\nExiting\n");
    }

    // Sprawdzamy czy w kernelu jest obsluga QoS
    if (!is_qos())
    {
	syslog(LOG_ERR,"This kernel don't supporte QoS - recompile it with QoS support enabled.");
	syslog(LOG_ERR,"Exit.");
	error("This kernel don't supporte QoS - recompile it with QoS support enabled.\nExiting\n");
    }

    // sprawdzamy wersje kernela
    kernel_type = check_linux();

    // sprawdzamy, ktora wersje konfiguracji wczytac
    if (argc>1)
    {
	char    *p;
			
	for(n=1;n<argc;n++)
	{
	    if (strstr(argv[n],"-config="))
	    {
		p = strtok(argv[n],"=");
		p = strtok(NULL," ");
		if (p)
		{
		    shaperd_counter = atoi(p);
		    if (shaperd_counter < 0 || shaperd_counter > 9)
		    {
			syslog(LOG_ERR,"value of config type out of range. Should be 0-9.\nExiting.\n");
			error("value of config type out of range. Should be 0-9.\nExiting.\n");
		    }
		}
	    }
	}

	for(n=1;n<argc;n++)
	{
	    if (strstr(argv[n],"shownat"))
	    {
		interactive = 1;
		break;
	    }
	}
    }

    sprintf(configfile,"%s/shaper.%d.cfg",CONFIG_DIR,shaperd_counter);
    sprintf(pidfile,"%s/shaperd.%d.pid",PID_DIR,shaperd_counter);
    sprintf(ignorefile,"%s/ignore.%d",CONFIG_DIR,shaperd_counter);
    sprintf(iplistfile,"%s/iplist.%d",CONFIG_DIR,shaperd_counter);
    sprintf(oldfile,"%s/bitrate_user_sh.%d.old",RUNTIME_DIR,shaperd_counter);
    sprintf(oldfile_upload,"%s/bitrate_user_up.%d.old",RUNTIME_DIR,shaperd_counter);
    sprintf(lastrate,"%s/last.%d",RUNTIME_DIR,shaperd_counter);
    sprintf(difffile,"%s/diff.%d",RUNTIME_DIR,shaperd_counter);

    // czytamy liste interfejsow w systemie
    if (debug>2) printf("debug 3: reading list of system interfaces\n");
    lista = dev_list();

    // czytamy plik konfiguracyjny
    if (debug>2) printf("debug 3: Reading %d config file\n",shaperd_counter);
    config = read_config(configfile);

    // Sprawdzamy rodzaj firewalla
    if (check_ipchains())
    {
	if (debug > 1 && !interactive) syslog(LOG_INFO,"Checking firewall type: ipchains");
	firewall_type=1;
    }
    else
    if (check_iptables())
    {
	if (debug > 1 && !interactive) syslog(LOG_INFO,"Checking firewall type: iptables");
	firewall_type=2;
    }

    if (!firewall_type)
    {
	syslog(LOG_ERR,"Unknown firewall type");
	syslog(LOG_ERR,"Exit.");
	error("Unknown firewall type.\nExiting.\n");
    }
    
    // sprawdzamy parametry podane przy starcie programu
    if (debug>2) printf("debug 3: Reading start options\n");
    if (argc>1)
    {
	char	*p;
	int	fin;

	for(n=1;n<argc;n++)
	{
	    fin = 0;
	    p = strtok(argv[n],"=");
	    if (!strcmp(p,"-config"))
	    {
		p = strtok(NULL," ");
		fin = 1;
	    }
	    else
	    if (!strcmp(p,"-speed_ext"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    char	*lo = lower(p);
		    
		    if (! strcmp(lo,"kbit") || ! strcmp(lo,"mbit")) strncpy(speed_ext,lo,10);
		    else strncpy(speed_ext,"\0",10);
		    fin = 1;
		    free(lo);
		}
	    }
	    else
	    if (!strcmp(p,"-debug"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    debug = atoi(p);
		    fin = 1;
		}
	    }
	    else
	    if (!strcmp(p,"-delay"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    delay = atoi(p);
		    if (delay < 10) delay = 10;
		    fin = 1;
		}
	    }
	    else
	    if (!strcmp(p,"-write_delay"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    olddelay = atoi(p);
		    if (olddelay < 0) olddelay = 0;
		    fin = 1;
		}
	    }
	    else
	    if (!strcmp(p,"-start_speed"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    char	*lo = lower(p);

		    start_speed = atoi(p);
		    if (start_speed < 0) start_speed = 0;
		    if (start_speed > 255) start_speed = 255;
		    fin = 1;
		}
	    }
	    else
	    if (!strcmp(p,"-even_division"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    char	*lo = lower(p);

		    if (!strcmp(lo,"yes")) even_division = 1;
		    else
		    if (!strcmp(lo,"no")) even_division = 0;
		    else
    			even_division = atoi(p);
		    fin = 1;
		}
	    }
	    else
	    if (!strcmp(p,"-quick"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    char	*lo = lower(p);

		    if (!strcmp(lo,"yes")) quick_start = 1;
		    else
		    if (!strcmp(lo,"no")) quick_start = 0;
		    else
    			quick_start = atoi(p);
		    fin = 1;
		}
	    }
	    else
	    if (!strcmp(p,"-continuous_control"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    char	*lo = lower(p);

		    if (!strcmp(lo,"yes")) continuous_control = 1;
		    else
		    if (!strcmp(lo,"no")) continuous_control = 0;
		    else
    			continuous_control = atoi(p);
		    fin = 1;
		}
	    }
	    else
	    if (!strcmp(p,"-jump_type"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
    		    jump_type = atoi(p);
		    fin = 1;
		}
	    }
	    else
	    if (!strcmp(p,"-check_sum_of_bandwidth"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    char	*lo = lower(p);

		    if (!strcmp(lo,"yes")) check_sum_of_bandwidth = 1;
		    else
		    if (!strcmp(lo,"no")) check_sum_of_bandwidth = 0;
		    else
    			check_sum_of_bandwidth = atoi(p);
		    fin = 1;
		}
	    }
	    else
	    if (!strcmp(p,"-squid_support"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    char	*lo = lower(p);

		    if (!strcmp(lo,"yes")) squid = 1;
		    else
		    if (!strcmp(lo,"no")) squid = 0;
		    else
			squid = atoi(p);
		    fin = 1;
		    if (squid==1 && !interactive) syslog(LOG_INFO,"squid_support active");
		    else
		    if (squid==2 && !interactive) syslog(LOG_INFO,"squid_support rules_only");
		}
	    }
	    else
	    if (!strcmp(p,"-divide_upload"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    char	*lo = lower(p);

		    if (!strcmp(lo,"yes")) divide_upload = 1;
		    else
		    if (!strcmp(lo,"no")) divide_upload = 0;
		    else
			divide_upload = atoi(p);
		    fin = 1;
		    if (divide_upload && !interactive) syslog(LOG_INFO,"divide_upload active");
		}
	    }
	    else
	    if (!strcmp(p,"-extended_queue"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    char	*lo = lower(p);

		    if (!strcmp(lo,"yes")) extended_queue = 1;
		    else
		    if (!strcmp(lo,"no")) extended_queue = 0;
		    else
			extended_queue = atoi(p);
		    fin = 1;
		    if (extended_queue && !interactive) syslog(LOG_INFO,"Extended queue activated");
		}
	    }
	    else
	    if (!strcmp(p,"-nomasq"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    char	*lo = lower(p);

		    if (!strcmp(lo,"yes")) nomasq = 1;
		    else
		    if (!strcmp(lo,"no")) nomasq = 0;
		    else
			nomasq = atoi(p);
		    fin = 1;
		    if (nomasq && !interactive) syslog(LOG_INFO,"masquerade control deactivated");
		}
	    }
	    else
	    if (!strcmp(p,"-class_type"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    if (!strcmp(lower(p),"cbq")) class_type = 0;
		    else
		    if (!strcmp(lower(p),"htb")) class_type = 1;
		    else
		    if (!strcmp(lower(p),"ehtb")) class_type = 2;
		    else
		    if (!strcmp(lower(p),"shtb")) class_type = 3;
		    fin = 1;
		    
		    if (class_type == 1 && !interactive) syslog(LOG_INFO,"HTB Download Class type activated");
		    else
		    if (class_type == 2 && !interactive) syslog(LOG_INFO,"EHTB Download Class type activated");
		    else
		    if (class_type == 3 && !interactive) syslog(LOG_INFO,"SHTB Download Class type activated");
		    free(p);
		}
	    }
	    else
	    if (!strcmp(p,"-upload_class_type"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    if (!strcmp(lower(p),"cbq")) upload_class_type = 0;
		    else
		    if (!strcmp(lower(p),"htb")) upload_class_type = 1;
		    else
		    if (!strcmp(lower(p),"ehtb")) upload_class_type = 2;
		    else
		    if (!strcmp(lower(p),"shtb")) upload_class_type = 3;
		    fin = 1;
		    
		    if (upload_class_type == 1 && !interactive) syslog(LOG_INFO,"HTB Upload Class type activated");
		    else
		    if (upload_class_type == 2 && !interactive) syslog(LOG_INFO,"EHTB Upload Class type activated");
		    else
		    if (upload_class_type == 3 && !interactive) syslog(LOG_INFO,"SHTB Upload Class type activated");
		    free(p);
		}
	    }
	    else
	    if (!strcmp(p,"-debug_output"))
	    {
		p = strtok(NULL," ");
		if (p)
		{
		    strcpy(output,p);
		    fin = 1;
		}
	    }
	    else
	    if (!strcmp(p,"shownat_all"))
	    {
		interactive = 1;
		alt_natstat = 0;
		read_iplist(config);
		if (squid==1)
		{
		    if (nomasq) read_firewall(firewall_type);
		    read_squid(firewall_type);
		    read_sqout(firewall_type);
		    nattab = natstat(ignore, config, firewall_type);
		    free_natstat_tab(nattab);
		    sleep(1);
		    if (nomasq) read_firewall(firewall_type);
		    read_squid(firewall_type);
		    read_sqout(firewall_type);
		}
		else
		{
		    if (nomasq) read_firewall(firewall_type);
		    if (squid) read_sqout(firewall_type);
		    nattab = natstat(ignore, config, firewall_type);
		    free_natstat_tab(nattab);
		    sleep(1);
		    if (nomasq) read_firewall(firewall_type);
		    if (squid) read_sqout(firewall_type);
		}
		nattab = natstat(ignore, config, firewall_type);
		shownat(nattab);
		closelog();
		free_natstat_tab(nattab);
//		free_config(config);
		frmem();
		exit(0);
	    }
	    else
	    if (!strcmp(p,"shownat"))
	    {
		interactive = 1;
		alt_natstat = 0;
		ignore = read_ignore(ignorefile);
		read_iplist(config);
		if (squid==1)
		{
		    if (nomasq) read_firewall(firewall_type);
		    read_squid(firewall_type);
		    read_sqout(firewall_type);
		    nattab = natstat(ignore, config, firewall_type);
		    free_natstat_tab(nattab);
		    sleep(1);
		    if (nomasq) read_firewall(firewall_type);
		    read_squid(firewall_type);
		    read_sqout(firewall_type);
		}
		else
		{
		    if (nomasq) read_firewall(firewall_type);
		    if (squid) read_sqout(firewall_type);
		    nattab = natstat(ignore, config, firewall_type);
		    free_natstat_tab(nattab);
		    sleep(1);
		    if (nomasq) read_firewall(firewall_type);
		    if (squid) read_sqout(firewall_type);
		}
		nattab = natstat(ignore, config, firewall_type);
		shownat(nattab);
		closelog();
		free_natstat_tab(nattab);
	        free_ignore(ignore);
//		free_config(config);
		frmem();
		exit(0);
	    }
	    else
	    if (!strcmp(p,"--version") || !strcmp(p,"-V"))
	    {
		printf("shaperd %s\n",SHAPERD_VERSION);
		closelog();
		free_config(config);
		frmem();
		exit(0);
	    }
	    else
	    if (!strcmp(p,"--help"))
	    {
		printf("Usage: shaperd [options] [commands]\n\
Options:\n\
\t-config=0-9			number of shaperd config (deflt. 0)\n\
\t-start_speed=n		start speed of new user (deflt. 0)\n\
\t-check_sum_of_bandwidth=yes|no\n\
\t-squid_support=yes|no|rules_only	PROXY support switch (deflt. no)\n\
\t-divide_upload=yes|no		divide upload bandwidth (deflt. no)\n\
\t-extended_queue=yes|no		extended dividing which create 4 class\n\
					for every user with high/med/low/mass\n\
					priorities (defl. no)\n\
\t-nomasq=yes|no			disable masquerade connections \n\
\t				tracking <deflt. yes)\n\
\t-class_type=cbq|htb|ehtb|shtb	download class type (deflt. cbq)\n\
\t-upload_class_type=cbq|htb|ehtb|shtb	upload class type (deflt. cbq)\n\
\t-even_division=yes|no		even division of bandwidth (deflt. no)\n\
\t-continuous_control=yes|no	continuous QoS control (deflt. yes)\n\
\t-jump_type=n			multiplier of speed jump (deflt. 0)\n\
\t-speed_ext=bit|kbit|mbit	speed extension (deflt. bit)\n\
\t-delay=seconds			cycle delay time (deflt 10)\n\
\t-write_delay=n			after how many cycles to write (0 disable)\n\
\t				bitrate_user_sh.x.old file (deflt. 6)\n\
\t-debug=0|1|2|3|4		debug level (deflt. 0)\n\
\t--version\t-V		print package version\n\
\t--help help\n\
\n\
Commands:\n\
\tshownat		show current masqueraded connections (without ignore)\n\
\tshownat_all	show all current masqueraded connections\n\n");

		closelog();
//		free_config(config);
//		frmem();
		exit(1);
	    }
	    else
	    if (fin == 0)
	    {
		syslog(LOG_ERR,"syntax error. Unknown parameter: %s.",argv[n]);
		closelog();
//		free_ignore(ignore);
//		free_config(config);
//		frmem();
		error("shaperd: syntax error. Unknown parameter: %s.\ntry: shaperd --help\n\n",argv[n]);
	    }
	}
    }

    if (nop_factor >= add_factor) error("nop_factor must be less than add_factor!");

    // sprawdzamy czy juz jakis shaper nie pracuje
    if (debug>2) printf("debug 3: checking if any other shaperd.%d is working\n",shaperd_counter);
    if (is_shaperd_running())
    {
	syslog(LOG_ERR,"Any shaperd%d is still working. Exiting.",shaperd_counter);
	closelog();
//	free_config(config);
//	frmem();
	error("Any shaperd%d is still working. Exiting.\n",shaperd_counter);
	exit(1);
    }

    // sprawdzamy czy komenda tc ma opcje quantum dla htb
    if (!interactive && (class_type || upload_class_type) && is_htb3())
    {
	syslog(LOG_INFO,"HTB3 found - quantum option enabled.");
	htb_quantum = 1;
    }

    if (!interactive && squid && squid_factor!=1) syslog(LOG_INFO,"Setting squid_factor to %f.",squid_factor);

    // ceil tylko dla HTB
    if (class_type == 0 || class_type == 2 || class_type == 3) ceil_download = 0;
    if (upload_class_type == 0 || upload_class_type == 2 || upload_class_type == 3) ceil_upload = 0;

    // czytamy liste ignorowanych polaczen
    if (debug>2) printf("debug 3: reading %s/ignore.%d file\n",CONFIG_DIR,shaperd_counter);
    ignore = read_ignore(ignorefile);
    
    // czytamy liste lokalnych numerow ip
    if (debug>2) printf("debug 3: reading %s/iplist.%d file\n",CONFIG_DIR,shaperd_counter);
    read_iplist(config);

    // czytamy stan licznikow i limitow od ostatniego restartu shapera (jesli jest co czytac)
    read_last_state(lastrate);

    // uruchamiamy program jako daemona systemowego
    if (debug>2) printf("debug 3: daemonize\n");
    if (daemonize() < 0) exit(1);

    // czy ciagla kontrola QoS wlaczona
    if (continuous_control)
    {
	if (debug > 1) printf("Continuous traffic control enabled\n");
	syslog(LOG_INFO, "Continuous traffic control enabled\n");
    }

    if (check_sum_of_bandwidth) syslog(LOG_INFO,"Check sum of bandwidth enabled");
    if (enable_eir_factor) syslog(LOG_INFO,"EIR factor enabled");
    if (static_dnload_class) syslog(LOG_INFO,"static_dnload enabled");
    if (static_upload_class) syslog(LOG_INFO,"static_upload enabled");

    if (! olddelay)
    {
	if (debug > 1) printf("Creating bandwidth allocation files in /var/shaper/ directory disabled\n");
	syslog(LOG_INFO, "Creating bandwidth allocation files in /var/shaper/ directory disabled\n");
    }

    if (!quick_start)
    {
	// tworzymy regulki na firewallu rejestrujace ilosc pobranych danych
        if (debug>2) printf("debug 3: removing firewall shaperd rules\n");
	delete_firewall(config,firewall_type);
        if (debug>2) printf("debug 3: creating firewall shaperd rules\n");
        create_firewall(config,firewall_type);
    }

    syslog(LOG_INFO, "Initialisation finished");

    delay_org = delay;

    mult = 1;
    if (! strcmp(speed_ext,"bit")) mult = 1;
    else if (! strcmp(speed_ext,"kbit")) mult = 1024;
    else if (! strcmp(speed_ext,"mbit")) mult = 1048576;

    for(n=1;n<11;n++)
    {
	masqip_pos[n]=1;
	masqip_pos_upload[n]=1;
    }

    if (continuous_control)
    {
	// usuwamy wszystkie ograniczenia
	if (debug>2) printf("debug 3: removing all QoS classes\n");
//	cbq_off_local(config);
	cbq_off_all(config);

	// ustawiamy standardowe ograniczenia
	if (debug>2) printf("debug 3: creating root QoS classes\n");
	cbq_standard_on(config);
    }

    lastrate_cnt = lastrate_numcycles;
    check_firewall_cnt = check_firewall_numcycles;

    // petla glowna
    if (debug>2) printf("debug 3: beginning main loop\n");
    while(!exit_signal)
    {
	int	*masq_cir_dnload[10];
	int	*masq_cir_upload[10];
	int	*masq_eir_dnload[10];
	int	*masq_eir_upload[10];
	float	*masq_feir_dnload[10];
	float	*masq_feir_upload[10];
	char	**masq_ip_dnload[10];
	char	**masq_ip_upload[10];
	unsigned int total_dnload_eir;
	unsigned int total_upload_eir;
	

	if (debug) putstring("start main_loop");
//	start_time = time(NULL);
	start_loop = time(NULL);
	currbitrate_total = 0;

	// czytamy na firewallu ilosc pobranych i wyslanych danych 
	if (debug>2) printf("debug 3: reading firewall\n");
	read_firewall(firewall_type);
	if (divide_upload)
	{
	    read_firewall_upload(firewall_type);
	    if (squid) read_sqout(firewall_type);
	}
	if (squid==1) read_squid(firewall_type);

	// czytamy wszystkie polaczenia na maskaradzie
	nattab = natstat(ignore, config, firewall_type);
	if (divide_upload) nattab_upload = natstat_upload(ignore, config, firewall_type);

	// petla interfejsow internetowych
	for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
	{
	    if (debug>2) printf("debug 3: int_cnt=%d int=%s\n",int_cnt,config[1][(int_cnt*6)+1]);
	    // tworzymy liste maskowanych numerow ip dla przydzialow
	    if (debug>2) printf("debug 3: creating working ip's table.\n");
	    masq[int_cnt] = get_masqip(nattab,config[1][(int_cnt*6)+1],int_cnt);
	    if (divide_upload) masq_upload[int_cnt] = get_masqip_upload(nattab_upload,config[1][(int_cnt*6)+1],int_cnt);

	    nr[int_cnt] = 1;
	    nr_upload[int_cnt] = 1;

	    // sprawdzamy czy interfejs jest internetowy
	    if (local_int_tab2[1][(int_cnt*6)+5])
	    {
		masq_ip_dnload[int_cnt] = (char **) malloc(sizeof(char *)*masqip_pos[int_cnt]+2);
		masq_cir_dnload[int_cnt] = (int *) malloc(sizeof(int)*masqip_pos[int_cnt]+2);
		masq_eir_dnload[int_cnt] = (int *) malloc(sizeof(int)*masqip_pos[int_cnt]+2);
		masq_feir_dnload[int_cnt] = (float *) malloc(sizeof(float)*masqip_pos[int_cnt]+2);

		for(n=1;n<masqip_pos[int_cnt];n++)
		    masq_eir_dnload[int_cnt][n] = 0;
		    
		// petla userow na maskaradzie - download
		for(n=1;n<masqip_pos[int_cnt];n++)
		{
		    masq_ip_dnload[int_cnt][n] = masq[int_cnt][n];
		    masq_cir_dnload[int_cnt][n] = get_ip_lospeed(masq[int_cnt][n]);
		    masq_eir_dnload[int_cnt][n] = get_ip_hispeed(masq[int_cnt][n]);
		    masq_feir_dnload[int_cnt][n] = 1;

		    // sprawdzamy czy interfejs internetowy usera jest taki sam jak aktualny
		    if (!strcmp(config[1][(int_cnt*6)+1],get_ip_int_iface(masq[int_cnt][n])))
		    {
			// zwiekszamy licznik ilosci userow na maskardzie
			nr[int_cnt]++;
		    }
		}
		if (debug > 1) printf("Number of IP's on %s interface for download allocation bandwidth: %d\n",config[1][(int_cnt*6)+1],nr[int_cnt]-1);

		// sortujemy numery ip aktywne w kierunku download wedlug CIR
	    	qsort2(masq_ip_dnload[int_cnt],masq_cir_dnload[int_cnt],masq_eir_dnload[int_cnt],1,masqip_pos[int_cnt]-1);

		if (debug > 1) printf("Sumowanie download EIRow\n");
		// sumujemy EIRy
		total_dnload_eir = 0;
		for(n=1;n<masqip_pos[int_cnt];n++)
		    total_dnload_eir += masq_eir_dnload[int_cnt][n];
		    
		if (debug > 1) printf("Obliczanie dnload EIRow\n");
		// obliczamy wspolczynniki eir
		for(n=1;n<masqip_pos[int_cnt];n++)
		{
//		    if (debug) printf("masq_eir_dnload[%d][%d]=%d total_dnload_eir=%d\n",int_cnt,n,masq_eir_dnload[int_cnt][n],total_dnload_eir);
		    
		    if (total_dnload_eir != 0) masq_feir_dnload[int_cnt][n] = (float) masq_eir_dnload[int_cnt][n] / (float) total_dnload_eir;
		    else masq_feir_dnload[int_cnt][n] = 1;
		}

//		for(n=1;n<masqip_pos[int_cnt];n++)
//		    printf("dnload: %s\t%d\t%d\t%.2f\t%d\n",masq_ip_dnload[int_cnt][n],masq_cir_dnload[int_cnt][n],masq_eir_dnload[int_cnt][n],masq_feir_dnload[int_cnt][n],(unsigned int)(local_int_tab2[1][(int_cnt*6)+2]*masq_feir_dnload[int_cnt][n]));

		// petla userow na maskaradzie - upload
		if (divide_upload)
		{
		    masq_ip_upload[int_cnt] = (char **) malloc(sizeof(char *)*masqip_pos_upload[int_cnt]+2);
		    masq_cir_upload[int_cnt] = (int *) malloc(sizeof(int)*masqip_pos_upload[int_cnt]+2);
		    masq_eir_upload[int_cnt] = (int *) malloc(sizeof(int)*masqip_pos_upload[int_cnt]+2);
		    masq_feir_upload[int_cnt] = (float *) malloc(sizeof(float)*masqip_pos_upload[int_cnt]+2);

		    for(n=1;n<masqip_pos_upload[int_cnt];n++)
			masq_eir_upload[int_cnt][n] = 0;

		    for(n=1;n<masqip_pos_upload[int_cnt];n++)
		    {
			masq_ip_upload[int_cnt][n] = masq_upload[int_cnt][n];
//		        masq_cir_upload[int_cnt][n] = get_ip_lospeed(masq_upload[int_cnt][n]);
//		        masq_eir_upload[int_cnt][n] = get_ip_hispeed(masq_upload[int_cnt][n]);
		        masq_cir_upload[int_cnt][n] = get_ip_lospeed_upload(masq_upload[int_cnt][n]);
		        masq_eir_upload[int_cnt][n] = get_ip_hispeed_upload(masq_upload[int_cnt][n]);
		        masq_feir_upload[int_cnt][n] = 1;

			// sprawdzamy czy interfejs internetowy usera jest taki sam jak aktualny
			if (!strcmp(config[1][(int_cnt*6)+1],get_ip_int_iface(masq_upload[int_cnt][n])))
			    // zwiekszamy licznik ilosci userow na maskardzie
			    nr_upload[int_cnt]++;
		    }
		    if (debug > 1) printf("Number of IP's on %s interface for upload allocation bandwidth: %d\n",config[1][(int_cnt*6)+1],nr_upload[int_cnt]-1);

		    // sortujemy numery ip aktywne w kierunku upload wedlug CIR
	    	    qsort2(masq_ip_upload[int_cnt],masq_cir_upload[int_cnt],masq_eir_upload[int_cnt],1,masqip_pos_upload[int_cnt]-1);

		    if (debug > 1) printf("Sumowanie upload EIRow\n");
		    // sumujemy EIRy
		    total_upload_eir = 0;
		    for(n=1;n<masqip_pos_upload[int_cnt];n++)
			total_upload_eir += masq_eir_upload[int_cnt][n];
		
		    if (debug > 1) printf("Obliczanie upload EIRow\n");
		    // obliczamy wspolczynniki eir
		    for(n=1;n<masqip_pos_upload[int_cnt];n++)
		    {
//			if (debug) printf("masq_eir_upload[%d][%d]=%d total_upload_eir=%d\n",int_cnt,n,masq_eir_upload[int_cnt][n],total_upload_eir);

			if (total_upload_eir != 0) masq_feir_upload[int_cnt][n] = (float) masq_eir_upload[int_cnt][n] / (float) total_upload_eir;
			else masq_feir_upload[int_cnt][n] = 1;
		    }

//		    for(n=1;n<masqip_pos_upload[int_cnt];n++)
//			printf("upload: %s\t%d\t%d\t%.2f\t%d\n",masq_ip_upload[int_cnt][n],masq_cir_upload[int_cnt][n],masq_eir_upload[int_cnt][n],masq_feir_upload[int_cnt][n],(unsigned int)(local_int_tab2[1][(int_cnt*6)+4]*masq_feir_upload[int_cnt][n]));
		}

		// tworzymy tablice z aktualnymi przydzialami
		if (debug>2) printf("debug 3: creating user's speed allocation table for %s interface.\n",config[1][(int_cnt*6)+1]);
    		speed_tab[int_cnt] = create_speed_table(nr[int_cnt]);
    		if (divide_upload) speed_tab_upload[int_cnt] = create_speed_table(nr_upload[int_cnt]);
		del_tab[int_cnt] = create_speed_table(iplista_pos+1);
		if (divide_upload) del_tab_upload[int_cnt] = create_speed_table(iplista_pos+1);

		// czyscimy tablice z ostatnimi przydzialami
		if (debug>2) printf("debug 3: clearing user's last speed allocation table\n");
		bitrate_user_last[int_cnt] = clear_bitrate_user_last(bitrate_user_last[int_cnt],masq[int_cnt],int_cnt);
		if (divide_upload) bitrate_user_last_upload[int_cnt] = clear_bitrate_user_last_upload(bitrate_user_last_upload[int_cnt],masq_upload[int_cnt],int_cnt);

		// usuwamy wszystkie bany na firewallu dla userow przelamujacych widelki
		if (ban_user)
		{
		    int	m;
		    struct      IPLISTA *ptr;
		
    		    for(m=1;m<iplista_pos;m++)
        	    {
			ptr = iplista_str + m;
			if (ptr -> ban_download_cnt == 1)
			{
			    unban_user_download(config,ptr);
			    ptr -> ban_download_cnt = 0;
			}
			if (ptr -> ban_upload_cnt == 1)
			{
			    unban_user_upload(config,ptr);
			    ptr -> ban_upload_cnt = 0;
			}
			if (ptr -> ban_download_cnt > 1) ptr -> ban_download_cnt--;
			if (ptr -> ban_upload_cnt > 1) ptr -> ban_upload_cnt--;

			// Zmniejszamy licznik blokujacy kasowanie klas a jesli jest wyzerowany to kasujemy licznik ilosci banow
			if (ptr -> ban_download_cnt2)
			    ptr -> ban_download_cnt2--;
			else
			    ptr -> ban_download_cnt3 = 0;

			if (ptr -> ban_upload_cnt2)
			    ptr -> ban_upload_cnt2--;
			else
			    ptr -> ban_upload_cnt3 = 0;
		    }
		}

		// robimy ograniczenia download tylko wtedy gdy jest wiecej niz jeden user lub check_always=1
    		if (nr[int_cnt]-1 > 1 || (nr[int_cnt]-1 > 0 && check_always))
		{
		    int	t;

		    if (debug > 1) printf("Dnload ip: IP\t\t\tCurr.Bitrate\tLast Bitrate\t%s\n",config[1][(int_cnt*6)+1]);
		    ilip[int_cnt] = nr[int_cnt]-1;
		    speed[int_cnt] = (local_int_tab2[1][(int_cnt*6)+2] * mult) / ilip[int_cnt];
		    
			/** ZQ **/
			currbitrate_tab = create_bitrate_tab(nr[int_cnt]-1);
			lastbitrate_tab = (long int*)create_bitrate_tab(nr[int_cnt]-1);
 
			// najpierw wrzucamy bitrate'y wszystkich userow do tablicy
				
			for(n=1;n<nr[int_cnt];n++)
			{
					currbitrate_tab[n-1] = ckbitrate_user(masq_ip_dnload[int_cnt][n]);
					lastbitrate_tab[n-1] = ckbitrate_user_last(bitrate_user_last[int_cnt],masq_ip_dnload[int_cnt][n],int_cnt) * mult;

			}
			
			for(n=1;n<nr[int_cnt];n++)
			{
			// sprawdzamy czy rzeczywista szybkosc nie byla wieksza od przydzielonych widelek
			if (lastbitrate_tab[n-1] > 0 && (currbitrate_tab[n-1] > ((lastbitrate_tab[n-1]*((100+ceil_download+20)/100)))))
			{
			    int		m;
			    struct	IPLISTA	*ptr;
				
			    for(m=1;m<iplista_pos;m++)
		    	    {
				ptr = iplista_str + m;
		    	        if ((ip2hex3(masq_ip_dnload[int_cnt][n]) & ptr -> mask) == (ptr -> ip & ptr -> mask))
			        {
				    ptr -> feir = masq_feir_dnload[int_cnt][n];
				    if (ptr -> factor < 1) ptr -> factor = 100;
			    	    ptr -> factor = (int)((float)((float)(lastbitrate_tab[n-1]*((100+ceil_download)/100))/(float)currbitrate_tab[n-1])*100);
				    ptr -> shtb_refresh = 1;
				    if (ptr -> factor < 1)
				    {
					if (!flagi.clear_firewall_done) syslog(LOG_ERR,"download_factor is too small!");
					ptr -> factor = min_factor;
				    }
//				    syslog(LOG_ERR,"download ip: %s curr=%lu last=%lu factor=%d factor_cnt=%d\n",iplista[m],currbitrate,lastbitrate,iplista_factor[m],iplista_factor_cnt[m]);
				    (ptr -> factor_cnt)--;
				    if (ptr -> factor < check_download_factor && ptr -> factor_cnt < 1)
				    {
					if (!flagi.clear_firewall_done && control_mesg)
					{
					    syslog(LOG_ERR,"Can't control download bandwidth of IP %s",masq_ip_dnload[int_cnt][n]);
					    syslog(LOG_ERR,"download ip: %s curr=%lu last=%lu factor=%d factor_cnt=%d\n",ptr -> str_ip,currbitrate_tab[n-1],lastbitrate_tab[n-1],ptr -> factor,ptr -> factor_cnt);
					}
					// usuwamy klase ktora nie ogranicza ruchu
					if (remove_dead_class && ! ptr -> ban_download_cnt && ! ptr -> ban_download_cnt2)
					{
			    		    ptr -> factor = 100;
					    ptr -> factor_cnt = check_factor_cnt;
					    if (!flagi.clear_firewall_done && control_mesg) syslog(LOG_ERR,"Removing download class of IP %s",masq_ip_dnload[int_cnt][n]);
					    del_ip2speed_table(del_tab[int_cnt],masq_ip_dnload[int_cnt][n]);
					    if (ban_user) ptr -> ban_download_cnt2 = default_ban_download_cnt2;
					}
					// regenerujemy regulki na firewallu dla tej klasy
					if (refresh_dead_fwrule && ! ptr -> ban_download_cnt && ! ptr -> ban_download_cnt2)
					{
					    del_user_from_firewall(config,ptr);
					    add_user_to_firewall(config,ptr,m);
//					    ptr -> is_overlimit = 0;
//    					    ptr -> is_overlimit_upload = 0;
//    					    ptr -> is_shtb_overlimit = 0;
//					    ptr -> is_shtb_overlimit_upload = 0;
				    	    ptr -> shtb_refresh = 1;
					    ptr -> shtb_refresh_upload = 1;
					    ptr -> ipspeed_last = 0;
					    ptr -> squid_speed_last = 0;
					    ptr -> sqout_speed_last = 0;
					    ptr -> ipspeed_last_upload = 0;
//					    ptr -> state_ipspeed_last = 0;
//					    ptr -> state_squid_speed_last = 0;
//					    ptr -> state_sqout_speed_last = 0;
//					    ptr -> state_ipspeed_last_upload = 0;
					}
					// banujemy na firewallu usera przekraczajacego widelki
					if (ban_user && ! ptr -> ban_download_cnt)
					{
					    syslog(LOG_ERR,"Ban download of IP %s",masq_ip_dnload[int_cnt][n]);
					    ban_user_download(config,ptr);
					    if (ptr -> ban_download_cnt3 < max_ban_download)
					        ptr -> ban_download_cnt = ptr -> ban_download_cnt3 + default_ban_download_cnt;
					    else
					        ptr -> ban_download_cnt = max_ban_download + default_ban_download_cnt;
					    ptr -> ban_download_cnt3++;
					}
				    }
				}
			    }
			}
			else
			if (currbitrate_tab[n-1] < ((lastbitrate_tab[n-1]*90)/100))
			{
			    int		m;
			    struct	IPLISTA	*ptr;

			    for(m=1;m<iplista_pos;m++)
		    	    {
				ptr = iplista_str + m;
		    	        if ((ip2hex3(masq_ip_dnload[int_cnt][n]) & ptr -> mask) == (ptr -> ip & ptr -> mask))
			        {
				    ptr -> feir = masq_feir_dnload[int_cnt][n];
			    	    ptr -> factor = 100;
				    if (ptr -> factor > 100) ptr -> factor = 100;
				    ptr -> factor_cnt = check_factor_cnt;
				    if (ptr -> factor < 1)
				    {
					if (!flagi.clear_firewall_done) syslog(LOG_ERR,"download_factor is too small !");
					ptr -> factor = min_factor;
				    }
				}
			    }
			}
			
			// Jesli zmienil sie po reload jakis CIR w kierunku download to usuwamy klase
			if (reload_signal2)
			{
			    int		m;
			    struct	IPLISTA	*ptr;
			    
			    for(m=1;m<iplista_pos;m++)
			    {
				ptr = iplista_str + m;
				if (ptr -> refresh)
				{
			    	    ptr -> factor = 100;
				    ptr -> factor_cnt = check_factor_cnt;
//				    del_ip2speed_table(del_tab[int_cnt],masq_ip_dnload[int_cnt][n]);
				}
			    }
			}
			if (lastbitrate_tab[n-1] < 1 || (even_division && ! continuous_control))
			    add_ip2speed_table_new(speed_tab[int_cnt],masq_ip_dnload[int_cnt][n]);
			else if ((even_division && continuous_control) || class_type == 3) add_ip2speed_table_nop1(speed_tab[int_cnt],masq_ip_dnload[int_cnt][n]);
			else if (lastbitrate_tab[n-1] <= speed[int_cnt])
			{
	    		if (currbitrate_tab[n-1] < ((lastbitrate_tab[n-1] * nop_factor)/100))
				    add_ip2speed_table_sub1(speed_tab[int_cnt],masq_ip_dnload[int_cnt][n]);
				else if (currbitrate_tab[n-1] < ((lastbitrate_tab[n-1] * add_factor)/100))
					add_ip2speed_table_nop1(speed_tab[int_cnt],masq_ip_dnload[int_cnt][n]);
				else
				{
					/**ZQ**/
					
					// po pierwsze sprawdzamy czy dany ip nie przekroczyl limitu
					//i czy nie trzeba wprowadzic dodatkowych kryteriow
					int		m;
					struct	IPLISTA	*ptr;
					int is_overlimit_local=0;


					for(m=1;m<iplista_pos;m++)
					{
						ptr = iplista_str + m;
						if ((ip2hex3(masq_ip_dnload[int_cnt][n]) & ptr -> mask) == (ptr -> ip & ptr -> mask) && ptr->is_overlimit)
							is_overlimit_local=1;
					}


					if (is_overlimit_local)
					{
					
						//sprawdzamy czy bitrate'y innych ip nie wzrosly
						int l;
						int low_prio=0;
						if (debug > 1) printf("overlimit detected!\n");


						for(l=1;l<nr[int_cnt];l++)
						{
															
							currbitrate_total+=currbitrate_tab[l-1] ;
								
							if (l==n) continue;	//nie porownujemy tych samych IP


							if (currbitrate_tab[l-1] > ((lastbitrate_tab[l-1] * nop_factor)/100))
							//wzrost ruchu albo utrzymanie, sprawdzamy czy oddac prio
							{
								if (debug > 1) printf("other IP active, lowprio->ON\n");
								low_prio=1;
							}
							else
								if (debug > 1) printf("other IP not active, lowprio->OFF\n");
						}
		
						if(low_prio && currbitrate_total>(ptr->hi*multipler()-lastbitrate_tab[n-1])*3/4)
						{	//sprawdzmy jeszcze czy wspolne bitraty innych ip
							// sa wieksze od bitratu akt ip
								if (debug > 1) printf("other IPs active,reducing download! SUB()\n");
								add_ip2speed_table_sub1(speed_tab[int_cnt],masq_ip_dnload[int_cnt][n]);
						}
						else
						{
								if (debug > 1) printf("other IPs not active,not reducing download! ADD()\n");
								add_ip2speed_table_add1(speed_tab[int_cnt],masq_ip_dnload[int_cnt][n]);
						}
						
					}
					else
						add_ip2speed_table_add1(speed_tab[int_cnt],masq_ip_dnload[int_cnt][n]);
						
				}
			}
			
			else
			{
				if (currbitrate_tab[n-1] < ((lastbitrate_tab[n-1] * nop_factor)/100))
				    add_ip2speed_table_sub2(speed_tab[int_cnt],masq_ip_dnload[int_cnt][n]);
				else if (currbitrate_tab[n-1] < ((lastbitrate_tab[n-1] * add_factor)/100))
					add_ip2speed_table_nop2(speed_tab[int_cnt],masq_ip_dnload[int_cnt][n]);
				else
				{
					/**ZQ**/
					
					// po pierwsze sprawdzamy czy dany ip nie przekroczyl limitu
					//i czy nie trzeba wprowadzic dodatkowych kryteriow
					int		m;
					struct	IPLISTA	*ptr;
					int is_overlimit_local=0;


					for(m=1;m<iplista_pos;m++)
					{
						ptr = iplista_str + m;
						if ((ip2hex3(masq_ip_dnload[int_cnt][n]) & ptr -> mask) == (ptr -> ip & ptr -> mask) && ptr->is_overlimit)
							is_overlimit_local=1;
					}


					if (is_overlimit_local)
					{
						
						//sprawdzamy czy bitrate'y innych ip nie wzrosly
						int l;
						int low_prio=0;
						if (debug > 1) printf("overlimit detected!\n");


						for(l=1;l<nr[int_cnt];l++)
						{
															
							currbitrate_total+=currbitrate_tab[l-1] ;
								
							if (l==n) continue;	//nie porownujemy tych samych IP


							if (currbitrate_tab[l-1] > ((lastbitrate_tab[l-1] * nop_factor)/100))
							//wzrost ruchu albo utrzymanie, sprawdzamy czy oddac prio
							{
								if (debug > 1) printf("other IP active, lowprio->ON\n");
								low_prio=1;
							}
							else
								if (debug > 1) printf("other IP not active, lowprio->OFF\n");
						}
		
						if(low_prio && currbitrate_total>(ptr->hi*multipler()-lastbitrate_tab[n-1])*3/4)
						{	//sprawdzmy jeszcze czy wspolne bitraty innych ip
							// sa wieksze od bitratu akt ip
								if (debug > 1) printf("other IPs active,reducing download! SUB()\n");
								add_ip2speed_table_sub2(speed_tab[int_cnt],masq_ip_dnload[int_cnt][n]);
						}
						else
						{
								if (debug > 1) printf("other IPs not active,not reducing download! ADD()\n");
								add_ip2speed_table_add2(speed_tab[int_cnt],masq_ip_dnload[int_cnt][n]);
						}
						
					}
					else
						add_ip2speed_table_add1(speed_tab[int_cnt],masq_ip_dnload[int_cnt][n]);
						
				}
				}
			if (debug > 1) printf("Dnload ip: %s\t\t%lu\t\t%ld\n",masq_ip_dnload[int_cnt][n],currbitrate_tab[n-1],lastbitrate_tab[n-1]);
		    }

		}

		// robimy ograniczenia upload tylko wtedy gdy jest wiecej niz jeden user lub check_always=1
		if (divide_upload)
		{
    		    if (nr_upload[int_cnt]-1 > 1 || (nr_upload[int_cnt]-1 > 0 && check_always))
		    {
			int	t;

			if (debug > 1) printf("Upload ip: IP\t\t\tCurr.Bitrate\tLast Bitrate\t%s\n",config[1][(int_cnt*6)+1]);
		        ilip_upload[int_cnt] = nr_upload[int_cnt]-1;
		        speed_upload[int_cnt] = (local_int_tab2[1][(int_cnt*6)+4] * mult) / ilip_upload[int_cnt];
		        for(n=1;n<nr_upload[int_cnt];n++)
			{
			    currbitrate = ckbitrate_user_upload(masq_ip_upload[int_cnt][n]);
			    lastbitrate = ckbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],masq_ip_upload[int_cnt][n],int_cnt) * mult;
			    // sprawdzamy czy ktos nie przekracza widelek powyzej tolerancji
			    if (lastbitrate > 0 && (currbitrate > ((lastbitrate*((100+ceil_upload+20)/100)))))
			    {
				int	m;
				struct	IPLISTA *ptr;
				for(m=1;m<iplista_pos;m++)
		    		{
				    ptr = iplista_str + m;
		    		    if ((ip2hex3(masq_ip_upload[int_cnt][n]) & ptr -> mask) == (ptr -> ip & ptr -> mask))
				    {
					ptr -> feir_upload = masq_feir_upload[int_cnt][n];
					if (ptr -> upload_factor < 1) ptr -> upload_factor = 100;
					ptr -> upload_factor = (int)((float)((float)(lastbitrate*((100+ceil_upload)/100))/(float)currbitrate)*100);
					ptr -> shtb_refresh_upload = 1;
					if (ptr -> upload_factor < 1)
					{
					    if (!flagi.clear_firewall_done) syslog(LOG_ERR,"upload_factor is too small !");
					    ptr -> upload_factor = 1;
					}
//					syslog(LOG_ERR,"upload ip: %s curr=%lu last=%lu factor=%d factor_cnt=%d\n",iplista[m],currbitrate,lastbitrate,iplista_upload_factor[m],iplista_upload_factor_cnt[m]);
					(ptr -> upload_factor_cnt)--;
					if (ptr -> upload_factor < check_upload_factor && ptr -> upload_factor_cnt < 1)
					{
					    if (!flagi.clear_firewall_done && control_mesg)
					    {
						syslog(LOG_ERR,"Can't control upload bandwidth of IP %s",masq_ip_upload[int_cnt][n]);
					        syslog(LOG_ERR,"upload ip: %s curr=%lu last=%lu factor=%d factor_cnt=%d\n",ptr -> str_ip,currbitrate,lastbitrate,ptr -> upload_factor,ptr -> upload_factor_cnt);
					    }
					    if (remove_dead_class && ! ptr -> ban_upload_cnt && ! ptr -> ban_upload_cnt2)
					    {
						ptr -> upload_factor = 100;
						ptr -> upload_factor_cnt = check_upload_factor_cnt;
						if (!flagi.clear_firewall_done && control_mesg) syslog(LOG_ERR,"Removing upload class of IP %s",masq_ip_upload[int_cnt][n]);
						del_ip2speed_table(del_tab_upload[int_cnt],masq_ip_upload[int_cnt][n]);
						if (ban_user) ptr -> ban_upload_cnt2 = default_ban_upload_cnt2;
					    }
					    // regenerujemy regulki na firewallu dla tej klasy
					    if (refresh_dead_fwrule && ! ptr -> ban_upload_cnt && ! ptr -> ban_upload_cnt2)
					    {
						del_user_from_firewall(config,ptr);
					        add_user_to_firewall(config,ptr,m);
//						ptr -> is_overlimit = 0;
//    					        ptr -> is_overlimit_upload = 0;
//    					        ptr -> is_shtb_overlimit = 0;
//					        ptr -> is_shtb_overlimit_upload = 0;
				    	        ptr -> shtb_refresh = 1;
					        ptr -> shtb_refresh_upload = 1;
					        ptr -> ipspeed_last = 0;
					        ptr -> squid_speed_last = 0;
					        ptr -> sqout_speed_last = 0;
					        ptr -> ipspeed_last_upload = 0;
//					        ptr -> state_ipspeed_last = 0;
//					        ptr -> state_squid_speed_last = 0;
//					        ptr -> state_sqout_speed_last = 0;
//					        ptr -> state_ipspeed_last_upload = 0;
					    }
					    // banujemy na firewallu usera przekraczajacego widelki
					    if (ban_user && ! ptr -> ban_upload_cnt)
					    {
						syslog(LOG_ERR,"Ban upload of IP %s",masq_ip_upload[int_cnt][n]);
						ban_user_upload(config,ptr);
					        if (ptr -> ban_upload_cnt3 < max_ban_upload)
						    ptr -> ban_upload_cnt = ptr -> ban_upload_cnt3 + default_ban_upload_cnt;
						else
						    ptr -> ban_upload_cnt = max_ban_upload + default_ban_upload_cnt;
						ptr -> ban_upload_cnt3++;
					    }
					}
				    }
				}
			    }
			    else
			    {
				int	m;
				struct	IPLISTA	*ptr;
				
				for(m=1;m<iplista_pos;m++)
		    		{
				    ptr = iplista_str + m;
		    		    if ((ip2hex3(masq_ip_upload[int_cnt][n]) & ptr -> mask) == (ptr -> ip & ptr -> mask))
				    {
					ptr -> feir_upload = masq_feir_upload[int_cnt][n];
					ptr -> upload_factor = 100;
					if (ptr -> upload_factor > 100) ptr -> upload_factor = 100;
    					ptr -> upload_factor_cnt = check_upload_factor_cnt;
					if (ptr -> upload_factor < 1)
					{
					    if (!flagi.clear_firewall_done) syslog(LOG_ERR,"upload_factor is too small !");
					    ptr -> upload_factor = 1;
					}
				    }
				}
			    }

			    if (flagi.clear_firewall_done)
			    {
				if (flagi.clear_firewall_done_counter > 5)
				{
				    flagi.clear_firewall_done = 0;
				    flagi.clear_firewall_done_counter = 0;
			        }
				else flagi.clear_firewall_done_counter++;
			    }

			    // Jesli zmienil sie po reload jakis CIR w kierunku upload to usuwamy klase
			    if (reload_signal2)
			    {
				int		m;
			        struct		IPLISTA	*ptr;
			    
				for(m=1;m<iplista_pos;m++)
				{
				    ptr = iplista_str + m;
				    if (ptr -> refresh_upload)
				    {
					ptr -> upload_factor = 100;
					ptr -> upload_factor_cnt = check_upload_factor_cnt;
//					del_ip2speed_table(del_tab_upload[int_cnt],masq_ip_upload[int_cnt][n]);
				    }
				}
			    }
				
			    if (lastbitrate < 0 || lastbitrate == 0 || (even_division && ! continuous_control))
			        add_ip2speed_table_new(speed_tab_upload[int_cnt],masq_ip_upload[int_cnt][n]);
			    else if ((even_division && continuous_control) || upload_class_type == 3) add_ip2speed_table_nop1(speed_tab_upload[int_cnt],masq_ip_upload[int_cnt][n]);
			    else
			        if (lastbitrate <= speed_upload[int_cnt])
			        {
	    			    if (currbitrate < ((lastbitrate * nop_factor)/100))
				        add_ip2speed_table_sub1(speed_tab_upload[int_cnt],masq_ip_upload[int_cnt][n]);
				    else
				        if (currbitrate < ((lastbitrate * add_factor)/100))
				    	    add_ip2speed_table_nop1(speed_tab_upload[int_cnt],masq_ip_upload[int_cnt][n]);
					else
					    add_ip2speed_table_add1(speed_tab_upload[int_cnt],masq_ip_upload[int_cnt][n]);
				}
				else
				{
				    if (currbitrate < ((lastbitrate * nop_factor)/100))
					add_ip2speed_table_sub2(speed_tab_upload[int_cnt],masq_ip_upload[int_cnt][n]);
				    else
					if (currbitrate < ((lastbitrate * add_factor)/100))
					    add_ip2speed_table_nop2(speed_tab_upload[int_cnt],masq_ip_upload[int_cnt][n]);
					else
					    add_ip2speed_table_add2(speed_tab_upload[int_cnt],masq_ip_upload[int_cnt][n]);
				}
			    if (debug > 1) printf("Upload ip: %s\t\t%lu\t\t%ld\n",masq_ip_upload[int_cnt][n],currbitrate,lastbitrate);
			}
		    }
		}

		if (continuous_control)
		{
		    // Usuwamy ograniczenia download dla niepracujacych numerow IP
		    int         *iplista_fin;
		    int         *iplista_fin2;
		    int		m;
		    int		nodel;
		    struct	IPLISTA	*ptr;

		    if (iplista_pos)
		    {
			iplista_fin = (int *) calloc(iplista_pos,sizeof(int));
			iplista_work[int_cnt] = iplista_fin;

	    		for(n=1;n<iplista_pos;n++)
			    iplista_fin[n] = 0;

			for(n=1;n<iplista_pos;n++)
		        {
			    ptr = iplista_str + n;
			    for(m=1;m<nr[int_cnt];m++)
			    {
		    		if ((ip2hex3(masq_ip_dnload[int_cnt][m]) & ptr -> mask) == (ptr -> ip & ptr -> mask))
				{
		    		    iplista_fin[n] = 1;
				    ptr -> bool = 1;
				}
			    }
			}

			for(n=1;n<iplista_pos;n++)
			{
			    ptr = iplista_str + n;
			    if (! iplista_fin[n])
		    	    {
				nodel = 0;
			        for(m=1;m<local_int_pos;m++)
			        {
				    iplista_fin2 = iplista_work[m];
				    if (iplista_fin2 && iplista_fin2[n])
				    {
					nodel = 1;
					break;
				    }
				}
			    	if ((! nodel) && (!strcmp(config[1][(int_cnt*6)+1],ptr -> int_iface)))
				{
				    del_ip2speed_table(del_tab[int_cnt],ptr -> str_ip);
				}
			    }
			}
		    }

		    // Usuwamy ograniczenia upload dla niepracujacych numerow IP
		    if (divide_upload)
		    {
			if (iplista_pos)
			{
			    struct	IPLISTA	*ptr;

			    iplista_fin = (int *) calloc(iplista_pos,sizeof(int));

	    		    for(n=1;n<iplista_pos;n++)
				iplista_fin[n] = 0;

			    for(n=1;n<iplista_pos;n++)
		    	    {
				ptr = iplista_str + n;
				for(m=1;m<nr_upload[int_cnt];m++)
				{
		    		    if ((ip2hex3(masq_ip_upload[int_cnt][m]) & ptr -> mask) == (ptr -> ip & ptr -> mask))
				    {
		    			iplista_fin[n] = 1;
					ptr -> bool_upload = 1;
				    }
				}
			    }

    			    for(n=1;n<iplista_pos;n++)
			    {
				ptr = iplista_str + n;
				if ((! iplista_fin[n]) && (!strcmp(config[1][(int_cnt*6)+1],ptr -> int_iface)))
		    		{
			    	    del_ip2speed_table(del_tab_upload[int_cnt],ptr -> str_ip);
				}
			    }
			    free(iplista_fin);
			}
		    }
		}
		free(masq_feir_dnload[int_cnt]);
		free(masq_eir_dnload[int_cnt]);
		free(masq_cir_dnload[int_cnt]);
		free(masq_ip_dnload[int_cnt]);
		if (divide_upload)
		{
		    free(masq_feir_upload[int_cnt]);
		    free(masq_eir_upload[int_cnt]);
		    free(masq_cir_upload[int_cnt]);
		    free(masq_ip_upload[int_cnt]);
		}
	    }
	}

	for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
	{
	    if (iplista_work[int_cnt]) free(iplista_work[int_cnt]);
	}

	
	start_time = time(NULL);

	if (! continuous_control)
	{
    	    // usuwamy wszystkie ograniczenia
    	    if (debug>2) printf("debug 3: removing all QoS classes\n");
//    	    cbq_off_local(config);
    	    cbq_off_all(config);

    	    // ustawiamy standardowe ograniczenia
    	    if (debug>2) printf("debug 3: creating root QoS classes\n");
    	    cbq_standard_on(config);
	}
	
	for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
	{
	    // jesli interfejs z internetem
	    if (local_int_tab2[1][(int_cnt*6)+5])
	    {
		reszta[int_cnt] = local_int_tab2[1][(int_cnt*6)+2] - total_dnload_cir;
		reszta_upload[int_cnt] = local_int_tab2[1][(int_cnt*6)+4] - total_upload_cir;
	    
		for(n=1;n<local_int_pos;n++)
		    cnt[int_cnt][n] = 4;

		if (debug>2) printf("debug 3: creating user's download QoS classes for %s interface.\n",config[1][(int_cnt*6)+1]);

		// download new:
		for(n=1;n<nr[int_cnt];n++)
		{
    		    str = get_speed_table_new(speed_tab[int_cnt],n);
		    if (str[0])
		    {
			int		pos;
			char		*intf;
		        char		*ipg;
			int		bcn,isp;
			int		los,his;

			if (class_type != 3)
			{
			    if (1)
			    {
				his = get_ip_hispeed(str);
			        los = get_ip_lospeed(str);
				total_dnload_cir = total_dnload_cir + los;
			        if (los > local_int_tab2[1][(int_cnt*6)+1])
			        {
//			    	    total_dnload_cir += los;
			    	    if (debug > 2) printf("ip=%s add cir=%d total_dnload_cir=%d\n",str,los,total_dnload_cir);
				}
			        if (! always_max)
				{
				    if (!start_speed) tspeed = speed[int_cnt] / mult;
				    else tspeed = (get_ip_lospeed(str) * start_speed);
				    if (tspeed > (speed[int_cnt] / mult))  tspeed = speed[int_cnt] / mult;
				}
			        else tspeed = his;
			        if (tspeed > his) tspeed = his;
			        if (check_sum_of_bandwidth && tspeed > (reszta[int_cnt] / ilip[int_cnt])) tspeed = reszta[int_cnt] / ilip[int_cnt];
				if (tspeed < los) tspeed = los;
				if (los > local_int_tab2[1][(int_cnt*6)+1] && tspeed < los) tspeed = los;
			        if (debug > 1) printf("high_speed_start_dnload: %ld\n",tspeed);
			    }
//			    else tspeed = get_ip_lospeed(str);

    			    if ((pos = get_config_by_ip(config,str)) != -1)
			    {
		    		intf = get_ip_iface(str);
			        bcn = atoi(config[1][(pos*6)+5]);
			        isp = atoi(config[1][(pos*6)+2]);
				ipg = config[1][(pos*6)+3];
			        cbq_class_add(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,1,20,"sharing borrow",class_type,get_ip_str(str));
		    	        bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],str,tspeed,int_cnt);
		    	        reszta[int_cnt] = reszta[int_cnt] - tspeed;
		    	        ilip[int_cnt]--;
		    		cnt[int_cnt][pos]++;
			        if (cnt[int_cnt][pos] > 255)
				{
				    syslog(LOG_ERR,"Ooops! Too many IP numbers. Could be problem with creating CBQ class.");
			    	    if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could be problem with creating CBQ class.\n");
				}
			    }
			    else
		    	    {
				syslog(LOG_ERR,"Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			        if (debug>2) printf("debug 3: Interface name for IP number %s not found in %s/iplist.%d\n",str,CONFIG_DIR,shaperd_counter);
			    }
			    if (debug > 1) printf("new_dnload:  %s\n",str);
			}
			else
			{
			    tspeed = get_ip_hispeed(str);
    			    if ((pos = get_config_by_ip(config,str)) != -1)
			    {
		    		intf = get_ip_iface(str);
			        bcn = atoi(config[1][(pos*6)+5]);
			        isp = atoi(config[1][(pos*6)+2]);
				ipg = config[1][(pos*6)+3];
			        cbq_class_add(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,1,20,"sharing borrow",class_type,get_ip_str(str));
		    	        bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],str,tspeed,int_cnt);
		    	        reszta[int_cnt] = reszta[int_cnt] - tspeed;
		    	        ilip[int_cnt]--;
		    		cnt[int_cnt][pos]++;
			        if (cnt[int_cnt][pos] > 255)
				{
				    syslog(LOG_ERR,"Ooops! Too many IP numbers. Could be problem with creating CBQ class.");
			    	    if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could be problem with creating CBQ class.\n");
				}
			    }
			    else
		    	    {
				syslog(LOG_ERR,"Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			        if (debug>2) printf("debug 3: Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			    }
			    if (debug > 1) printf("new_dnload:  %s\n",str);
			}
		    }
		}

		// upload new:
		if (divide_upload)
		{
		    for(n=1;n<nr_upload[int_cnt];n++)
		    {
    			str = get_speed_table_new(speed_tab_upload[int_cnt],n);
		        if (str[0])
		        {
			    int		pos;
			    char	*intf;
			    char	*ipg;
			    int		bcn,isp;
			    int		los,his;
    
			    if (upload_class_type != 3)
			    {
				if (1)
			        {
				    his = get_ip_hispeed_upload(str);
			    	    los = get_ip_lospeed_upload(str);
				    total_upload_cir = total_upload_cir + los;
			    	    if (los > local_int_tab2[1][(int_cnt*6)+3])
			    	    {
//					total_upload_cir += los;
				        if (debug > 2) printf("ip=%s add cir=%d total_upload_cir=%d\n",str,los,total_upload_cir);
				    }
				    if (!always_max)
				    {
			    		if (!start_speed) tspeed = speed_upload[int_cnt] / mult;
					else tspeed = los * start_speed;
					if (tspeed > (speed_upload[int_cnt] / mult))  tspeed = speed_upload[int_cnt] / mult;
				    }
				    else tspeed = his;
			    	    if (tspeed > his) tspeed = his;
			    	    if (check_sum_of_bandwidth && tspeed > (reszta_upload[int_cnt] / ilip_upload[int_cnt])) tspeed = reszta_upload[int_cnt] / ilip_upload[int_cnt];
			    	    if (tspeed < los) tspeed = los;
			    	    if (los > local_int_tab2[1][(int_cnt*6)+3] && tspeed < los) tspeed = los;
				    if (debug > 1) printf("high_speed_start_upload: %ld\n",tspeed);
				}
			        else tspeed = get_ip_lospeed_upload(str);

    				if ((pos = get_config_by_ip_upload(config,str)) != -1)
			        {
		    		    intf = get_ip_int_iface(str);
			    	    bcn = atoi(config[1][(pos*6)+3]);
			    	    isp = local_int_tab2[1][(int_cnt*6)+4];
//			    	    ipg = config[1][(pos*6)+3];
			    	    ipg = config[1][((get_config_by_ip(config,str))*6)+3];
				    if (get_config_by_ip(config,str) == -1) ipg="0.0.0.0/0";

			    	    cbq_class_add_upload(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,1,20,"sharing borrow",upload_class_type,get_ip_str(str));
		    	    	    if (squid_ingress) cbq_ingress_add(get_ip_iface(str),tspeed,bcn,get_ip_cnt(str)+4,ipg,str,16);
				    bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,tspeed,int_cnt);
		    		    reszta_upload[int_cnt] = reszta_upload[int_cnt] - tspeed;
		    	    	    ilip_upload[int_cnt]--;
				}
			        else
		    		{
				    syslog(LOG_ERR,"Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			    	    if (debug>2) printf("debug 3: Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
				}
				if (debug > 1) printf("new_upload:  %s\n",str);
			    }
			    else
			    {
				tspeed = get_ip_hispeed_upload(str);
    			        if ((pos = get_config_by_ip_upload(config,str)) != -1)
			        {
		    		    intf = get_ip_int_iface(str);
			    	    bcn = atoi(config[1][(pos*6)+3]);
			    	    isp = local_int_tab2[1][(int_cnt*6)+4];
//			    	    ipg = config[1][(pos*6)+3];
				    ipg = config[1][((get_config_by_ip(config,str))*6)+3];
				    if (get_config_by_ip(config,str) == -1) ipg="0.0.0.0/0";

			    	    cbq_class_add_upload(intf,isp,tspeed,bcn,get_ip_cnt(str)+4,ipg,str,1,20,"sharing borrow",upload_class_type,get_ip_str(str));
				    if (squid_ingress) cbq_ingress_add(get_ip_iface(str),tspeed,bcn,get_ip_cnt(str)+4,ipg,str,16);
		    	    	    bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,tspeed,int_cnt);
		    		    reszta_upload[int_cnt] = reszta_upload[int_cnt] - tspeed;
		    	    	    ilip_upload[int_cnt]--;
				}
			        else
		    		{
				    syslog(LOG_ERR,"Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			    	    if (debug>2) printf("debug 3: Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
				}
				if (debug > 1) printf("new_upload:  %s\n",str);
			    }
			}
		    }
		}
//printf("1\n");
		// download sub1:
		for(n=1;n<nr[int_cnt];n++)
		{
		    str = get_speed_table_sub1(speed_tab[int_cnt],n);
		    if (str[0])
		    {
	    		int		pos;
	    	        char		*intf;
		        char		*ipg;
	    		int		bcn,isp;
		        int		his,los,fact;

	        	lastbitrate = ckbitrate_user_last(bitrate_user_last[int_cnt],str,int_cnt) * mult;
	        	if (! even_division) tspeed = ((lastbitrate * add_factor)/100) / mult;
			else tspeed = speed[int_cnt] / mult;
		        his = get_ip_hispeed(str);
		        los = get_ip_lospeed(str);
			if (los > local_int_tab2[1][(int_cnt*6)+1]) reszta[int_cnt] += los;
			if (tspeed > his) tspeed = his;
			if (check_sum_of_bandwidth && tspeed > (reszta[int_cnt] / ilip[int_cnt])) tspeed = reszta[int_cnt] / ilip[int_cnt];
	        	if (tspeed < los) tspeed = los;
			if (los > local_int_tab2[1][(int_cnt*6)+1] && tspeed < los) tspeed = los;
    	    	        if ((pos = get_config_by_ip(config,str)) != -1)
			{
	    	            intf = get_ip_iface(str);
		            bcn = atoi(config[1][(pos*6)+5]);
		            isp = atoi(config[1][(pos*6)+2]);
		    	    ipg = config[1][(pos*6)+3];
			    fact = get_ip_factor(str);
			    if (! continuous_control) cbq_class_add(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,0,20,"",class_type,get_ip_str(str));
			    else cbq_class_change(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,0,20,"",class_type,get_ip_str(str));
		            bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],str,tspeed,int_cnt);
		            reszta[int_cnt] = reszta[int_cnt] - tspeed;
		            ilip[int_cnt]--;
		            cnt[int_cnt][pos]++;
			    if (cnt[int_cnt][pos] > 255)
			    {
			        syslog(LOG_ERR,"Ooops! Too many IP numbers. Could be problem with creating CBQ class.");
			        if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could be problem with creating CBQ class.\n");
			    }
			}
		        else
	    	        {
		    	    syslog(LOG_ERR,"Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			}
		        if (debug > 1) printf("sub1_dnload:  %s\n",str);
		    }
		}
//printf("2\n");
		// upload sub1:
		if (divide_upload) {
		for(n=1;n<nr_upload[int_cnt];n++)
		{
		    str = get_speed_table_sub1(speed_tab_upload[int_cnt],n);
		    if (str[0])
		    {
	    	        int		pos;
	    	        char		*intf;
			char		*ipg;
	    	        int		bcn,isp;
			int		his,los,fact;

	        	lastbitrate = ckbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,int_cnt) * mult;
	        	if (! even_division) tspeed = ((lastbitrate * add_factor)/100) / mult;
			else tspeed = speed_upload[int_cnt] / mult;
		        his = get_ip_hispeed_upload(str);
		        los = get_ip_lospeed_upload(str);
			if (los > local_int_tab2[1][(int_cnt*6)+3]) reszta_upload[int_cnt] += los;
	        	if (tspeed > his) tspeed = his;
			if (check_sum_of_bandwidth && tspeed > (reszta_upload[int_cnt] / ilip_upload[int_cnt])) tspeed = reszta_upload[int_cnt] / ilip_upload[int_cnt];
	        	if (tspeed < los) tspeed = los;
			if (los > local_int_tab2[1][(int_cnt*6)+3] && tspeed < los) tspeed = los;
    	    	        if ((pos = get_config_by_ip_upload(config,str)) != -1)
			{
	    	            intf = get_ip_int_iface(str);
		            bcn = atoi(config[1][(pos*6)+3]);
			    isp = local_int_tab2[1][(int_cnt*6)+4];
//		    	    ipg = config[1][(pos*6)+3];
			    ipg = config[1][((get_config_by_ip(config,str))*6)+3];
			    if (get_config_by_ip(config,str) == -1) ipg="0.0.0.0/0";
			    fact = get_ip_upload_factor(str);
			    if (! continuous_control)
			    {
				cbq_class_add_upload(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,0,20,"",upload_class_type,get_ip_str(str));
				if (squid_ingress) cbq_ingress_add(get_ip_iface(str),tspeed,bcn,get_ip_cnt(str)+4,ipg,str,16);
			    }
			    else 
			    {
				cbq_class_change_upload(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,0,20,"",upload_class_type,get_ip_str(str));
				if (squid_ingress) cbq_ingress_change(get_ip_iface(str),tspeed,bcn,get_ip_cnt(str)+4,ipg,str,16);
			    }
		            bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,tspeed,int_cnt);
		            reszta_upload[int_cnt] = reszta_upload[int_cnt] - tspeed;
		            ilip_upload[int_cnt]--;
//		            cnt[int_cnt][pos]++;
//			    if (cnt[int_cnt][pos] > 255)
//			    {
//			        syslog(LOG_ERR,"Ooops! Too many IP numbers. Could be problem with creating CBQ class.");
//			        if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could be problem with creating CBQ class.\n");
//			    }
			}
		        else
	    	        {
		    	    syslog(LOG_ERR,"Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			}
		        if (debug > 1) printf("sub1_upload:  %s\n",str);
		    }
		}
		}
//printf("3\n");
		// download nop1:
		for(n=1;n<nr[int_cnt];n++)
		{
		    str = get_speed_table_nop1(speed_tab[int_cnt],n);
	    	    if (str[0])
	    	    {
			int		pos;
	    	        char		*intf;
			char    	*ipg;
	    	        int		bcn,isp;
		        int		los,his,fact;

			if (class_type != 3)
			{
	    	    	    lastbitrate = ckbitrate_user_last(bitrate_user_last[int_cnt],str,int_cnt) * mult;
		    	    his = get_ip_hispeed(str);
		    	    los = get_ip_lospeed(str);
			    if (los > local_int_tab2[1][(int_cnt*6)+1]) reszta[int_cnt] += los;
		    	    if (! even_division) tspeed = lastbitrate / mult;
			    else tspeed = speed[int_cnt] / mult;
		    	    if (tspeed > his) tspeed = his;
			    if (check_sum_of_bandwidth && tspeed > (reszta[int_cnt] / ilip[int_cnt])) tspeed = reszta[int_cnt] / ilip[int_cnt];
		    	    if (check_sum_of_bandwidth && tspeed > reszta[int_cnt]) tspeed = reszta[int_cnt];
		    	    if (tspeed < los) tspeed = los;
			    if (los > local_int_tab2[1][(int_cnt*6)+1] && tspeed < los) tspeed = los;
    			    if ((pos = get_config_by_ip(config,str)) != -1)
		    	    {
		        	intf = get_ip_iface(str);
			        bcn = atoi(config[1][(pos*6)+5]);
		    	        isp = atoi(config[1][(pos*6)+2]);
		    	        ipg = config[1][(pos*6)+3];
			        fact = get_ip_factor(str);
		    	        if (! continuous_control) cbq_class_add(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,1,20,"",class_type,get_ip_str(str));
			        else cbq_class_change(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,1,20,"",class_type,get_ip_str(str));
		    	        bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],str,tspeed,int_cnt);
		    	        reszta[int_cnt] = reszta[int_cnt] - tspeed;
		    	        ilip[int_cnt]--;
		    	        cnt[int_cnt][pos]++;
			        if (cnt[int_cnt][pos] > 255)
				{
			    	    syslog(LOG_ERR,"Ooops! Too many IP numbers. Could be problem with creating CBQ class.");
				    if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could be problem with creating CBQ class.\n");
				}
			    }
		    	    else
			    {
				syslog(LOG_ERR,"Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			        if (debug>2) printf("debug 3: Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			    }
			    if (debug > 1) printf("nop1_dnload:  %s\n",str);
			}
			else
			// Jesli class_type=SHTB to zmieniamy szybkosc tylko po przekroczeniu default_download_limit
			{
			    struct	IPLISTA * ptr;
			
			    ptr = get_ip_str(str);
	    		    lastbitrate = ckbitrate_user_last(bitrate_user_last[int_cnt],str,int_cnt) * mult;
		    	    his = get_ip_hispeed(str);
			    tspeed = his;
			    if (ptr && (ptr -> shtb_refresh || (! ptr -> is_shtb_overlimit && ptr -> is_overlimit)))
			    {
    				if ((pos = get_config_by_ip(config,str)) != -1)
		    	        {
				    ptr -> is_shtb_overlimit = 1;
				    ptr -> shtb_refresh = 0;
		    		    intf = get_ip_iface(str);
			    	    bcn = atoi(config[1][(pos*6)+5]);
		    	    	    isp = atoi(config[1][(pos*6)+2]);
		    	    	    ipg = config[1][(pos*6)+3];
				    fact = get_ip_factor(str);
		    	    	    if (! continuous_control) cbq_class_add(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,1,20,"",class_type,get_ip_str(str));
			    	    else cbq_class_change(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,1,20,"",class_type,get_ip_str(str));
		    	    	    bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],str,tspeed,int_cnt);
		    	    	    reszta[int_cnt] = reszta[int_cnt] - tspeed;
		    	    	    ilip[int_cnt]--;
		    	    	    cnt[int_cnt][pos]++;
			    	    if (cnt[int_cnt][pos] > 255)
			    	    {
					syslog(LOG_ERR,"Ooops! Too many IP numbers. Could be problem with creating CBQ class.");
				        if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could be problem with creating CBQ class.\n");
				    }
				}
		    	        else
				{
				    syslog(LOG_ERR,"Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			    	    if (debug>2) printf("debug 3: Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
				}
			    	if (debug > 1) printf("nop1_dnload:  %s\n",str);
			    }
			}
		    }
		}
		// upload nop1:
		if (divide_upload)
		{
		    for(n=1;n<nr_upload[int_cnt];n++)
		    {
			str = get_speed_table_nop1(speed_tab_upload[int_cnt],n);
	    	        if (str[0])
	    		{
			    int		pos;
	    	    	    char		*intf;
			    char    	*ipg;
	    	    	    int		bcn,isp;
			    int		los,his,fact;

			    if (upload_class_type != 3)
			    {
	    	    	        lastbitrate = ckbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,int_cnt) * mult;
		    		his = get_ip_hispeed_upload(str);
		    	        los = get_ip_lospeed_upload(str);
			        if (los > local_int_tab2[1][(int_cnt*6)+3]) reszta_upload[int_cnt] += los;
		    	        if (! even_division) tspeed = lastbitrate / mult;
			        else tspeed = speed_upload[int_cnt] / mult;
		    	        if (tspeed > his) tspeed = his;
			        if (check_sum_of_bandwidth && tspeed > (reszta_upload[int_cnt] / ilip_upload[int_cnt])) tspeed = reszta_upload[int_cnt] / ilip_upload[int_cnt];
		    	        if (check_sum_of_bandwidth && tspeed > reszta_upload[int_cnt]) tspeed = reszta_upload[int_cnt];
		    	        if (tspeed < los) tspeed = los;
			        if (los > local_int_tab2[1][(int_cnt*6)+3] && tspeed < los) tspeed = los;
    			        if ((pos = get_config_by_ip_upload(config,str)) != -1)
		    	        {
		        	    intf = get_ip_int_iface(str);
			    	    bcn = atoi(config[1][(pos*6)+3]);
				    isp = local_int_tab2[1][(int_cnt*6)+4];
//		    	    	    ipg = config[1][(pos*6)+3];
				    ipg = config[1][((get_config_by_ip(config,str))*6)+3];
				    if (get_config_by_ip(config,str) == -1) ipg="0.0.0.0/0";
				    fact = get_ip_upload_factor(str);
		    	    	    if (! continuous_control)
				    {
					cbq_class_add_upload(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,1,20,"",upload_class_type,get_ip_str(str));
					if (squid_ingress) cbq_ingress_add(get_ip_iface(str),tspeed,bcn,get_ip_cnt(str)+4,ipg,str,16);
				    }
				    else
				    {
					cbq_class_change_upload(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,1,20,"",upload_class_type,get_ip_str(str));
					if (squid_ingress) cbq_ingress_change(get_ip_iface(str),tspeed,bcn,get_ip_cnt(str)+4,ipg,str,16);
				    }
		    	    	    bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,tspeed,int_cnt);
		    		    reszta_upload[int_cnt] = reszta_upload[int_cnt] - tspeed;
		    	    	    ilip_upload[int_cnt]--;
				}
		    	        else
				{
				    syslog(LOG_ERR,"Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			    	    if (debug>2) printf("debug 3: Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
				}
				if (debug > 1) printf("nop1_upload:  %s\n",str);
			    }
			    else
			    {
				struct	IPLISTA * ptr;
			    
    				ptr = get_ip_str(str);
	    	    	        lastbitrate = ckbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,int_cnt) * mult;
		    		his = get_ip_hispeed_upload(str);
				tspeed = his;
				if (ptr && (ptr -> shtb_refresh_upload || (! ptr -> is_shtb_overlimit_upload && ptr -> is_overlimit_upload)))
				{
    				    if ((pos = get_config_by_ip_upload(config,str)) != -1)
		    	    	    {
					ptr -> is_shtb_overlimit_upload = 1;
					ptr -> shtb_refresh_upload = 0;
		    		        intf = get_ip_int_iface(str);
			    	        bcn = atoi(config[1][(pos*6)+3]);
				        isp = local_int_tab2[1][(int_cnt*6)+4];
//		    	    	        ipg = config[1][(pos*6)+3];
					ipg = config[1][((get_config_by_ip(config,str))*6)+3];
					if (get_config_by_ip(config,str) == -1) ipg="0.0.0.0/0";
				        fact = get_ip_upload_factor(str);
		    	    	        if (! continuous_control)
					{
					    cbq_class_add_upload(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,1,20,"",upload_class_type,get_ip_str(str));
					    if (squid_ingress) cbq_ingress_add(get_ip_iface(str),tspeed,bcn,get_ip_cnt(str)+4,ipg,str,16);
					}
				        else
					{
					    cbq_class_change_upload(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,1,20,"",upload_class_type,get_ip_str(str));
					    if (squid_ingress) cbq_ingress_change(get_ip_iface(str),tspeed,bcn,get_ip_cnt(str)+4,ipg,str,16);
					}
		    		        bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,tspeed,int_cnt);
		    	    	        reszta_upload[int_cnt] = reszta_upload[int_cnt] - tspeed;
		    		        ilip_upload[int_cnt]--;
				    }
		    		    else
			    	    {
					syslog(LOG_ERR,"Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			    	        if (debug>2) printf("debug 3: Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
				    }
			    	    if (debug > 1) printf("nop1_upload:  %s\n",str);
				}
			    }
			}
		    }
		}

		// download add1:
		for(n=1;n<nr[int_cnt];n++)
		{
	    	    str = get_speed_table_add1(speed_tab[int_cnt],n);
		    if (str[0])
	    	    {
	    	        int		pos;
	    		char		*intf;
		        char	        *ipg;
		        int		bcn,isp;
			int		los,his,fact;

	    	        lastbitrate = ckbitrate_user_last(bitrate_user_last[int_cnt],str,int_cnt) * mult;
		        los = get_ip_lospeed(str);
		        his = get_ip_hispeed(str);
			if (los > local_int_tab2[1][(int_cnt*6)+1]) reszta[int_cnt] += los;
		        if (! even_division)
			{
			    if (jump_type) tspeed = ((lastbitrate/mult) + (los * jump_type));
			    else tspeed = ((lastbitrate/mult) + (reszta[int_cnt] / ilip[int_cnt]));
			}
			else tspeed = speed[int_cnt] / mult;
			if (tspeed > his) tspeed = his;
		        if (check_sum_of_bandwidth && tspeed > (reszta[int_cnt] / ilip[int_cnt])) tspeed = reszta[int_cnt] / ilip[int_cnt];
		        if (check_sum_of_bandwidth && tspeed > reszta[int_cnt]) tspeed = reszta[int_cnt];
			if (tspeed < los) tspeed = los;
			if (los > local_int_tab2[1][(int_cnt*6)+1] && tspeed < los) tspeed = los;
    		        if ((pos = get_config_by_ip(config,str)) != -1)
		        {
	    	            intf = get_ip_iface(str);
		            bcn = atoi(config[1][(pos*6)+5]);
		            isp = atoi(config[1][(pos*6)+2]);
		    	    ipg = config[1][(pos*6)+3];
			    fact = get_ip_factor(str);
		    	    if (! continuous_control) cbq_class_add(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,2,20,"",class_type,get_ip_str(str));
			    else cbq_class_change(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,2,20,"",class_type,get_ip_str(str));
			    bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],str,tspeed,int_cnt);
		    	    reszta[int_cnt] = reszta[int_cnt] - tspeed;
		    	    ilip[int_cnt]--;
		    	    cnt[int_cnt][pos]++;
			    if (cnt[int_cnt][pos] > 255)
			    {
			        syslog(LOG_ERR,"Ooops! Too many IP numbers. Could be problem with creating CBQ class.");
			        if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could be problem with creating CBQ class.\n");
			    }
			}
		        else
		        {
		    	    syslog(LOG_ERR,"Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			}
			if (debug > 1) printf("add1_dnload:  %s\n",str);
		    }
    		}

		// upload add1:
		if (divide_upload) {
		for(n=1;n<nr_upload[int_cnt];n++)
		{
	    	    str = get_speed_table_add1(speed_tab_upload[int_cnt],n);
		    if (str[0])
	    	    {
	    	        int		pos;
	    		char		*intf;
		        char	        *ipg;
			int		bcn,isp;
		        int		los,his,fact;

	    	        lastbitrate = ckbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,int_cnt) * mult;
		        los = get_ip_lospeed_upload(str);
		        his = get_ip_hispeed_upload(str);
			if (los > local_int_tab2[1][(int_cnt*6)+3]) reszta_upload[int_cnt] += los;
		        if (! even_division)
			{
			    if (jump_type) tspeed = ((lastbitrate/mult) + (los * jump_type));
			    else tspeed = ((lastbitrate/mult) + (reszta_upload[int_cnt] / ilip_upload[int_cnt]));
			}
			else tspeed = speed_upload[int_cnt] / mult;
			if (tspeed > his) tspeed = his;
		        if (check_sum_of_bandwidth && tspeed > (reszta_upload[int_cnt] / ilip_upload[int_cnt])) tspeed = reszta_upload[int_cnt] / ilip_upload[int_cnt];
		        if (check_sum_of_bandwidth && tspeed > reszta_upload[int_cnt]) tspeed = reszta_upload[int_cnt];
			if (tspeed < los) tspeed = los;
			if (los > local_int_tab2[1][(int_cnt*6)+3] && tspeed < los) tspeed = los;
    		        if ((pos = get_config_by_ip_upload(config,str)) != -1)
		        {
	    	            intf = get_ip_int_iface(str);
		            bcn = atoi(config[1][(pos*6)+3]);
			    isp = local_int_tab2[1][(int_cnt*6)+4];
//		    	    ipg = config[1][(pos*6)+3];
			    ipg = config[1][((get_config_by_ip(config,str))*6)+3];
			    if (get_config_by_ip(config,str) == -1) ipg="0.0.0.0/0";
			    fact = get_ip_upload_factor(str);
		    	    if (! continuous_control)
			    {
				cbq_class_add_upload(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,2,20,"",upload_class_type,get_ip_str(str));
				if (squid_ingress) cbq_ingress_add(get_ip_iface(str),tspeed,bcn,get_ip_cnt(str)+4,ipg,str,16);
			    }
			    else
			    {
				cbq_class_change_upload(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,2,20,"",upload_class_type,get_ip_str(str));
				if (squid_ingress) cbq_ingress_change(get_ip_iface(str),tspeed,bcn,get_ip_cnt(str)+4,ipg,str,16);
			    }
			    bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,tspeed,int_cnt);
		    	    reszta_upload[int_cnt] = reszta_upload[int_cnt] - tspeed;
		    	    ilip_upload[int_cnt]--;
			}
		        else
		        {
		    	    syslog(LOG_ERR,"Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			}
			if (debug > 1) printf("add1_upload:  %s\n",str);
		    }
    		}
		}

		// download sub2:
		for(n=1;n<nr[int_cnt];n++)
	        {
	    	    str = get_speed_table_sub2(speed_tab[int_cnt],n);
	    	    if (str[0])
	    	    {
    	        	int		pos;
	    	        char		*intf;
		        char		*ipg;
	    	        int		bcn,isp;
			int		his,los,fact;

		        lastbitrate = ckbitrate_user_last(bitrate_user_last[int_cnt],str,int_cnt) * mult;
		        if (! even_division) tspeed = ((lastbitrate * add_factor)/100) / mult;
			else tspeed = speed[int_cnt] / mult;
		        los = get_ip_lospeed(str);
		        his = get_ip_hispeed(str);
			if (los > local_int_tab2[1][(int_cnt*6)+1]) reszta[int_cnt] += los;
			if (tspeed > his) tspeed = his;
			if (check_sum_of_bandwidth && tspeed > (reszta[int_cnt] / ilip[int_cnt])) tspeed = reszta[int_cnt] / ilip[int_cnt];
		        if (check_sum_of_bandwidth && tspeed > reszta[int_cnt]) tspeed = reszta[int_cnt];
			if (tspeed < los) tspeed = los;
			if (los > local_int_tab2[1][(int_cnt*6)+1] && tspeed < los) tspeed = los;
    	    	        if ((pos = get_config_by_ip(config,str)) != -1)
	    	        {
	    		    intf = get_ip_iface(str);
			    bcn = atoi(config[1][(pos*6)+5]);
		    	    isp = atoi(config[1][(pos*6)+2]);
			    ipg = config[1][(pos*6)+3];
			    fact = get_ip_factor(str);
		    	    if (! continuous_control) cbq_class_add(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,2,20,"",class_type,get_ip_str(str));
			    else cbq_class_change(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,2,20,"",class_type,get_ip_str(str));
			    bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],str,tspeed,int_cnt);
		    	    reszta[int_cnt] = reszta[int_cnt] - tspeed;
		    	    ilip[int_cnt]--;
		    	    cnt[int_cnt][pos]++;
			    if (cnt[int_cnt][pos] > 255)
			    {
				syslog(LOG_ERR,"Ooops! Too many IP numbers. Could be problem with creating CBQ class.");
			        if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could be problem with creating CBQ class.\n");
			    }
			}
	    	        else
			{
			    syslog(LOG_ERR,"Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
	    		}
	    		if (debug > 1) printf("sub2_dnload:  %s\n",str);
		    }
		}

		// upload sub2:
		if (divide_upload) {
		for(n=1;n<nr_upload[int_cnt];n++)
	        {
	    	    str = get_speed_table_sub2(speed_tab_upload[int_cnt],n);
	    	    if (str[0])
	    	    {
    	    		int		pos;
		        char		*intf;
			char    	*ipg;
	    	        int		bcn,isp;
			int		his,los,fact;

		        lastbitrate = ckbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,int_cnt) * mult;
		        if (! even_division) tspeed = ((lastbitrate * add_factor)/100) / mult;
			else tspeed = speed_upload[int_cnt] / mult;
		        los = get_ip_lospeed_upload(str);
		        his = get_ip_hispeed_upload(str);
			if (los > local_int_tab2[1][(int_cnt*6)+3]) reszta_upload[int_cnt] += los;
			if (tspeed > his) tspeed = his;
			if (check_sum_of_bandwidth && tspeed > (reszta_upload[int_cnt] / ilip_upload[int_cnt])) tspeed = reszta_upload[int_cnt] / ilip_upload[int_cnt];
		        if (check_sum_of_bandwidth && tspeed > reszta_upload[int_cnt]) tspeed = reszta_upload[int_cnt];
			if (tspeed < los) tspeed = los;
			if (los > local_int_tab2[1][(int_cnt*6)+3] && tspeed < los) tspeed = los;
    	    	        if ((pos = get_config_by_ip_upload(config,str)) != -1)
	    	        {
	    		    intf = get_ip_int_iface(str);
			    bcn = atoi(config[1][(pos*6)+3]);
			    isp = local_int_tab2[1][(int_cnt*6)+4];
//			    ipg = config[1][(pos*6)+3];
			    ipg = config[1][((get_config_by_ip(config,str))*6)+3];
			    if (get_config_by_ip(config,str) == -1) ipg="0.0.0.0/0";
			    fact = get_ip_upload_factor(str);
		    	    if (! continuous_control)
			    {
				cbq_class_add_upload(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,2,20,"",upload_class_type,get_ip_str(str));
				if (squid_ingress) cbq_ingress_add(get_ip_iface(str),tspeed,bcn,get_ip_cnt(str)+4,ipg,str,16);
			    }
			    else
			    {
				cbq_class_change_upload(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,2,20,"",upload_class_type,get_ip_str(str));
				if (squid_ingress) cbq_ingress_change(get_ip_iface(str),tspeed,bcn,get_ip_cnt(str)+4,ipg,str,16);
			    }
			    bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,tspeed,int_cnt);
		    	    reszta_upload[int_cnt] = reszta_upload[int_cnt] - tspeed;
		    	    ilip_upload[int_cnt]--;
			}
	    	        else
			{
			    syslog(LOG_ERR,"Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
	    		}
	    		if (debug > 1) printf("sub2_upload:  %s\n",str);
		    }
		}
		}

		// download nop2
	        for(n=1;n<nr[int_cnt];n++)
    		{
		    str = get_speed_table_nop2(speed_tab[int_cnt],n);
	    	    if (str[0])
	    	    {
	    		int		pos;
	    	        char		*intf;
			char    	*ipg;
		        int		bcn,isp;
			int		los,his,fact;

	        	lastbitrate = ckbitrate_user_last(bitrate_user_last[int_cnt],str,int_cnt) * mult;
	    	        if (! even_division) tspeed = lastbitrate / mult;
			else tspeed = speed[int_cnt] / mult;
			los = get_ip_lospeed(str);
			his = get_ip_hispeed(str);
			if (los > local_int_tab2[1][(int_cnt*6)+1]) reszta[int_cnt] += los;
			if (tspeed > his) tspeed = his;
	    	        if (check_sum_of_bandwidth && tspeed > (reszta[int_cnt] / ilip[int_cnt])) tspeed = reszta[int_cnt] / ilip[int_cnt];
		        if (check_sum_of_bandwidth && tspeed > reszta[int_cnt]) tspeed = reszta[int_cnt];
			if (tspeed < los) tspeed = los;
			if (los > local_int_tab2[1][(int_cnt*6)+1] && tspeed < los) tspeed = los;
    	    	        if ((pos = get_config_by_ip(config,str)) != -1)
	    		{
			    intf = get_ip_iface(str);
			    bcn = atoi(config[1][(pos*6)+5]);
			    isp = atoi(config[1][(pos*6)+2]);
			    ipg = config[1][(pos*6)+3];
			    fact = get_ip_factor(str);
			    if (! continuous_control) cbq_class_add(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,3,20,"",class_type,get_ip_str(str));
			    else cbq_class_change(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,3,20,"",class_type,get_ip_str(str));
		    	    bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],str,tspeed,int_cnt);
		    	    reszta[int_cnt] = reszta[int_cnt] - tspeed;
		    	    ilip[int_cnt]--;
		    	    cnt[int_cnt][pos]++;
			    if (cnt[int_cnt][pos] > 255)
			    {
			        syslog(LOG_ERR,"Ooops! Too many IP numbers. Could be problem with creating CBQ class.");
			        if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could be problem with creating CBQ class.\n");
			    }
			}
	    	        else
	    		{
			    syslog(LOG_ERR,"Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			}
	    	        if (debug > 1) printf("nop2_dnload:  %s\n",str);
		    }
		}

		// upload nop2
		if (divide_upload) {
	        for(n=1;n<nr_upload[int_cnt];n++)
    		{
		    str = get_speed_table_nop2(speed_tab_upload[int_cnt],n);
	    	    if (str[0])
	    	    {
	    		int		pos;
	    	        char		*intf;
			char    	*ipg;
		        int		bcn,isp;
			int		los,his,fact;

	        	lastbitrate = ckbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,int_cnt) * mult;
	    	        if (! even_division) tspeed = lastbitrate / mult;
			else tspeed = speed_upload[int_cnt] / mult;
			los = get_ip_lospeed_upload(str);
			his = get_ip_hispeed_upload(str);
			if (los > local_int_tab2[1][(int_cnt*6)+3]) reszta_upload[int_cnt] += los;
			if (tspeed > his) tspeed = his;
	    	        if (check_sum_of_bandwidth && tspeed > (reszta_upload[int_cnt] / ilip_upload[int_cnt])) tspeed = reszta_upload[int_cnt] / ilip_upload[int_cnt];
		        if (check_sum_of_bandwidth && tspeed > reszta_upload[int_cnt]) tspeed = reszta_upload[int_cnt];
			if (tspeed < los) tspeed = los;
			if (los > local_int_tab2[1][(int_cnt*6)+3] && tspeed < los) tspeed = los;
    	    	        if ((pos = get_config_by_ip_upload(config,str)) != -1)
	    		{
			    intf = get_ip_int_iface(str);
			    bcn = atoi(config[1][(pos*6)+3]);
//			    isp = atoi(config[1][(pos*6)+2]);
			    isp = local_int_tab2[1][(int_cnt*6)+4];
//			    ipg = config[1][(pos*6)+3];
			    ipg = config[1][((get_config_by_ip(config,str))*6)+3];
			    if (get_config_by_ip(config,str) == -1) ipg="0.0.0.0/0";
			    fact = get_ip_upload_factor(str);
			    if (! continuous_control)
			    {
				cbq_class_add_upload(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,3,20,"",upload_class_type,get_ip_str(str));
				if (squid_ingress) cbq_ingress_add(get_ip_iface(str),tspeed,bcn,get_ip_cnt(str)+4,ipg,str,16);
			    }
			    else
			    {
				cbq_class_change_upload(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,3,20,"",upload_class_type,get_ip_str(str));
				if (squid_ingress) cbq_ingress_change(get_ip_iface(str),tspeed,bcn,get_ip_cnt(str)+4,ipg,str,16);
			    }
		    	    bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,tspeed,int_cnt);
		    	    reszta_upload[int_cnt] = reszta_upload[int_cnt] - tspeed;
		    	    ilip_upload[int_cnt]--;
			}
	    	        else
	    		{
			    syslog(LOG_ERR,"Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			}
	    	        if (debug > 1) printf("nop2_dnload:  %s\n",str);
		    }
		}
		}

		// download add2
		for(n=1;n<nr[int_cnt];n++)
    		{
		    str = get_speed_table_add2(speed_tab[int_cnt],n);
	    	    if (str[0])
		    {
	    		int		pos;
    		        char		*intf;
			char		*ipg;
		        int		bcn,isp;
			int		los,his,fact;

		        lastbitrate = ckbitrate_user_last(bitrate_user_last[int_cnt],str,int_cnt) * mult;
			los = get_ip_lospeed(str);
		        his = get_ip_hispeed(str);
			if (los > local_int_tab2[1][(int_cnt*6)+1]) reszta[int_cnt] += los;
		        if (! even_division)
			{
			    if (jump_type) tspeed = ((lastbitrate/mult) + (los * jump_type));
			    else tspeed = ((lastbitrate/mult) + (reszta[int_cnt] / ilip[int_cnt]));
			}
			else tspeed = speed[int_cnt] / mult;
		        if (tspeed > his) tspeed = his;
			if (check_sum_of_bandwidth && tspeed > (reszta[int_cnt] / ilip[int_cnt])) tspeed = reszta[int_cnt] / ilip[int_cnt];
		        if (tspeed < los) tspeed = los;
			if (los > local_int_tab2[1][(int_cnt*6)+1] && tspeed < los) tspeed = los;
    			if ((pos = get_config_by_ip(config,str)) != -1)
	    		{
			    intf = get_ip_iface(str);
		    	    bcn = atoi(config[1][(pos*6)+5]);
		    	    isp = atoi(config[1][(pos*6)+2]);
			    ipg = config[1][(pos*6)+3];
			    fact = get_ip_factor(str);
			    if (! continuous_control) cbq_class_add(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,3,20,"",class_type,get_ip_str(str));
			    else cbq_class_change(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,3,20,"",class_type,get_ip_str(str));
		    	    bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],str,tspeed,int_cnt);
		    	    reszta[int_cnt] = reszta[int_cnt] - tspeed;
		    	    ilip[int_cnt]--;
		    	    cnt[int_cnt][pos]++;
			    if (cnt[int_cnt][pos] > 255)
			    {
				syslog(LOG_ERR,"Ooops! Too many IP numbers. Could be problem with creating CBQ class.");
				if (debug>2) printf("debug 3: Ooops! Too many IP numbers. Could be problem with creating CBQ class.\n");
			    }
			}
			else
			{
			    syslog(LOG_ERR,"Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			}
			if (debug > 1) printf("add2_dnload:  %s\n",str);
		    }
		}

		// upload add2
		if (divide_upload) {
		for(n=1;n<nr_upload[int_cnt];n++)
    		{
		    str = get_speed_table_add2(speed_tab_upload[int_cnt],n);
	    	    if (str[0])
		    {
	    		int		pos;
		        char		*intf;
			char    	*ipg;
		        int		bcn,isp;
			int		los,his,fact;

		        lastbitrate = ckbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,int_cnt) * mult;
			los = get_ip_lospeed_upload(str);
		        his = get_ip_hispeed_upload(str);
			if (los > local_int_tab2[1][(int_cnt*6)+3]) reszta_upload[int_cnt] += los;
		        if (! even_division)
			{
			    if (jump_type) tspeed = ((lastbitrate/mult) + (los * jump_type));
			    else tspeed = ((lastbitrate/mult) + (reszta_upload[int_cnt] / ilip_upload[int_cnt]));
			}
			else tspeed = speed_upload[int_cnt] / mult;
		        if (tspeed > his) tspeed = his;
			if (check_sum_of_bandwidth && tspeed > (reszta_upload[int_cnt] / ilip_upload[int_cnt])) tspeed = reszta_upload[int_cnt] / ilip_upload[int_cnt];
		        if (tspeed < los) tspeed = los;
			if (los > local_int_tab2[1][(int_cnt*6)+3] && tspeed < los) tspeed = los;
    			if ((pos = get_config_by_ip_upload(config,str)) != -1)
	    		{
			    intf = get_ip_int_iface(str);
		    	    bcn = atoi(config[1][(pos*6)+3]);
			    isp = local_int_tab2[1][(int_cnt*6)+4];
//			    ipg = config[1][(pos*6)+3];
			    ipg = config[1][((get_config_by_ip(config,str))*6)+3];
			    if (get_config_by_ip(config,str) == -1) ipg="0.0.0.0/0";
			    fact = get_ip_upload_factor(str);
			    if (! continuous_control)
			    {
				cbq_class_add_upload(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,3,20,"",upload_class_type,get_ip_str(str));
				if (squid_ingress) cbq_ingress_add(get_ip_iface(str),tspeed,bcn,get_ip_cnt(str)+4,ipg,str,16);
			    }
			    else
			    {
				cbq_class_change_upload(intf,isp,(tspeed*fact)/100,bcn,get_ip_cnt(str)+4,ipg,str,3,20,"",upload_class_type,get_ip_str(str));
				if (squid_ingress) cbq_ingress_change(get_ip_iface(str),tspeed,bcn,get_ip_cnt(str)+4,ipg,str,16);
			    }
		    	    bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,tspeed,int_cnt);
		    	    reszta_upload[int_cnt] = reszta_upload[int_cnt] - tspeed;
		    	    ilip_upload[int_cnt]--;
			}
			else
			{
			    syslog(LOG_ERR,"Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			    if (debug>2) printf("debug 3: Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
			}
			if (debug > 1) printf("add2_upload:  %s\n",str);
		    }
		}
		}

//		printf("reszta=%ld\n",reszta[int_cnt]);

		if (check_sum_of_bandwidth && class_type != 3 && reszta[int_cnt] < 0)
		{
		    syslog(LOG_ERR,"Total of assigned download bandwidth is more than hispeed!");
		    if (debug > 1)
		    {
			printf("debug: Total of assigned download bandwidth is more than hispeed!\n");
		    }
		}

		if (check_sum_of_bandwidth && divide_upload && upload_class_type != 3 && reszta_upload[int_cnt] < 0)
		{
		    syslog(LOG_ERR,"Total of assigned upload bandwidth is more than hispeed!");
		    if (debug > 1)
		    {
			printf("debug: Total of assigned upload bandwidth is more than hispeed!\n");
		    }
		}

		// download
		if (continuous_control)
		{
		    struct	IPLISTA	*ptr1, *ptr2;
		    
		    for(n=1;n<iplista_pos;n++)
    		    {
	    		int		pos;
		        char		*intf;
		        char        	*ipg;
		        int		bcn,isp;
		        int		los,his;
		        int		fin, m, x;

			ptr1 = iplista_str + n;
			str = get_speed_table_del(del_tab[int_cnt],n);
	    		if (str[0])
		        {
		    	    lastbitrate = ckbitrate_user_last(bitrate_user_last[int_cnt],str,int_cnt) * mult;

			    fin = 0;
			    x = 0;
			    for(m=1;m<iplista_pos;m++)
			    {
				ptr2 = iplista_str + m;
				if (!strcmp(ptr2 -> str_ip,str) && !strcmp(str,ptr2 -> str_ip))
				{
				    fin = m;
				    x++;
				}
			    }
			    if (x > 1)
			    {
				syslog(LOG_ERR,"BUG: download x=%d \n",x);
			    }

			    if ((iplista_str + fin) -> bool == 1)
			    {
				(iplista_str + fin) -> bool = 0;
				(iplista_str + fin) -> is_shtb_overlimit = 0;
			        los = get_ip_lospeed(str);
		    	        his = get_ip_hispeed(str);
				total_dnload_cir = total_dnload_cir - los;
				if (los > local_int_tab2[1][(int_cnt*6)+1])
			        {
//				    total_dnload_cir -= los;
				    if (debug > 2) printf("ip=%s rem cir=%d total_cir=%d\n",str,los,total_dnload_cir);
				}
			        tspeed = ((lastbitrate/mult) + los);
    				if ((pos = get_config_by_ip(config,str)) != -1)
	    		        {
				    intf = get_ip_iface(str);
		    	    	    bcn = atoi(config[1][(pos*6)+5]);
		    		    isp = atoi(config[1][(pos*6)+2]);
			    	    ipg = config[1][(pos*6)+3];
				    cbq_class_del(intf,isp,lastbitrate/mult,bcn,get_ip_cnt(str)+4,ipg,str,3,1,"",class_type,get_ip_str(str));
				    bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],str,0,int_cnt);
				}
				else
				{
				    syslog(LOG_ERR,"Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
				    if (debug>2) printf("debug 3: Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
				}
				if (debug > 1) printf("del_dnload:  %s\n",str);
			    }
			}
		    }
		}

		// upload
		if (divide_upload) {
		if (continuous_control)
		{
		    struct	IPLISTA	*ptr1, *ptr2;
		    
		    for(n=1;n<iplista_pos;n++)
    		    {
	    		int		pos;
		        char		*intf;
		        char        	*ipg;
		        int		bcn,isp;
		        int		los,his;
		        int		fin, m, x;

	    		ptr1 = iplista_str + n;
			str = get_speed_table_del(del_tab_upload[int_cnt],n);
	    		if (str[0])
		        {
		    	    lastbitrate = ckbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,int_cnt) * mult;

			    fin = 0;
			    x = 0;
			    for(m=1;m<iplista_pos;m++)
			    {
				ptr2 = iplista_str + m;
				if (!strcmp(ptr2 -> str_ip,str) && !strcmp(str,ptr2 -> str_ip))
				{
				    fin = m;
				    x++;
				}
			    }
			    if (x > 1)
			    {
				syslog(LOG_ERR,"BUG: upload x=%d \n",x);
			    }

			    if ((iplista_str + fin) -> bool_upload)
			    {
				(iplista_str + fin) -> bool_upload = 0;
				(iplista_str + fin) -> is_shtb_overlimit_upload = 0;
			        los = get_ip_lospeed_upload(str);
		    	        his = get_ip_hispeed_upload(str);
				total_upload_cir = total_upload_cir - los;
				if (los > local_int_tab2[1][(int_cnt*6)+3])
			        {
//				    total_upload_cir -= los;
				    if (debug > 2) printf("ip=%s rem cir=%d total_upload_cir=%d\n",str,los,total_upload_cir);
				}
			        tspeed = ((lastbitrate/mult) + los);
    				if ((pos = get_config_by_ip_upload(config,str)) != -1)
	    		        {
				    intf = get_ip_int_iface(str);
		    	    	    bcn = atoi(config[1][(pos*6)+3]);
//		    		    isp = atoi(config[1][(pos*6)+2]);
				    isp = local_int_tab2[1][(int_cnt*6)+4];
//			    	    ipg = config[1][(pos*6)+3];
				    ipg = config[1][((get_config_by_ip(config,str))*6)+3];
				    if (get_config_by_ip(config,str) == -1) ipg="0.0.0.0/0";
				    cbq_class_del_upload(intf,isp,lastbitrate/mult,bcn,get_ip_cnt(str)+4,ipg,str,3,1,"",upload_class_type,get_ip_str(str));
				    if (squid_ingress) cbq_ingress_del(get_ip_iface(str),lastbitrate/mult,bcn,get_ip_cnt(str)+4,ipg,str,16);
				    bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],str,0,int_cnt);
				}
				else
				{
				    syslog(LOG_ERR,"Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
				    if (debug>2) printf("debug 3: Interface name for IP number %s not found in %s/iplist.%d",str,CONFIG_DIR,shaperd_counter);
				}
				if (debug > 1) printf("del_upload:  %s\n",str);
			    }
			}
		    }
		}
		}
	    }
	}

	// sprawdzamy czas przydzialu widelek, jesli za dlugi w stosunku do
	// opoznienia delay to zwiekszamy opoznienie o 10%
	// jesli czas jest bardzo krotki to zmniejszamy opoznienie.
	delta_time = time(NULL)-start_time;
	loop_time = time(NULL)-start_loop;
	if (debug > 1) printf("Time of creating allocations %d\n",delta_time);
	if (debug > 1) printf("Time of main loop %d\n",loop_time);
	
	if(alt_thandle)
	{
	    
	    delta_factor = 1;
	    check_time = delta_time + delta_factor;
	    if (debug > 1) printf("Alternative Delay Handle: check_time=%i\n",check_time);
	}
	else
	    check_time = delta_time * delta_factor;
	if (check_time > delay)
	{
	    delay = check_time;
	    if (delay_mesg)
	    {
		if (debug > 1)
	        {
	    	    printf("debug: Delay parameter has too low amount for this number of IP's or possibility of server.\n");
	    	    printf("debug: Increasing delay to %d seconds\n",delay);
		}
    	        syslog(LOG_INFO,"Delay parameter has too low amount for this number of IP's or possibility of server.");
		syslog(LOG_INFO,"Increasing delay to %d seconds",delay);
	    }
	}
	else
	if (check_time < delay)
	{
	    delay = check_time;
	    if (delay <= delay_org) delay = delay_org;
	    else
	    {
		if (delay_mesg)
		{
		    if (debug > 1)
		    {
	        	printf("debug: Delay parameter has too high amount.\n");
		        printf("debug: Decreasing delay to %d seconds\n",delay);
		    }
	    	    syslog(LOG_INFO,"Delay parameter has too high amount.");
	    	    syslog(LOG_INFO,"Decreasing delay to %d seconds",delay);
		}
	    }
	}

/*
	n=0;
	start_time = time(NULL);
	while(!exit_signal && n<delay)
	{
	    sleep(1);
	    n++;
	}
	delta_time = time(NULL)-start_time;
	if (debug) printf("Delay time %d\n",delta_time);
*/

	// zapisujemy plik bitrate_user_sh.old jesli olddelay > 0
	old++;
	if (olddelay && old >= olddelay)
	{
	    for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
	    {
		if (local_int_tab2[1][(int_cnt*6)+5])
		{
		    if (nr[int_cnt]-1 == 1 && !check_always)
		    {
	    		bitrate_user_last[int_cnt] = clear_bitrate_user_last(bitrate_user_last[int_cnt],masq[int_cnt],int_cnt);
			bitrate_user_last[int_cnt] = mkbitrate_user_last(bitrate_user_last[int_cnt],masq[int_cnt][1],local_int_tab2[1][(int_cnt*6)+2],int_cnt);
			if (divide_upload)
			{
	    		    bitrate_user_last_upload[int_cnt] = clear_bitrate_user_last_upload(bitrate_user_last_upload[int_cnt],masq_upload[int_cnt],int_cnt);
			    bitrate_user_last_upload[int_cnt] = mkbitrate_user_last_upload(bitrate_user_last_upload[int_cnt],masq_upload[int_cnt][1],local_int_tab2[1][(int_cnt*6)+4],int_cnt);
			}
		    }
		    else
		    if (nr[int_cnt]-1 < 1)
		    {
	    		bitrate_user_last[int_cnt] = clear_bitrate_user_last(bitrate_user_last[int_cnt],masq[int_cnt],int_cnt);
	    		if (divide_upload) bitrate_user_last_upload[int_cnt] = clear_bitrate_user_last_upload(bitrate_user_last_upload[int_cnt],masq_upload[int_cnt],int_cnt);
		    }
/*
		    if (debug>2) printf("debug 3: free_masqip memory allocation\n");
		    free_masqip(masq[int_cnt],int_cnt);
		    if (debug>2) printf("debug 3: free_speed_table memory allocation\n");
    		    free_speed_table(speed_tab[int_cnt],nr[int_cnt]);
    		    free_speed_table(del_tab[int_cnt],iplista_pos+1);
*/
		}
	    }
	    if (debug>2) printf("debug 3: writing /var/shaper/bitrate_user_sh.%d.old file\n",shaperd_counter);
	    write_bitrate_user_last(bitrate_user_last,oldfile,int_cnt);
	    if (divide_upload)
	    {
		if (debug>2) printf("debug 3: writing /var/shaper/bitrate_user_up.%d.old file\n",shaperd_counter);
		write_bitrate_user_last_upload(bitrate_user_last_upload,oldfile_upload,int_cnt);
	    }
	    old = 0;
	}
	
	// sprawdzamy czy liczniki na firewallu nie zblizaja sie do przepelnienia
	// jesli tak to zerujemy firewall
	if (check_firewall_numcycles)
	{
	    check_firewall_cnt--;
	    if (check_firewall_cnt < 1)
	    {
		if (!is_clean_firewall(firewall_type))
		{
		    clear_firewall(firewall_type);
		    for(n=1;n<4;n++)
		    {
			if (is_clean_firewall(firewall_type))
			{
			    syslog(LOG_INFO,"Cleared firewall");
			    break;
			}
			else
			{
			    syslog(LOG_ERR,"Firewall clearing error. Trying again.");
			    clear_firewall(firewall_type);
			}
		    }
		    if (! is_clean_firewall(firewall_type))
		    {
			syslog(LOG_ERR,"Firewall clearing error. I give up. Exiting...");
			error("Firewall clearing error. I give up. Exiting\n");
		    }
		}
		check_firewall_cnt = check_firewall_numcycles;
	    }
	}
	
	// zapisujemy istatnie transfery aby w razie padniecia systemu (reset :)
	// po ponownym starcie zostaly przywrocone
	if (lastrate_numcycles)
	{
	    lastrate_cnt--;
	    if (lastrate_cnt < 1)
	    {
		write_last_state(lastrate);
	        lastrate_cnt = lastrate_numcycles;
	    }
	}
	
	// robimy opoznienie
	n=0;
//	start_time = time(NULL);
//	while(!exit_signal && n<delay)
	while(!exit_signal && n < (delay - loop_time))
	{
	    sleep(1);
	    n++;
	}

	// obliczamy czas tworzenia widelek
	delta_time = time(NULL) - start_loop;
	if (debug > 1) printf("Delay time %d\n",delta_time);

	for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
	{
    	    if (debug>2) printf("debug 3: free_masqip memory allocation\n");
	    free_masqip(masq[int_cnt],int_cnt);
	    if (divide_upload) free_masqip_upload(masq_upload[int_cnt],int_cnt);
	    if (local_int_tab2[1][(int_cnt*6)+5])
	    {
		if (debug>2) printf("debug 3: free_speed_table memory allocation\n");
    		free_speed_table(speed_tab[int_cnt],nr[int_cnt]);
    		free_speed_table(del_tab[int_cnt],iplista_pos+1);
    		if (divide_upload)
		{
		    free_speed_table(speed_tab_upload[int_cnt],nr_upload[int_cnt]);
    		    free_speed_table(del_tab_upload[int_cnt],iplista_pos+1);
		}
	    }
	}

	if (debug>2) printf("debug 3: free_natstat_tab memory allocation\n");
    	free_natstat_tab(nattab);
    	if (divide_upload) free_natstat_tab_upload(nattab_upload);
	
	if (reload_signal2) reload_signal2 = 0;
	if (reload_signal)
	{
	    reload_signal = 0;
	    syslog(LOG_INFO,"Reloading configuration.");
	    reload_config(configfile);
	    reload_iplist(config);
	    syslog(LOG_INFO,"Reloading configuration done.");
	    reload_signal2 = 1;
	}

	if (clear_signal) clear_signal = 0;
	if (diff_signal)
	{
	    diff_signal = 0;
	    syslog(LOG_INFO,"Reading diff file.");
	    read_last_diff(difffile);
	}

	if (debug) putstring("stop  main_loop");
    }
    // tworzymy plik z ostatnimi stanami i limitami
    write_last_state(lastrate);

    // usuwamy wszystkie bany na firewallu dla userow przelamujacych widelki
    if (ban_user)
    {
        int	m;
        struct      IPLISTA *ptr;
		
	if (debug > 1) printf("Removing ban_user\n");
        for(m=1;m<iplista_pos;m++)
        {
    	    ptr = iplista_str + m;
	    if (ptr -> ban_download_cnt == 1)
	    {
	        unban_user_download(config,ptr);
		ptr -> ban_download_cnt = 0;
	    }
	    if (ptr -> ban_upload_cnt == 1)
	    {
	        unban_user_upload(config,ptr);
	        ptr -> ban_upload_cnt = 0;
	    }
	}
    }

    // usuwamy wszystkie ograniczenia
    if (debug>2) printf("debug 3: removing all QoS classes\n");
    cbq_off_all(config);

    // usuwamy pliki z ograniczeniami
    if (debug > 1) printf("Removing %s\n",oldfile);
    remove(oldfile);
    if (debug > 1) printf("Removing %s\n",oldfile_upload);
    remove(oldfile_upload);

    // usuwamy PID
    if (debug > 1) printf("Removing %s\n",pidfile);
    remove(pidfile);

    if (debug>2) printf("debug 3: free_bitrate_user_last memory allocation\n");
    
    for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
    {
        if (local_int_tab2[1][(int_cnt*6)+5])
        {
	    free_bitrate_user_last(bitrate_user_last[int_cnt],int_cnt);
	    if (divide_upload) free_bitrate_user_last_upload(bitrate_user_last_upload[int_cnt],int_cnt);
	}
    }

    if (!quick_start)
    {
	if (debug>2) printf("debug 3: removing firewall shaperd rules\n");
	delete_firewall(config,firewall_type);
    }

    if (debug>2) printf("debug 3: free_ignore memory allocation\n");
    free_ignore(ignore);
    if (debug>2) printf("debug 3: free_config memory allocation\n");
    free_config(config);
    if (debug>2) printf("debug 3: frmem memory allocation\n");
    frmem();
    if (debug>2) printf("debug 3: exiting\n");

    syslog(LOG_INFO, "Normal termination.");
    closelog();

    exit(0);
}

void frmem(void)
{
    int		m;

    free_iplist();

    if (devlist)
    {
	for(m=1;m<devlist_pos;m++)
	{
	    free(devlist[m]);
	}
	free(devlist);
    }

    return;
}

void error(char *fmt, ...)
{
    va_list	args;

    va_start(args, fmt);
    fprintf(stderr, "shaperd%d: ",shaperd_counter);
    vfprintf(stderr, fmt, args);
    fprintf(stderr,"\n");
    va_end(args);

    frmem();
    remove(pidfile);
    exit(1);
}

void exit_handler()
{
    exit_signal = 1;
}

void reload_handler()
{
    int		n;
    struct	IPLISTA *ptr;
    
    reload_signal = 1;
}

void clear_handler()
{
    int	n;
    struct	IPLISTA	*ptr;

    clear_signal = 1;
    syslog(LOG_INFO,"Clearing counters.");

    clear_firewall(firewall_type);
    for(n=0;n<5;n++)
    {
	if (is_clean_firewall2(firewall_type)) break;
	else
	{
	    syslog(LOG_ERR,"Firewall clearing2 error. Trying again.");
	    read_firewall(firewall_type);
	    if (divide_upload) read_firewall_upload(firewall_type);
	    if (squid)
	    {
		read_squid(firewall_type);
	        if (divide_upload) read_sqout(firewall_type);
	    }
	    clear_firewall(firewall_type);
	}
    }
    if (! is_clean_firewall2(firewall_type))
    {
	syslog(LOG_ERR,"Firewall clearing2 error. I give up. Exiting...");
	error("Firewall clearing2 error. I give up. Exiting\n");
    }
	
    for(n=1;n<iplista_pos;n++)
    {
	ptr = iplista_str + n;
	if (debug > 1) printf("clearing transfers of: %s\n",ptr -> str_ip);
	ptr -> is_overlimit = 0;
	ptr -> is_overlimit_upload = 0;
	ptr -> is_shtb_overlimit = 0;
	ptr -> is_shtb_overlimit_upload = 0;
	ptr -> shtb_refresh = 1;
	ptr -> shtb_refresh_upload = 1;
	ptr -> ipspeed_last = 0;
	ptr -> squid_speed_last = 0;
	ptr -> sqout_speed_last = 0;
	ptr -> ipspeed_last_upload = 0;
	ptr -> state_ipspeed_last = 0;
	ptr -> state_squid_speed_last = 0;
	ptr -> state_sqout_speed_last = 0;
	ptr -> state_ipspeed_last_upload = 0;
    }
//    clear_firewall(firewall_type);
}

void diff_handler()
{
    diff_signal = 1;
}

int my_system (const char *command)
{
    char	*environ[]=
    {
	"HOME=/",
	"PATH=/sbin:/bin:/usr/sbin:/usr/bin",
	"TERM=linux",
	NULL
    };

    int pid, status;

    if (command == 0)
	return 1;
    pid = fork();
    if (pid == -1)
	return -1;
    if (pid == 0)
    {
	char *argv[4];

	argv[0] = "sh";
	argv[1] = "-c";
	argv[2] = (char *) command;
	argv[3] = 0;
	execve("/bin/sh", argv, environ);
	exit(127);
    }
    do
    {
	if (waitpid(pid, &status, 0) == -1)
	{
	    if (errno != EINTR) return -1;
	}
	else return status;
    }
    while(1);
}

int numlines(char *fname)
{
    FILE	*fp;
    int		line=0;
    char	buf[1000];
    
    if (!(fp = fopen(fname,"r")))
    {
	syslog(LOG_ERR,"File %s not found.",fname);
	error("debug 3: File %s not found.\ndebug 3: exiting\n",fname);
    }
    while(fgets(buf,1000,fp))
    {
	if (buf[0] != '#') line++;
    }
    fclose(fp);
    return(line);
}

unsigned long int ckbitrate_user(char *ip)
{
    int		m,n,pos;
    FILE	*fp;
    char	buf[1000];
    char	ip_tmp[20];
    char	ipt[20];
    long unsigned int	d1,d2,sp,tm,res;
    struct	IPLISTA	*ptr;

    res = 0;
    for(n=1;n<iplista_pos;n++)
    {
	ptr = iplista_str + n;
	if ((ip2hex3(ip) & ptr -> mask) == (ptr -> ip & ptr -> mask))
	{
	    // jesli wyzeruje sie licznik na firewallu to oznacza ze przekrecil sie w kolo
	    if (ptr -> ipspeed < ptr -> ipspeed_last)
	    {
		if (debug > 1) printf("wyzerowany licznik shaper dla %s\n",ptr -> str_ip);
		ptr -> state_ipspeed_last += ptr -> ipspeed_last;
//		ptr -> is_overlimit = 1;
		ptr -> ipspeed_last = 0;
	    }
	    if (ptr -> squid_speed < ptr -> squid_speed_last)
	    {
		if (debug > 1) printf("wyzerowany licznik squid dla %s\n",ptr -> str_ip);
		ptr -> state_squid_speed_last += ptr -> squid_speed_last;
//		ptr -> is_overlimit = 1;
		ptr -> squid_speed_last = 0;
	    }
	    
	    sp = ptr -> ipspeed - ptr -> ipspeed_last;
	    if (squid==1)
	    {
		sp = sp + (ptr -> squid_speed - ptr -> squid_speed_last);
	    }
	    tm = ptr -> iptime - ptr -> iptime_last;
	    if (tm > 0)
	    {
		res = ((sp/tm)*8);
		ptr -> ipspeed_last = ptr -> ipspeed;
		ptr -> iptime_last = ptr -> iptime;
		if (squid==1)
		{
		    ptr -> squid_speed_last = ptr -> squid_speed;
		    ptr -> squid_time_last = ptr -> squid_time;
		}
	    }
	}
    }
    return(res);
}

unsigned long int ckbitrate_user_upload(char *ip)
{
    int		m,n,pos;
    FILE	*fp;
    char	buf[1000];
    char	ip_tmp[20];
    char	ipt[20];
    long unsigned int	d1,d2,sp,tm,res;
    struct	IPLISTA	*ptr;

    res = 0;
    for(n=1;n<iplista_pos;n++)
    {
	ptr = iplista_str + n;
	if ((ip2hex3(ip) & ptr -> mask) == (ptr -> ip & ptr -> mask))
	{
	    if (ptr -> ipspeed_upload < ptr -> ipspeed_last_upload)
	    {
		if (debug > 1) printf("wyzerowany licznik shaout dla %s\n",ptr -> str_ip);
		ptr -> state_ipspeed_last_upload += ptr -> ipspeed_last_upload;
//		ptr -> is_overlimit_upload = 1;
		ptr -> ipspeed_last_upload = 0;
	    }
	    if (ptr -> sqout_speed < ptr -> sqout_speed_last)
	    {
		if (debug > 1) printf("wyzerowany licznik sqout dla %s\n",ptr -> str_ip);
		ptr -> state_sqout_speed_last += ptr -> sqout_speed_last;
//		ptr -> is_overlimit_upload = 1;
		ptr -> sqout_speed_last = 0;
	    }

	    sp = ptr -> ipspeed_upload - ptr -> ipspeed_last_upload;
	    if (squid)
	    {
		sp = sp + (ptr -> sqout_speed - ptr -> sqout_speed_last);
	    }
	    tm = ptr -> iptime_upload - ptr -> iptime_last_upload;
	    if (tm > 0)
	    {
		res = ((sp/tm)*8);
		ptr -> ipspeed_last_upload = ptr -> ipspeed_upload;
		ptr -> iptime_last_upload = ptr -> iptime_upload;
		if (squid)
		{
		    ptr -> sqout_speed_last = ptr -> sqout_speed;
		    ptr -> sqout_time_last = ptr -> sqout_time;
		}
	    }
	}
    }
    return(res);
}

void read_firewall(int firewall_type)
{
    int		f1,m,n;
    struct	stat stbuf;
    unsigned long int	cnt1,cnt2;
    unsigned long int	dd1 = 0,dd2 = 0,dd3 = 0,dd4 = 0;
    char	aa[12][20];
    char	*src;
    char	buf[30];
    char	buft[1000];
    char	pop[200];

    FILE	*fp;

    fflush(NULL);

    if (firewall_type==1)
    {
	sprintf(pop,"%s -vxL shaper%d -n 2>> %s\n",ipchains_path,shaperd_counter,output);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read shaper%d table from ipchains",shaperd_counter);
	    error("Can't read shaper%d table from ipchains.\nExiting\n",shaperd_counter);
	}
    }
    else
    if (firewall_type==2)
    {
	sprintf(pop,"%s -vxL shaper%d -n 2>> %s\n",iptables_path,shaperd_counter,output);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read shaper%d table from iptables",shaperd_counter);
	    error("Can't read shaper%d table from iptables.\nExiting\n",shaperd_counter);
	}
    }
    else
    {
	syslog(LOG_ERR,"BUG: firewall type %d not exists!",firewall_type);
	error("BUG: firewall type %d not exists!\nExiting\n",firewall_type);
    }

    fgets(buft,1000,fp);
    fgets(buft,1000,fp);
    while ((fgets(buft,1000,fp))!=NULL)
    {
	char	bufor[200];
	char	ipt[35];
	struct	IPLISTA	*ptr;

	sscanf(buft,"%lu %lu %s %s %s %s %s %s %s %s %s",
	    &dd1,&dd2,aa[3],aa[4],aa[5],aa[6],aa[7],aa[8],aa[9],aa[10],aa[11]);

	for(m=1;m<iplista_pos;m++)
	{
	    ptr = iplista_str + m;
	    if (ptr -> mask == 0xffffffff)
	    {
		char	*res = hex2ip(ptr -> ip & ptr -> mask);
		
		strcpy(ipt,res);
		free(res);
	    }
	    else
	    {
		strcpy(ipt,ptr -> str_ip);
	    }

	    strcat(ipt," ");
	    if (strstr(buft,ipt))
	    {
		ptr -> ipspeed = dd2;
		ptr -> iptime  = (long unsigned int) time(NULL);
		if (debug > 1) printf("read_firewall: %s %x %lu %lu\n",
			ptr -> str_ip,
			ptr -> ip & ptr -> mask,
			ptr -> ipspeed,
			ptr -> iptime);
	    }
//	    else
//	    if (strstr(buft,"RETURN")) flagi.firewall_status = 1;
	}
    }
    pclose(fp);
}

int is_clean_firewall(int firewall_type)
{
    int		f1,m,n;
    struct	stat stbuf;
    unsigned long int	cnt1,cnt2;
    unsigned long int	dd1 = 0,dd2 = 0,dd3 = 0,dd4 = 0;
    char	aa[12][20];
    char	*src;
    char	buf[30];
    char	buft[1000];
    char	pop[200];

    FILE	*fp;

    fflush(NULL);

    if (firewall_type==1)
    {
	sprintf(pop,"%s -vxL shaper%d -n 2>> %s\n",ipchains_path,shaperd_counter,output);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read shaper%d table from ipchains",shaperd_counter);
	    error("Can't read shaper%d table from ipchains.\nExiting\n",shaperd_counter);
	}
    }
    else
    if (firewall_type==2)
    {
	sprintf(pop,"%s -vxL shaper%d -n 2>> %s\n",iptables_path,shaperd_counter,output);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read shaper%d table from iptables",shaperd_counter);
	    error("Can't read shaper%d table from iptables.\nExiting\n",shaperd_counter);
	}
    }
    else
    {
	syslog(LOG_ERR,"BUG: firewall type %d not exists!",firewall_type);
	error("BUG: firewall type %d not exists!\nExiting\n",firewall_type);
    }

    fgets(buft,1000,fp);
    fgets(buft,1000,fp);
    while ((fgets(buft,1000,fp))!=NULL)
    {
	char	bufor[200];
	char	ipt[35];
	struct	IPLISTA	*ptr;

	sscanf(buft,"%lu %lu %s %s %s %s %s %s %s %s %s",
	    &dd1,&dd2,aa[3],aa[4],aa[5],aa[6],aa[7],aa[8],aa[9],aa[10],aa[11]);

	if (dd2 > MAX_FIREWALL_VALUE)
	{
	    pclose(fp);
	    return(0);
	}
    }
    pclose(fp);

    if (squid)
    {
        if (firewall_type==1)
	{
	    sprintf(pop,"%s -vxL shaper%d -n 2>> %s\n",ipchains_path,shaperd_counter,output);
	    if (!(fp = popen(pop,"r")))
	    {
		syslog(LOG_ERR,"Can't read shaper%d table from ipchains",shaperd_counter);
	        error("Can't read shaper%d table from ipchains.\nExiting\n",shaperd_counter);
	    }
	}
	else
	if (firewall_type==2)
	{
	    sprintf(pop,"%s -vxL shaper%d -n 2>> %s\n",iptables_path,shaperd_counter,output);
	    if (!(fp = popen(pop,"r")))
	    {
		syslog(LOG_ERR,"Can't read shaper%d table from iptables",shaperd_counter);
		error("Can't read shaper%d table from iptables.\nExiting\n",shaperd_counter);
	    }
	}
	else
	{
	    syslog(LOG_ERR,"BUG: firewall type %d not exists!",firewall_type);
	    error("BUG: firewall type %d not exists!\nExiting\n",firewall_type);
	}

	fgets(buft,1000,fp);
	fgets(buft,1000,fp);
	while ((fgets(buft,1000,fp))!=NULL)
        {
	    char	bufor[200];
	    char	ipt[35];
	    struct	IPLISTA	*ptr;

	    sscanf(buft,"%lu %lu %s %s %s %s %s %s %s %s %s",
		&dd1,&dd2,aa[3],aa[4],aa[5],aa[6],aa[7],aa[8],aa[9],aa[10],aa[11]);

	    if (dd2 > MAX_FIREWALL_VALUE)
	    {
		pclose(fp);
		return(0);
	    }
	}
	pclose(fp);
    }

    if (firewall_type==1)
    {
	sprintf(pop,"%s -vxL shaout%d -n 2>> %s\n",ipchains_path,shaperd_counter,output);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read shaout%d table from ipchains",shaperd_counter);
	    error("debug 3: Can't read shaout%d table from ipchains.\nExiting\n",shaperd_counter);
	}
    }
    else
    if (firewall_type==2)
    {
	sprintf(pop,"%s -vxL shaout%d -n 2>> %s\n",iptables_path,shaperd_counter,output);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read shaout%d table from iptables",shaperd_counter);
	    error("debug 3: Can't read shaout%d table from iptables.\nExiting\n",shaperd_counter);
	}
    }
    else
    {
	if (debug) syslog(LOG_ERR,"BUG: firewall type %d not exists!",firewall_type);
	error("BUG: firewall type %d not exists!\nExiting\n",firewall_type);
    }

    fgets(buft,1000,fp);
    fgets(buft,1000,fp);
    while ((fgets(buft,1000,fp))!=NULL)
    {
	char	bufor[200];
	char	ipt[35];
	struct	IPLISTA	*ptr;

	sscanf(buft,"%lu %lu %s %s %s %s %s %s %s %s %s",
	    &dd1,&dd2,aa[3],aa[4],aa[5],aa[6],aa[7],aa[8],aa[9],aa[10],aa[11]);

	if (dd2 > MAX_FIREWALL_VALUE)
	{
	    pclose(fp);
	    return(0);
	}
    }
    pclose(fp);

    if (firewall_type==1)
    {
	sprintf(pop,"%s -vxL sqout%d -n 2>> %s\n",ipchains_path,shaperd_counter,output);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read sqout%d table from ipchains",shaperd_counter);
	    error("debug 3: Can't read sqout%d table from ipchains.\nExiting\n",shaperd_counter);
	}
    }
    else
    if (firewall_type==2)
    {
	sprintf(pop,"%s -vxL sqout%d -n 2>> %s\n",iptables_path,shaperd_counter,output);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read sqout%d table from iptables",shaperd_counter);
	    error("debug 3: Can't read sqout%d table from iptables.\nExiting\n",shaperd_counter);
	}
    }
    else
    {
	if (debug) syslog(LOG_ERR,"BUG: firewall type %d not exists!",firewall_type);
	error("BUG: firewall type %d not exists!\nExiting\n",firewall_type);
    }

    fgets(buft,1000,fp);
    fgets(buft,1000,fp);
    while ((fgets(buft,1000,fp))!=NULL)
    {
	char	bufor[200];
	char	ipt[35];
	struct	IPLISTA	*ptr;

	sscanf(buft,"%lu %lu %s %s %s %s %s %s %s %s %s",
	    &dd1,&dd2,aa[3],aa[4],aa[5],aa[6],aa[7],aa[8],aa[9],aa[10],aa[11]);

	if (dd2 > MAX_FIREWALL_VALUE)
	{
	    pclose(fp);
	    return(0);
	}
    }
    pclose(fp);

    return(1);
}

/*
** wynik:
** 0 - firewall nie wyzerowany
** 1 - firewall wyzerowany
*/
int is_clean_firewall2(int firewall_type)
{
    int		f1,m,n;
    struct	stat stbuf;
    unsigned long int	cnt1,cnt2;
    unsigned long int	dd1 = 0,dd2 = 0,dd3 = 0,dd4 = 0;
    char	aa[12][20];
    char	*src;
    char	buf[30];
    char	buft[1000];
    char	pop[200];

    FILE	*fp;

    fflush(NULL);

    if (firewall_type==1)
    {
	sprintf(pop,"%s -vxL shaper%d -n 2>> %s\n",ipchains_path,shaperd_counter,output);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read shaper%d table from ipchains",shaperd_counter);
	    error("Can't read shaper%d table from ipchains.\nExiting\n",shaperd_counter);
	}
    }
    else
    if (firewall_type==2)
    {
	sprintf(pop,"%s -vxL shaper%d -n 2>> %s\n",iptables_path,shaperd_counter,output);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read shaper%d table from iptables",shaperd_counter);
	    error("Can't read shaper%d table from iptables.\nExiting\n",shaperd_counter);
	}
    }
    else
    {
	syslog(LOG_ERR,"BUG: firewall type %d not exists!",firewall_type);
	error("BUG: firewall type %d not exists!\nExiting\n",firewall_type);
    }

    fgets(buft,1000,fp);
    fgets(buft,1000,fp);
    while ((fgets(buft,1000,fp))!=NULL)
    {
	char	bufor[200];
	char	ipt[35];
	struct	IPLISTA	*ptr;

	sscanf(buft,"%lu %lu %s %s %s %s %s %s %s %s %s",
	    &dd1,&dd2,aa[3],aa[4],aa[5],aa[6],aa[7],aa[8],aa[9],aa[10],aa[11]);

	for(m=1;m<iplista_pos;m++)
	{
	    ptr = iplista_str + m;
	    if (ptr -> mask == 0xffffffff)
	    {
		char	*res = hex2ip(ptr -> ip & ptr -> mask);
		
		strcpy(ipt,res);
		free(res);
	    }
	    else
	    {
		strcpy(ipt,ptr -> str_ip);
	    }

	    strcat(ipt," ");
	    if (strstr(buft,ipt) && dd2 > 0 && (ptr -> ipspeed + 100000) <= dd2)
	    {
		syslog(LOG_INFO,"DEBUG1: %s %lu <= %lu",ptr->str_ip,ptr->ipspeed,dd2);
	        pclose(fp);
		return(0);
	    }
	}
    }
    pclose(fp);

    if (divide_upload)
    {
    fflush(NULL);
    if (firewall_type==1)
    {
	sprintf(pop,"%s -vxL shaout%d -n 2>> %s\n",ipchains_path,shaperd_counter,output);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read shaout%d table from ipchains",shaperd_counter);
	    error("Can't read shaout%d table from ipchains.\nExiting\n",shaperd_counter);
	}
    }
    else
    if (firewall_type==2)
    {
	sprintf(pop,"%s -vxL shaout%d -n 2>> %s\n",iptables_path,shaperd_counter,output);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read shaout%d table from iptables",shaperd_counter);
	    error("Can't read shaout%d table from iptables.\nExiting\n",shaperd_counter);
	}
    }
    else
    {
	syslog(LOG_ERR,"BUG: firewall type %d not exists!",firewall_type);
	error("BUG: firewall type %d not exists!\nExiting\n",firewall_type);
    }

    fgets(buft,1000,fp);
    fgets(buft,1000,fp);
    while ((fgets(buft,1000,fp))!=NULL)
    {
	char	bufor[200];
	char	ipt[35];
	struct	IPLISTA	*ptr;

	sscanf(buft,"%lu %lu %s %s %s %s %s %s %s %s %s",
	    &dd1,&dd2,aa[3],aa[4],aa[5],aa[6],aa[7],aa[8],aa[9],aa[10],aa[11]);

	for(m=1;m<iplista_pos;m++)
	{
	    ptr = iplista_str + m;
	    if (ptr -> mask == 0xffffffff)
	    {
		char	*res = hex2ip(ptr -> ip & ptr -> mask);
		
		strcpy(ipt,res);
		free(res);
	    }
	    else
	    {
		strcpy(ipt,ptr -> str_ip);
	    }

	    strcat(ipt," ");
	    if (strstr(buft,ipt) && dd2 && (ptr -> ipspeed_upload + 100000) <= dd2)
	    {
		syslog(LOG_INFO,"DEBUG2: %s %lu <= %lu",ptr->str_ip,ptr->ipspeed,dd2);
	        pclose(fp);
		return(0);
	    }
	}
    }
    pclose(fp);
    }

    if (squid)
    {
    fflush(NULL);
    if (firewall_type==1)
    {
	sprintf(pop,"%s -vxL squid%d -n 2>> %s\n",ipchains_path,shaperd_counter,output);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read squid%d table from ipchains",shaperd_counter);
	    error("Can't read squid%d table from ipchains.\nExiting\n",shaperd_counter);
	}
    }
    else
    if (firewall_type==2)
    {
	sprintf(pop,"%s -vxL squid%d -n 2>> %s\n",iptables_path,shaperd_counter,output);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read squid%d table from iptables",shaperd_counter);
	    error("Can't read squid%d table from iptables.\nExiting\n",shaperd_counter);
	}
    }
    else
    {
	syslog(LOG_ERR,"BUG: firewall type %d not exists!",firewall_type);
	error("BUG: firewall type %d not exists!\nExiting\n",firewall_type);
    }

    fgets(buft,1000,fp);
    fgets(buft,1000,fp);
    while ((fgets(buft,1000,fp))!=NULL)
    {
	char	bufor[200];
	char	ipt[35];
	struct	IPLISTA	*ptr;

	sscanf(buft,"%lu %lu %s %s %s %s %s %s %s %s %s",
	    &dd1,&dd2,aa[3],aa[4],aa[5],aa[6],aa[7],aa[8],aa[9],aa[10],aa[11]);

	for(m=1;m<iplista_pos;m++)
	{
	    ptr = iplista_str + m;
	    if (ptr -> mask == 0xffffffff)
	    {
		char	*res = hex2ip(ptr -> ip & ptr -> mask);
		
		strcpy(ipt,res);
		free(res);
	    }
	    else
	    {
		strcpy(ipt,ptr -> str_ip);
	    }

	    strcat(ipt," ");
	    if (strstr(buft,ipt) && dd2 && (ptr -> squid_speed + 100000) <= dd2)
	    {
		syslog(LOG_INFO,"DEBUG3: %s %lu <= %lu",ptr->str_ip,ptr->ipspeed,dd2);
	        pclose(fp);
		return(0);
	    }
	}
    }
    pclose(fp);
    
    fflush(NULL);
    if (firewall_type==1)
    {
	sprintf(pop,"%s -vxL sqout%d -n 2>> %s\n",ipchains_path,shaperd_counter,output);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read sqout%d table from ipchains",shaperd_counter);
	    error("Can't read sqout%d table from ipchains.\nExiting\n",shaperd_counter);
	}
    }
    else
    if (firewall_type==2)
    {
	sprintf(pop,"%s -vxL sqout%d -n 2>> %s\n",iptables_path,shaperd_counter,output);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read sqout%d table from iptables",shaperd_counter);
	    error("Can't read sqout%d table from iptables.\nExiting\n",shaperd_counter);
	}
    }
    else
    {
	syslog(LOG_ERR,"BUG: firewall type %d not exists!",firewall_type);
	error("BUG: firewall type %d not exists!\nExiting\n",firewall_type);
    }

    fgets(buft,1000,fp);
    fgets(buft,1000,fp);
    while ((fgets(buft,1000,fp))!=NULL)
    {
	char	bufor[200];
	char	ipt[35];
	struct	IPLISTA	*ptr;

	sscanf(buft,"%lu %lu %s %s %s %s %s %s %s %s %s",
	    &dd1,&dd2,aa[3],aa[4],aa[5],aa[6],aa[7],aa[8],aa[9],aa[10],aa[11]);

	for(m=1;m<iplista_pos;m++)
	{
	    ptr = iplista_str + m;
	    if (ptr -> mask == 0xffffffff)
	    {
		char	*res = hex2ip(ptr -> ip & ptr -> mask);
		
		strcpy(ipt,res);
		free(res);
	    }
	    else
	    {
		strcpy(ipt,ptr -> str_ip);
	    }

	    strcat(ipt," ");
	    if (strstr(buft,ipt) && dd2 && (ptr -> sqout_speed + 100000) <= dd2)
	    {
		syslog(LOG_INFO,"DEBUG4: %s %lu <= %lu",ptr->str_ip,ptr->ipspeed,dd2);
	        pclose(fp);
		return(0);
	    }
	}
    }
    pclose(fp);
    }

    return(1);
}

void read_firewall_upload(int firewall_type)
{
    int		f1,m,n;
    struct	stat stbuf;
    unsigned long int	cnt1,cnt2;
    unsigned long int	dd1 = 0,dd2 = 0,dd3 = 0,dd4 = 0;
    char	aa[12][20];
    char	*src;
    char	buf[30];
    char	buft[1000];
    char	pop[200];

    FILE	*fp;

    fflush(NULL);
    if (firewall_type==1)
    {
	sprintf(pop,"%s -vxL shaout%d -n 2>> %s\n",ipchains_path,shaperd_counter,output);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read shaout%d table from ipchains",shaperd_counter);
	    error("debug 3: Can't read shaout%d table from ipchains.\nExiting\n",shaperd_counter);
	}
    }
    else
    if (firewall_type==2)
    {
	sprintf(pop,"%s -vxL shaout%d -n 2>> %s\n",iptables_path,shaperd_counter,output);
	if (!(fp = popen(pop,"r")))
	{
	    syslog(LOG_ERR,"Can't read shaout%d table from iptables",shaperd_counter);
	    error("debug 3: Can't read shaout%d table from iptables.\nExiting\n",shaperd_counter);
	}
    }
    else
    {
	if (debug) syslog(LOG_ERR,"BUG: firewall type %d not exists!",firewall_type);
	error("BUG: firewall type %d not exists!\nExiting\n",firewall_type);
    }
    fgets(buft,1000,fp);
    fgets(buft,1000,fp);
    while ((fgets(buft,1000,fp))!=NULL)
    {
	char	bufor[200];
	char	ipt[35];
	struct	IPLISTA	*ptr;

//	printf("%s\n",buft);
	sscanf(buft,"%lu %lu %s %s %s %s %s %s %s %s %s",
	    &dd1,&dd2,aa[3],aa[4],aa[5],aa[6],aa[7],aa[8],aa[9],aa[10],aa[11]);
	for(m=1;m<iplista_pos;m++)
	{
	    ptr = iplista_str + m;
	    if (ptr -> mask == 0xffffffff)
	    {
		char	*res = hex2ip(ptr -> ip & ptr -> mask);
		
		strcpy(ipt,res);
		free(res);
	    }
	    else
	    {
		strcpy(ipt,ptr -> str_ip);
	    }

	    strcat(ipt," ");
//	    printf("read_firewall_cmp: %s %s %s\n",iplista[m],buft,ipt);
	    if (strstr(buft,ipt))
	    {
		ptr -> ipspeed_upload = dd2;
		ptr -> iptime_upload = (long unsigned int) time(NULL);
		if (debug > 1) printf("read_firewall_upload: %s %x %lu %lu\n",
					ptr -> str_ip,
					ptr -> ip & ptr -> mask,
					ptr -> ipspeed_upload,
					ptr -> iptime_upload);
	    }
	}
    }
    pclose(fp);
}

void write_bitrate(char *fname)
{
    FILE	*fw;
    int		m;
    int		fd;
    char	buf[200];
    struct	IPLISTA	*ptr;

    fd = creat(fname,0644);
    for(m=1;m<iplista_pos;m++)
    {
	ptr = iplista_str + m;
	sprintf(buf,"%s %lu %lu\n",
		ptr -> str_ip,
		ptr -> ipspeed,
		ptr -> iptime);
	write(fd,buf,strlen(buf));
    }
    close(fd);
}

char **dev_list(void)
{
    FILE        *fp;
    int         m,n;
    char	buft[1000];
    char	*buftptr=buft;
    char	iface[10];
    char	*devlist_cont;
    char	*res;

    m=numlines(DEVFILE);
    devlist = (char **) calloc(m+2,sizeof(char *));
    fp = fopen(DEVFILE,"r");
    fgets(buft,1000,fp);
    fgets(buft,1000,fp);
    while ((fgets(buft,1000,fp))!=NULL)
    {
	res=strtok(buft,":");
	while(isspace(*res))
	    res++;

	devlist[devlist_pos] = (char *) calloc(strlen(res)+2,sizeof(char));
	strcpy(devlist[devlist_pos],res);
	if (debug > 1) printf("devlist: %s\n",devlist[devlist_pos]);
	devlist_pos++;
    }
    fclose(fp);
    return(devlist);
}

void cbq_off(char *dev)
{
    char	com[100];
    char	buf[200];
    FILE	*fp;

    fflush(NULL);
    sprintf(com,"/bin/sh 2>> %s",output);
    if (!notc && (fp = popen(com,"w")))
    {
        sprintf(buf,"%s qdisc del dev %s root 2>> /dev/null\n",tc_path,dev);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
        sprintf(buf,"%s qdisc del dev %s ingress 2>> /dev/null\n",tc_path,dev);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	pclose(fp);
    }
}

void cbq_off_local(char ***config)
{
    int		n;

    for(n=1;n<local_int_pos;n++)
    {
	if (!(local_int_tab2[1][(n*6)+5]))
    	    cbq_off(config[1][(n*6)+1]);
    }
}

void cbq_off_all(char ***config)
{
    int		n;

    for(n=1;n<local_int_pos;n++)
    {
        cbq_off(config[1][(n*6)+1]);
    }
}

void cbq_setup_root(char *iface, unsigned long int max_speed, int id1, int type)
{
    unsigned long int	ts;
    char	buf[4000];
    char	com[100];
    FILE	*fp;

    fflush(NULL);
    if (debug) putstring("start cbq_setup_root");
    sprintf(com,"/bin/sh 2>> %s",output);
    if (!notc && (fp = popen(com,"w")))
    {
	ts = max_speed/id1;
	if (type == 0)
	{
	    if (debug > 1) printf("cbq_setup_root:\n");
	    sprintf(buf,"%s qdisc add dev %s root handle %d: cbq bandwidth %lu%s avpkt 1000 cell 8\n",
		    tc_path,iface,id1,max_speed,speed_ext);
	    if (debug > 3) printf("%s",buf);
	    fputs(buf,fp);
	}
	else
	if (type == 1 || type == 2 || type == 3)
	{
	    if (debug > 1) printf("htb_setup_root:\n");
//	    sprintf(buf,"/sbin/tc qdisc add dev %s root handle %d: htb 1 default 2\n",
//		    iface,id1);
	    sprintf(buf,"%s qdisc add dev %s root handle %d: htb default 2\n",
		    tc_path,iface,id1);
	    fputs(buf,fp);
	    if (debug > 3) printf("%s",buf);
	}

	if (type == 0)
	{
	    float weight = max_speed / 10;

	    if (weight < 1) weight = 1;
	    sprintf(buf,"%s class add dev %s parent %d:0 classid %d:1 cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio 3 allot 1514 maxburst 20 avpkt 1000\n",
		    tc_path,iface,id1,id1,max_speed,speed_ext,max_speed,speed_ext,weight,speed_ext);
	}
	else
	if (type == 1 || type == 2 || type == 3)
	{
	    int		burst;
	    char	burst_str[30];
	    int		cburst;
	    char	cburst_str[30];
	    int		quantum;
	    char	quantum_str[30];

	    quantum = (max_speed * mult)/10;
	    if (htb_quantum) sprintf(quantum_str,"quantum %d",quantum);
	    else strcpy(quantum_str,"\0");

	    if (htb_burst)
	    {
		burst = (max_speed * mult)/htb_burst;
		sprintf(burst_str,"burst %d",burst);
	    }
	    else strcpy(burst_str,"\0");
	    
	    if (htb_cburst)
	    {
		cburst = (max_speed * mult)/htb_cburst;
		sprintf(cburst_str,"cburst %d",cburst);
	    }
	    else strcpy(cburst_str,"\0");
	    
    	    sprintf(buf,"%s class add dev %s parent %d:0 classid %d:1 htb rate %lu%s prio 1 %s %s %s\n",
		    tc_path,iface,id1,id1,max_speed,speed_ext,quantum_str,burst_str,cburst_str);
	}
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	pclose(fp);
    }
    if (debug) putstring("stop  cbq_setup_root");
}

//void cbq_setup_clas(char *mainip, char *iface, unsigned long int max_speed, int id1, char *ipg, char *ipd)
void cbq_setup_clas(char *iface, unsigned long int max_speed, int id1, char *ipg, char *ipd, int type)
{
    char        buf[2000];
    char	com[100];
    FILE	*fp;

    fflush(NULL);
    if (debug) putstring("start cbq_setup_clas");
    sprintf(com,"/bin/sh 2>> %s",output);
    if (!notc && (fp = popen(com,"w")))
    {
	if (type == 0)
	{
	    float	weight = max_speed / 10;
	    
	    if (weight < 1) weight = 1;
	    sprintf(buf,"%s class add dev %s parent %d:1 classid %d:2 cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio 3 allot 1514 maxburst 20 avpkt 1000\n",
	    	    tc_path, iface, id1, id1, max_speed, speed_ext, max_speed, speed_ext, weight, speed_ext);
	    if (debug > 1) printf("cbq_setup_clas:\n");
	}
	else
	if (type == 1 || type == 2 || type == 3)
	{
	    int		burst;
	    char	burst_str[30];
	    int		cburst;
	    char	cburst_str[30];
	    int		quantum;
	    char	quantum_str[30];

	    quantum = (max_speed * mult)/10;
	    if (htb_quantum) sprintf(quantum_str,"quantum %d",quantum);
	    else strcpy(quantum_str,"\0");

	    if (htb_burst)
	    {
		burst = (max_speed * mult)/htb_burst;
		sprintf(burst_str,"burst %d",burst);
	    }
	    else strcpy(burst_str,"\0");
	    
	    if (htb_cburst)
	    {
		cburst = (max_speed * mult)/htb_cburst;
		sprintf(cburst_str,"cburst %d",cburst);
	    }
	    else strcpy(cburst_str,"\0");
	    
	    sprintf(buf,"%s class add dev %s parent %d:1 classid %d:2 htb rate %lu%s prio 1 %s %s %s\n",
		    tc_path, iface, id1, id1, max_speed, speed_ext, quantum_str, burst_str, cburst_str);
	    if (debug > 1) printf("htb_setup_clas:\n");
	}
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	if (type == 0)
	{
    	    sprintf(buf,"%s qdisc add dev %s parent %d:2 tbf rate %lu%s buffer 10Kb limit 15Kb\n",
	    	    tc_path, iface, id1, max_speed, speed_ext);
	}
	else
	if (type == 1 || type == 2 || type == 3)
	{
    	    sprintf(buf,"%s qdisc add dev %s parent %d:2 handle %d: sfq perturb 10\n",
	    	    tc_path, iface, id1, (id1*10)+2);
	}

	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);

	if (squid==1)
	{
            sprintf(buf,"%s filter add dev %s parent %d:0 protocol ip prio 10 handle %d fw classid %d:2\n",
    		    tc_path,iface,id1,1000*id1,id1);
	    fputs(buf,fp);
	}
	else
	{
    	    sprintf(buf,"%s filter add dev %s parent %d:0 protocol ip prio 100 handle %d::%d u32 match ip src %s match ip sport 0 0x0 match ip dst %s flowid %d:2\n",
	    	    tc_path, iface, id1, 800, 1, ipg, ipd, id1);
	    if (debug > 3) printf("%s",buf);
	    fputs(buf,fp);
	}
	pclose(fp);
    }
    if (debug) putstring("stop  cbq_setup_clas");
}

void cbq_setup_xfilters(char *iface, int id1, char *mainip, char *ipd, int n)
{
    char        buf[2000];
    char	com[100];
    FILE	*fp;

    fflush(NULL);
    if (debug) putstring("start cbq_setup_xfilters");
    sprintf(com,"/bin/sh 2>> %s",output);
    if (!notc && (fp = popen(com,"w")))
    {
	if (debug > 1) printf("cbq_setup_xfilters:\n");
	sprintf(buf,"%s filter add dev %s parent %d:0 protocol ip prio 100 handle %d::%d u32 match ip src %s match ip sport 0 0x0 match ip dst %s flowid %d:1\n",
		tc_path, iface, id1, 800+n, 4, mainip, ipd, id1);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	pclose(fp);
    }
    if (debug) putstring("stop  cbq_setup_xfilters");
}


void cbq_ingress_root(char *iface)
{
    char	buf[2000];
    char	com[100];
    FILE	*fp;

    fflush(NULL);
    if (debug) putstring("start cbq_ingress_root");
    sprintf(com,"/bin/sh 2>> %s",output);
    if (!notc && (fp = popen(com,"w")))
    {
	if (debug > 1) printf("cbq_ingress_root:\n");
	sprintf(buf,"%s qdisc add dev %s handle ffff: ingress\n",tc_path,iface);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	pclose(fp);
    }
    if (debug) putstring("stop  cbq_ingress_root");
}

void cbq_class_add(	char *iface, unsigned long int max_speed,
			unsigned long int t_speed, int id1, int id2,
			char *ipg, char *ipd, int pri, int maxburst,
			char *borrow, int type, struct IPLISTA * ptr)
{
    int		prio = 100;
    char	buf[2000];
    char	com[100];
    FILE	*fp;

    fflush(NULL);
    if (debug) putstring("start cbq_class_add");
    sprintf(com,"/bin/sh 2>> %s",output);
    if (!notc && (fp = popen(com,"w")))
    {
	if (type == 0)
	{
	    float	weight = t_speed;
	    
	    if (weight < 1) weight = 1;
	    pri = pri + 2;
	    sprintf(buf,"%s class add dev %s parent %d:1 classid %d:%d cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio %d allot 1514 maxburst %d avpkt 1000 %s\n",
    		    tc_path,iface,id1,id1,id2,max_speed,speed_ext,t_speed,speed_ext,weight,speed_ext,pri,maxburst,borrow);
	    if (debug > 1) printf("cbq_class_add:\n");
	}
	else
	if (type == 1)
	{
	    if (ptr)
	    {
		int		burst;
		char		burst_str[30];
		int		cburst;
		char		cburst_str[30];
		int		quantum;
		char		quantum_str[30];

		quantum = (t_speed * mult)/10;
		if (htb_quantum) sprintf(quantum_str,"quantum %d",quantum);
		else strcpy(quantum_str,"\0");

		if (htb_burst)
		{
		    burst = ((burst_type ? t_speed : ptr -> hi) * mult)/htb_burst;
		    sprintf(burst_str,"burst %d",burst);
		}
		else strcpy(burst_str,"\0");
	    
		if (htb_cburst)
		{
		    cburst = ((cburst_type ? t_speed : ptr -> hi) * mult)/htb_cburst;
		    sprintf(cburst_str,"cburst %d",cburst);
		}
		else strcpy(cburst_str,"\0");

		if (strstr(borrow,"bounded"))
		{
//		sprintf(buf,"/sbin/tc class add dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class add dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
			    tc_path,iface,id1,id1,id2,t_speed,speed_ext,(t_speed*(100+ceil_download))/100,speed_ext,pri,burst_str,cburst_str,quantum_str);
		}
		else
		{
//		sprintf(buf,"/sbin/tc class add dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class add dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			    tc_path,iface,id1,id1,id2,t_speed,speed_ext,(t_speed*(100+ceil_download))/100,speed_ext,pri,burst_str,cburst_str,quantum_str);
		}
		if (debug > 1) printf("htb_class_add:\n");
	    }
	    else
    	    {
                if (debug > 1) printf("BUG: htb_class_add - NULL struct pointer!\n");
                syslog(LOG_ERR,"BUG: htb_class_add - NULL struct pointer!");
    	    }
	}
	else
	if (type == 2 || type == 3)
	{
	    if (ptr)
	    {
    		int		burst;
		char		burst_str[30];
		int		cburst;
		char		cburst_str[30];
	        int		quantum;
	        char		quantum_str[30];

		quantum = (t_speed * mult)/10;
	        if (htb_quantum) sprintf(quantum_str,"quantum %d",quantum);
	        else strcpy(quantum_str,"\0");

		if (htb_burst)
		{
		    burst = ((burst_type ? t_speed : ptr -> hi) * mult)/htb_burst;
		    sprintf(burst_str,"burst %d",burst);
		}
		else strcpy(burst_str,"\0");
	    
		if (htb_cburst)
		{
		    cburst = ((cburst_type ? t_speed : ptr -> hi) * mult)/htb_cburst;
		    sprintf(cburst_str,"cburst %d",cburst);
		}
		else strcpy(cburst_str,"\0");

	        if (strstr(borrow,"bounded"))
		{
//		    sprintf(buf,"/sbin/tc class add dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class add dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
			tc_path,iface,id1,id1,id2,ptr -> lo,speed_ext,t_speed,speed_ext,pri,burst_str,cburst_str,quantum_str);
	        }
		else
	        {
//	    	    sprintf(buf,"/sbin/tc class add dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
	    	    sprintf(buf,"%s class add dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			tc_path,iface,id1,id1,id2,ptr -> lo,speed_ext,t_speed,speed_ext,pri,burst_str,cburst_str,quantum_str);
	        }
		if (debug > 1) printf("ehtb_class_add:\n");
	    }
	    else
	    {
		if (debug > 1) printf("BUG: ehtb_class_add - NULL struct pointer!\n");
		syslog(LOG_ERR,"BUG: ehtb_class_add - NULL struct pointer!");
	    }
	}
	if (debug > 3) printf("%s",buf); 
	fputs(buf,fp);
	if (type == 0)
	{
	    if (! extended_queue)
	    {
		sprintf(buf,"%s qdisc add dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    		tc_path,iface,id1,id2,t_speed,speed_ext);
		fputs(buf,fp);
	        if (debug > 3) printf("%s",buf);
	    }
	    else
	    {
		float	weight = t_speed / 10;
		
		if (weight < 1) weight = 1;
	        pri = pri + 2;
		sprintf(buf,"%s class add dev %s parent %d:%d classid %d:%d cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio %d allot 1514 maxburst %d avpkt 1000\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+100,max_speed,speed_ext,t_speed,speed_ext,weight,speed_ext,3,maxburst);
		fputs(buf,fp);
	        if (debug > 3) printf("%s",buf);
		sprintf(buf,"%s class add dev %s parent %d:%d classid %d:%d cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio %d allot 1514 maxburst %d avpkt 1000\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+101,max_speed,speed_ext,t_speed,speed_ext,weight,speed_ext,4,maxburst);
		fputs(buf,fp);
	        if (debug > 3) printf("%s",buf);
		sprintf(buf,"%s class add dev %s parent %d:%d classid %d:%d cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio %d allot 1514 maxburst %d avpkt 1000\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+102,max_speed,speed_ext,t_speed,speed_ext,weight,speed_ext,5,maxburst);
		fputs(buf,fp);
	        if (debug > 3) printf("%s",buf);
		sprintf(buf,"%s class add dev %s parent %d:%d classid %d:%d cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio %d allot 1514 maxburst %d avpkt 1000\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+103,max_speed,speed_ext,t_speed,speed_ext,weight,speed_ext,6,maxburst);
		fputs(buf,fp);
	        if (debug > 3) printf("%s",buf);
		sprintf(buf,"%s qdisc add dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    		tc_path,iface,id1,(4*id2)+100,t_speed,speed_ext);
		fputs(buf,fp);
	        if (debug > 3) printf("%s",buf);
		sprintf(buf,"%s qdisc add dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    		tc_path,iface,id1,(4*id2)+101,t_speed,speed_ext);
		fputs(buf,fp);
	        if (debug > 3) printf("%s",buf);
		sprintf(buf,"%s qdisc add dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    		tc_path,iface,id1,(4*id2)+102,t_speed,speed_ext);
		fputs(buf,fp);
	        if (debug > 3) printf("%s",buf);
		sprintf(buf,"%s qdisc add dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    		tc_path,iface,id1,(4*id2)+103,t_speed,speed_ext);
		fputs(buf,fp);
	        if (debug > 3) printf("%s",buf);
	    }
	}
	else
	if (type == 1 || type == 2 || type == 3)
	{
	    if (! extended_queue)
	    {
		sprintf(buf,"%s qdisc add dev %s parent %d:%d sfq perturb 10\n",
			tc_path,iface,id1,id2);
		fputs(buf,fp);
		if (debug > 3) printf("%s",buf);
	    }
	    else
	    {
		if (ptr)
		{
		    int		burst;
		    char	burst_str[30];
		    int		cburst;
		    char	cburst_str[30];
		    int		quantum;
		    char	quantum_str[30];

	    	    quantum = (t_speed * mult)/10;
	    	    if (htb_quantum) sprintf(quantum_str,"quantum %d",quantum);
		    else strcpy(quantum_str,"\0");

		    if (htb_burst)
		    {
			burst = ((burst_type ? t_speed : ptr -> hi) * mult)/htb_burst;
			if (burst > 240000) burst = 240000;
			sprintf(burst_str,"burst %d",burst);
		    }
		    else strcpy(burst_str,"\0");
	    
		    if (htb_cburst)
		    {
			cburst = ((cburst_type ? t_speed : ptr -> hi) * mult)/htb_cburst;
			sprintf(cburst_str,"cburst %d",cburst);
		    }
		    else strcpy(cburst_str,"\0");

//		sprintf(buf,"/sbin/tc class add dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class add dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			    tc_path,iface,id1,id2,id1,(4*id2)+100,1,speed_ext,(t_speed*(100+ceil_download))/100,speed_ext,0,burst_str,cburst_str,quantum_str);
		    fputs(buf,fp);
		    if (debug > 3) printf("%s",buf);
//		sprintf(buf,"/sbin/tc class add dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class add dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			    tc_path,iface,id1,id2,id1,(4*id2)+101,1,speed_ext,(t_speed*(100+ceil_download))/100,speed_ext,1,burst_str,cburst_str,quantum_str);
		    fputs(buf,fp);
		    if (debug > 3) printf("%s",buf);
//		sprintf(buf,"/sbin/tc class add dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class add dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			    tc_path,iface,id1,id2,id1,(4*id2)+102,1,speed_ext,(t_speed*(100+ceil_download))/100,speed_ext,2,burst_str,cburst_str,quantum_str);
		    fputs(buf,fp);
		    if (debug > 3) printf("%s",buf);
//		sprintf(buf,"/sbin/tc class add dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class add dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			    tc_path,iface,id1,id2,id1,(4*id2)+103,1,speed_ext,(t_speed*(100+ceil_download))/100,speed_ext,3,burst_str,cburst_str,quantum_str);
		    fputs(buf,fp);
		    if (debug > 3) printf("%s",buf);

		    sprintf(buf,"%s qdisc add dev %s parent %d:%d sfq perturb 10\n",
			    tc_path,iface,id1,(4*id2)+100);
		    fputs(buf,fp);
		    if (debug > 3) printf("%s",buf);
		    sprintf(buf,"%s qdisc add dev %s parent %d:%d sfq perturb 10\n",
			    tc_path,iface,id1,(4*id2)+101);
		    fputs(buf,fp);
		    if (debug > 3) printf("%s",buf);
		    sprintf(buf,"%s qdisc add dev %s parent %d:%d sfq perturb 10\n",
			    tc_path,iface,id1,(4*id2)+102);
		    fputs(buf,fp);
		    if (debug > 3) printf("%s",buf);
		    sprintf(buf,"%s qdisc add dev %s parent %d:%d sfq perturb 10\n",
			    tc_path,iface,id1,(4*id2)+103);
		    fputs(buf,fp);
		    if (debug > 3) printf("%s",buf);
		}
		else
        	{
            	    if (debug > 1) printf("BUG: htb_class_add - NULL struct pointer!\n");
            	    syslog(LOG_ERR,"BUG: htb_class_add - NULL struct pointer!");
        	}
	    }
	}

//	if (squid && ! extended_queue)
	if (squid==1)
	{
	    if (! extended_queue)
	    {
    		sprintf(buf,"%s filter add dev %s parent %d:0 protocol ip prio %d handle %d::%d u32 match ip src %s match ip sport %d 0xffff match ip tos 8 0xff match ip dst %s flowid %d:%d\n",
		    tc_path,iface,id1,prio,800,400+id2,ipg,squid_port,ipd,id1,id2);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
	    }
	    else
	    {
    		sprintf(buf,"%s filter add dev %s parent %d:0 protocol ip prio %d handle %d::%d u32 match ip src %s match ip sport %d 0xffff match ip tos 8 0xff match ip dst %s flowid %d:%d\n",
		    tc_path,iface,id1,prio,800,400+id2,ipg,squid_port,ipd,id1,(4*id2)+101);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
	    }
	}
	if (! extended_queue)
	{
        sprintf(buf,"%s filter add dev %s parent %d:0 protocol ip prio %d handle %d::%d u32 match ip sport 0 0x0 match ip dst %s flowid %d:%d\n",
    	        tc_path,iface,id1,prio,800,100+id2,ipd,id1,id2);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	}
	else
	{
        sprintf(buf,"%s filter add dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
    	        tc_path,iface,id1,10,(4*id2)+100+(id1*1000),id1,(4*id2)+100);
	fputs(buf,fp);
        sprintf(buf,"%s filter add dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
    	        tc_path,iface,id1,10,(4*id2)+101+(id1*1000),id1,(4*id2)+101);
	fputs(buf,fp);
        sprintf(buf,"%s filter add dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
    	        tc_path,iface,id1,10,(4*id2)+102+(id1*1000),id1,(4*id2)+102);
	fputs(buf,fp);
        sprintf(buf,"%s filter add dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
    	        tc_path,iface,id1,10,(4*id2)+103+(id1*1000),id1,(4*id2)+103);
	fputs(buf,fp);

//        sprintf(buf,"/sbin/tc filter add dev %s parent %d:0 protocol ip prio %d handle %d::%d u32 match ip sport 0 0x0 match ip dst %s flowid %d:%d\n",
//    	        iface,id1,prio,800,100+id2,ipd,id1,(4*id2)+103);
//	if (debug > 3) printf("%s",buf);
//	fputs(buf,fp);


	}
	pclose(fp);
    }
    if (debug) putstring("stop  cbq_class_add");
}
void cbq_ingress_add(char *iface, unsigned long int max_speed, int id1, int id2, char *ipg, char *ipd, int pri)
{
    int		prio = 100;
    int		maxburst=5000;
    char	buf[2000];
    char	com[100];
    FILE	*fp;

//    if (!ipg) ipg="0.0.0.0/0";
    if (ipg)
    {
    fflush(NULL);
    if (debug) putstring("start cbq_ingress_add");
    sprintf(com,"/bin/sh 2>> %s",output);
    if (!notc && (fp = popen(com,"w")))
    {
	if (debug > 1) printf("cbq_ingress_add:\n");
	sprintf(buf,"%s filter add dev %s parent ffff: handle 800::%d protocol ip prio %d u32 match ip src %s match ip dst %s match ip dport %d 0xffff police rate %lu%s burst %d drop flowid :1\n",
	    tc_path,iface,(800+id2),pri,ipd,ipg,squid_port,(unsigned long int)((float)max_speed*(float)squid_factor),speed_ext,maxburst);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	pclose(fp);
    }
    }
    if (debug) putstring("stop  cbq_ingress_add");
}

void cbq_class_add_upload(char *iface, unsigned long int max_speed,
			unsigned long int t_speed, int id1, int id2,
			char *ipg, char *ipd, int pri, int maxburst,
			char *borrow, int type, struct IPLISTA * ptr)
{
    int		prio = 100;
    char	buf[2000];
    char	com[100];
    FILE	*fp;

    fflush(NULL);
    if (debug) putstring("start cbq_class_add_upload");
    sprintf(com,"/bin/sh 2>> %s",output);
    if (!notc && (fp = popen(com,"w")))
    {
	if (type == 0)
	{
	    float	weight = t_speed / 10;
	    
	    if (weight < 1) weight = 1;
	    pri = pri + 2;
	    sprintf(buf,"%s class add dev %s parent %d:1 classid %d:%d cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio %d allot 1514 maxburst %d avpkt 1000 %s\n",
    		    tc_path,iface,id1,id1,id2,max_speed,speed_ext,t_speed,speed_ext,weight,speed_ext,pri,maxburst,borrow);
	    if (debug > 1) printf("cbq_class_add_upload:\n");
	}
	else
	if (type == 1)
	{
	    if (ptr)
	    {
		int		burst;
		char		burst_str[30];
		int		cburst;
		char		cburst_str[30];
		int		quantum;
		char		quantum_str[30];

		quantum = (t_speed * mult)/10;
		if (htb_quantum) sprintf(quantum_str,"quantum %d",quantum);
		else strcpy(quantum_str,"\0");

		if (htb_burst)
		{
	    	burst = ((burst_type ? t_speed : ptr -> hi_upload) * mult)/htb_burst;
	    	sprintf(burst_str,"burst %d",burst);
		}
		else strcpy(burst_str,"\0");
	    
		if (htb_cburst)
		{
	    	    cburst = ((cburst_type ? t_speed : ptr -> hi_upload) * mult)/htb_cburst;
		    sprintf(cburst_str,"cburst %d",cburst);
		}
		else strcpy(cburst_str,"\0");

		if (strstr(borrow,"bounded"))
		{
//		sprintf(buf,"/sbin/tc class add dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s burst %lu%s prio %d %s\n",
		    sprintf(buf,"%s class add dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s %s %s prio %d %s\n",
			    tc_path,iface,id1,id1,id2,t_speed,speed_ext,(t_speed*(100+ceil_upload))/100,speed_ext,burst_str,cburst_str,pri,quantum_str);
		}
		else
		{
//		sprintf(buf,"/sbin/tc class add dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s burst %lu%s prio %d %s\n",
		    sprintf(buf,"%s class add dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s %s %s prio %d %s\n",
    			    tc_path,iface,id1,id1,id2,t_speed,speed_ext,(t_speed*(100+ceil_upload))/100,speed_ext,burst_str,cburst_str,pri,quantum_str);
		}
		if (debug > 1) printf("htb_class_add_upload:\n");
	    }
	    else
            {
                if (debug > 1) printf("BUG: htb_class_add_upload - NULL struct pointer!\n");
                syslog(LOG_ERR,"BUG: htb_class_add_upload - NULL struct pointer!");
            }
	}
	else
	if (type == 2 || type == 3)
	{
	    if (ptr)
	    {
		int	burst;
		char	burst_str[30];
		int	cburst;
		char	cburst_str[30];
	        int	quantum;
	        char	quantum_str[30];

	        quantum = (t_speed * mult)/10;
		if (htb_quantum) sprintf(quantum_str,"quantum %d",quantum);
	        else strcpy(quantum_str,"\0");

		if (htb_burst)
		{
	    	    burst = ((burst_type ? t_speed : ptr -> hi_upload) * mult)/htb_burst;
	    	    sprintf(burst_str,"burst %d",burst);
		}
		else strcpy(burst_str,"\0");
	    
		if (htb_cburst)
		{
	    	    cburst = ((cburst_type ? t_speed : ptr -> hi_upload) * mult)/htb_cburst;
		    sprintf(cburst_str,"cburst %d",cburst);
		}
		else strcpy(cburst_str,"\0");

		if (strstr(borrow,"bounded"))
	        {
//		    sprintf(buf,"/sbin/tc class add dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s burst %lu%s prio %d %s\n",
		    sprintf(buf,"%s class add dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s %s %s prio %d %s\n",
			tc_path,iface,id1,id1,id2,ptr -> lo_upload,speed_ext,t_speed,speed_ext,burst_str,cburst_str,pri,quantum_str);
	        }
	        else
	        {
//	    	    sprintf(buf,"/sbin/tc class add dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s burst %lu%s prio %d %s\n",
	    	    sprintf(buf,"%s class add dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s %s %s prio %d %s\n",
    			tc_path,iface,id1,id1,id2,ptr -> lo_upload,speed_ext,t_speed,speed_ext,burst_str,cburst_str,pri,quantum_str);
	        }
	        if (debug > 1) printf("ehtb_class_add_upload:\n");
	    }
	    else
	    {
	        if (debug > 1) printf("BUG: ehtb_class_add_upload - NULL struct pointer!\n");
	        syslog(LOG_ERR,"BUG: ehtb_class_add_upload - NULL struct pointer!");
	    }
	}

	if (debug > 3) printf("%s",buf); 
	fputs(buf,fp);
	if (type == 0)
	{
	    if (! extended_queue)
	    {
		sprintf(buf,"%s qdisc add dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    		tc_path,iface,id1,id2,t_speed,speed_ext);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
	    }
	    else
	    {
		float	weight = t_speed / 10;
		
		if (weight < 1) weight = 1;	    
		sprintf(buf,"%s class add dev %s parent %d:%d classid %d:%d cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio %d allot 1514 maxburst %d avpkt 1000\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+100,max_speed,speed_ext,t_speed,speed_ext,weight,speed_ext,3,maxburst);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class add dev %s parent %d:%d classid %d:%d cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio %d allot 1514 maxburst %d avpkt 1000\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+101,max_speed,speed_ext,t_speed,speed_ext,weight,speed_ext,4,maxburst);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class add dev %s parent %d:%d classid %d:%d cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio %d allot 1514 maxburst %d avpkt 1000\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+102,max_speed,speed_ext,t_speed,speed_ext,weight,speed_ext,5,maxburst);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class add dev %s parent %d:%d classid %d:%d cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio %d allot 1514 maxburst %d avpkt 1000\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+103,max_speed,speed_ext,t_speed,speed_ext,weight,speed_ext,6,maxburst);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);

		sprintf(buf,"%s qdisc add dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    		tc_path,iface,id1,(4*id2)+100,t_speed,speed_ext);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc add dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    		tc_path,iface,id1,(4*id2)+101,t_speed,speed_ext);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc add dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    		tc_path,iface,id1,(4*id2)+102,t_speed,speed_ext);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc add dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    		tc_path,iface,id1,(4*id2)+103,t_speed,speed_ext);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
	    }
	}
	else
	if (type == 1 || type == 2 || type == 3)
	{
	    if (! extended_queue)
	    {
		sprintf(buf,"%s qdisc add dev %s parent %d:%d sfq perturb 10\n",
	    		tc_path,iface,id1,id2);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
	    }
	    else
	    {
		if (ptr)
		{
		    int			quantum;
		    char		quantum_str[30];
		    int			burst;
		    char		burst_str[30];
		    int			cburst;
		    char		cburst_str[30];

		    quantum = (t_speed * mult)/10;
	    	    if (htb_quantum) sprintf(quantum_str,"quantum %d",quantum);
	    	    else strcpy(quantum_str,"\0");

		    if (htb_burst)
		    {
	    		burst = ((burst_type ? t_speed : ptr -> hi_upload) * mult)/htb_burst;
			if (burst > 240000) burst = 240000;
	    		sprintf(burst_str,"burst %d",burst);
		    }
		    else strcpy(burst_str,"\0");
	    
		    if (htb_cburst)
		    {
	    		cburst = ((cburst_type ? t_speed : ptr -> hi_upload) * mult)/htb_cburst;
			sprintf(cburst_str,"cburst %d",cburst);
		    }
		    else strcpy(cburst_str,"\0");

//		sprintf(buf,"/sbin/tc class add dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class add dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			    tc_path,iface,id1,id2,id1,(4*id2)+100,1,speed_ext,(t_speed*(100+ceil_upload))/100,speed_ext,0,burst_str,cburst_str,quantum_str);
		    if (debug > 3) printf("%s",buf);
		    fputs(buf,fp);
//		sprintf(buf,"/sbin/tc class add dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class add dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			    tc_path,iface,id1,id2,id1,(4*id2)+101,1,speed_ext,(t_speed*(100+ceil_upload))/100,speed_ext,1,burst_str,cburst_str,quantum_str);
		    if (debug > 3) printf("%s",buf);
		    fputs(buf,fp);
//		sprintf(buf,"/sbin/tc class add dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class add dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			    tc_path,iface,id1,id2,id1,(4*id2)+102,1,speed_ext,(t_speed*(100+ceil_upload))/100,speed_ext,2,burst_str,cburst_str,quantum_str);
		    if (debug > 3) printf("%s",buf);
		    fputs(buf,fp);
//		sprintf(buf,"/sbin/tc class add dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class add dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			    tc_path,iface,id1,id2,id1,(4*id2)+103,1,speed_ext,(t_speed*(100+ceil_upload))/100,speed_ext,3,burst_str,cburst_str,quantum_str);
		    if (debug > 3) printf("%s",buf);
		    fputs(buf,fp);

		    sprintf(buf,"%s qdisc add dev %s parent %d:%d sfq perturb 10\n",
	    		    tc_path,iface,id1,(4*id2)+100);
		    if (debug > 3) printf("%s",buf);
		    fputs(buf,fp);
		    sprintf(buf,"%s qdisc add dev %s parent %d:%d sfq perturb 10\n",
	    		    tc_path,iface,id1,(4*id2)+101);
		    if (debug > 3) printf("%s",buf);
		    fputs(buf,fp);
		    sprintf(buf,"%s qdisc add dev %s parent %d:%d sfq perturb 10\n",
	    		    tc_path,iface,id1,(4*id2)+102);
		    if (debug > 3) printf("%s",buf);
		    fputs(buf,fp);
		    sprintf(buf,"%s qdisc add dev %s parent %d:%d sfq perturb 10\n",
	    		    tc_path,iface,id1,(4*id2)+103);
		    if (debug > 3) printf("%s",buf);
		    fputs(buf,fp);
		}
		else
    		{
        	    if (debug > 1) printf("BUG: htb_class_add_upload - NULL struct pointer!\n");
            	    syslog(LOG_ERR,"BUG: htb_class_add_upload - NULL struct pointer!");
        	}
	    }
	}

	if (! extended_queue)
	{
    	    sprintf(buf,"%s filter add dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
    	    	    tc_path,iface,id1,10,id2+(id1*1000),id1,id2);
	    if (debug > 3) printf("%s",buf);
	    fputs(buf,fp);
	}
	else
	{
    	    sprintf(buf,"%s filter add dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
    	    	    tc_path,iface,id1,10,(4*id2)+100+(id1*1000),id1,(4*id2)+100);
	    if (debug > 3) printf("%s",buf);
	    fputs(buf,fp);
    	    sprintf(buf,"%s filter add dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
    	    	    tc_path,iface,id1,10,(4*id2)+101+(id1*1000),id1,(4*id2)+101);
	    if (debug > 3) printf("%s",buf);
	    fputs(buf,fp);
    	    sprintf(buf,"%s filter add dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
    	    	    tc_path,iface,id1,10,(4*id2)+102+(id1*1000),id1,(4*id2)+102);
	    if (debug > 3) printf("%s",buf);
	    fputs(buf,fp);
    	    sprintf(buf,"%s filter add dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
    	    	    tc_path,iface,id1,10,(4*id2)+103+(id1*1000),id1,(4*id2)+103);
	    if (debug > 3) printf("%s",buf);
	    fputs(buf,fp);
	}
	pclose(fp);
    }
    if (debug) putstring("stop  cbq_class_add_upload");
}

void cbq_class_change(	char *iface, unsigned long int max_speed,
			unsigned long int t_speed, int id1, int id2,
			char *ipg, char *ipd, int pri, int maxburst,
			char *borrow, int type, struct IPLISTA * ptr)
{
    int		prio = 100;
    char	buf[2000];
    char	com[100];
    FILE	*fp;

    fflush(NULL);
    if (debug) putstring("start cbq_class_change");
//    putstring("dev=%s parent=%d:1 classid=%d:%d bandwidth=%lu%s rate=%lu%s",iface,id1,id1,id2,max_speed,speed_ext,t_speed,speed_ext);
    sprintf(com,"/bin/sh 2>> %s",output);
    if (!notc && (fp = popen(com,"w")))
    {
	if (type == 0)
	{
	    float	weight = t_speed / 10;

	    if (weight < 1) weight = 1;
	    pri = pri + 2;
	    sprintf(buf,"%s class change dev %s parent %d:1 classid %d:%d cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio %d allot 1514 maxburst %d avpkt 1000 %s\n",
    		    tc_path,iface,id1,id1,id2,max_speed,speed_ext,t_speed,speed_ext,weight,speed_ext,pri,maxburst,borrow);
	    if (debug > 1) printf("cbq_class_change:\n");
	}
	else
	if (type == 1)
	{
	    if (ptr)
	    {
		int		burst;
		char		burst_str[30];
		int		cburst;
		char		cburst_str[30];
		int		quantum;
		char		quantum_str[30];

		quantum = (t_speed * mult)/10;
		if (htb_quantum) sprintf(quantum_str,"quantum %d",quantum);
		else strcpy(quantum_str,"\0");

		if (htb_burst)
		{
	    	    burst = ((burst_type ? t_speed : ptr -> hi) * mult)/htb_burst;
	    	    sprintf(burst_str,"burst %d",burst);
		}
		else strcpy(burst_str,"\0");
	    
		if (htb_cburst)
		{
	    	    cburst = ((cburst_type ? t_speed : ptr -> hi) * mult)/htb_cburst;
	    	    sprintf(cburst_str,"cburst %d",cburst);
		}
		else strcpy(cburst_str,"\0");

		if (strstr(borrow,"bounded"))
		{
//		sprintf(buf,"/sbin/tc class change dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class change dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
			    tc_path,iface,id1,id1,id2,t_speed,speed_ext,(t_speed*(100+ceil_download))/100,speed_ext,pri,burst_str,cburst_str,quantum_str);
		}
		else
		{
//		sprintf(buf,"/sbin/tc class change dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class change dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			    tc_path,iface,id1,id1,id2,t_speed,speed_ext,(t_speed*(100+ceil_download))/100,speed_ext,pri,burst_str,cburst_str,quantum_str);
		}
		if (debug > 1) printf("htb_class_change:\n");
	    }
	    else
            {
                if (debug > 1) printf("BUG: htb_class_change - NULL struct pointer!\n");
                syslog(LOG_ERR,"BUG: htb_class_change - NULL struct pointer!");
            }
	}
	else
	if (type == 2 || type == 3)
	{
	    if (ptr)
	    {
		int		burst;
		char		burst_str[30];
		int		cburst;
		char		cburst_str[30];
		int		quantum;
	        char	quantum_str[30];

		quantum = (t_speed * mult)/10;
	        if (htb_quantum) sprintf(quantum_str,"quantum %d",quantum);
	        else strcpy(quantum_str,"\0");

		if (htb_burst)
		{
		    burst = ((burst_type ? t_speed : ptr -> hi) * mult)/htb_burst;
	    	    sprintf(burst_str,"burst %d",burst);
		}
		else strcpy(burst_str,"\0");
	    
		if (htb_cburst)
		{
	    	    cburst = ((cburst_type ? t_speed : ptr -> hi) * mult)/htb_cburst;
	    	    sprintf(cburst_str,"cburst %d",cburst);
		}
		else strcpy(cburst_str,"\0");
		
		if (strstr(borrow,"bounded"))
	        {
//		    sprintf(buf,"/sbin/tc class change dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class change dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
			tc_path,iface,id1,id1,id2,ptr -> lo,speed_ext,t_speed,speed_ext,pri,burst_str,cburst_str,quantum_str);
		}
		else
		{
//		    sprintf(buf,"/sbin/tc class change dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class change dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			tc_path,iface,id1,id1,id2,ptr -> lo,speed_ext,t_speed,speed_ext,pri,burst_str,cburst_str,quantum_str);
		}
		if (debug > 1) printf("ehtb_class_change:\n");
	    }
	    else
	    {
	        if (debug > 1) printf("BUG: ehtb_class_change - NULL struct pointer!\n");
	        syslog(LOG_ERR,"BUG: ehtb_class_change - NULL struct pointer!");
	    }
	}
	if (debug > 3) printf("%s",buf); 
	fputs(buf,fp);

	if (type == 0)
	{
	    if (! extended_queue)
	    {
		sprintf(buf,"%s qdisc change dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    		tc_path,iface,id1,id2,t_speed,speed_ext);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
	    }
	    else
	    {
		float	weight = t_speed / 10;
	    
		if (weight < 1 ) weight = 1;
		sprintf(buf,"%s qdisc change dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    		tc_path,iface,id1,(4*id2)+100,t_speed,speed_ext);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc change dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    		tc_path,iface,id1,(4*id2)+101,t_speed,speed_ext);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc change dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    		tc_path,iface,id1,(4*id2)+102,t_speed,speed_ext);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc change dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    		tc_path,iface,id1,(4*id2)+103,t_speed,speed_ext);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);

		sprintf(buf,"%s class change dev %s parent %d:%d classid %d:%d cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio %d allot 1514 maxburst %d avpkt 1000\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+100,max_speed,speed_ext,t_speed,speed_ext,weight,speed_ext,3,maxburst);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class change dev %s parent %d:%d classid %d:%d cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio %d allot 1514 maxburst %d avpkt 1000\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+101,max_speed,speed_ext,t_speed,speed_ext,weight,speed_ext,4,maxburst);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class change dev %s parent %d:%d classid %d:%d cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio %d allot 1514 maxburst %d avpkt 1000\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+102,max_speed,speed_ext,t_speed,speed_ext,weight,speed_ext,5,maxburst);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class change dev %s parent %d:%d classid %d:%d cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio %d allot 1514 maxburst %d avpkt 1000\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+103,max_speed,speed_ext,t_speed,speed_ext,weight,speed_ext,6,maxburst);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
	    }
	}
	else
	if (type == 1 || type == 2 || type == 3)
	{
	    if (extended_queue)
	    {
		if (ptr)
		{
		    int			quantum;
		    char		quantum_str[30];
		    int			burst;
		    char		burst_str[30];
		    int			cburst;
		    char		cburst_str[30];

		    quantum = (t_speed * mult)/10;
	    	    if (htb_quantum) sprintf(quantum_str,"quantum %d",quantum);
	    	    else strcpy(quantum_str,"\0");

		    if (htb_burst)
		    {
			burst = ((burst_type ? t_speed : ptr -> hi) * mult)/htb_burst;
			if (burst > 240000) burst = 240000;
	    		sprintf(burst_str,"burst %d",burst);
		    }
		    else strcpy(burst_str,"\0");
	    
		    if (htb_cburst)
		    {
	    		cburst = ((cburst_type ? t_speed : ptr -> hi) * mult)/htb_cburst;
	    		sprintf(cburst_str,"cburst %d",cburst);
		    }
		    else strcpy(cburst_str,"\0");
    
//		sprintf(buf,"/sbin/tc class change dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class change dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			    tc_path,iface,id1,id2,id1,(4*id2)+100,1,speed_ext,(t_speed*(100+ceil_download))/100,speed_ext,0,burst_str,cburst_str,quantum_str);
		    fputs(buf,fp);
		    if (debug > 3) printf("%s",buf);
//		sprintf(buf,"/sbin/tc class change dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class change dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			    tc_path,iface,id1,id2,id1,(4*id2)+101,1,speed_ext,(t_speed*(100+ceil_download))/100,speed_ext,1,burst_str,cburst_str,quantum_str);
		    fputs(buf,fp);
		    if (debug > 3) printf("%s",buf);
//		sprintf(buf,"/sbin/tc class change dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class change dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			    tc_path,iface,id1,id2,id1,(4*id2)+102,1,speed_ext,(t_speed*(100+ceil_download))/100,speed_ext,2,burst_str,cburst_str,quantum_str);
		    fputs(buf,fp);
		    if (debug > 3) printf("%s",buf);
//		sprintf(buf,"/sbin/tc class change dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class change dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			    tc_path,iface,id1,id2,id1,(4*id2)+103,1,speed_ext,(t_speed*(100+ceil_download))/100,speed_ext,3,burst_str,cburst_str,quantum_str);
		    fputs(buf,fp);
		    if (debug > 3) printf("%s",buf);
		}
		else
        	{
            	    if (debug > 1) printf("BUG: htb_class_change - NULL struct pointer!\n");
            	    syslog(LOG_ERR,"BUG: htb_class_change - NULL struct pointer!");
        	}
	    }
	}
	pclose(fp);
    }
    if (debug) putstring("stop  cbq_class_change");
}

void cbq_ingress_change(char *iface, unsigned long int max_speed, int id1, int id2, char *ipg, char *ipd, int pri)
{
    int		prio = 100;
    int         maxburst=5000;
    char	buf[2000];
    char	com[100];
    FILE	*fp;

//    if (!ipg) ipg="0.0.0.0/0";
    if (ipg)
    {
    fflush(NULL);
    if (debug) putstring("start cbq_ingress_change");
    sprintf(com,"/bin/sh 2>> %s",output);
    if (!notc && (fp = popen(com,"w")))
    {
	if (debug > 1) printf("cbq_ingress_change:\n");
	sprintf(buf,"%s filter change dev %s parent ffff: handle 800::%d protocol ip prio %d u32 match ip src %s match ip dst %s match ip dport %d 0xffff police rate %lu%s burst %d drop flowid :1\n",
	    tc_path,iface,(800+id2),pri,ipd,ipg,squid_port,(unsigned long int)((float)max_speed*(float)squid_factor),speed_ext,maxburst);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	pclose(fp);
    }
    }
    if (debug) putstring("stop  cbq_ingress_change");
}

void cbq_class_change_upload(char *iface, unsigned long int max_speed,
			    unsigned long int t_speed, int id1, int id2,
			    char *ipg, char *ipd, int pri, int maxburst,
			    char *borrow, int type, struct IPLISTA * ptr)
{
    int		prio = 100;
    char	buf[2000];
    char	com[100];
    FILE	*fp;

    fflush(NULL);
    if (debug) putstring("start cbq_class_change_upload");
//    putstring("dev=%s parent=%d:1 classid=%d:%d bandwidth=%lu%s rate=%lu%s ip=%s maxburst=%d weight=%lu%s, borr=%s",
//	iface,id1,id1,id2,max_speed,speed_ext,t_speed,speed_ext,ipd,maxburst,t_speed/10,speed_ext,borrow);
    sprintf(com,"/bin/sh 2>> %s",output);
//    sprintf(com,"/bin/sh 2>> /dev/null");
    if (!notc && (fp = popen(com,"w")))
    {
	if (type == 0)
	{
	    float	weight = t_speed / 10;
	    
	    if (weight < 1) weight = 1;	
	    pri = pri + 2;
	    sprintf(buf,"%s class change dev %s parent %d:1 classid %d:%d cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio %d allot 1514 maxburst %d avpkt 1000 %s\n",
    		    tc_path,iface,id1,id1,id2,max_speed,speed_ext,t_speed,speed_ext,weight,speed_ext,pri,maxburst,borrow);
	    if (debug > 1) printf("cbq_class_change_upload:\n");
	}
	else
	if (type == 1)
	{
	    if (ptr)
	    {
		int		burst;
		char		burst_str[30];
		int		cburst;
		char		cburst_str[30];
		int		quantum;
		char		quantum_str[30];

    		quantum = (t_speed * mult)/10;
		if (htb_quantum) sprintf(quantum_str,"quantum %d",quantum);
		else strcpy(quantum_str,"\0");
        
		if (htb_burst)
		{
	    	    burst = ((burst_type ? t_speed : ptr -> hi_upload) * mult)/htb_burst;
	    	    sprintf(burst_str,"burst %d",burst);
		}
		else strcpy(burst_str,"\0");
	    
		if (htb_cburst)
		{
	    	    cburst = ((cburst_type ? t_speed : ptr -> hi_upload) * mult)/htb_cburst;
	    	    sprintf(cburst_str,"cburst %d",cburst);
		}
		else strcpy(cburst_str,"\0");

		if (strstr(borrow,"bounded"))
		{
//		sprintf(buf,"/sbin/tc class change dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class change dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
			    tc_path,iface,id1,id1,id2,t_speed,speed_ext,(t_speed*(100+ceil_upload))/100,speed_ext,pri,burst_str,cburst_str,quantum_str);
		}
		else
		{
//		sprintf(buf,"/sbin/tc class change dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class change dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			    tc_path,iface,id1,id1,id2,t_speed,speed_ext,(t_speed*(100+ceil_upload))/100,speed_ext,pri,burst_str,cburst_str,quantum_str);
		}
		if (debug > 1) printf("htb_class_change_upload:\n");
	    }
	    else
            {
                if (debug > 1) printf("BUG: htb_class_change_upload - NULL struct pointer!\n");
                syslog(LOG_ERR,"BUG: htb_class_change_upload - NULL struct pointer!");
            }
	}
	else
	if (type == 2 || type == 3)
	{
	    if (ptr)
	    {
		int		burst;
		char		burst_str[30];
		int		cburst;
		char		cburst_str[30];
	        int		quantum;
	        char		quantum_str[30];

    		quantum = (t_speed * mult)/10;
	        if (htb_quantum) sprintf(quantum_str,"quantum %d",quantum);
	        else strcpy(quantum_str,"\0");
		
		if (htb_burst)
		{
		    burst = ((burst_type ? t_speed : ptr -> hi_upload) * mult)/htb_burst;
	    	    sprintf(burst_str,"burst %d",burst);
		}
		else strcpy(burst_str,"\0");
	    
		if (htb_cburst)
		{
	    	    cburst = ((cburst_type ? t_speed : ptr -> hi_upload) * mult)/htb_cburst;
	    	    sprintf(cburst_str,"cburst %d",cburst);
		}
		else strcpy(cburst_str,"\0");

	        if (strstr(borrow,"bounded"))
	        {
//	    	    sprintf(buf,"/sbin/tc class change dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
	    	    sprintf(buf,"%s class change dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
	    		tc_path,iface,id1,id1,id2,ptr -> lo_upload,speed_ext,t_speed,speed_ext,pri,burst_str,cburst_str,quantum_str);
	        }
	        else
	        {
//		    sprintf(buf,"/sbin/tc class change dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class change dev %s parent %d:1 classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			tc_path,iface,id1,id1,id2,ptr -> lo_upload,speed_ext,t_speed,speed_ext,pri,burst_str,cburst_str,quantum_str);
		}
	        if (debug > 1) printf("ehtb_class_change_upload:\n");
	    }
	    else
	    {
	        if (debug > 1) printf("BUG: ehtb_class_change_upload - NULL struct pointer!\n");
	        syslog(LOG_ERR,"BUG: ehtb_class_change_upload - NULL struct pointer!");
	    }
	}
	if (debug > 3) printf("%s",buf); 
	fputs(buf,fp);

	if (type == 0)
	{
	    if (! extended_queue)
	    {
		sprintf(buf,"%s qdisc change dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    		tc_path,iface,id1,id2,t_speed,speed_ext);
		if (debug > 3) printf("%s",buf); 
		fputs(buf,fp);
	    }
	    else
	    {
		float	weight = t_speed / 10;
		
		if (weight < 1) weight = 1;	    
		sprintf(buf,"%s qdisc change dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    		tc_path,iface,id1,(4*id2)+100,t_speed,speed_ext);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc change dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    		tc_path,iface,id1,(4*id2)+101,t_speed,speed_ext);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc change dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    		tc_path,iface,id1,(4*id2)+102,t_speed,speed_ext);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc change dev %s parent %d:%d tbf rate %lu%s buffer 10Kb limit 5Kb\n",
	    		tc_path,iface,id1,(4*id2)+103,t_speed,speed_ext);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);

		sprintf(buf,"%s class change dev %s parent %d:%d classid %d:%d cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio %d allot 1514 maxburst %d avpkt 1000\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+100,max_speed,speed_ext,t_speed,speed_ext,weight,speed_ext,3,maxburst);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class change dev %s parent %d:%d classid %d:%d cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio %d allot 1514 maxburst %d avpkt 1000\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+101,max_speed,speed_ext,t_speed,speed_ext,weight,speed_ext,4,maxburst);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class change dev %s parent %d:%d classid %d:%d cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio %d allot 1514 maxburst %d avpkt 1000\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+102,max_speed,speed_ext,t_speed,speed_ext,weight,speed_ext,5,maxburst);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class change dev %s parent %d:%d classid %d:%d cbq bandwidth %lu%s rate %lu%s cell 8 weight %.0f%s prio %d allot 1514 maxburst %d avpkt 1000\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+103,max_speed,speed_ext,t_speed,speed_ext,weight,speed_ext,6,maxburst);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
	    }
	}
	else
	if (type == 1 || type == 2 || type == 3)
	{
	    if (! extended_queue)
	    {
/*
		sprintf(buf,"/sbin/tc qdisc change dev %s parent %d:%d sfq perturb 10\n",
	    		iface,id1,id2);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
*/
	    }
	    else
	    {
		if (ptr)
		{
		    int			quantum;
		    char		quantum_str[30];
		    int			burst;
		    char		burst_str[30];
		    int			cburst;
		    char		cburst_str[30];

    		    quantum = (t_speed * mult)/10;
	    	    if (htb_quantum) sprintf(quantum_str,"quantum %d",quantum);
	    	    else strcpy(quantum_str,"\0");
		
		    if (htb_burst)
		    {
			burst = ((burst_type ? t_speed : ptr -> hi_upload) * mult)/htb_burst;
			if (burst > 240000) burst = 240000;
	    		sprintf(burst_str,"burst %d",burst);
		    }
		    else strcpy(burst_str,"\0");
	    
		    if (htb_cburst)
		    {
	    		cburst = ((cburst_type ? t_speed : ptr -> hi_upload) * mult)/htb_cburst;
	    		sprintf(cburst_str,"cburst %d",cburst);
		    }
		    else strcpy(cburst_str,"\0");
        
//		sprintf(buf,"/sbin/tc class change dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class change dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			    tc_path,iface,id1,id2,id1,(4*id2)+100,1,speed_ext,(t_speed*(100+ceil_upload))/100,speed_ext,0,burst_str,cburst_str,quantum_str);
		    fputs(buf,fp);
		    if (debug > 3) printf("%s",buf);
//		sprintf(buf,"/sbin/tc class change dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class change dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			    tc_path,iface,id1,id2,id1,(4*id2)+101,1,speed_ext,(t_speed*(100+ceil_upload))/100,speed_ext,1,burst_str,cburst_str,quantum_str);
		    fputs(buf,fp);
		    if (debug > 3) printf("%s",buf);
//		sprintf(buf,"/sbin/tc class change dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class change dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			    tc_path,iface,id1,id2,id1,(4*id2)+102,1,speed_ext,(t_speed*(100+ceil_upload))/100,speed_ext,2,burst_str,cburst_str,quantum_str);
		    fputs(buf,fp);
		    if (debug > 3) printf("%s",buf);
//		sprintf(buf,"/sbin/tc class change dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d burst %lu%s %s\n",
		    sprintf(buf,"%s class change dev %s parent %d:%d classid %d:%d htb rate %lu%s ceil %lu%s prio %d %s %s %s\n",
    			    tc_path,iface,id1,id2,id1,(4*id2)+103,1,speed_ext,(t_speed*(100+ceil_upload))/100,speed_ext,3,burst_str,cburst_str,quantum_str);
		    fputs(buf,fp);
		    if (debug > 3) printf("%s",buf);
		}
		else
        	{
            	    if (debug > 1) printf("BUG: htb_class_change_upload - NULL struct pointer!\n");
            	    syslog(LOG_ERR,"BUG: htb_class_change_upload - NULL struct pointer!");
        	}
	    }
	}
//	if (debug > 3) printf("%s",buf);
//	fputs(buf,fp);
	pclose(fp);
    }
    if (debug) putstring("stop  cbq_class_change_upload");
}

void cbq_class_del(	char *iface, unsigned long int max_speed,
			unsigned long int t_speed, int id1, int id2,
			char *ipg, char *ipd, int pri, int maxburst,
			char *borrow, int type, struct IPLISTA * ptr)
{
    int		prio = 100;
    char	buf[2000];
    char	com[100];
    FILE	*fp;

    fflush(NULL);
    if (debug) putstring("start cbq_class_del");
//    putstring("dev=%s parent=%d:1 classid=%d:%d ip=%s",iface,id1,id1,id2,ipd);
//    sprintf(com,"/bin/sh 2>> %s",output);
    sprintf(com,"/bin/sh 2>> %s","/dev/null");
    if (!notc && (fp = popen(com,"w")))
    {
//	if (squid && !extended_queue)
	if (squid==1)
	{
	    if (! extended_queue)
	    {
    		sprintf(buf,"%s filter del dev %s parent %d:0 protocol ip prio %d handle %d::%d u32 match ip src %s match ip sport %d 0xffff match ip tos 8 0xff match ip dst %s flowid %d:%d\n",
			tc_path,iface,id1,prio,800,400+id2,ipg,squid_port,ipd,id1,id2);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
	    }
	    else
	    {
    		sprintf(buf,"%s filter del dev %s parent %d:0 protocol ip prio %d handle %d::%d u32 match ip src %s match ip sport %d 0xffff match ip tos 8 0xff match ip dst %s flowid %d:%d\n",
		    tc_path,iface,id1,prio,800,400+id2,ipg,squid_port,ipd,id1,(4*id2)+101);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
	    }
	}

	if (! extended_queue)
	{
        sprintf(buf,"%s filter del dev %s parent %d:0 protocol ip prio %d handle %d::%d u32 match ip sport 0 0x0 match ip dst %s flowid %d:%d\n",
    	        tc_path,iface,id1,prio,800,100+id2,ipd,id1,id2);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	}
	else
	{
        sprintf(buf,"%s filter del dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
    	        tc_path,iface,id1,10,(4*id2)+100+(id1*1000),id1,(4*id2)+100);
	fputs(buf,fp);
        sprintf(buf,"%s filter del dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
    	        tc_path,iface,id1,10,(4*id2)+101+(id1*1000),id1,(4*id2)+101);
	fputs(buf,fp);
        sprintf(buf,"%s filter del dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
    	        tc_path,iface,id1,10,(4*id2)+102+(id1*1000),id1,(4*id2)+102);
	fputs(buf,fp);
        sprintf(buf,"%s filter del dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
    	        tc_path,iface,id1,10,(4*id2)+103+(id1*1000),id1,(4*id2)+103);
	fputs(buf,fp);

//        sprintf(buf,"/sbin/tc filter del dev %s parent %d:0 protocol ip prio %d handle %d::%d u32 match ip sport 0 0x0 match ip dst %s flowid %d:%d\n",
//    	        iface,id1,prio,800,100+id2,ipd,id1,(4*id2)+103);
//	if (debug > 3) printf("%s",buf);
//	fputs(buf,fp);
	}

	if (type == 0)
	{
	    if (! extended_queue)
	    {
		sprintf(buf,"%s qdisc del dev %s parent %d:%d\n",
	    		tc_path,iface,id1,id2);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
	    }
	    else
	    {
		sprintf(buf,"%s qdisc del dev %s parent %d:%d\n",
			tc_path,iface,id1,(4*id2)+100);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc del dev %s parent %d:%d\n",
			tc_path,iface,id1,(4*id2)+101);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc del dev %s parent %d:%d\n",
			tc_path,iface,id1,(4*id2)+102);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc del dev %s parent %d:%d\n",
			tc_path,iface,id1,(4*id2)+103);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class del dev %s parent %d:%d classid %d:%d\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+100);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class del dev %s parent %d:%d classid %d:%d\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+101);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class del dev %s parent %d:%d classid %d:%d\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+102);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class del dev %s parent %d:%d classid %d:%d\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+103);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
	    }
	}
	else
	if (type == 1 || type == 2 || type == 3)
	{
	    if (! extended_queue)
	    {
		sprintf(buf,"%s qdisc del dev %s parent %d:%d\n",
	    		tc_path,iface,id1,id2);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
	    }
	    else
	    {
		sprintf(buf,"%s qdisc del dev %s parent %d:%d\n",
			tc_path,iface,id1,(4*id2)+100);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc del dev %s parent %d:%d\n",
			tc_path,iface,id1,(4*id2)+101);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc del dev %s parent %d:%d\n",
			tc_path,iface,id1,(4*id2)+102);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc del dev %s parent %d:%d\n",
			tc_path,iface,id1,(4*id2)+103);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class del dev %s parent %d:%d classid %d:%d\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+100);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class del dev %s parent %d:%d classid %d:%d\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+101);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class del dev %s parent %d:%d classid %d:%d\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+102);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class del dev %s parent %d:%d classid %d:%d\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+103);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
	    }
	}

	if (type == 0)
	{
	    pri = pri + 2;
	    sprintf(buf,"%s class del dev %s parent %d:1 classid %d:%d\n",
    		    tc_path,iface,id1,id1,id2);
	    if (debug > 1) printf("cbq_class_del:\n");
	}
	else
	if (type == 1 || type == 2 || type == 3)
	{
	    sprintf(buf,"%s class del dev %s parent %d:1 classid %d:%d\n",
	    	    tc_path,iface,id1,id1,id2);
	    if (debug > 1) printf("htb_class_del:\n");
	}
	if (debug > 3) printf("%s",buf); 
	fputs(buf,fp);
	pclose(fp);
    }
    if (debug) putstring("stop  cbq_class_del");
}

void cbq_ingress_del(char *iface, unsigned long int max_speed, int id1, int id2, char *ipg, char *ipd, int pri)
{
    int		prio = 100;
    int         maxburst=5000;
    char	buf[2000];
    char	com[100];
    FILE	*fp;

    if (ipg)
    {
    fflush(NULL);
    if (debug) putstring("start cbq_ingress_del");
    sprintf(com,"/bin/sh 2>> %s",output);
    if (!notc && (fp = popen(com,"w")))
    {
	sprintf(buf,"%s filter del dev %s parent ffff: handle 800::%d protocol ip prio %d u32 match ip src %s match ip dst %s match ip dport %d 0xffff police rate %lu%s burst %d drop flowid :1\n",
	    tc_path,iface,id2,pri,ipd,ipg,squid_port,(unsigned long int)((float)max_speed*(float)squid_factor),speed_ext,maxburst);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	if (debug > 1) printf("cbq_ingress_del:\n");
	pclose(fp);
    }
    }
    if (debug) putstring("stop  cbq_ingress_del");
}

void cbq_class_del_upload(char *iface, unsigned long int max_speed,
			unsigned long int t_speed, int id1, int id2,
			char *ipg, char *ipd, int pri, int maxburst,
			char *borrow, int type, struct IPLISTA * ptr)
{
    int		prio = 100;
    char	buf[2000];
    char	com[100];
    FILE	*fp;

    fflush(NULL);
    if (debug) putstring("start cbq_class_del_upload");
//    putstring("dev=%s parent=%d:1 classid=%d:%d ip=%s",iface,id1,id1,id2,ipd);
//    sprintf(com,"/bin/sh 2>> %s",output);
    sprintf(com,"/bin/sh 2>> %s","/dev/null");
    if (!notc && (fp = popen(com,"w")))
    {
//        sprintf(buf,"/sbin/tc filter del dev %s parent %d:0 protocol ip prio %d handle %d::%d u32 match ip sport 0 0x0 match ip dst %s flowid %d:%d\n",
//    	        iface,id1,prio,800,900+id2,ipd,id1,id2);
//        sprintf(buf,"/sbin/tc filter del dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
//    	        iface,id1,1,id2+1000,id1,id2);
//	if (debug > 3) printf("%s",buf);
//	fputs(buf,fp);

	if (! extended_queue)
	{
        sprintf(buf,"%s filter del dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
    	        tc_path,iface,id1,10,id2+(id1*1000),id1,id2);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	}
	else
	{
        sprintf(buf,"%s filter del dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
    	        tc_path,iface,id1,10,(4*id2)+100+(id1*1000),id1,(4*id2)+100);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
        sprintf(buf,"%s filter del dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
    	        tc_path,iface,id1,10,(4*id2)+101+(id1*1000),id1,(4*id2)+101);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
        sprintf(buf,"%s filter del dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
    	        tc_path,iface,id1,10,(4*id2)+102+(id1*1000),id1,(4*id2)+102);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
        sprintf(buf,"%s filter del dev %s parent %d:0 protocol ip prio %d handle %d fw classid %d:%d\n",
    	        tc_path,iface,id1,10,(4*id2)+103+(id1*1000),id1,(4*id2)+103);
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);
	}
	if (type == 0)
	{
	    if (! extended_queue)
	    {
		sprintf(buf,"%s qdisc del dev %s parent %d:%d\n",
	    		tc_path,iface,id1,id2);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
	    }
	    else
	    {
		sprintf(buf,"%s qdisc del dev %s parent %d:%d\n",
			tc_path,iface,id1,(4*id2)+100);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc del dev %s parent %d:%d\n",
			tc_path,iface,id1,(4*id2)+101);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc del dev %s parent %d:%d\n",
			tc_path,iface,id1,(4*id2)+102);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc del dev %s parent %d:%d\n",
			tc_path,iface,id1,(4*id2)+103);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class del dev %s parent %d:%d classid %d:%d\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+100);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class del dev %s parent %d:%d classid %d:%d\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+101);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class del dev %s parent %d:%d classid %d:%d\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+102);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class del dev %s parent %d:%d classid %d:%d\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+103);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
	    }
	}
	else
	if (type == 1 || type == 2 || type == 3)
	{
	    if (! extended_queue)
	    {
		sprintf(buf,"%s qdisc del dev %s parent %d:%d\n",
	    		tc_path,iface,id1,id2);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
	    }
	    else
	    {
		sprintf(buf,"%s qdisc del dev %s parent %d:%d\n",
			tc_path,iface,id1,(4*id2)+100);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc del dev %s parent %d:%d\n",
			tc_path,iface,id1,(4*id2)+101);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc del dev %s parent %d:%d\n",
			tc_path,iface,id1,(4*id2)+102);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s qdisc del dev %s parent %d:%d\n",
			tc_path,iface,id1,(4*id2)+103);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class del dev %s parent %d:%d classid %d:%d\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+100);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class del dev %s parent %d:%d classid %d:%d\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+101);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class del dev %s parent %d:%d classid %d:%d\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+102);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
		sprintf(buf,"%s class del dev %s parent %d:%d classid %d:%d\n",
    			tc_path,iface,id1,id2,id1,(4*id2)+103);
		if (debug > 3) printf("%s",buf);
		fputs(buf,fp);
	    }
	}
	if (debug > 3) printf("%s",buf);
	fputs(buf,fp);

	if (type == 0)
	{
	    pri = pri + 2;
	    sprintf(buf,"%s class del dev %s parent %d:1 classid %d:%d\n",
    		    tc_path,iface,id1,id1,id2);
	    if (debug > 1) printf("cbq_class_del:\n");
	}
	else
	if (type == 1 || type == 2 || type == 3)
	{
	    sprintf(buf,"%s class del dev %s parent %d:1 classid %d:%d\n",
	    	    tc_path,iface,id1,id1,id2);
	    if (debug > 1) printf("htb_class_del:\n");
	}
	if (debug > 3) printf("%s",buf); 
	fputs(buf,fp);
	pclose(fp);
    }
    if (debug) putstring("stop  cbq_class_del_upload");
}

void cbq_standard_on(char ***config)
{
    char    	*dev;
    int     	bcn;
    unsigned long int isp;
    char    	*ipg;
    char    	*ipu;
    int		n,m;
    char	*mainip = NULL;

    for(n=1;n<local_int_pos;n++)
    {
	// jesli interfejs lokalny
	if (!(local_int_tab2[1][(n*6)+5]))
	{
	    dev = config[1][(n*6)+1];
	    bcn = atoi(config[1][(n*6)+5]);
	    isp = strtoul(config[1][(n*6)+2],NULL,10);
	    ipg = config[1][(n*6)+3];
	    ipu = config[1][(n*6)+4];
	    cbq_setup_root(dev,isp,bcn,class_type);
	    cbq_setup_clas(dev,isp,bcn,ipg,ipu,class_type);
	    // dla kazdego interfejsu lokalnego tworzymy wyjatki w ograniczeniach
	    // przy transferze z numeru IP zewnetrznego
	    for(m=1;m<local_int_pos;m++)
	    {
		if ((local_int_tab2[1][(m*6)+5]))
		cbq_setup_xfilters(dev,bcn,config[1][(m*6)+2],ipu,m-1);
	    }
	    // jesli squid_ingress=1 - tworzymy qdisc typu ingress do ograniczania szybkosci wysylania do squida
	    if (squid_ingress) cbq_ingress_root(dev);
	}
	else
	// jesli interfejs internetowy
	if ((local_int_tab2[1][(n*6)+5]))
	{
	    dev = config[1][(n*6)+1];
//	    bcn = atoi(config[1][(n*6)+3]);
//	    isp = local_int_tab2[1][(n*6)+3];
	    bcn = atoi(config[1][(n*6)+3]);
	    isp = local_int_tab2[1][(n*6)+4];
/*
	    if (class_type == 0) isp = local_int_tab2[1][(n*6)+3];
	    else isp = local_int_tab2[1][(n*6)+2]+local_int_tab2[1][(n*6)+3];
*/
	    if (isp)
	    {
		ipg = "0.0.0.0/0";
	        ipu = "255.255.255.255/32";
//		if (! mainip) mainip = config[1][(n*6)+2];
		mainip = config[1][(n*6)+2];
		cbq_setup_root(dev,isp,bcn,upload_class_type);
	        cbq_setup_clas(dev,isp,bcn,ipg,ipu,upload_class_type);
		if (! divide_upload) cbq_class_add(dev,isp,local_int_tab2[1][(n*6)+4],bcn,4,"0.0.0.0/0","0.0.0.0/0",3,20,"bounded",upload_class_type,NULL);
	    }
	    else
	    {
		syslog(LOG_INFO,"disabled upload bandwidth control of %s interface.",dev);
		if (debug > 1) printf("disabled upload bandwidth control of %s interface.\n",dev);
	    }
	}
        if (debug > 1)
        {
    	    printf("cbq_standard_on:\n");
	    printf("cbq_setup_root:  %s %lu %d\n",dev,isp,bcn);
	    printf("cbq_setup_clas:  %s %s %lu %d %s %s\n",mainip,dev,isp,bcn,ipg,ipu);
	}
    }
}

char ***natstat(char **ignore, char ***config, int firewall_type)
{
    char	source[20],destin[20],sport[10],port[10];
    char	source2[20],destin2[20],sport2[10],port2[10];
    char	s1[20],s2[20],s3[20],s4[20];
    int		timeout;
    int		d1,d2,d3,m,n,fin;
    FILE	*fp;
    char	source_b[20];
    char        source_b2[20];
    char	destin_b[20];
    char	loc_ip_b[20];
    char	gat_ip_b[20];
    unsigned int	source_i,source_ix;
    unsigned int	destin_i;
    unsigned int	source2_i,source2_ix;
    unsigned int	destin2_i;
    int		source_t;
    int		destin_t;
    unsigned int	loc_ip_i,loc_ip_ix;
    unsigned int	gat_ip_i;
    char	***natstat_tab = NULL;
    char	bufor[1000];
    char	ignorebuf[200];
    int		ignbuf = 0;
    int		prot = 0;
    int		nat_find = 0;
    char	com[100];

    if (static_dnload_class)
    {
	struct	IPLISTA	*ptr;

	if (debug>2) printf("debug 3: reading current connection without checking masquerade for static class\n");
	natstat_tab = (char ***) calloc(3,sizeof(char **));
    	natstat_tab[1] = (char **) NULL;
	for(m=1;m<iplista_pos;m++)
	{
	    ptr = iplista_str + m;
	    {
	        ptr -> ipspeed_last2 = ptr -> ipspeed;
	        natstat_tab[1] = (char **) realloc((char **)natstat_tab[1], sizeof(char *)*((natstat_tab_pos+1)*4));
	        natstat_tab[1][(natstat_tab_pos*4)+1] = (char *) calloc(strlen(ptr -> str_ip)+2,sizeof(char));
    	        strcpy(natstat_tab[1][(natstat_tab_pos*4)+1],ptr -> str_ip);
	        natstat_tab[1][(natstat_tab_pos*4)+2] = (char *) calloc(strlen("nomasq")+2,sizeof(char));
	        strcpy(natstat_tab[1][(natstat_tab_pos*4)+2],"nomasq");
	        natstat_tab[1][(natstat_tab_pos*4)+3] = (char *) calloc(strlen("all")+2,sizeof(char));
	        strcpy(natstat_tab[1][(natstat_tab_pos*4)+3],"all");
	        if (debug > 1) printf("static natstat_nomasq: %s %s %s\n",
		    natstat_tab[1][(natstat_tab_pos*4)+1],
    	    	    natstat_tab[1][(natstat_tab_pos*4)+2],
	    	    natstat_tab[1][(natstat_tab_pos*4)+3]);
		natstat_tab_pos++;
	    }
	}
	return(natstat_tab);
    }

//    if (!nomasq && (firewall_type == 1) && (fp = fopen("/root/ipchains.2.4.x.2","r")))
    sprintf(com,"%s -L -M -n 2>> %s",ipchains_path,output);
    if (!nomasq && (firewall_type == 1) && (fp = popen(com,"r")))
    {
	if (debug>2) printf("debug 3: reading current connection on ipchains firewall\n");
	natstat_tab = (char ***) calloc(3,sizeof(char **));
	natstat_tab[1] = (char **) NULL;
	fgets(bufor,1000,fp);
	fgets(bufor,1000,fp);
	while(fgets(bufor,1000,fp))
	{
	    nat_find = 0;
	    if (alt_natstat)
	    {
		char	str[20];

		for(m=0;m<natstat_tab_pos;m++)
	        {
		    strcpy(str,natstat_tab[1][(m*4)+1]);
		    strcat(str," ");
		    if (strstr(bufor,str))
		    {
		        nat_find = 1;
			break;
		    }
		}
	    }

	    if (! nat_find)
	    {
	    sscanf(bufor,"%s %4d:%s %s %s %s %s -> %s",s1,&d2,s2,source,destin,sport,s3,port);
	    if (strstr(bufor,"tcp")) prot = 0;
	    else prot = 1;

	    if (kernel_type >= 2 && kernel_type <=3) timeout = (timeout_global / 60) - d2;
	    else
	    if (kernel_type >= 4) timeout = timeout_ipchains_24 - d2;
	    else
	    {
		syslog(LOG_ERR,"This software don't support 2.%d kernels.",kernel_type);
		error("This software don't support 2.%d kernels.",kernel_type);
	    }
	    
	    if (prot || (timeout <= timeout_global / 60))
	    {
//		for(m=1;m<local_int_pos;m++)
		{
		    strcpy(ignorebuf,source);
		    strcat(ignorebuf," ");
		    strcat(ignorebuf,destin);
		    strcat(ignorebuf," ");
		    strcat(ignorebuf,port);
		    strcat(ignorebuf,"$");
		    fin = 0;
		    for(n=1;n<ignore_pos;n++)
			if (strstr(ignorebuf,ignore[n])) fin = 1;
		    
		    if (! fin)
		    {
			natstat_tab[1] = (char **) realloc((char **)natstat_tab[1], sizeof(char *)*((natstat_tab_pos+1)*4));
		    	natstat_tab[1][(natstat_tab_pos*4)+1] = (char *) calloc(strlen(source)+2,sizeof(char));
		    	strcpy(natstat_tab[1][(natstat_tab_pos*4)+1],source);
		    	natstat_tab[1][(natstat_tab_pos*4)+2] = (char *) calloc(strlen(destin)+2,sizeof(char));
		    	strcpy(natstat_tab[1][(natstat_tab_pos*4)+2],destin);
		    	natstat_tab[1][(natstat_tab_pos*4)+3] = (char *) calloc(strlen(port)+2,sizeof(char));
		    	strcpy(natstat_tab[1][(natstat_tab_pos*4)+3],port);
    
    			if (debug > 1) printf("natstat: %s %s %s\n",
			    natstat_tab[1][(natstat_tab_pos*4)+1],
    			    natstat_tab[1][(natstat_tab_pos*4)+2],
			    natstat_tab[1][(natstat_tab_pos*4)+3]);
			natstat_tab_pos++;
		    }
		}
	    }
	    }
	}
	pclose(fp);
	return(natstat_tab);
    }
    else
    if (!nomasq && (firewall_type == 2) && (fp = fopen(IP_CONNTRACK,"r")))
    {
	if (debug>2) printf("debug 3: reading current connection on iptables firewall\n");
    	natstat_tab = (char ***) calloc(3,sizeof(char **));
    	natstat_tab[1] = (char **) NULL;
    	while(fgets(bufor,1000,fp))
    	{
	    nat_find = 0;
	    if (alt_natstat)
	    {
		char	str[20];

		for(m=0;m<natstat_tab_pos;m++)
	        {
		    strcpy(str,natstat_tab[1][(m*4)+1]);
		    strcat(str," ");
		    if (strstr(bufor,str))
		    {
		        nat_find = 1;
			break;
		    }
		}
	    }

	    if (! nat_find && strstr(bufor,"ESTABLISHED") && !strstr(bufor,"127.0.0.1"))
	    {
	    if (strstr(bufor,"tcp"))
	    {
    	        sscanf(bufor,"%s %d %d %s src=%s dst=%s sport=%s dport=%s src=%s dst=%s sport=%s dport=%s [ASSURED] use=%d",
	    	    s1,&d1,&d2,s2,source,destin,sport,port,source2,destin2,sport2,port2,&d3);
	        prot = 0;
	    }
	    else
	    {
    	        sscanf(bufor,"%s %d %d src=%s dst=%s sport=%s dport=%s src=%s dst=%s sport=%s dport=%s",
	    	    s1,&d1,&d2,source,destin,sport,port,source2,destin2,sport2,port2);
	        prot = 1;
	    }
	    timeout = timeout_iptables_24 - d2;
//	    if (timeout <= timeout_global && (prot && strcmp(bufor,"127.0.0.1")) || (strcmp(bufor,"127.0.0.1") && ! strcmp(s2,"ESTABLISHED")))
	    if (timeout <= timeout_global)
	    {
		for(m=1;m<local_int_pos;m++)
		{
		    // jesli interfejs lokalny
		    if (!local_int_tab2[1][(m*6)+5])
		    {
			source_i  = ip2hex3(source)  & local_int_tab2[1][(m*6)+1];
			source_ix = ip2hex3(source)  & local_int_tab2[1][(m*6)+2];
			destin_i  = ip2hex3(destin)  & local_int_tab2[1][(m*6)+2];
			source2_i = ip2hex3(source2) & local_int_tab2[1][(m*6)+1];
			source2_ix= ip2hex3(source2) & local_int_tab2[1][(m*6)+2];
			destin2_i = ip2hex3(destin2) & local_int_tab2[1][(m*6)+2];
			loc_ip_i  = ip2hex2(config[1][(m*6)+3]) & local_int_tab2[1][(m*6)+1];
			loc_ip_ix = ip2hex2(config[1][(m*6)+3]) & local_int_tab2[1][(m*6)+2];
			gat_ip_i  = ip2hex2(config[1][(m*6)+4]) & local_int_tab2[1][(m*6)+2];
			ignbuf = 0;
//		    printf("%x %x %x %x %x %x\n",source_i,loc_ip_i,destin_i,gat_ip_i,destin_i,loc_ip_i);
//		    printf("%x %x %x %x %x %x\n",source_ix,loc_ip_ix,destin_i,gat_ip_i,destin_i,loc_ip_i);

//	    	    if ((source_i == loc_ip_i)
//			&& (destin_i != gat_ip_i)
//	    		&& (destin_i != loc_ip_i))
//		    {
	    	        if (((source_ix == loc_ip_ix)
			    || (source_i == loc_ip_i))
			    && (destin_i != gat_ip_i)
	    		    && (destin_i != loc_ip_i))
			{
		    	    // emulacja grep'a
		    	    strcpy(ignorebuf,source);
		    	    strcat(ignorebuf," ");
		    	    strcat(ignorebuf,destin);
		    	    strcat(ignorebuf," ");
		    	    strcat(ignorebuf,port);
		    	    strcat(ignorebuf,"$");
		    	    ignbuf = 1;
			}
			else
//		    if ((source2_i == loc_ip_i)
//			&& (destin2_i != gat_ip_i)
//			&& (destin2_i != loc_ip_i))
//		    {
			if (((source2_ix == loc_ip_ix)
			    || (source2_i == loc_ip_i))
			    && (destin2_i != gat_ip_i)
			    && (destin2_i != loc_ip_i))
			{
		    	    strcpy(ignorebuf,source2);
		    	    strcat(ignorebuf," ");
		    	    strcat(ignorebuf,destin2);
		    	    strcat(ignorebuf," ");
		    	    strcat(ignorebuf,port2);
		    	    strcat(ignorebuf,"$");
		    	    ignbuf = 2;
			}
			if (ignbuf)
			{
			    fin = 0;
		    	    for(n=1;n<ignore_pos;n++)
				if (strstr(ignorebuf,ignore[n])) fin = 1;

			    if (! fin)
			    {
		    		natstat_tab[1] = (char **) realloc((char **)natstat_tab[1], sizeof(char *)*((natstat_tab_pos+1)*4));
				if (ignbuf == 1)
				{
		    	    	    natstat_tab[1][(natstat_tab_pos*4)+1] = (char *) calloc(strlen(source)+2,sizeof(char));
    	    		    	    strcpy(natstat_tab[1][(natstat_tab_pos*4)+1],source);
		    	    	    natstat_tab[1][(natstat_tab_pos*4)+2] = (char *) calloc(strlen(destin)+2,sizeof(char));
		    	    	    strcpy(natstat_tab[1][(natstat_tab_pos*4)+2],destin);
		    	    	    natstat_tab[1][(natstat_tab_pos*4)+3] = (char *) calloc(strlen(port)+2,sizeof(char));
		    	    	    strcpy(natstat_tab[1][(natstat_tab_pos*4)+3],port);
				}
				else
				{
		    	    	    natstat_tab[1][(natstat_tab_pos*4)+1] = (char *) calloc(strlen(source2)+2,sizeof(char));
    	    		    	    strcpy(natstat_tab[1][(natstat_tab_pos*4)+1],source2);
		    	    	    natstat_tab[1][(natstat_tab_pos*4)+2] = (char *) calloc(strlen(destin2)+2,sizeof(char));
		    	    	    strcpy(natstat_tab[1][(natstat_tab_pos*4)+2],destin2);
		    	    	    natstat_tab[1][(natstat_tab_pos*4)+3] = (char *) calloc(strlen(port2)+2,sizeof(char));
		    	    	    strcpy(natstat_tab[1][(natstat_tab_pos*4)+3],port2);
				}
    				if (debug > 1) printf("natstat: %s %s %s\n",
			    	    natstat_tab[1][(natstat_tab_pos*4)+1],
    				    natstat_tab[1][(natstat_tab_pos*4)+2],
			    	    natstat_tab[1][(natstat_tab_pos*4)+3]);
				natstat_tab_pos++;
			    }
			}
		    }
		}
	    }
	    }
	}
	fclose(fp);
    }
    else
    if (nomasq)
    {
	struct	IPLISTA	*ptr;

	if (debug>2) printf("debug 3: reading current connection without checking masquerade\n");
	natstat_tab = (char ***) calloc(3,sizeof(char **));
    	natstat_tab[1] = (char **) NULL;
	for(m=1;m<iplista_pos;m++)
	{
	    ptr = iplista_str + m;
//	    if (ptr -> static_dnload || (ptr -> ipspeed_last2_counter > 0) || (ptr -> ipspeed > (ptr -> ipspeed_last2 + 2000)))
	    if (ptr -> static_dnload
	    || (ptr -> ipspeed_last2_counter > 0)
	    || (ptr -> ipspeed > (ptr -> ipspeed_last2 + natstat_sensivity)))
	    {
//		if ((ptr -> ipspeed_last2_counter < 1) || (ptr -> ipspeed > (ptr -> ipspeed_last2 + 2000)))
		if ((ptr -> ipspeed_last2_counter < 1)
		|| (ptr -> ipspeed > (ptr -> ipspeed_last2 + natstat_sensivity)))
		    ptr -> ipspeed_last2_counter = nomasq_cycles;
	        ptr -> ipspeed_last2 = ptr -> ipspeed;
	        natstat_tab[1] = (char **) realloc((char **)natstat_tab[1], sizeof(char *)*((natstat_tab_pos+1)*4));
	        natstat_tab[1][(natstat_tab_pos*4)+1] = (char *) calloc(strlen(ptr -> str_ip)+2,sizeof(char));
    	        strcpy(natstat_tab[1][(natstat_tab_pos*4)+1],ptr -> str_ip);
	        natstat_tab[1][(natstat_tab_pos*4)+2] = (char *) calloc(strlen("nomasq")+2,sizeof(char));
	        strcpy(natstat_tab[1][(natstat_tab_pos*4)+2],"nomasq");
	        natstat_tab[1][(natstat_tab_pos*4)+3] = (char *) calloc(strlen("all")+2,sizeof(char));
	        strcpy(natstat_tab[1][(natstat_tab_pos*4)+3],"all");
	        if (debug > 1) printf("natstat_nomasq: %s %s %s\n",
		    natstat_tab[1][(natstat_tab_pos*4)+1],
    	    	    natstat_tab[1][(natstat_tab_pos*4)+2],
	    	    natstat_tab[1][(natstat_tab_pos*4)+3]);
		natstat_tab_pos++;
	    }
	    else
	    {
		if (ptr -> ipspeed < ptr -> ipspeed_last2) ptr -> ipspeed_last2 = ptr -> ipspeed;
	    }
	    if (ptr -> ipspeed_last2_counter > 0) (ptr -> ipspeed_last2_counter)--;
	}
    }
    else
    {
	syslog(LOG_ERR,"Can't read from /proc/net/ip_conntrack file");
	error("Can't read from /proc/net/ip_conntrack file\nExiting\n");
    }

    if (squid==1)
    {
	struct	IPLISTA	*ptr;
	
	if (debug>2) printf("debug 3: reading current squid connection\n");
        for(m=1;m<iplista_pos;m++)
        {
	    ptr = iplista_str + m;
//    	    if (ptr -> squid_speed > ptr -> squid_speed_last2)
    	    if (ptr -> squid_speed > (ptr -> squid_speed_last2 + natstat_sensivity))
	    {
		ptr -> squid_speed_last2 = ptr -> squid_speed;
		sprintf(port,"%d",squid_port);
		natstat_tab[1] = (char **) realloc((char **)natstat_tab[1], sizeof(char *)*((natstat_tab_pos+1)*4));
		natstat_tab[1][(natstat_tab_pos*4)+1] = (char *) calloc(strlen(ptr -> str_ip)+2,sizeof(char));
    		strcpy(natstat_tab[1][(natstat_tab_pos*4)+1],ptr -> str_ip);
		natstat_tab[1][(natstat_tab_pos*4)+2] = (char *) calloc(strlen("proxy")+2,sizeof(char));
		strcpy(natstat_tab[1][(natstat_tab_pos*4)+2],"proxy");
		natstat_tab[1][(natstat_tab_pos*4)+3] = (char *) calloc(strlen(port)+2,sizeof(char));
		strcpy(natstat_tab[1][(natstat_tab_pos*4)+3],port);
		if (debug > 1) printf("natstat_squid: %s %s %s\n",
		    natstat_tab[1][(natstat_tab_pos*4)+1],
    	    	    natstat_tab[1][(natstat_tab_pos*4)+2],
	    	    natstat_tab[1][(natstat_tab_pos*4)+3]);
		    natstat_tab_pos++;
	    }
	    else
	    {
		if (ptr -> squid_speed < ptr -> squid_speed_last2) ptr -> squid_speed_last2 = ptr -> squid_speed;
	    }
	}
    }

    return(natstat_tab);
}

char ***natstat_upload(char **ignore, char ***config, int firewall_type)
{
    char	***natstat_tab_upload = NULL;
    int		m;
    struct	IPLISTA	*ptr;

    if (debug>2) printf("debug 3: reading current upload connection without checking masquerade\n");
    natstat_tab_upload = (char ***) calloc(3,sizeof(char **));
    natstat_tab_upload[1] = (char **) NULL;

    if (static_upload_class)
    {

        for(m=1;m<iplista_pos;m++)
	{
	    ptr = iplista_str + m;
	    ptr -> ipspeed_last2_upload = ptr -> ipspeed_upload;
	    natstat_tab_upload[1] = (char **) realloc((char **)natstat_tab_upload[1], sizeof(char *)*((natstat_tab_pos_upload+1)*4));
	    natstat_tab_upload[1][(natstat_tab_pos_upload*4)+1] = (char *) calloc(strlen(ptr -> str_ip)+2,sizeof(char));
    	    strcpy(natstat_tab_upload[1][(natstat_tab_pos_upload*4)+1],ptr -> str_ip);
	    natstat_tab_upload[1][(natstat_tab_pos_upload*4)+2] = (char *) calloc(strlen("nomasq")+2,sizeof(char));
	    strcpy(natstat_tab_upload[1][(natstat_tab_pos_upload*4)+2],"nomasq");
	    natstat_tab_upload[1][(natstat_tab_pos_upload*4)+3] = (char *) calloc(strlen("all")+2,sizeof(char));
	    strcpy(natstat_tab_upload[1][(natstat_tab_pos_upload*4)+3],"all");
	    if (debug > 1) printf("static natstat_upload_nomasq: %s %s %s\n",
	        natstat_tab_upload[1][(natstat_tab_pos_upload*4)+1],
    	        natstat_tab_upload[1][(natstat_tab_pos_upload*4)+2],
	        natstat_tab_upload[1][(natstat_tab_pos_upload*4)+3]);
	    natstat_tab_pos_upload++;
	}
        return(natstat_tab_upload);
    }

    for(m=1;m<iplista_pos;m++)
    {
	ptr = iplista_str + m;
        if (ptr -> static_upload
	    || (ptr -> ipspeed_last2_counter_upload > 0)
	    || (ptr -> ipspeed_upload > (ptr -> ipspeed_last2_upload + natstat_upload_sensivity)))
        {
    	    if (ptr -> static_upload
	    || (ptr -> ipspeed_last2_counter_upload < 1)
	    || (ptr -> ipspeed_upload > (ptr -> ipspeed_last2_upload + natstat_upload_sensivity))) ptr -> ipspeed_last2_counter_upload = nomasq_cycles;
	    ptr -> ipspeed_last2_upload = ptr -> ipspeed_upload;
	    natstat_tab_upload[1] = (char **) realloc((char **)natstat_tab_upload[1], sizeof(char *)*((natstat_tab_pos_upload+1)*4));
	    natstat_tab_upload[1][(natstat_tab_pos_upload*4)+1] = (char *) calloc(strlen(ptr -> str_ip)+2,sizeof(char));
    	    strcpy(natstat_tab_upload[1][(natstat_tab_pos_upload*4)+1],ptr -> str_ip);
	    natstat_tab_upload[1][(natstat_tab_pos_upload*4)+2] = (char *) calloc(strlen("nomasq")+2,sizeof(char));
	    strcpy(natstat_tab_upload[1][(natstat_tab_pos_upload*4)+2],"nomasq");
	    natstat_tab_upload[1][(natstat_tab_pos_upload*4)+3] = (char *) calloc(strlen("all")+2,sizeof(char));
	    strcpy(natstat_tab_upload[1][(natstat_tab_pos_upload*4)+3],"all");
	    if (debug > 1) printf("natstat_upload_nomasq: %s %s %s\n",
	        natstat_tab_upload[1][(natstat_tab_pos_upload*4)+1],
    	        natstat_tab_upload[1][(natstat_tab_pos_upload*4)+2],
	        natstat_tab_upload[1][(natstat_tab_pos_upload*4)+3]);
	    natstat_tab_pos_upload++;
	}
	else
	{
	    if (ptr -> ipspeed_upload < ptr -> ipspeed_last2_upload) ptr -> ipspeed_last2_upload = ptr -> ipspeed_upload;
	}
	if (ptr -> ipspeed_last2_counter_upload > 0) (ptr -> ipspeed_last2_counter_upload)--;
    }

    if (squid)
    {
	char	port[10];
	
	if (debug>2) printf("debug 3: reading current sqout connection\n");
    	for(m=1;m<iplista_pos;m++)
    	{
	    ptr = iplista_str + m;
    	    if (ptr -> sqout_speed > (ptr -> sqout_speed_last2 + natstat_upload_sensivity))
	    {
	        ptr -> sqout_speed_last2 = ptr -> sqout_speed;
	        sprintf(port,"%d",squid_port);
	        natstat_tab_upload[1] = (char **) realloc((char **)natstat_tab_upload[1], sizeof(char *)*((natstat_tab_pos_upload+1)*4));
	        natstat_tab_upload[1][(natstat_tab_pos_upload*4)+1] = (char *) calloc(strlen(ptr -> str_ip)+2,sizeof(char));
    		strcpy(natstat_tab_upload[1][(natstat_tab_pos_upload*4)+1],ptr -> str_ip);
		natstat_tab_upload[1][(natstat_tab_pos_upload*4)+2] = (char *) calloc(strlen("proxy")+2,sizeof(char));
		strcpy(natstat_tab_upload[1][(natstat_tab_pos_upload*4)+2],"proxy");
		natstat_tab_upload[1][(natstat_tab_pos_upload*4)+3] = (char *) calloc(strlen(port)+2,sizeof(char));
		strcpy(natstat_tab_upload[1][(natstat_tab_pos_upload*4)+3],port);
		if (debug > 1) printf("natstat_upload_sqout: %s %s %s\n",
		    natstat_tab_upload[1][(natstat_tab_pos_upload*4)+1],
    	    	    natstat_tab_upload[1][(natstat_tab_pos_upload*4)+2],
	    	    natstat_tab_upload[1][(natstat_tab_pos_upload*4)+3]);
		    natstat_tab_pos_upload++;
	    }
	    else
	    {
	        if (ptr -> sqout_speed < ptr -> sqout_speed_last2) ptr -> sqout_speed_last2 = ptr -> sqout_speed;
	    }
	}
    }

    return(natstat_tab_upload);
}

void free_natstat_tab(char ***natstat_tab)
{
    int		m,n;
    
    m=0;
    for(m=0;m<natstat_tab_pos;m++)
    {
        for(n=3;n>0;n--)
	{
//    	    free((char *) natstat_tab[1][(m*4)+n]);
    	    free(natstat_tab[1][(m*4)+n]);
	}
    }
    free(natstat_tab[1]);
    free(natstat_tab);
    natstat_tab_pos = 0;
}

void free_natstat_tab_upload(char ***natstat_tab)
{
    int		m,n;
    
    m=0;
    for(m=0;m<natstat_tab_pos_upload;m++)
    {
        for(n=3;n>0;n--)
	{
//    	    free((char *) natstat_tab[1][(m*4)+n]);
    	    free(natstat_tab[1][(m*4)+n]);
	}
    }
    free(natstat_tab[1]);
    free(natstat_tab);
    natstat_tab_pos_upload = 0;
}

char **read_ignore(char *fname)
{
    FILE        *fp;
    char	*res;
    int         m;
    char	buft[100];
    char	**ignore_tab;

    m = numlines(fname);
    ignore_tab = (char **) calloc(m+2,sizeof(char *));
    fp = fopen(fname,"r");
    while ((res=strtok(fgets(buft,100,fp),"\n")))
    {
	if (res[0] != '#' && strlen(res))
	{
	    ignore_tab[ignore_pos] = (char *) calloc(strlen(buft)+2,sizeof(char));
	    strcpy(ignore_tab[ignore_pos],buft);
	    if (debug > 1) printf("ignore: %s\n",ignore_tab[ignore_pos]);
	    ignore_pos++;
	}
    }
    fclose(fp);
    return(ignore_tab);
}

void free_ignore(char **ignore_tab)
{
    int		n;

    for(n=1;n<ignore_pos;n++)
    {
	free(ignore_tab[n]);
    }
    free(ignore_tab);
    ignore_pos = 1;
}

char **get_masqip(char ***natstat_tab, char *iface, int int_cnt)
{
    char	**masqip = NULL;
    char	*ip;
    char	ipt[20];
    int		m,n,fin;

    masqip = (char **) malloc(sizeof(char *)*iplista_pos+2);
    for(n=0;n<natstat_tab_pos;n++)
    {
	if (strlen(natstat_tab[1][(n*4)+1]) > 0)
	{
	    if (ip = ip2ip_with_mask(natstat_tab[1][(n*4)+1]))
	    {
		fin = 0;
	        for(m=1;m<masqip_pos[int_cnt];m++)
		    if (! strcmp(ip,masqip[m]) && ! strcmp(masqip[m],ip)) fin = 1;

		if (! fin && ! strcmp(iface,get_ip_int_iface(ip)) && ! strcmp(get_ip_int_iface(ip),iface))
		{
		    masqip[masqip_pos[int_cnt]] = (char *) malloc(sizeof(char)*strlen(ip)+2);
		    strcpy(masqip[masqip_pos[int_cnt]++],ip);
		    if (debug > 1) printf("get_masqip: %s\n",ip);
		}
	    }
	    else
	    {
		if (!mask_mesg)
		{
		    syslog(LOG_ERR,"Can't find mask for IP %s\n",natstat_tab[1][(n*4)+1]);
		    if (debug > 1) printf("Can't find mask for IP %s\n",natstat_tab[1][(n*4)+1]);
		}
	    }
	}
    }
    return(masqip);
}

char **get_masqip_upload(char ***natstat_tab, char *iface, int int_cnt)
{
    char	**masqip = NULL;
    char	*ip;
    char	ipt[20];
    int		m,n,fin;

    masqip = (char **) malloc(sizeof(char *)*iplista_pos+2);
    for(n=0;n<natstat_tab_pos_upload;n++)
    {
	if (strlen(natstat_tab[1][(n*4)+1]) > 0)
	{
	    if (ip = ip2ip_with_mask(natstat_tab[1][(n*4)+1]))
	    {
		fin = 0;
	        for(m=1;m<masqip_pos_upload[int_cnt];m++)
		    if (! strcmp(ip,masqip[m]) && ! strcmp(masqip[m],ip)) fin = 1;

		if (! fin && ! strcmp(iface,get_ip_int_iface(ip)) && ! strcmp(get_ip_int_iface(ip),iface))
		{
		    masqip[masqip_pos_upload[int_cnt]] = (char *) malloc(sizeof(char)*strlen(ip)+2);
		    strcpy(masqip[masqip_pos_upload[int_cnt]++],ip);
		    if (debug > 1) printf("get_masqip_upload: %s\n",ip);
		}
	    }
	    else
	    {
		if (!mask_mesg)
		{
		    syslog(LOG_ERR,"Can't find mask for IP %s\n",natstat_tab[1][(n*4)+1]);
		    if (debug > 1) printf("Can't find mask for IP %s\n",natstat_tab[1][(n*4)+1]);
		}
	    }
	}
    }
    return(masqip);
}

void free_masqip(char **masqip, int int_cnt)
{
    int		n;

    for(n=1;n<masqip_pos[int_cnt];n++)
    {
	free(masqip[n]);
    }
    free(masqip);
    masqip_pos[int_cnt] = 1;
}

void free_masqip_upload(char **masqip, int int_cnt)
{
    int		n;

    for(n=1;n<masqip_pos_upload[int_cnt];n++)
    {
	free(masqip[n]);
    }
    free(masqip);
    masqip_pos_upload[int_cnt] = 1;
}
/**ZQ**/
unsigned long int   *create_bitrate_tab(int ilip)
{
    unsigned long int   *bitrate_tab;

    bitrate_tab = (unsigned long int*) calloc(ilip,sizeof(unsigned long int));
   
    return(bitrate_tab);
}

char ***create_speed_table(int ilip)
{
    char	***speed_tab;
    int		n,m;

    speed_tab = (char ***) calloc(3,sizeof(char **));
    speed_tab[1] = (char **) calloc(ilip*10,sizeof(char *));
    return(speed_tab);
}

void free_speed_table(char ***speed_tab, int pos)
{
    int		m, n;

//    if (speed_tab)
//    {
	for(n=1;n<9;n++)
	{
	    for(m=0;m<=(pos-1);m++)
	    {
//		if (speed_tab[1][(m*9)+n]) free(speed_tab[1][(m*9)+n]);
		free(speed_tab[1][(m*9)+n]);
	    }
	}
	free(speed_tab[1]);
	free(speed_tab);
//    }
}

void add_ip2speed_table_new(char ***speed_tab, char *ip)
{
    int		pos = 0;

    while(speed_tab[1][(pos*9)+1])
	pos++;

    speed_tab[1][(pos*9)+1] = (char *) calloc(strlen(ip)+2,sizeof(char));
    strcpy(speed_tab[1][(pos*9)+1],ip);
}

void add_ip2speed_table_sub1(char ***speed_tab, char *ip)
{
    int		pos = 0;

    while(speed_tab[1][(pos*9)+2])
	pos++;

    speed_tab[1][(pos*9)+2] = (char *) calloc(strlen(ip)+2,sizeof(char));
    strcpy(speed_tab[1][(pos*9)+2],ip);
}

void add_ip2speed_table_nop1(char ***speed_tab, char *ip)
{
    int		pos = 0;

    while(speed_tab[1][(pos*9)+3])
	pos++;

    speed_tab[1][(pos*9)+3] = (char *) calloc(strlen(ip)+2,sizeof(char));
    strcpy(speed_tab[1][(pos*9)+3],ip);
}

void add_ip2speed_table_add1(char ***speed_tab, char *ip)
{
    int		pos = 0;

    while(speed_tab[1][(pos*9)+4])
	pos++;

    speed_tab[1][(pos*9)+4] = (char *) calloc(strlen(ip)+2,sizeof(char));
    strcpy(speed_tab[1][(pos*9)+4],ip);
}

void add_ip2speed_table_sub2(char ***speed_tab, char *ip)
{
    int		pos = 0;

    while(speed_tab[1][(pos*9)+5])
	pos++;

    speed_tab[1][(pos*9)+5] = (char *) calloc(strlen(ip)+2,sizeof(char));
    strcpy(speed_tab[1][(pos*9)+5],ip);
}

void add_ip2speed_table_nop2(char ***speed_tab, char *ip)
{
    int		pos = 0;

    while(speed_tab[1][(pos*9)+6])
	pos++;

    speed_tab[1][(pos*9)+6] = (char *) calloc(strlen(ip)+2,sizeof(char));
    strcpy(speed_tab[1][(pos*9)+6],ip);
}

void add_ip2speed_table_add2(char ***speed_tab, char *ip)
{
    int		pos = 0;

    while(speed_tab[1][(pos*9)+7])
	pos++;

    speed_tab[1][(pos*9)+7] = (char *) calloc(strlen(ip)+2,sizeof(char));
    strcpy(speed_tab[1][(pos*9)+7],ip);
}

void del_ip2speed_table(char ***speed_tab, char *ip)
{
    int		pos = 0;

    while(speed_tab[1][(pos*9)+8])
	pos++;

    speed_tab[1][(pos*9)+8] = (char *) calloc(strlen(ip)+2,sizeof(char));
    strcpy(speed_tab[1][(pos*9)+8],ip);
}

char *get_speed_table_new(char ***speed_tab, int pos)
{
    char	*nil = "\0";
    char	*res;

    if (res = speed_tab[1][((pos-1)*9)+1]) return(res);
    else return(nil);
}

char *get_speed_table_sub1(char ***speed_tab, int pos)
{
    char	*nil = "\0";
    char	*res;

    if (res = speed_tab[1][((pos-1)*9)+2]) return(res);
    else return(nil);
}

char *get_speed_table_nop1(char ***speed_tab, int pos)
{
    char	*nil = "\0";
    char	*res;

    if (res = speed_tab[1][((pos-1)*9)+3]) return(res);
    else return(nil);
}

char *get_speed_table_add1(char ***speed_tab, int pos)
{
    char	*nil = "\0";
    char	*res;

    if (res = speed_tab[1][((pos-1)*9)+4]) return(res);
    else return(nil);
}

char *get_speed_table_sub2(char ***speed_tab, int pos)
{
    char	*nil = "\0";
    char	*res;

    if (res = speed_tab[1][((pos-1)*9)+5]) return(res);
    else return(nil);
}

char *get_speed_table_nop2(char ***speed_tab, int pos)
{
    char	*nil = "\0";
    char	*res;

    if (res = speed_tab[1][((pos-1)*9)+6]) return(res);
    else return(nil);
}

char *get_speed_table_add2(char ***speed_tab, int pos)
{
    char	*nil = "\0";
    char	*res;

    if (res = speed_tab[1][((pos-1)*9)+7]) return(res);
    else return(nil);
}

char *get_speed_table_del(char ***speed_tab, int pos)
{
    char	*nil = "\0";
    char	*res;

    if (res = speed_tab[1][((pos-1)*9)+8]) return(res);
    else return(nil);
}

char *get_ip_iface(char *ip)
{
    int		n;
    struct	IPLISTA *ptr;

    for(n=1;n<iplista_pos;n++)
    {
	ptr = iplista_str + n;
	if ((ip2hex3(ip) & ptr -> mask) == (ptr -> ip & ptr -> mask))
	    return(ptr -> iface);
    }
    return("\0");
}

char *get_ip_iface_str(struct IPLISTA *ptr)
{
    return(ptr -> iface);
}

char *get_ip_int_iface(char *ip)
{
    int		n;
    struct	IPLISTA	*ptr;

    for(n=1;n<iplista_pos;n++)
    {
	ptr = iplista_str + n;
	if ((ip2hex3(ip) & ptr -> mask) == (ptr -> ip & ptr -> mask))
	    return(ptr -> int_iface);
    }
    return("\0");
}

char *get_ip_int_iface_str(struct IPLISTA *ptr)
{
    return(ptr -> int_iface);
}

int get_ip_factor(char *ip)
{
    int		n;
    struct	IPLISTA	*ptr;

    for(n=1;n<iplista_pos;n++)
    {
	ptr = iplista_str + n;
	if ((ip2hex3(ip) & ptr -> mask) == (ptr -> ip & ptr -> mask))
	    return(ptr -> factor);
    }
    return(100);
}

int get_ip_upload_factor(char *ip)
{
    int		n;
    struct	IPLISTA	*ptr;

    for(n=1;n<iplista_pos;n++)
    {
	ptr = iplista_str + n;
	if ((ip2hex3(ip) & ptr -> mask) == (ptr -> ip & ptr -> mask))
	    return(ptr -> upload_factor);
    }
    return(100);
}

unsigned short int get_ip_cnt(char *ip)
{
    int			n;
    unsigned short int	m = 0;
    char		*iface;
    struct		IPLISTA	*ptr;
    
    iface = get_ip_int_iface(ip);
    for(n=1;n<iplista_pos;n++)
    {
	ptr = iplista_str + n;
	if (!strcmp(ptr -> int_iface,iface))
	{
	    m++;
	    if ((ip2hex3(ip) & ptr -> mask) == (ptr -> ip & ptr -> mask))
	    {
		return(m);
	    }
	}
    }
    return(m);
}

unsigned short int get_ip_cnt2(struct IPLISTA *ptr_curr, struct IPLISTA *ptr_search, int iplista_pos_new)
{
    int			n;
    unsigned short int	m = 0;
    struct	IPLISTA	*ptr;
    char		*iface;
    
    iface = ptr_curr -> int_iface;
    for(n=1;n<iplista_pos_new;n++)
    {
	ptr = ptr_search + n;
	if (!strcmp(ptr -> int_iface,iface))
	{
	    m++;
	    if ((ptr_curr -> ip & ptr -> mask) == (ptr -> ip & ptr -> mask))
	    {
//		printf("m=%d\n",m);
		return(m);
	    }
	}
    }
    return(m);
}

int get_ip_mask(char *ip)
{
    int		n;
    struct	IPLISTA	*ptr;

    for(n=1;n<iplista_pos;n++)
    {
	ptr = iplista_str + n;
	if (! strcmp(ptr -> str_ip,ip) && ! strcmp(ip,ptr -> str_ip))
	{
	    return(ptr -> mask);
	}
    }
    return(0);
}
unsigned long int get_ip_lospeed(char *ip)
{
    int		n;
    struct	IPLISTA	*ptr;

    for(n=1;n<iplista_pos;n++)
    {
	ptr = iplista_str + n;
	if (! strcmp(ptr -> str_ip,ip) && ! strcmp(ip,ptr -> str_ip))
	{
	    if (ptr -> limit
	    && (ptr -> is_overlimit
	    || (!total_limit && (((ptr -> limit) * multipler()) < (ptr -> ipspeed + ptr -> squid_speed + ptr -> state_ipspeed_last + ptr -> state_squid_speed_last)))
	    || ( total_limit && (((ptr -> limit + ptr -> limit_upload) * multipler()) < (ptr -> ipspeed + ptr -> squid_speed + ptr -> state_ipspeed_last + ptr -> state_squid_speed_last + ptr -> ipspeed_upload + ptr -> sqout_speed + ptr -> state_ipspeed_last_upload + ptr -> state_sqout_speed_last)))))
	    {
		if (!ptr -> is_overlimit)
		{
		    syslog(LOG_INFO,"IP: %s reached download limit!",ptr -> str_ip);
/*
		    syslog(LOG_INFO,"IP: %s reached download limit! %.0f<(%u+%u+%.0f+%.0f)",
			ptr -> str_ip,
		        (ptr -> limit * multipler()),
		        ptr -> ipspeed,
		        ptr -> squid_speed,
		        ptr -> state_ipspeed_last,
		        ptr -> state_squid_speed_last);
*/
		    if (debug) syslog(LOG_INFO,"DEBUG: %.0f%c%.0f",
			(ptr -> limit * multipler()),
			((ptr -> limit * multipler()) < (ptr -> ipspeed + ptr -> squid_speed + ptr -> state_ipspeed_last + ptr -> state_squid_speed_last) ? '<' : '>'),
			(ptr -> ipspeed + ptr -> squid_speed + ptr -> state_ipspeed_last + ptr -> state_squid_speed_last));
		}
		ptr -> is_overlimit = 1;
		if (common_limit || total_limit) ptr -> is_overlimit_upload = 1;
		if (debug > 3) printf("limits overcome! setting isoverlimit flag \n");
		/**ZQ**/
		if (extended_download_limits)
		    return (ptr->lo);
		else
		    return (ptr -> limit_lo);
	    }
	    else return(ptr -> lo);
	}
  
    }
    return(100);
}

unsigned long int get_ip_lospeed_upload(char *ip)
{
    int		n;
    struct	IPLISTA	*ptr;

    for(n=1;n<iplista_pos;n++)
    {
	ptr = iplista_str + n;
	if (! strcmp(ptr -> str_ip,ip) && ! strcmp(ip,ptr -> str_ip))
	    if ((ptr -> limit_upload || (total_limit && ptr -> limit))
	    && (ptr -> is_overlimit_upload
	    || (!total_limit && (((ptr -> limit_upload) * multipler()) < (ptr -> ipspeed_upload + ptr -> sqout_speed + ptr -> state_ipspeed_last_upload + ptr -> state_sqout_speed_last)))
	    || ( total_limit && (((ptr -> limit + ptr -> limit_upload) * multipler()) < (ptr -> ipspeed + ptr -> squid_speed + ptr -> state_ipspeed_last + ptr -> state_squid_speed_last + ptr -> ipspeed_upload + ptr -> sqout_speed + ptr -> state_ipspeed_last_upload + ptr -> state_sqout_speed_last)))))
	    {
		if (!ptr -> is_overlimit_upload)
		{
		    syslog(LOG_INFO,"IP: %s reached upload limit!",ptr -> str_ip);
/*
		    syslog(LOG_INFO,"IP: %s reached upload limit! %.0f<(%u+%u+%.0f+%.0f)",
			ptr -> str_ip,
		        (ptr -> limit_upload * multipler()),
		        ptr -> ipspeed_upload,
		        ptr -> sqout_speed,
		        ptr -> state_ipspeed_last_upload,
		        ptr -> state_sqout_speed_last);
*/
		    if (debug) syslog(LOG_INFO,"DEBUG: %.0f%c%.0f",
			(ptr -> limit_upload * multipler()),
			((ptr -> limit_upload * multipler()) < (ptr -> ipspeed_upload + ptr -> sqout_speed + ptr -> state_ipspeed_last_upload + ptr -> state_sqout_speed_last) ? '<' : '>'),
			(ptr -> ipspeed_upload + ptr -> sqout_speed + ptr -> state_ipspeed_last_upload + ptr -> state_sqout_speed_last));
		}
		ptr -> is_overlimit_upload = 1;
		if (common_limit || total_limit) ptr -> is_overlimit = 1;
		return(ptr -> limit_lo_upload);
	    }
	    else return(ptr -> lo_upload);
    }
    return(100);
}

unsigned long int get_ip_hispeed(char *ip)
{
    int			n;
    unsigned long int	ret = 100;
    struct		IPLISTA	*ptr;

    for(n=1;n<iplista_pos;n++)
    {
	ptr = iplista_str + n;
	if (! strcmp(ptr -> str_ip,ip) && ! strcmp(ip,ptr -> str_ip))
	{
	    if (ptr -> limit
	    && (ptr -> is_overlimit
	    || (!total_limit && (((ptr -> limit) * multipler()) < (ptr -> ipspeed + ptr -> squid_speed + ptr -> state_ipspeed_last + ptr -> state_squid_speed_last)))
	    || ( total_limit && (((ptr -> limit + ptr -> limit_upload) * multipler()) < (ptr -> ipspeed + ptr -> squid_speed + ptr -> state_ipspeed_last + ptr -> state_squid_speed_last + ptr -> ipspeed_upload + ptr -> sqout_speed + ptr -> state_ipspeed_last_upload + ptr -> state_sqout_speed_last)))))
	    {
		if (!ptr -> is_overlimit)
		{
		    syslog(LOG_INFO,"IP: %s reached download limit!",ptr -> str_ip);
/*
		    syslog(LOG_INFO,"IP: %s reached download limit! %.0f<(%u+%u+%.0f+%.0f)",
			ptr -> str_ip,
		        (ptr -> limit * multipler()),
		        ptr -> ipspeed,
	    		ptr -> squid_speed,
		        ptr -> state_ipspeed_last,
		        ptr -> state_squid_speed_last);
*/
		    if (debug) syslog(LOG_INFO,"DEBUG: %.0f%c%.0f",
			(ptr -> limit * multipler()),
			((ptr -> limit * multipler()) < (ptr -> ipspeed + ptr -> squid_speed + ptr -> state_ipspeed_last + ptr -> state_squid_speed_last) ? '<' : '>'),
			(ptr -> ipspeed + ptr -> squid_speed + ptr -> state_ipspeed_last + ptr -> state_squid_speed_last));
		}
			ptr -> is_overlimit = 1;
			if (common_limit || total_limit) ptr -> is_overlimit_upload = 1;
			if (debug > 3) printf("limits overcome! setting isoverlimit flag \n");
			//*ZQ **/
			if (extended_download_limits)
				return (ptr -> hi);	
			else
				return(ptr -> limit_hi);
		}
	    else ret = (ptr -> hi);
	    if (enable_eir_factor
		&& ptr -> hi > ((float)ptr -> feir * (float)ptr -> max_hi))
		ret = (int) ((float)ptr -> feir * (float)ptr -> max_hi);
	}
    }
    return(ret);
}

unsigned long int get_ip_hispeed_upload(char *ip)
{
    int			n;
    unsigned long int	ret = 100;
    struct		IPLISTA	*ptr;

    for(n=1;n<iplista_pos;n++)
    {
	ptr = iplista_str + n;
	if (! strcmp(ptr -> str_ip,ip) && ! strcmp(ip,ptr -> str_ip))
	{
	    if ((ptr -> limit_upload || (total_limit && ptr -> limit))
	    && (ptr -> is_overlimit_upload
	    || (!total_limit && (((ptr -> limit_upload) * multipler()) < (ptr -> ipspeed_upload + ptr -> sqout_speed + ptr -> state_ipspeed_last_upload + ptr -> state_sqout_speed_last)))
	    || ( total_limit && (((ptr -> limit + ptr -> limit_upload) * multipler()) < (ptr -> ipspeed + ptr -> squid_speed + ptr -> state_ipspeed_last + ptr -> state_squid_speed_last + ptr -> ipspeed_upload + ptr -> sqout_speed + ptr -> state_ipspeed_last_upload + ptr -> state_sqout_speed_last)))))
	    {
		if (!ptr -> is_overlimit_upload)
		{
		    syslog(LOG_INFO,"IP: %s reached upload limit!",ptr -> str_ip);
/*
		    syslog(LOG_INFO,"IP: %s reached upload limit! %.0f<(%u+%u+%.0f+%.0f)",
			ptr -> str_ip,
		        (ptr -> limit_upload * multipler()),
		        ptr -> ipspeed_upload,
		        ptr -> sqout_speed,
		        ptr -> state_ipspeed_last_upload,
		        ptr -> state_sqout_speed_last);
*/
		    if (debug) syslog(LOG_INFO,"DEBUG: %.0f%c%.0f",
			(ptr -> limit_upload * multipler()),
			((ptr -> limit_upload * multipler()) < (ptr -> ipspeed_upload + ptr -> sqout_speed + ptr -> state_ipspeed_last_upload + ptr -> state_sqout_speed_last) ? '<' : '>'),
			(ptr -> ipspeed_upload + ptr -> sqout_speed + ptr -> state_ipspeed_last_upload + ptr -> state_sqout_speed_last));
		}
		ptr -> is_overlimit_upload = 1;
		if (common_limit || total_limit) ptr -> is_overlimit = 1;
		ret = (ptr -> limit_hi_upload);
	    }
	    else ret = (ptr -> hi_upload);
	    if (enable_eir_factor
		&& ptr -> hi_upload > ((float)ptr -> feir_upload * (float)ptr -> max_hi_upload))
		ret = (int) ((float)ptr -> feir_upload * (float)ptr -> max_hi_upload);
	}
    }
    return(ret);
}

int get_config_by_ip(char ***config, char *ip)
{
    int		n;
    char	*iface;

    iface = get_ip_iface(ip);
//    printf("ip=%s %s\n",ip,iface);
    for(n=1;n<local_int_pos;n++)
    {
//	if ((!local_int_tab2[1][(n*6)+5])
//	    && (! strcmp(iface,config[1][(n*6)+1]))
//	    && (! strcmp(config[1][(n*6)+1],iface)))
	if ((!local_int_tab2[1][(n*6)+5]) && (! strcmp(config[1][(n*6)+1],iface)))
	{
//	    printf("%s %d\n",config[1][(n*6)+1],n);
	    return(n);
	}
    }
    return(-1);
}

int get_config_by_ip_str(char ***config, struct IPLISTA *ptr)
{
    int		n;
    char	*iface;

    iface = get_ip_iface_str(ptr);
    for(n=1;n<local_int_pos;n++)
    {
	if ((!local_int_tab2[1][(n*6)+5]) && (! strcmp(config[1][(n*6)+1],iface)))
	{
//	    printf("%s %d\n",config[1][(n*6)+1],n);
	    return(n);
	}
    }
    return(-1);
}

int get_config_by_ip_upload(char ***config, char *ip)
{
    int		n;
    char	*iface;

    iface = get_ip_int_iface(ip);
//    printf("ip=%s %s\n",ip,iface);
    for(n=1;n<local_int_pos;n++)
    {
//	if ((local_int_tab2[1][(n*6)+5])
//	    && (! strcmp(iface,config[1][(n*6)+1]))
//	    && (! strcmp(config[1][(n*6)+1],iface)))
	if ((local_int_tab2[1][(n*6)+5]) && (! strcmp(config[1][(n*6)+1],iface)))
	{
//	    printf("%s %d\n",config[1][(n*6)+1],n);
	    return(n);
	}
    }
    return(-1);
}

int get_config_by_ip_upload_str(char ***config, struct IPLISTA *ptr)
{
    int		n;
    char	*iface;

    iface = get_ip_int_iface_str(ptr);
    for(n=1;n<local_int_pos;n++)
    {
	if ((local_int_tab2[1][(n*6)+5]) && (! strcmp(config[1][(n*6)+1],iface)))
	{
	    return(n);
	}
    }
    return(-1);
}

char *check_mask(char *ip)
{
    char	mask[20];
    int		d1,d2,d3,d4;
    int		n = 0;
    int		no_dots = 0;
    int		m;
    
    if (! strchr(ip,'/')) return(NULL);

    while(ip[n++] != '/')
	;

    if (! strlen(ip+n)) return(NULL);

    m = n;
    while(ip[m])
	if (ip[m++] == '.') no_dots++;

    if (no_dots == 3)
    {
        sscanf(ip+n,"%3d.%3d.%3d.%3d",&d1,&d2,&d3,&d4);    
        if (d1<0 || d1>255 || d2<0 || d2>255 || d3<0 || d3>255 || d4<0 || d4>255)
	    return(NULL);
	else return(ip+n);
    }
    else
    if (no_dots>3 || (no_dots>0 && no_dots<3)) return(NULL);
    else
    if (atoi(ip+n)<=32 || atoi(ip+n)>=0) return(ip+n);

    return(NULL);
}


int ip2hex(char *ip)
{
    char	buf[20];
    int		a,b,c,d;
    int		res;

    sscanf(ip,"%d.%d.%d.%d",&a,&b,&c,&d);
    if (a>=0 && a<=255
	&& b>=0 && b<=255
	&& c>=0 && c<=255
	&& d>=0 && d<=255)
    {
	sprintf(buf,"%02x%02x%02x%02x",a,b,c,d);
	sscanf(buf,"%x",&res);
	return(res);
    }
    else return(0);
}

int ip2hex2(char *ip)
{
    char	buf[20];
    int		a,b,c,d;
    int		res;

    sscanf(ip,"%d.%d.%d.%d",&a,&b,&c,&d);
    if (a>=0 && a<=255
	&& b>=0 && b<=255
	&& c>=0 && c<=255
	&& d>=0 && d<=255)
    {
	res = (a*256+b)*65536+(c*256+d);
	return(res);
    }
    else return(0);
}

int ip2hex3(char *ip)
{
    char	buf[20];
    int		a,b,c,d;

    sscanf(ip,"%d.%d.%d.%d",&a,&b,&c,&d);
    return((a*256+b)*65536+(c*256+d));
}

char *hex2ip(int ip)
{
    char	*res;
//    static char	res[20];
    char	ipt[20];
    int		a,b,c,d;

    res = (char *) calloc(22,sizeof(char));
    sprintf(ipt,"%08x",ip);
    sscanf(ipt,"%02x%02x%02x%02x",&a,&b,&c,&d);
    sprintf(res,"%d.%d.%d.%d",a,b,c,d);
    return(res);
}

char *hex2ip2(char *ip)
{
    char	*res;
//    static char	res[20];
    char	ipt[20];
    int		a,b,c,d;

    res = (char *) calloc(22,sizeof(char));
    sprintf(ipt,"%s",ip);
    sscanf(ipt,"%02x%02x%02x%02x",&a,&b,&c,&d);
    sprintf(res,"%d.%d.%d.%d",a,b,c,d);
    return(res);
}

char *get_ip_iface2(char ***local_int_tab, char *ip)
{
    int		intip, mip, maska, n;
    char	*mainip;
    int		res;

    mip = ip2hex(ip);
    for(n=1;n<local_int_pos;n++)
    {
	maska = mask2hex(local_int_tab[1][(n*6)+4]);
        intip = ip2hex(local_int_tab[1][(n*6)+4]);
	res = intip & maska;
	if ((mip & maska) == res) return(hex2ip(res));
    }
    return(NULL);
}

int mask2hex(char *ip)
{
    char	mask[20];
    int		d1,d2,d3,d4;
    int		n = 0;
    int		no_dots = 0;
    int		m;
    int		res = 0;

    if (! strchr(ip,'/')) return(0);

    while(ip[n++] != '/')
	;

    if (! strlen(ip+n)) return(0);

    m = n;
    while(ip[m])
	if (ip[m++] == '.') no_dots++;

    if (no_dots == 3)
    {
        sscanf(ip+n,"%3d.%3d.%3d.%3d",&d1,&d2,&d3,&d4);    
        if (d1<0 || d1>255 || d2<0 || d2>255 || d3<0 || d3>255 || d4<0 || d4>255)
	    return(0);
	else return(ip2hex(ip+n));
    }
    else
    if (no_dots>3 || (no_dots>0 && no_dots<3)) return(0);
    else
    if (atoi(ip+n)<=32 || atoi(ip+n)>=0)
    {
	for(m=31;m>=(32-atoi(ip+n));m--)
	    res = res + ldexp(1,m);
	return(res);
    }
    return(0);
}

int mask2hex2(char *maska)
{
    char	mask[20];
    int		d1,d2,d3,d4;
    int		n = 0;
    int		no_dots = 0;
    int		m;
    int		res = 0;

    if (!strlen(maska)) return(0);

    m = n;
    while(maska[m])
	if (maska[m++] == '.') no_dots++;

    if (no_dots == 3)
    {
        sscanf(maska,"%3d.%3d.%3d.%3d",&d1,&d2,&d3,&d4);    
        if (d1<0 || d1>255 || d2<0 || d2>255 || d3<0 || d3>255 || d4<0 || d4>255)
	    return(0);
	else return(ip2hex(maska));
    }
    else
    if (no_dots>3 || (no_dots>0 && no_dots<3)) return(0);
    else
    if (atoi(maska)<=32 || atoi(maska)>=0)
    {
	for(m=31;m>=(32-atoi(maska));m--)
	    res = res + ldexp(1,m);
	return(res);
    }
    return(0);
}

void create_firewall(char ***config, int firewall_type)
{
    int		pos;
    int		n;
    int		nlinii;
    char	fname[100];
    char	bufor[1000];
    char	fbufor[1000];
    FILE	*fp;
    FILE	*ff;
    char	com[100];

    fflush(NULL);
    sprintf(com,"/bin/sh 2>> %s",output);
    if (fp = popen(com,"w"))
    {
	if (firewall_type == 1)
	{
	    char	pop1[100];
	    char	pop2[100];
	    struct	IPLISTA	*ptr;
	    
	    sprintf(bufor,"%s -M -S %d 10 60\n",ipchains_path,timeout_ipchains_22);
	    fputs(bufor,fp);
	    // tablice download
	    sprintf(pop1,"%s -N shaper%d\n",ipchains_path,shaperd_counter);
	    sprintf(pop2,"%s -I output -j shaper%d\n",ipchains_path,shaperd_counter);
    	    fputs(pop1,fp);
	    fputs(pop2,fp);
	    if (divide_upload)
	    {
	    // tablice upload
	    sprintf(pop1,"%s -N shaout%d\n",ipchains_path,shaperd_counter);
	    sprintf(pop2,"%s -I forward -j shaout%d\n",ipchains_path,shaperd_counter);
    	    fputs(pop1,fp);
	    fputs(pop2,fp);
	    }
    	    for(n=1;n<iplista_pos;n++)
	    {
		ptr = iplista_str + n;
		if ((pos = get_config_by_ip(config,ptr -> str_ip)) != -1)
		{
		    // download
		    sprintf(bufor,"%s -A shaper%d -s ! %s -d %s -j RETURN\n",
			ipchains_path,shaperd_counter,config[1][(pos*6)+3],ptr -> str_ip);
		    fputs(bufor,fp);
		    if (divide_upload)
		    {
			int	pos2;

			if ((pos2 = get_config_by_ip_upload(config,ptr -> str_ip)) != -1)
			{
			    // upload
		    	    sprintf(bufor,"%s -A shaout%d -s %s -d ! %s -m %d -j RETURN\n",
				    ipchains_path,shaperd_counter,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+get_ip_cnt(ptr -> str_ip)+4);
			    fputs(bufor,fp);
			}
		    }
		}
	    }
	}
	else
	if (firewall_type == 2)
	{
	    char	pop1[100];
	    int		int_cnt;
	    struct	IPLISTA	*ptr;
	    
	    // download
	    sprintf(pop1,"%s -N shaper%d\n",iptables_path,shaperd_counter);
	    fputs(pop1,fp);

	    if (squid)
	    {
		// squid
		sprintf(pop1,"%s -N squid%d\n",iptables_path,shaperd_counter);
		fputs(pop1,fp);
	    }
	    if (divide_upload)
	    {
	    // upload
	    sprintf(pop1,"%s -N shaout%d\n",iptables_path,shaperd_counter);
	    fputs(pop1,fp);
	    if (squid)
	    {
		// squid
		sprintf(pop1,"%s -N sqout%d\n",iptables_path,shaperd_counter);
		fputs(pop1,fp);
	    }
	    }

	    // squid
    	    if (squid)
	    {
		sprintf(bufor,"%s -I OUTPUT -j squid%d\n",iptables_path,shaperd_counter);
		fputs(bufor,fp);
		if (divide_upload)
		{
		    sprintf(bufor,"%s -I INPUT -j sqout%d\n",iptables_path,shaperd_counter);
		    fputs(bufor,fp);
		}
	    }
/*
	    for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
	    {
	        if (!local_int_tab2[1][(int_cnt*6)+5])
	        {
	    	    if (squid)
		    {
			sprintf(bufor,"/sbin/iptables -A OUTPUT -o %s -j squid%d\n",config[1][(int_cnt*6)+1],shaperd_counter);
			fputs(bufor,fp);
		    }
		}
	    }
*/
	    for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
	    {
		if (local_int_tab2[1][(int_cnt*6)+5])
		{
		    // download
		    if (!load_balancing)
		    {
			sprintf(bufor,"%s -I FORWARD -i %s -j shaper%d\n",iptables_path,config[1][(int_cnt*6)+1],shaperd_counter);
		    }
		    else
		    {
			sprintf(bufor,"%s -I FORWARD -j shaper%d\n",iptables_path,shaperd_counter);
		    }
		    fputs(bufor,fp);
		    if (divide_upload)
		    {
		    // upload
		    if (!load_balancing)
		    {
			sprintf(bufor,"%s -I FORWARD -o %s -j shaout%d\n",iptables_path,config[1][(int_cnt*6)+1],shaperd_counter);
			fputs(bufor,fp);
			sprintf(bufor,"%s -I OUTPUT -o %s -j shaout%d\n",iptables_path,config[1][(int_cnt*6)+1],shaperd_counter);
			fputs(bufor,fp);
		    }
		    else
		    {
			sprintf(bufor,"%s -I FORWARD -j shaout%d\n",iptables_path,shaperd_counter);
			fputs(bufor,fp);
			sprintf(bufor,"%s -I OUTPUT -j shaout%d\n",iptables_path,shaperd_counter);
			fputs(bufor,fp);
		    }

//		    if (!load_balancing)
//		    {
			sprintf(bufor,"%s -A shaout%d -o %s -s %s -j RETURN\n",
			    iptables_path,shaperd_counter,config[1][(int_cnt*6)+1],config[1][(int_cnt*6)+2]);
//		    }
//		    else
//		    {
//			sprintf(bufor,"/sbin/iptables -A shaout%d -s %s -j RETURN\n",
//			    shaperd_counter,config[1][(int_cnt*6)+2]);
//		    }
		    fputs(bufor,fp);

		    if (extended_queue)
		    {
		    sprintf(bufor,"%s -t mangle -A POSTROUTING -s %s -j MARK --set-mark %d\n",
			    iptables_path,config[1][(int_cnt*6)+2],(1000*atoi(config[1][(int_cnt*6)+3]))+103+(4*(get_ip_cnt(config[1][(int_cnt*6)+2])+4)));
		    fputs(bufor,fp);

		    sprintf(fname,"%s/queue_upload_server_low.%d",CONFIG_DIR,shaperd_counter);
		    nlinii = 0;
		    if (ff = fopen(fname,"r"))
		    {
		        char	*prot,*src,*sport,*dst,*dport;

			while ((fgets(fbufor,1000,ff)) != NULL)
			{
			    nlinii++;
			    if (fbufor[0] != '#' && strlen(fbufor))
			    {
			        if (count_char_in_string(fbufor,';') != 4) printf("Syntax error in %s line %d\n",fname,nlinii);
			        else
			        {
			    	    prot = strtok(fbufor,";");
				    src = strtok(NULL,";");
				    sport = strtok(NULL,";");
				    dst = strtok(NULL,";");
				    dport = strtok(NULL,"\n");
				    if (!strcmp(sport,"*") && !strcmp("*",sport)) sport = "0:65535";
				    if (!strcmp(dport,"*") && !strcmp("*",dport)) dport = "0:65535";
				    if (!strcmp(dst,"*") && !strcmp("*",dst)) dst = "0/0";
				    if ((!strcmp(src,"*") && !strcmp("*",src))
					|| (!strcmp(src,config[1][(int_cnt*6)+2]) && !strcmp(config[1][(int_cnt*6)+2],src)))
				    {
					if (!strcmp(prot,"icmp") && !strcmp("icmp",prot))
					{
					    sprintf(bufor,"%s -t mangle -A POSTROUTING -p %s -s %s -d %s -j MARK --set-mark %d\n",
						    iptables_path,prot,config[1][(int_cnt*6)+2],dst,(1000*atoi(config[1][(int_cnt*6)+3]))+102+(4*(get_ip_cnt(config[1][(int_cnt*6)+2])+4)));
					    fputs(bufor,fp);
					}
					else
					{
					    sprintf(bufor,"%s -t mangle -A POSTROUTING -p %s -s %s --sport %s -d %s --dport %s -j MARK --set-mark %d\n",
						    iptables_path,prot,config[1][(int_cnt*6)+2],sport,dst,dport,(1000*atoi(config[1][(int_cnt*6)+3]))+102+(4*(get_ip_cnt(config[1][(int_cnt*6)+2])+4)));
					    fputs(bufor,fp);
					}
				    }
				}
			    }
			}
			fclose(ff);
		    }
		    else printf("Can't open %s file\n",fname);

		    sprintf(fname,"%s/queue_upload_server_med.%d",CONFIG_DIR,shaperd_counter);
		    nlinii = 0;
		    if (ff = fopen(fname,"r"))
		    {
		        char	*prot,*src,*sport,*dst,*dport;

			while ((fgets(fbufor,1000,ff)) != NULL)
			{
			    nlinii++;
			    if (fbufor[0] != '#' && strlen(fbufor))
			    {
			        if (count_char_in_string(fbufor,';') != 4) printf("Syntax error in %s line %d\n",fname,nlinii);
			        else
			        {
			    	    prot = strtok(fbufor,";");
				    src = strtok(NULL,";");
				    sport = strtok(NULL,";");
				    dst = strtok(NULL,";");
				    dport = strtok(NULL,"\n");
				    if (!strcmp(sport,"*") && !strcmp("*",sport)) sport = "0:65535";
				    if (!strcmp(dport,"*") && !strcmp("*",dport)) dport = "0:65535";
				    if (!strcmp(dst,"*") && !strcmp("*",dst)) dst = "0/0";
				    if ((!strcmp(src,"*") && !strcmp("*",src))
					|| (!strcmp(src,config[1][(int_cnt*6)+2]) && !strcmp(config[1][(int_cnt*6)+2],src)))
				    {
					if (!strcmp(prot,"icmp") && !strcmp("icmp",prot))
					{
					    sprintf(bufor,"%s -t mangle -A POSTROUTING -p %s -s %s -d %s -j MARK --set-mark %d\n",
						    iptables_path,prot,config[1][(int_cnt*6)+2],dst,(1000*atoi(config[1][(int_cnt*6)+3]))+101+(4*(get_ip_cnt(config[1][(int_cnt*6)+2])+4)));
					    fputs(bufor,fp);
					}
					else
					{
					    sprintf(bufor,"%s -t mangle -A POSTROUTING -p %s -s %s --sport %s -d %s --dport %s -j MARK --set-mark %d\n",
						    iptables_path,prot,config[1][(int_cnt*6)+2],sport,dst,dport,(1000*atoi(config[1][(int_cnt*6)+3]))+101+(4*(get_ip_cnt(config[1][(int_cnt*6)+2])+4)));
					    fputs(bufor,fp);
					}
				    }
				}
			    }
			}
			fclose(ff);
		    }
		    else printf("Can't open %s file\n",fname);

		    sprintf(fname,"%s/queue_upload_server_high.%d",CONFIG_DIR,shaperd_counter);
		    nlinii = 0;
		    if (ff = fopen(fname,"r"))
		    {
		        char	*prot,*src,*sport,*dst,*dport;

			while ((fgets(fbufor,1000,ff)) != NULL)
			{
			    nlinii++;
			    if (fbufor[0] != '#' && strlen(fbufor))
			    {
			        if (count_char_in_string(fbufor,';') != 4) printf("Syntax error in %s line %d\n",fname,nlinii);
			        else
			        {
			    	    prot = strtok(fbufor,";");
				    src = strtok(NULL,";");
				    sport = strtok(NULL,";");
				    dst = strtok(NULL,";");
				    dport = strtok(NULL,"\n");
				    if (!strcmp(sport,"*") && !strcmp("*",sport)) sport = "0:65535";
				    if (!strcmp(dport,"*") && !strcmp("*",dport)) dport = "0:65535";
				    if (!strcmp(dst,"*") && !strcmp("*",dst)) dst = "0/0";
				    if ((!strcmp(src,"*") && !strcmp("*",src))
					|| (!strcmp(src,config[1][(int_cnt*6)+2]) && !strcmp(config[1][(int_cnt*6)+2],src)))
				    {
					if (!strcmp(prot,"icmp") && !strcmp("icmp",prot))
					{
					    sprintf(bufor,"%s -t mangle -A POSTROUTING -p %s -s %s -d %s -j MARK --set-mark %d\n",
						    iptables_path,prot,config[1][(int_cnt*6)+2],dst,(1000*atoi(config[1][(int_cnt*6)+3]))+100+(4*(get_ip_cnt(config[1][(int_cnt*6)+2])+4)));
					    fputs(bufor,fp);
					}
					else
					{
					    sprintf(bufor,"%s -t mangle -A POSTROUTING -p %s -s %s --sport %s -d %s --dport %s -j MARK --set-mark %d\n",
						    iptables_path,prot,config[1][(int_cnt*6)+2],sport,dst,dport,(1000*atoi(config[1][(int_cnt*6)+3]))+100+(4*(get_ip_cnt(config[1][(int_cnt*6)+2])+4)));
					    fputs(bufor,fp);
					}
				    }
				}
			    }
			}
			fclose(ff);
		    }
		    else printf("Can't open %s file\n",fname);

		    }
		    else
		    {
			sprintf(bufor,"%s -t mangle -A POSTROUTING -s %s -j MARK --set-mark %d\n",
			        iptables_path,config[1][(int_cnt*6)+2],(1000*atoi(config[1][(int_cnt*6)+3]))+get_ip_cnt(config[1][(int_cnt*6)+2])+4);
			fputs(bufor,fp);
		    }
		    }
		}
	    }
	    if (squid)
	    {
		for(pos=1;pos<local_int_pos;pos++)
		{
		    if (!local_int_tab2[1][(pos*6)+5])
		    {
    			sprintf(bufor,"%s -A squid%d -p tcp --src %s --sport %d --dst %s -m tos --tos 0 -j RETURN\n",
			    iptables_path,shaperd_counter,config[1][(pos*6)+3],squid_port,config[1][(pos*6)+4]);
			fputs(bufor,fp);
    			sprintf(bufor,"%s -A squid%d -p udp --src %s --sport %d --dst %s -m tos --tos 0 -j RETURN\n",
			    iptables_path,shaperd_counter,config[1][(pos*6)+3],squid_port,config[1][(pos*6)+4]);
			fputs(bufor,fp);

			sprintf(bufor,"%s -A POSTROUTING -t mangle -p tcp --src %s --sport %d --dst %s -m tos --tos 0 -j MARK --set-mark %d\n",
			    iptables_path,config[1][(pos*6)+3],squid_port,config[1][(pos*6)+4],atoi(config[1][(pos*6)+5])*1000);
			fputs(bufor,fp);
			sprintf(bufor,"%s -A POSTROUTING -t mangle -p udp --src %s --sport %d --dst %s -m tos --tos 0 -j MARK --set-mark %d\n",
			    iptables_path,config[1][(pos*6)+3],squid_port,config[1][(pos*6)+4],atoi(config[1][(pos*6)+5])*1000);
			fputs(bufor,fp);

			if (squid==1)
			{
			// pelna szybkosc przy transferze lokalnym z serwera do userow
			sprintf(bufor,"%s -A POSTROUTING -t mangle -p tcp --src %s --sport ! %d --dst %s -j MARK --set-mark %d\n",
			    iptables_path,config[1][(pos*6)+3],squid_port,config[1][(pos*6)+4],atoi(config[1][(pos*6)+5])*1000);
			fputs(bufor,fp);
			sprintf(bufor,"%s -A POSTROUTING -t mangle -p udp --src %s --sport ! %d --dst %s -j MARK --set-mark %d\n",
			    iptables_path,config[1][(pos*6)+3],squid_port,config[1][(pos*6)+4],atoi(config[1][(pos*6)+5])*1000);
			fputs(bufor,fp);
			}
		    }
		}
	    }

    	    for(n=1;n<iplista_pos;n++)
	    {
		ptr = iplista_str + n;
	        if ((pos = get_config_by_ip(config,ptr -> str_ip)) != -1)
	        {
		    if (squid)
		    {
		        sprintf(bufor,"%s -A squid%d -p tcp --src %s --sport %d -m tos --tos 8 --dst %s -j RETURN\n",
			        iptables_path,shaperd_counter,config[1][(pos*6)+3],squid_port,ptr -> str_ip);
			fputs(bufor,fp);
			if (squid==1)
			{
			if (extended_queue)
			{
			    sprintf(bufor,"%s -A POSTROUTING -t mangle -p tcp --src %s --sport %d --dst %s -m tos --tos 8 -j MARK --set-mark %d\n",
			        iptables_path,config[1][(pos*6)+3],squid_port,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+101+(4*(get_ip_cnt(ptr -> str_ip)+4)));
			    fputs(bufor,fp);
			    sprintf(bufor,"%s -A POSTROUTING -t mangle -p udp --src %s --sport %d --dst %s -m tos --tos 8 -j MARK --set-mark %d\n",
				iptables_path,config[1][(pos*6)+3],squid_port,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+101+(4*(get_ip_cnt(ptr -> str_ip)+4)));
			    fputs(bufor,fp);
			}
			else
			{
			    sprintf(bufor,"%s -A POSTROUTING -t mangle -p tcp --src %s --sport %d --dst %s -m tos --tos 8 -j MARK --set-mark %d\n",
				iptables_path,config[1][(pos*6)+3],squid_port,ptr -> str_ip,(4*(get_ip_cnt(ptr -> str_ip)+4))+(1000*atoi(config[1][(pos*6)+5])));
			    fputs(bufor,fp);
			    sprintf(bufor,"%s -A POSTROUTING -t mangle -p udp --src %s --sport %d --dst %s -m tos --tos 8 -j MARK --set-mark %d\n",
				iptables_path,config[1][(pos*6)+3],squid_port,ptr -> str_ip,(4*(get_ip_cnt(ptr -> str_ip)+4))+(1000*atoi(config[1][(pos*6)+5])));
			    fputs(bufor,fp);
			}
			}
		    }
		    // download
//		    if (!load_balancing)
//		    {
			sprintf(bufor,"%s -A shaper%d -o %s -s ! %s -d %s -j RETURN\n",
		    	    iptables_path,shaperd_counter,config[1][(pos*6)+1],config[1][(pos*6)+3],ptr -> str_ip);
//		    }
//		    else
//		    {
//			sprintf(bufor,"/sbin/iptables -A shaper%d -s ! %s -d %s -j RETURN\n",
//		    	    shaperd_counter,config[1][(pos*6)+3],ptr -> str_ip);
//		    }
		    fputs(bufor,fp);
		    if (extended_queue)
		    {
		        //download
			// W zaleznoci od pola TOS i adresu docelowego znakujemy pakiety
			sprintf(bufor,"%s -t mangle -A FORWARD -d %s -j MARK --set-mark %d\n",
				iptables_path,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+103+(4*(get_ip_cnt(ptr -> str_ip)+4)));
			fputs(bufor,fp);
			sprintf(bufor,"%s -t mangle -A FORWARD -d %s -m tos --tos 0x04 -j MARK --set-mark %d\n",
				iptables_path,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+102+(4*(get_ip_cnt(ptr -> str_ip)+4)));
			fputs(bufor,fp);
			sprintf(bufor,"%s -t mangle -A FORWARD -d %s -m tos --tos 0x08 -j MARK --set-mark %d\n",
				iptables_path,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+101+(4*(get_ip_cnt(ptr -> str_ip)+4)));
			fputs(bufor,fp);
			sprintf(bufor,"%s -t mangle -A FORWARD -d %s -m tos --tos 0x10 -j MARK --set-mark %d\n",
				iptables_path,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+100+(4*(get_ip_cnt(ptr -> str_ip)+4)));
			fputs(bufor,fp);
		    }

		    if (divide_upload)
		    {
		        int	pos2;

		        if ((pos2 = get_config_by_ip_upload(config,ptr -> str_ip)) != -1)
		    	{
			    if (squid)
			    {
				sprintf(bufor,"%s -A sqout%d -i %s -p tcp --src %s --dst %s --dport %d -j RETURN\n",
		    		    iptables_path,shaperd_counter,config[1][(pos*6)+1],ptr -> str_ip,config[1][(pos*6)+3],squid_port);
				fputs(bufor,fp);
			    }

			    // upload
//			    if (!load_balancing)
//			    {
				sprintf(bufor,"%s -A shaout%d -i %s -s %s -d ! %s -j RETURN\n",
				    iptables_path,shaperd_counter,config[1][(pos*6)+1],ptr -> str_ip,config[1][(pos*6)+3]);
//			    }
//			    else
//			    {
//				sprintf(bufor,"/sbin/iptables -A shaout%d -s %s -d ! %s -j RETURN\n",
//				    shaperd_counter,ptr -> str_ip,config[1][(pos*6)+3]);
//			    }
			    fputs(bufor,fp);
			    if (! extended_queue)
			    {
				sprintf(bufor,"%s -t mangle -A FORWARD -s %s -d ! %s -j MARK --set-mark %d\n",
				        iptables_path,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+get_ip_cnt(ptr -> str_ip)+4);
				fputs(bufor,fp);
			    }
			    else
			    {
				// upload
			        sprintf(bufor,"%s -t mangle -A FORWARD -s %s -d ! %s -j MARK --set-mark %d\n",
					iptables_path,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+103+(4*(get_ip_cnt(ptr -> str_ip)+4)));
				fputs(bufor,fp);

				sprintf(bufor,"%s -t mangle -A FORWARD -s %s -d ! %s -m tos --tos 0x04 -j MARK --set-mark %d\n",
					iptables_path,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+102+(4*(get_ip_cnt(ptr -> str_ip)+4)));
				fputs(bufor,fp);
				sprintf(bufor,"%s -t mangle -A FORWARD -s %s -d ! %s -m tos --tos 0x08 -j MARK --set-mark %d\n",
					iptables_path,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+101+(4*(get_ip_cnt(ptr -> str_ip)+4)));
				fputs(bufor,fp);
				sprintf(bufor,"%s -t mangle -A FORWARD -s %s -d ! %s -m tos --tos 0x10 -j MARK --set-mark %d\n",
					iptables_path,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+100+(4*(get_ip_cnt(ptr -> str_ip)+4)));
				fputs(bufor,fp);
			    }
			}
		    }
		}
	    }
	}
//	fflush(fp);
	fflush(fp);
	pclose(fp);
    }
}

void delete_firewall(char ***config, int firewall_type)
{
    int		pos;
    int		n;
    int		nlinii;
    char	fname[100];
    char	fbufor[1000];
    char	bufor[1000];
    FILE	*ff;
    FILE	*fp;
    char	com[100];

    fflush(NULL);
    sprintf(com,"/bin/sh 2>> %s",output);
    if (fp = popen(com,"w"))
    {
	if (firewall_type == 1)
	{
	    char	pop1[100];
	    
	    // download
	    sprintf(pop1,"%s -F shaper%d 2> dev/null\n",ipchains_path,shaperd_counter);
	    fputs(pop1,fp);
	    sprintf(pop1,"%s -D output -j shaper%d 2> /dev/null\n",ipchains_path,shaperd_counter);
	    fputs(pop1,fp);
	    sprintf(pop1,"%s -X shaper%d 2> /dev/null\n",ipchains_path,shaperd_counter);
	    fputs(pop1,fp);
	    if (divide_upload)
	    {
	    // upload
	    sprintf(pop1,"%s -F shaout%d 2> /dev/null\n",ipchains_path,shaperd_counter);
	    fputs(pop1,fp);
	    sprintf(pop1,"%s -D forward -j shaout%d 2> /dev/null\n",ipchains_path,shaperd_counter);
    	    fputs(pop1,fp);
	    sprintf(pop1,"%s -X shaout%d 2> /dev/null\n",ipchains_path,shaperd_counter);
	    fputs(pop1,fp);
	    }
	}
	else
	if (firewall_type == 2)
	{
	    char	pop[100];
	    int         int_cnt;
	    struct	IPLISTA	*ptr;

	    // download
	    sprintf(pop,"%s -F shaper%d 2> /dev/null\n",iptables_path,shaperd_counter);
	    fputs(pop,fp);
	    if (divide_upload)
	    {
	    // upload
	    sprintf(pop,"%s -F shaout%d 2> /dev/null\n",iptables_path,shaperd_counter);
	    fputs(pop,fp);
	    }
	    if (squid)
	    {
	    sprintf(pop,"%s -F squid%d 2> /dev/null\n",iptables_path,shaperd_counter);
	    fputs(pop,fp);
	    sprintf(pop,"%s -F sqout%d 2> /dev/null\n",iptables_path,shaperd_counter);
	    fputs(pop,fp);
	    }
	    
	    for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
	    {
		if (local_int_tab2[1][(int_cnt*6)+5])
		{
		    if (!load_balancing)
		    {
			sprintf(bufor,"%s -D FORWARD -i %s -j shaper%d 2> /dev/null\n",iptables_path,config[1][(int_cnt*6)+1],shaperd_counter);
		    }
		    else
		    {
			sprintf(bufor,"%s -D FORWARD -j shaper%d 2> /dev/null\n",iptables_path,shaperd_counter);
		    }
		    fputs(bufor,fp);
		    if (divide_upload)
		    {
		    if (!load_balancing)
		    {
		    sprintf(bufor,"%s -D FORWARD -o %s -j shaout%d 2> /dev/null\n",iptables_path,config[1][(int_cnt*6)+1],shaperd_counter);
		    fputs(bufor,fp);
		    sprintf(bufor,"%s -D OUTPUT -o %s -j shaout%d 2> /dev/null\n",iptables_path,config[1][(int_cnt*6)+1],shaperd_counter);
		    fputs(bufor,fp);
		    }
		    else
		    {
		    sprintf(bufor,"%s -D FORWARD -j shaout%d 2> /dev/null\n",iptables_path,shaperd_counter);
		    fputs(bufor,fp);
		    sprintf(bufor,"%s -D OUTPUT -j shaout%d 2> /dev/null\n",iptables_path,shaperd_counter);
		    fputs(bufor,fp);
		    }
		    
		    if (extended_queue)
		    {
			sprintf(bufor,"%s -t mangle -D POSTROUTING -s %s -j MARK --set-mark %d 2> /dev/null\n",
				iptables_path,config[1][(int_cnt*6)+2],(1000*atoi(config[1][(int_cnt*6)+3]))+103+(4*(get_ip_cnt(config[1][(int_cnt*6)+2])+4)));
			fputs(bufor,fp);

			sprintf(fname,"%s/queue_upload_server_low.%d",CONFIG_DIR,shaperd_counter);
			nlinii = 0;
			if (ff = fopen(fname,"r"))
			{
			    char	*prot,*src,*sport,*dst,*dport;

			    while ((fgets(fbufor,1000,ff)) != NULL)
			    {
				nlinii++;
			        if (fbufor[0] != '#' && strlen(fbufor))
				{
			    	    if (count_char_in_string(fbufor,';') != 4) printf("Syntax error in %s line %d\n",fname,nlinii);
			    	    else
			    	    {
			    		prot = strtok(fbufor,";");
					src = strtok(NULL,";");
				        sport = strtok(NULL,";");
					dst = strtok(NULL,";");
				        dport = strtok(NULL,"\n");
					if (!strcmp(sport,"*") && !strcmp("*",sport)) sport = "0:65535";
				        if (!strcmp(dport,"*") && !strcmp("*",dport)) dport = "0:65535";
					if (!strcmp(dst,"*") && !strcmp("*",dst)) dst = "0/0";
				        if ((!strcmp(src,"*") && !strcmp("*",src))
					    || (!strcmp(src,config[1][(int_cnt*6)+2]) && !strcmp(config[1][(int_cnt*6)+2],src)))
					{
					    if (!strcmp(prot,"icmp") && !strcmp("icmp",prot))
					    {
						sprintf(bufor,"%s -t mangle -D POSTROUTING -p %s -s %s -d %s -j MARK --set-mark %d 2> /dev/null\n",
							iptables_path,prot,config[1][(int_cnt*6)+2],dst,(1000*atoi(config[1][(int_cnt*6)+3]))+102+(4*(get_ip_cnt(config[1][(int_cnt*6)+2])+4)));
						fputs(bufor,fp);
					    }
					    else
					    {
						sprintf(bufor,"%s -t mangle -D POSTROUTING -p %s -s %s --sport %s -d %s --dport %s -j MARK --set-mark %d 2> /dev/null\n",
							iptables_path,prot,config[1][(int_cnt*6)+2],sport,dst,dport,(1000*atoi(config[1][(int_cnt*6)+3]))+102+(4*(get_ip_cnt(config[1][(int_cnt*6)+2])+4)));
						fputs(bufor,fp);
					    }
				        }
				    }
				}
			    }
			    fclose(ff);
			}
		        else printf("Can't open %s file\n",fname);

			sprintf(fname,"%s/queue_upload_server_med.%d",CONFIG_DIR,shaperd_counter);
			nlinii = 0;
			if (ff = fopen(fname,"r"))
			{
		    	    char	*prot,*src,*sport,*dst,*dport;

			    while ((fgets(fbufor,1000,ff)) != NULL)
			    {
				nlinii++;
				if (fbufor[0] != '#' && strlen(fbufor))
				{
			    	    if (count_char_in_string(fbufor,';') != 4) printf("Syntax error in %s line %d\n",fname,nlinii);
			    	    else
			    	    {
			    		prot = strtok(fbufor,";");
					src = strtok(NULL,";");
					sport = strtok(NULL,";");
					dst = strtok(NULL,";");
					dport = strtok(NULL,"\n");
					if (!strcmp(sport,"*") && !strcmp("*",sport)) sport = "0:65535";
					if (!strcmp(dport,"*") && !strcmp("*",dport)) dport = "0:65535";
					if (!strcmp(dst,"*") && !strcmp("*",dst)) dst = "0/0";
				        if ((!strcmp(src,"*") && !strcmp("*",src))
					    || (!strcmp(src,config[1][(int_cnt*6)+2]) && !strcmp(config[1][(int_cnt*6)+2],src)))
					{
					    if (!strcmp(prot,"icmp") && !strcmp("icmp",prot))
					    {
						sprintf(bufor,"%s -t mangle -D POSTROUTING -p %s -s %s -d %s -j MARK --set-mark %d 2> /dev/null\n",
							iptables_path,prot,config[1][(int_cnt*6)+2],dst,(1000*atoi(config[1][(int_cnt*6)+3]))+101+(4*(get_ip_cnt(config[1][(int_cnt*6)+2])+4)));
						fputs(bufor,fp);
					    }
					    else
					    {
						sprintf(bufor,"%s -t mangle -D POSTROUTING -p %s -s %s --sport %s -d %s --dport %s -j MARK --set-mark %d 2> /dev/null\n",
							iptables_path,prot,config[1][(int_cnt*6)+2],sport,dst,dport,(1000*atoi(config[1][(int_cnt*6)+3]))+101+(4*(get_ip_cnt(config[1][(int_cnt*6)+2])+4)));
						fputs(bufor,fp);
					    }
					}
			    	    }
				}
			    }
			    fclose(ff);
			}
			else printf("Can't open %s file\n",fname);

			sprintf(fname,"%s/queue_upload_server_high.%d",CONFIG_DIR,shaperd_counter);
		        nlinii = 0;
			if (ff = fopen(fname,"r"))
			{
		    	    char	*prot,*src,*sport,*dst,*dport;

			    while ((fgets(fbufor,1000,ff)) != NULL)
			    {
			        nlinii++;
				if (fbufor[0] != '#' && strlen(fbufor))
			        {
				    if (count_char_in_string(fbufor,';') != 4) printf("Syntax error in %s line %d\n",fname,nlinii);
			    	    else
			    	    {
			    		prot = strtok(fbufor,";");
				        src = strtok(NULL,";");
				        sport = strtok(NULL,";");
				        dst = strtok(NULL,";");
				        dport = strtok(NULL,"\n");
				        if (!strcmp(sport,"*") && !strcmp("*",sport)) sport = "0:65535";
				        if (!strcmp(dport,"*") && !strcmp("*",dport)) dport = "0:65535";
				        if (!strcmp(dst,"*") && !strcmp("*",dst)) dst = "0/0";
				        if ((!strcmp(src,"*") && !strcmp("*",src))
					    || (!strcmp(src,config[1][(int_cnt*6)+2]) && !strcmp(config[1][(int_cnt*6)+2],src)))
				        {
					    if (!strcmp(prot,"icmp") && !strcmp("icmp",prot))
					    {
						sprintf(bufor,"%s -t mangle -D POSTROUTING -p %s -s %s -d %s -j MARK --set-mark %d 2> /dev/null\n",
							iptables_path,prot,config[1][(int_cnt*6)+2],dst,(1000*atoi(config[1][(int_cnt*6)+3]))+100+(4*(get_ip_cnt(config[1][(int_cnt*6)+2])+4)));
						fputs(bufor,fp);
					    }
					    else
					    {
				    	        sprintf(bufor,"%s -t mangle -D POSTROUTING -p %s -s %s --sport %s -d %s --dport %s -j MARK --set-mark %d 2> /dev/null\n",
							iptables_path,prot,config[1][(int_cnt*6)+2],sport,dst,dport,(1000*atoi(config[1][(int_cnt*6)+3]))+100+(4*(get_ip_cnt(config[1][(int_cnt*6)+2])+4)));
						fputs(bufor,fp);
					    }
					}
				    }
				}
			    }
			    fclose(ff);
			}
			else printf("Can't open %s file\n",fname);

			}
			else
			{
			    sprintf(bufor,"%s -t mangle -D POSTROUTING -s %s -j MARK --set-mark %d\n",
			        iptables_path,config[1][(int_cnt*6)+2],(1000*atoi(config[1][(int_cnt*6)+3]))+get_ip_cnt(config[1][(int_cnt*6)+2])+4);
			    fputs(bufor,fp);

			}
		    }
		}
	    }
	    sprintf(pop,"%s -X shaper%d 2> /dev/null\n",iptables_path,shaperd_counter);
	    fputs(pop,fp);
	    if (divide_upload)
	    {
		sprintf(pop,"%s -X shaout%d 2> /dev/null\n",iptables_path,shaperd_counter);
	        fputs(pop,fp);
		if (squid)
		{
		    sprintf(bufor,"%s -D INPUT -j sqout%d 2> /dev/null\n",iptables_path,shaperd_counter);
	    	    fputs(bufor,fp);
		}
	    }
	    if (squid)
	    {
		sprintf(pop,"%s -X squid%d 2> /dev/null\n",iptables_path,shaperd_counter);
		fputs(pop,fp);
		sprintf(pop,"%s -X sqout%d 2> /dev/null\n",iptables_path,shaperd_counter);
		fputs(pop,fp);
	    }

	    for(pos=1;pos<local_int_pos;pos++)
	    {
	        if (!local_int_tab2[1][(pos*6)+5])
	        {
	    	    if (squid==1)
		    {
			sprintf(bufor,"%s -D POSTROUTING -t mangle -p tcp --src %s --sport %d --dst %s -m tos --tos 0 -j MARK --set-mark %d 2> /dev/null\n",
			    iptables_path,config[1][(pos*6)+3],squid_port,config[1][(pos*6)+4],atoi(config[1][(pos*6)+5])*1000);
			fputs(bufor,fp);
			sprintf(bufor,"%s -D POSTROUTING -t mangle -p udp --src %s --sport %d --dst %s -m tos --tos 0 -j MARK --set-mark %d 2> /dev/null\n",
			    iptables_path,config[1][(pos*6)+3],squid_port,config[1][(pos*6)+4],atoi(config[1][(pos*6)+5])*1000);
			fputs(bufor,fp);

			sprintf(bufor,"%s -D POSTROUTING -t mangle -p tcp --src %s --sport ! %d --dst %s -j MARK --set-mark %d 2> /dev/null\n",
			    iptables_path,config[1][(pos*6)+3],squid_port,config[1][(pos*6)+4],atoi(config[1][(pos*6)+5])*1000);
			fputs(bufor,fp);
			sprintf(bufor,"%s -D POSTROUTING -t mangle -p udp --src %s --sport ! %d --dst %s -j MARK --set-mark %d 2> /dev/null\n",
			    iptables_path,config[1][(pos*6)+3],squid_port,config[1][(pos*6)+4],atoi(config[1][(pos*6)+5])*1000);
			fputs(bufor,fp);
		    }
		}
	    }

    	    if (squid)
	    {
		sprintf(bufor,"%s -D OUTPUT -j squid%d 2> /dev/null\n",iptables_path,shaperd_counter);
		fputs(bufor,fp);
	    }
    	    for(n=1;n<iplista_pos;n++)
	    {
		ptr = iplista_str + n;
	        if ((pos = get_config_by_ip(config,ptr -> str_ip)) != -1)
	        {
		    int		pos2;
		    
        	    if (squid==1)
	    	    {
			if (extended_queue)
			{
			    sprintf(bufor,"%s -D POSTROUTING -t mangle -p tcp --src %s --sport %d --dst %s -m tos --tos 8 -j MARK --set-mark %d 2> /dev/null\n",
			        iptables_path,config[1][(pos*6)+3],squid_port,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+101+(4*(get_ip_cnt(ptr -> str_ip)+4)));
			    fputs(bufor,fp);
			    sprintf(bufor,"%s -D POSTROUTING -t mangle -p udp --src %s --sport %d --dst %s -m tos --tos 8 -j MARK --set-mark %d 2> /dev/null\n",
				iptables_path,config[1][(pos*6)+3],squid_port,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+101+(4*(get_ip_cnt(ptr -> str_ip)+4)));
			    fputs(bufor,fp);
			}
			else
			{
			    sprintf(bufor,"%s -D POSTROUTING -t mangle -p tcp --src %s --sport %d --dst %s -m tos --tos 8 -j MARK --set-mark %d 2> /dev/null\n",
				iptables_path,config[1][(pos*6)+3],squid_port,ptr -> str_ip,(4*(get_ip_cnt(ptr -> str_ip)+4))+(1000*atoi(config[1][(pos*6)+5])));
			    fputs(bufor,fp);
			    sprintf(bufor,"%s -D POSTROUTING -t mangle -p udp --src %s --sport %d --dst %s -m tos --tos 8 -j MARK --set-mark %d 2> /dev/null\n",
				iptables_path,config[1][(pos*6)+3],squid_port,ptr -> str_ip,(4*(get_ip_cnt(ptr -> str_ip)+4))+(1000*atoi(config[1][(pos*6)+5])));
			    fputs(bufor,fp);
			}
		    }

		    if (extended_queue)
		    {
			//download
			sprintf(bufor,"%s -t mangle -D FORWARD -d %s -j MARK --set-mark %d 2> /dev/null\n",
				iptables_path,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+103+(4*(get_ip_cnt(ptr -> str_ip)+4)));
			fputs(bufor,fp);
			sprintf(bufor,"%s -t mangle -D FORWARD -d %s -m tos --tos 0x04 -j MARK --set-mark %d 2> /dev/null\n",
				iptables_path,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+102+(4*(get_ip_cnt(ptr -> str_ip)+4)));
			fputs(bufor,fp);
			sprintf(bufor,"%s -t mangle -D FORWARD -d %s -m tos --tos 0x08 -j MARK --set-mark %d 2> /dev/null\n",
				iptables_path,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+101+(4*(get_ip_cnt(ptr -> str_ip)+4)));
			fputs(bufor,fp);
			sprintf(bufor,"%s -t mangle -D FORWARD -d %s -m tos --tos 0x10 -j MARK --set-mark %d 2> /dev/null\n",
				iptables_path,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+100+(4*(get_ip_cnt(ptr -> str_ip)+4)));
			fputs(bufor,fp);
		    }

		    if (divide_upload)
		    {
			if ((pos2 = get_config_by_ip_upload(config,ptr -> str_ip)) != -1)
			{
			    if (squid)
			    {
				sprintf(bufor,"%s -D sqout%d -i %s -p tcp --src %s --dst %s --dport %d -j RETURN\n",
		    		    iptables_path,shaperd_counter,config[1][(pos*6)+1],ptr -> str_ip,config[1][(pos*6)+3],squid_port);
				fputs(bufor,fp);
			    }
			    if (! extended_queue)
			    {
				sprintf(bufor,"%s -t mangle -D FORWARD -s %s -d ! %s -j MARK --set-mark %d 2> /dev/null\n",
					iptables_path,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+get_ip_cnt(ptr -> str_ip)+4);
			        fputs(bufor,fp);
			    }
			    else
			    {
				sprintf(bufor,"%s -t mangle -D FORWARD -s %s -d ! %s -j MARK --set-mark %d 2> /dev/null\n",
					iptables_path,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+103+(4*(get_ip_cnt(ptr -> str_ip)+4)));
				fputs(bufor,fp);
				sprintf(bufor,"%s -t mangle -D FORWARD -s %s -d ! %s -m tos --tos 0x04 -j MARK --set-mark %d 2> /dev/null\n",
					iptables_path,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+102+(4*(get_ip_cnt(ptr -> str_ip)+4)));
				fputs(bufor,fp);
				sprintf(bufor,"%s -t mangle -D FORWARD -d %s -d ! %s -m tos --tos 0x08 -j MARK --set-mark %d 2> /dev/null\n",
					iptables_path,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+101+(4*(get_ip_cnt(ptr -> str_ip)+4)));
				fputs(bufor,fp);
				sprintf(bufor,"%s -t mangle -D FORWARD -d %s -d ! %s -m tos --tos 0x10 -j MARK --set-mark %d 2> /dev/null\n",
					iptables_path,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+100+(4*(get_ip_cnt(ptr -> str_ip)+4)));
				fputs(bufor,fp);
			    }
			}
		    }
		}
	    }
	}
	pclose(fp);
    }
}

void clear_firewall(int firewall_type)
{
    char	fname[100];
    FILE	*fp;
    char	com[100];

    fflush(NULL);
    flagi.clear_firewall_done = 1;
    flagi.clear_firewall_done_counter = 0;
    sprintf(com,"/bin/sh 2>> %s",output);
    if (fp = popen(com,"w"))
    {
	if (firewall_type == 1)
	{
	    char	pop1[200];
	    
	    // tablice download
	    sprintf(pop1,"%s -Z shaper%d 2>/dev/null\n",ipchains_path,shaperd_counter);
    	    fputs(pop1,fp);
	    if (divide_upload)
	    {
		// tablice upload
		sprintf(pop1,"%s -Z shaout%d 2>/dev/null\n",ipchains_path,shaperd_counter);
    		fputs(pop1,fp);
	    }
	}
	else
	if (firewall_type == 2)
	{
	    char	pop1[200];
	    
	    // download
	    sprintf(pop1,"%s -Z shaper%d 2>/dev/null\n",iptables_path,shaperd_counter);
	    fputs(pop1,fp);

	    if (squid)
	    {
		// squid
		sprintf(pop1,"%s -Z squid%d 2>/dev/null\n",iptables_path,shaperd_counter);
		fputs(pop1,fp);
		sprintf(pop1,"%s -Z sqout%d 2>/dev/null\n",iptables_path,shaperd_counter);
		fputs(pop1,fp);
	    }
	    if (divide_upload)
	    {
		// upload
		sprintf(pop1,"%s -Z shaout%d 2>/dev/null\n",iptables_path,shaperd_counter);
	        fputs(pop1,fp);
	    }
	}
	pclose(fp);
    }
}

char ***mkbitrate_user_last(char ***bitrate_user_last, char *ip, long int ispeed, int int_cnt)
{
    char	speed[20];
    char	time[20];

    
    sprintf(speed,"%d",ispeed);
    if ((ckbitrate_user_last(bitrate_user_last,ip,int_cnt)) == -1)
    {
        if (! bitrate_user_last)
	{
	    bitrate_user_last = (char ***) realloc(bitrate_user_last,sizeof(char **)*5);
	    bitrate_user_last[1] = (char **) NULL;
    	    bitrate_user_last[2] = (char **) NULL;
	}
	bitrate_user_last[1] = (char **) realloc((char **) bitrate_user_last[1],sizeof(char *)*((bitrate_user_last_pos[int_cnt]+1)*4));
	bitrate_user_last[2] = (char **) realloc((char **) bitrate_user_last[2],sizeof(char *)*((bitrate_user_last_pos[int_cnt]+1)*4));
        bitrate_user_last[1][bitrate_user_last_pos[int_cnt]+1]= (char *) calloc(strlen(ip)+2,sizeof(char));
	bitrate_user_last[2][bitrate_user_last_pos[int_cnt]+1]= (char *) calloc(strlen(speed)+2,sizeof(char));
	strcpy(bitrate_user_last[1][bitrate_user_last_pos[int_cnt]+1],ip);
        strcpy(bitrate_user_last[2][bitrate_user_last_pos[int_cnt]+1],speed);
	bitrate_user_last_pos[int_cnt]++;
    }
    else
    {
	int	n;

	for(n=0;n<bitrate_user_last_pos[int_cnt];n++)
    	    if (! strcmp(bitrate_user_last[1][n+1],ip)
		&& ! strcmp(ip,bitrate_user_last[1][n+1]))
		break;
	bitrate_user_last[1][n+1]= (char *) realloc(bitrate_user_last[1][n+1],sizeof(char *)*((n+1)*(strlen(ip)+2)));
	bitrate_user_last[2][n+1]= (char *) realloc(bitrate_user_last[2][n+1],sizeof(char *)*((n+1)*(strlen(speed)+2)));
	strcpy(bitrate_user_last[1][n+1],ip);
        strcpy(bitrate_user_last[2][n+1],speed);
    }
    return(bitrate_user_last);
}

char ***mkbitrate_user_last_upload(char ***bitrate_user_last, char *ip, long int ispeed, int int_cnt)
{
    char	speed[20];
    char	time[20];
    
    sprintf(speed,"%d",ispeed);
    if ((ckbitrate_user_last_upload(bitrate_user_last,ip,int_cnt)) == -1)
    {
        if (! bitrate_user_last)
	{
	    bitrate_user_last = (char ***) realloc(bitrate_user_last,sizeof(char **)*5);
	    bitrate_user_last[1] = (char **) NULL;
    	    bitrate_user_last[2] = (char **) NULL;
	}
	bitrate_user_last[1] = (char **) realloc((char **) bitrate_user_last[1],sizeof(char *)*((bitrate_user_last_pos_upload[int_cnt]+1)*4));
	bitrate_user_last[2] = (char **) realloc((char **) bitrate_user_last[2],sizeof(char *)*((bitrate_user_last_pos_upload[int_cnt]+1)*4));
        bitrate_user_last[1][bitrate_user_last_pos_upload[int_cnt]+1]= (char *) calloc(strlen(ip)+2,sizeof(char));
	bitrate_user_last[2][bitrate_user_last_pos_upload[int_cnt]+1]= (char *) calloc(strlen(speed)+2,sizeof(char));
	strcpy(bitrate_user_last[1][bitrate_user_last_pos_upload[int_cnt]+1],ip);
        strcpy(bitrate_user_last[2][bitrate_user_last_pos_upload[int_cnt]+1],speed);
	bitrate_user_last_pos_upload[int_cnt]++;
    }
    else
    {
	int	n;

	for(n=0;n<bitrate_user_last_pos_upload[int_cnt];n++)
    	    if (! strcmp(bitrate_user_last[1][n+1],ip)
		&& ! strcmp(ip,bitrate_user_last[1][n+1]))
		break;
	bitrate_user_last[1][n+1]= (char *) realloc(bitrate_user_last[1][n+1],sizeof(char *)*((n+1)*(strlen(ip)+2)));
	bitrate_user_last[2][n+1]= (char *) realloc(bitrate_user_last[2][n+1],sizeof(char *)*((n+1)*(strlen(speed)+2)));
	strcpy(bitrate_user_last[1][n+1],ip);
        strcpy(bitrate_user_last[2][n+1],speed);
    }
    return(bitrate_user_last);
}

char ***clear_bitrate_user_last(char ***bitrate_user_last, char **masq, int int_cnt)
{
    int		m,n;
    int		*iplista_fin;
    struct	IPLISTA	*ptr;

    iplista_fin = (int *) calloc(iplista_pos,sizeof(int));
    for(n=1;n<iplista_pos;n++)
	iplista_fin[n] = 0;

    for(n=1;n<iplista_pos;n++)
    {
	ptr = iplista_str + n;
	for(m=1;m<masqip_pos[int_cnt];m++)
        {
	    if ((ip2hex3(masq[m]) & ptr -> mask) == (ptr -> ip & ptr -> mask))
		iplista_fin[n] = 1;
	}
    }

    for(n=1;n<iplista_pos;n++)
    {
	ptr = iplista_str + n;
	if (! iplista_fin[n])
	{
    	    bitrate_user_last = mkbitrate_user_last(bitrate_user_last,ptr -> str_ip,0,int_cnt);
	}
    }
    
    free(iplista_fin);
    return(bitrate_user_last);
}

char ***clear_bitrate_user_last_upload(char ***bitrate_user_last, char **masq, int int_cnt)
{
    int		m,n;
    int		*iplista_fin;
    struct	IPLISTA	*ptr;

    iplista_fin = (int *) calloc(iplista_pos,sizeof(int));
    for(n=1;n<iplista_pos;n++)
	iplista_fin[n] = 0;

    for(n=1;n<iplista_pos;n++)
    {
	ptr = iplista_str + n;
	for(m=1;m<masqip_pos_upload[int_cnt];m++)
        {
	    if ((ip2hex3(masq[m]) & ptr -> mask) == (ptr -> ip & ptr -> mask))
	    {
		iplista_fin[n] = 1;
	    }
	}
    }

    for(n=1;n<iplista_pos;n++)
    {
	ptr = iplista_str + n;
	if (! iplista_fin[n])
	{
    	    bitrate_user_last = mkbitrate_user_last_upload(bitrate_user_last,ptr -> str_ip,0,int_cnt);
	}
    }
    
    free(iplista_fin);
    return(bitrate_user_last);
}

long int ckbitrate_user_last(char ***bitrate_user_last, char *ip, int int_cnt)
{
    int		n;

    if (bitrate_user_last)
	for(n=0;n<bitrate_user_last_pos[int_cnt];n++)
	{
	    if (! strcmp(bitrate_user_last[1][n+1],ip)
		&& ! strcmp(ip,bitrate_user_last[1][n+1]))
		return(atoi(bitrate_user_last[2][n+1]));
	}
    return(-1);
}

void set_bitrate_user_last(char ***bitrate_user_last, char *ip, int int_cnt, char *val)
{
    int		n;

    if (bitrate_user_last)
    {
	for(n=0;n<bitrate_user_last_pos[int_cnt];n++)
	{
	    if (! strcmp(bitrate_user_last[1][n+1],ip)
		&& ! strcmp(ip,bitrate_user_last[1][n+1]))
	    {
		bitrate_user_last[2][n+1] = val;
		return;
	    }
	}
    }
}

long int ckbitrate_user_last_upload(char ***bitrate_user_last, char *ip, int int_cnt)
{
    int		n;

    if (bitrate_user_last)
	for(n=0;n<bitrate_user_last_pos_upload[int_cnt];n++)
	{
	    if (! strcmp(bitrate_user_last[1][n+1],ip)
		&& ! strcmp(ip,bitrate_user_last[1][n+1]))
		return(atoi(bitrate_user_last[2][n+1]));
	}
    return(-1);
}

void set_bitrate_user_last_upload(char ***bitrate_user_last, char *ip, int int_cnt, char *val)
{
    int		n;

    if (bitrate_user_last)
    {
	for(n=0;n<bitrate_user_last_pos_upload[int_cnt];n++)
	{
	    if (! strcmp(bitrate_user_last[1][n+1],ip)
		&& ! strcmp(ip,bitrate_user_last[1][n+1]))
	    {
		bitrate_user_last[2][n+1] = val;
		return;
	    }
	}
    }
}

void free_bitrate_user_last(char ***bitrate_user_last, int int_cnt)
{
    int		n;

//    if (bitrate_user_last)
//    {
        for(n=0;n<bitrate_user_last_pos[int_cnt];n++)
        {
    	    free(bitrate_user_last[1][n+1]);
	    free(bitrate_user_last[2][n+1]);
        }
	free(bitrate_user_last[1]);
        free(bitrate_user_last[2]);
	free(bitrate_user_last);
//    }
}

void free_bitrate_user_last_upload(char ***bitrate_user_last, int int_cnt)
{
    int		n;

        for(n=0;n<bitrate_user_last_pos_upload[int_cnt];n++)
        {
    	    free(bitrate_user_last[1][n+1]);
	    free(bitrate_user_last[2][n+1]);
        }
	free(bitrate_user_last[1]);
        free(bitrate_user_last[2]);
	free(bitrate_user_last);
}

//void write_bitrate_user_last(char ***bitrate_user_last, char *fname, int int_cnt)
void write_bitrate_user_last(char ****bitrate_user_last, char *fname, int int_cnt)
{
    FILE	*fw;
    int		n;
    int		fd;
    char	buf[200];
    long int	lospeed, hispeed, speed, total_lospeed, max_hispeed, total_speed;

    if (fw = fopen(fname,"w"))
    {
	for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
	{
	    if (local_int_tab2[1][(int_cnt*6)+5])
	    {
		if (output_type)
		{
		    sprintf(buf,"DOWNLOAD [in %s]:\n\n", speed_ext);
		    fputs(buf,fw);
		    sprintf(buf,"| IP/Mask            |     lospeed |     hispeed |       speed |\n");
		    fputs(buf,fw);
		    sprintf(buf,"| -------------------|-------------|-------------|-------------|\n");
		    fputs(buf,fw);
/*		    sprintf(buf,"| 255.255.255.255/32 | 10000000000 | 10000000000 | 10000000000 |\n"); */

		    total_lospeed = 0;
		    max_hispeed = 0;
		    total_speed = 0;

		    for(n=0;n<bitrate_user_last_pos[int_cnt];n++)
		    {
			lospeed = get_ip_lospeed(bitrate_user_last[int_cnt][1][n+1]);
			hispeed = get_ip_hispeed(bitrate_user_last[int_cnt][1][n+1]);
			speed = strtol(bitrate_user_last[int_cnt][2][n+1],NULL,10);
		        sprintf(buf,"| %-18s | %'11ld | %'11ld | %'11ld |\n",bitrate_user_last[int_cnt][1][n+1],lospeed, hispeed,speed);
			fputs(buf,fw);
		        total_lospeed = total_lospeed + lospeed;
			if(max_hispeed < hispeed) max_hispeed = hispeed;
			total_speed = total_speed + speed;
		    }
		    sprintf(buf,"---------------------|-------------|-------------|-------------|\n");
		    fputs(buf,fw);
		    sprintf(buf,"              TOTAL: | %'11ld | %'11ld | %'11ld |\n", total_lospeed, max_hispeed, total_speed);
		    fputs(buf,fw);
		    sprintf(buf,"                     -------------------------------------------");
		    fputs(buf,fw);
		}
		else
		{
		    for(n=0;n<bitrate_user_last_pos[int_cnt];n++)
		    {
			speed = strtol(bitrate_user_last[int_cnt][2][n+1],NULL,10);
		        if (speed > 0)
			{
			    sprintf(buf,"%s %ld %s\n",bitrate_user_last[int_cnt][1][n+1],speed,speed_ext);
			    fputs(buf,fw);
			}
		    }
		}
	    }
	}

	fclose(fw);
    }
}

void write_bitrate_user_last_upload(char ****bitrate_user_last, char *fname, int int_cnt)
{
    FILE	*fw;
    int		n;
    int		fd;
    char	buf[200];
    long int	lospeed, hispeed, speed, total_lospeed, max_hispeed, total_speed;

    if (fw = fopen(fname,"w"))
    {
	for(int_cnt=1;int_cnt<local_int_pos;int_cnt++)
	{
	    if (local_int_tab2[1][(int_cnt*6)+5])
	    {
		if (output_type)
		{
		    sprintf(buf,"UPLOAD [in %s]:\n\n", speed_ext);
		    fputs(buf,fw);
		    sprintf(buf,"| IP/Mask            |     lospeed |     hispeed |       speed |\n");
		    fputs(buf,fw);
		    sprintf(buf,"| -------------------|-------------|-------------|-------------|\n");
		    fputs(buf,fw);
/*		    sprintf(buf,"| 255.255.255.255/32 | 10000000000 | 10000000000 | 10000000000 |\n"); */

		    total_lospeed = 0;
		    max_hispeed = 0;
		    total_speed = 0;

		    for(n=0;n<bitrate_user_last_pos_upload[int_cnt];n++)
		    {
			lospeed = get_ip_lospeed_upload(bitrate_user_last[int_cnt][1][n+1]);
			hispeed = get_ip_hispeed_upload(bitrate_user_last[int_cnt][1][n+1]);
			speed = strtol(bitrate_user_last[int_cnt][2][n+1],NULL,10);
			sprintf(buf,"| %-18s | %'11ld | %'11ld | %'11ld |\n",bitrate_user_last[int_cnt][1][n+1],lospeed,hispeed,speed);
		        fputs(buf,fw);
			total_lospeed = total_lospeed + lospeed;
			if(max_hispeed < hispeed) max_hispeed = hispeed;
			total_speed = total_speed + speed;
		    }
		    sprintf(buf,"---------------------|-------------|-------------|-------------|\n");
		    fputs(buf,fw);
		    sprintf(buf,"              TOTAL: | %'11ld | %'11ld | %'11ld |\n", total_lospeed, max_hispeed, total_speed);
		    fputs(buf,fw);
		    sprintf(buf,"                     -------------------------------------------");
		    fputs(buf,fw);
		}
		else
		{
		    for(n=0;n<bitrate_user_last_pos_upload[int_cnt];n++)
		    {
		        speed = strtol(bitrate_user_last[int_cnt][2][n+1],NULL,10);
		        if (speed > 0)
		        {
			    sprintf(buf,"%s %ld %s\n",bitrate_user_last[int_cnt][1][n+1],speed,speed_ext);
			    fputs(buf,fw);
		        }
		    }
		}
	    }
	}
	fclose(fw);
    }
}

static int daemonize(void)
{
    int fd,fd2;
    int pid;
    char buf[100];

    fprintf(stderr, "daemonizing...");

    if ((pid = fork()) < 0)
    {
	fprintf(stderr, " failed!\n");
	return -1;
    }
    else if (pid != 0)
    {
	unlink(pidfile);
	if ((fd = open(pidfile, O_CREAT|O_WRONLY, 0644)) >= 0)
	{
	    sprintf(buf,"%d\n",pid);
	    write(fd,buf,strlen(buf));
	    close(fd);
	}
	fprintf(stderr, " done. PID=%d\n", pid);
	exit(0);
    }

    // parent is gone now
    setsid();   // ditch controlling terminal, become session leader
    chdir("/"); // new working directory (don't prevent unmounting a FS)
    umask(0);   // clear inherited file creation mask

    if (!debug)
    {
        fd2 = open("/dev/null", O_RDWR);
	if ((fd2 = open("/dev/null", O_RDWR)) >= 0)
        {
    	    dup2(fd2, 0);
	    dup2(fd2, 1);
	    dup2(fd2, 2);
	}
    }

    // set up logging facility
//    sprintf(buf,"shaperd%s",shaperd_counter);
//    openlog(buf, LOG_CONS, LOG_DAEMON);
    syslog(LOG_INFO, "starting: LAN Traffic shaper %s (C) 2001-2004 Grzegorz Fitrzyk (sp9wun@poczta.onet.pl)",SHAPERD_VERSION);
    syslog(LOG_INFO, "running, PID=%d", getpid());
    if (debug) printf("Starting shaperd.%d %s\n",shaperd_counter,SHAPERD_VERSION);
    return 0;
}

int check_linux(void)
{
    FILE	*fp;
    char	buf[1000];
    char	*p,*q;
    int		a = 0;
    int		b = 0;
    
    if (fp = fopen("/proc/version","r"))
    {
	while(fgets(buf,1000,fp))
	{
	    if (strstr(buf,"Linux version"))
	    {
		p = strtok(buf," ");
		p = strtok(NULL," ");
		p = strtok(NULL," ");
		p = strtok(p,".");
		q = strtok(NULL,".");
		a = atoi(p);
		b = atoi(q);
//		printf("wersja: %d %d\n",a,b);
		if (a == 2)
		{
		    fclose(fp);
		    return(b);
		}
	    }
	}
	fclose(fp);
    }
    return(0);
}

int check_ipchains(void)
{
    FILE	*fp;
    char	buf[1000];
    char	com[100];

    sprintf(com,"%s -L -n 2> /dev/null\n",ipchains_path);
    if (fp = popen(com,"r"))
    {
	fgets(buf,1000,fp);
	pclose(fp);
	if (strstr(buf,"Chain")) return(1);
	else return(0);	
    }
}

int check_iptables(void)
{
    FILE	*fp;
    char	buf[1000];
    char	com[100];

    sprintf(com,"%s -L -n 2> /dev/null\n",iptables_path);
    if (fp = popen(com,"r"))
    {
	fgets(buf,1000,fp);
	pclose(fp);
	if (strstr(buf,"Chain")) return(1);
	else return(0);
    }
}

int is_shaperd_running(void)
{
    FILE	*fp;
    char	buft[1000];
    int		fin = 0;

    if (fp = fopen(pidfile,"r"))
    {
	fclose(fp);
	return(1);
    }
    else return(0);
}

int is_iproute2(void)
{
    FILE	*fp, *fq;
    char	buft[1000];
    int		res = 0;
    char	tmp[100];
    char	tmp2[100];

    fflush(NULL);
    sprintf(tmp,"/tmp/tc.%d.tmp",shaperd_counter);
    sprintf(tmp2,"%s 2>> /tmp/tc.%d.tmp\n",tc_path,shaperd_counter);
    if (fp = popen(tmp2,"w"))
    {
	pclose(fp);
	if (fq = fopen(tmp,"r"))
	{
	    while (fgets(buft,1000,fq))
	    {
		if (strstr(buft,"sage: tc ["))
		{
		    res = 1;
		    break;
		}
	    }
	    fclose(fq);
	    if (!res)
	    {
		if (fq = fopen(tmp,"r"))
		{
		    printf("Unknown answer of tc command. Dumping results:\n");
		    while (fgets(buft,1000,fq))
			printf("%s",buft);
		    fclose(fq);
		}
	    }
	    remove(tmp);
	}
        else
        {
    	    printf("Can't open %s file! Maybe there's no /tmp directory?\n",tmp);
	}
    }
    return(res);
}

int is_htb3(void)
{
    FILE	*fp, *fq;
    char	buft[1000];
    int		res = 0;
    char	tmp[100];
    char	tmp2[100];

    fflush(NULL);
    sprintf(tmp,"/tmp/tc2.%d.tmp",shaperd_counter);
    sprintf(tmp2,"%s class add htb help 2> /tmp/tc2.%d.tmp\n",tc_path,shaperd_counter);
    if (fp = popen(tmp2,"w"))
    {
	pclose(fp);
	if (fq = fopen(tmp,"r"))
	{
	    while (fgets(buft,1000,fq))
	    {
		if (strstr(buft,"[quantum Q]"))
		{
		    res = 1;
		    break;
		}
	    }
	    fclose(fq);
	    remove(tmp);
	}
        else
        {
    	    printf("Can't open %s file! Maybe there's no /tmp directory?\n",tmp);
	}
    }
    return(res);
}

int is_qos(void)
{
    FILE	*fp, *fq;
    char	buft[1000];
    int		res = 0;
    char	tmp[100];
    char	tmp2[100];

    sprintf(tmp,"/tmp/tc.%d.tmp",shaperd_counter);
    sprintf(tmp2,"%s class show > %s 2>>/tmp/tc.%d.tmp\n",tc_path,output,shaperd_counter);
    fflush(NULL);
    if (fp = popen(tmp2,"w"))
    {
	pclose(fp);
	if (fq = fopen(tmp,"r"))
	{
	    fgets(buft,1000,fq);
	    fclose(fq);
	    if (strstr(buft,"RTNETLINK error")) res = 0;
	    else res = 1;
	    remove(tmp);
	}
    }
    return(res);
}

void shownat(char ***natstat_tab)
{
    int		n;

    for(n=0;n<natstat_tab_pos;n++)
    	printf("%s %s %s\n",
	    natstat_tab[1][(n*4)+1],
	    natstat_tab[1][(n*4)+2],
	    natstat_tab[1][(n*4)+3]);
    return;
}

char *lower(char *string)
{
    char	*res;
    int		n = 0;

    res = (char *) calloc(strlen(string)+2,sizeof(char));
    while((res[n] = tolower(string[n])) && n<999)
	n++;

    return(res);
}

void read_squid(int firewall_type)
{
    int		f1,m,n;
    struct	stat stbuf;
    unsigned long int	cnt1,cnt2;
    unsigned long int	dd1,dd2,dd3,dd4;
    char	aa[12][20];
    char	*src;
    char	buf[30];
    char	buft[1000];

    FILE	*fw,*fp;

    if (debug>2) printf("debug 3: reading squid firewall rules\n");
    fflush(NULL);
    if (firewall_type==1)
    {
/*
	if (!(fp = popen("/sbin/ipchains -vxL shaper -n 2>> /dev/null","r")))
	{
	    syslog(LOG_ERR,"Can't read squid table from ipchains");
	    exit(1);
	}
*/
	syslog(LOG_ERR,"Shaperd don't support squid for ipchains firewall type");
	error("shaperd don't support squid for ipchains firewall type\nExiting\n");
    }
    else
    if (firewall_type==2)
    {
	char	buf2[100];
	
	sprintf(buf2,"%s -vxL squid%d -n 2>> %s",iptables_path,shaperd_counter,output);
	if (!(fp = popen(buf2,"r")))
	{
	    syslog(LOG_ERR,"Can't read squid table from iptables");
	    error("Can't read squid table from iptables\nExiting.\n");
	}
    }
    else
    {
	syslog(LOG_ERR,"BUG: firewall type %d not exists!",firewall_type);
	error("BUG! Firewall type %d not exists!\nExiting\n",firewall_type);
    }

    fgets(buft,1000,fp);
    fgets(buft,1000,fp);
    while ((fgets(buft,1000,fp))!=NULL)
    {
	char	bufor[200];
	char	buf2[200];
	char	ipt[20];
	struct	IPLISTA	*ptr;

	sprintf(buf2,"spt:%d",squid_port);
	if (strstr(buft,buf2) && strstr(buft,"0x08"))
	{
	    sscanf(buft,"%lu %lu %s %s %s %s %s %s %s",
		&dd1,&dd2,aa[3],aa[4],aa[5],aa[6],aa[7],aa[8],aa[9]);
	    for(m=1;m<iplista_pos;m++)
	    {
		ptr = iplista_str + m;
		if (ptr -> mask == 0xffffffff)
		{
		    char	*res = hex2ip(ptr -> ip & ptr -> mask);

		    strcpy(ipt,res);
		    free(res);
		}
		else
		{
		    strcpy(ipt,ptr -> str_ip);
		}
		strcat(ipt," ");
	        if (strstr(buft,ipt))
		{
		    ptr -> squid_speed = dd2;
		    ptr -> squid_time  = (long unsigned int) time(NULL);
		    if (debug > 1) printf("read_squid: %s %lu %lu\n",ptr -> str_ip,ptr -> squid_speed,ptr -> squid_time);
	        }
	    }
	}
    }
    pclose(fp);
}

void read_sqout(int firewall_type)
{
    int		f1,m,n;
    struct	stat stbuf;
    unsigned long int	cnt1,cnt2;
    unsigned long int	dd1,dd2,dd3,dd4;
    char	aa[12][20];
    char	*src;
    char	buf[30];
    char	buft[1000];

    FILE	*fw,*fp;

    if (debug>2) printf("debug 3: reading sqout firewall rules\n");
    fflush(NULL);
    if (firewall_type==1)
    {
	syslog(LOG_ERR,"Shaperd don't support squid for ipchains firewall type");
	error("shaperd don't support squid for ipchains firewall type\nExiting\n");
    }
    else
    if (firewall_type==2)
    {
	char	buf2[100];
	
	sprintf(buf2,"%s -vxL sqout%d -n 2>> %s",iptables_path,shaperd_counter,output);
	if (!(fp = popen(buf2,"r")))
	{
	    syslog(LOG_ERR,"Can't read sqout table from iptables");
	    error("Can't read sqout table from iptables\nExiting.\n");
	}
    }
    else
    {
	syslog(LOG_ERR,"BUG: firewall type %d not exists!",firewall_type);
	error("BUG! Firewall type %d not exists!\nExiting\n",firewall_type);
    }

    fgets(buft,1000,fp);
    fgets(buft,1000,fp);
    while ((fgets(buft,1000,fp))!=NULL)
    {
	char	bufor[200];
	char	buf2[200];
	char	ipt[20];
	struct	IPLISTA	*ptr;

	sprintf(buf2,"dpt:%d",squid_port);
	if (strstr(buft,buf2))
	{
	    sscanf(buft,"%lu %lu %s %s %s %s %s %s %s",
		&dd1,&dd2,aa[3],aa[4],aa[5],aa[6],aa[7],aa[8],aa[9]);
	    for(m=1;m<iplista_pos;m++)
	    {
		ptr = iplista_str + m;
		if (ptr -> mask == 0xffffffff)
		{
		    char	*res = hex2ip(ptr -> ip & ptr -> mask);

		    strcpy(ipt,res);
		    free(res);
		}
		else
		{
		    strcpy(ipt,ptr -> str_ip);
		}
		strcat(ipt," ");
	        if (strstr(buft,ipt))
		{
		    ptr -> sqout_speed = dd2;
		    ptr -> sqout_time  = (long unsigned int) time(NULL);
		    if (debug > 1) printf("read_sqout: %s %lu %lu\n",ptr -> str_ip,ptr -> sqout_speed,ptr -> sqout_time);
	        }
	    }
	}
    }
    pclose(fp);
}

char *ip2ip_with_mask(char *ip)
{
    int	m;
    struct	IPLISTA	*ptr;

    for(m=1;m<iplista_pos;m++)
    {
	ptr = iplista_str + m;
	if ((ip2hex2(ip) & ptr -> mask) == (ptr -> ip & ptr -> mask))
	    return(ptr -> str_ip);
    }
    return(NULL);
}

char *get_mainip(char *iface)
{
    FILE        	*fp;
    char		buf[2000];
    static char		buf2[20];
    char		*res;

    sprintf(buf,"/sbin/ifconfig %s 2>> %s | grep 'inet addr' | cut -d ':' -f2 | cut -d ' ' -f1\n",iface,output);
    if (fp = popen(buf,"r"))
    {
	fgets(buf2,20,fp);
	pclose(fp);
	buf2[strlen(buf2)-1] = '\0';
//	printf("mainip=%s#\n",buf2);
	if (strlen(buf2)) return(buf2);
    }
    return(NULL);
}

int count_char_in_string(char *string, char c)
{
    int		n = 0;
    int		m = 0;
    char	p;
    
    while(p = string[n++])
	if (p == c ) m++;
    return(m);
}

int is_device(char *dev)
{
    int		res = 0;
    int		n;

    if (dev)
    {
	for(n=1;n<devlist_pos;n++)
        {
	    if (!strcmp(devlist[n],dev) && !strcmp(dev,devlist[n]))
	    {
//    	    	printf("%s istnieje\n",devlist[n]);
		res = 1;
	    }
	}
    }
    return(res);
}

void putdate(void)
{
    FILE	*fp;
    char	com[100];

    sprintf(com,"/bin/sh >> %s",output);
    if (fp = popen(com,"w"))
    {
	fputs("date\n",fp);
	pclose(fp);
    }
}

void putstring(char *fmt, ...)
{
    va_list	args;
    FILE	*fp;
    char	com[100];
    char	buf[5000];
    char	buf1[5000];

    va_start(args, fmt);
    strcpy(buf1,"\0");
    sprintf(buf,"echo `date` ");
    strcat(buf1,buf);
    vsprintf(buf, fmt, args);
    strcat(buf1,buf);
    sprintf(buf,"\n");
    strcat(buf1,buf);

    sprintf(com,"/bin/sh >> %s",output);
    if (fp = popen(com,"w"))
    {
        fputs(buf1,fp);
        pclose(fp);
    }
    va_end(args);
}

int numcmp(int v1, int v2)
{
    if (v1 < v2) return -1;
    else if (v1 > v2) return 1;
    else return 0;
}

void swap(char **s, int *v, int *v2, int i, int j)
{
    int		temp,temp2;
    char	*str_temp;
    
    temp = v[i];
    temp2= v2[i];
    str_temp = s[i];
    v[i] = v[j];
    v2[i] = v2[j];
    s[i] = s[j];
    v[j] = temp;
    v2[j]= temp2;
    s[j] = str_temp;
}

void qsort2(char **string, int *value, int *value2, int left, int right)
{
    int i, last;
    
    if (left >= right) return;
    swap(string, value, value2, left, (left + right)/2);
    last = left;
    for(i=left+1;i<=right;i++)
	if (numcmp(value[i],value[left]) > 0) swap(string,value,value2,++last,i);
    swap(string,value,value2,left,last);
    qsort2(string,value,value2,left,last-1);
    qsort2(string,value,value2,last+1,right);
}

/* int multipler(char *str)
 * zwarca:
 * 1, gdy str to "bit",
 * 1024, gdy str to "kbit",
 * 1048576, gdy str to "mbit"
 * 1 w przypadku nie rozpoznania str
 */
int multipler(void)
{
    int		mult = 1;

    if (! strcasecmp(speed_ext,"bit")) mult = 1;
    else if (! strcasecmp(speed_ext,"kbit")) mult = 1024;
    else if (! strcasecmp(speed_ext,"mbit")) mult = 1048576;
    return(mult);
}

/* struct IPLISTA * get_ip_str(char * ip)
 * zwraca:
 * adres struktury w tablicy struktur IPLISTA zawierajacej podany ip
 * lub NULL jesli nie znaleziony
 */
struct IPLISTA * get_ip_str(char * ip)
{
    struct	IPLISTA * ptr;
    int		m;

    for(m=1;m<iplista_pos;m++)
    {
	ptr = iplista_str + m;
	if (!strcmp(ptr -> str_ip,ip) && !strcmp(ip,ptr -> str_ip)) return(ptr);
    }
    return(NULL);
}
